//                              -*- Mode: C++ -*-
//: ArteMessage.C
//
// 
//
// Author: Mauro Villa
// ECAL group
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/5/97
// Last Update ........
//

#include "arte/ArteMessage.hh"


////////////////// Static data declaration
// this is the object for output of errors, warnings and other strings
ArteMessage arteMsg;


////////////////////// ArteMessage Class definition
// Constructor
#ifndef __xlC__
  ArteMessage::ArteMessage() :
   	ostrstream(msg,SIZEBUF) {}
#else
  ArteMessage::ArteMessage() : 
  	ostrstream() {
      streambuf buffer(msg,SIZEBUF);
      init(&buffer);
  }
#endif

// Destructor
ArteMessage::~ArteMessage(){}


//--
//  Clear the buffer and get ready to receive another message
void ArteMessage::clear(){
  seekp(0);      // reset buffer pointers to starting position
  *this<<ends;   // put a null character in the starting position
  seekp(0);      // reset to start
} 

//--
// Write the stored message on all printers
ArteMessage& ArteMessage::allp(){
   *this<<ends;
   meallp_(str(), strlen(str()));
   clear();
   return *this;
}

//--
// count and print a message 
ArteMessage& ArteMessage::allp(int & ID, int NP){
  *this<<ends;
  mepric_(&ID, &NP, str(), strlen(str()));
  clear();
  return *this; 
}

//--
// print text on all printers declared by CTPL 
ArteMessage& ArteMessage::toPrinters(char* CTPL){
  *this<<ends;
  meselp_(str(), CTPL, strlen(str()), strlen(CTPL));
  clear();
  return *this;
}



//--
// Write error message on all printer units.
//      Batch: stop program.
//      Interactive: stop or continue. 
ArteMessage& ArteMessage::error(){
  *this<<ends;
  meerro_(str(), strlen(str()));
  clear();
  return *this;  // this line for the compiler. Execution is trapped
                 // in the function meerro_() 
}

//--
// error message; count for final statistics
ArteMessage& ArteMessage::error(int &ID){
  *this<<ends;
  meerrc_(&ID, str(), strlen(str()));
  clear();
  return *this;  // this line for the compiler. Execution is trapped
                 // in the function meerrc_() 
}


//--
// Print a warning
ArteMessage& ArteMessage::warn(){
  *this<<ends;
  mewarn_(str(), strlen(str()));
  clear();
  return *this;  
}

//--
// Print a warning;  count for final statistics
ArteMessage& ArteMessage::warn(int &ID){
  *this<<ends;
  mewarc_(&ID, str(), strlen(str()));
  clear();
  return *this; 
}



