*CMZ :          24/03/96  14.12.52  by  Hartwig Albrecht
*CMZ :  2.01/03 16/02/96  15.37.04  by  Hartwig Albrecht
*CMZ :  2.01/02 30/01/96  15.51.10  by  Hartwig Albrecht
*CMZ :  2.01/01 20/12/95  19.26.33  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   05/10/95

      SUBROUTINE ALEVNT

************************************************************************
*
* Description: generate one Lund event
*
* Called from: USEVNT
*
* External references: LUND
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MCIN.fi"
#include "jets/LUJETS.fi"
#include "pyth/PYSUBS.fi"
#include "pyth/PYPARS.fi"

      INTEGER NI, I
      REAL X, RLU

#include "arte/Arte.ff"
#include "auto/MCIN.ff"

C fill Lund particle/decay table

      IF (LUNDINIT .LT. 0)  THEN
        CALL ALTOPP
        CALL ALTDEC
        LUNDINIT = 1
      END IF

C event header bank EVHD

      CALL ATEVHD

C issue warning if event input file is given

      IF (IIOFLG(LEVI1) .GT. 0 .OR. IIOFLG(LEVI2) .GT. 0 .OR.
     +    IIOFLG(LEVI3) .GT. 0 .OR. IIOFLG(LEVI4) .GT. 0)
     +  CALL MEMESC (7621346, 1, ILARGEST,
     +    'LUND event generator: event input files ignored')

C set seed

      IF (LUNDSEED(1) .EQ. 0 .OR. LUNDSEED(2) .EQ. 0)  CALL ALRINI
      CALL RANECQ (LUNDSEED(1), LUNDSEED(2), 1, 'S')
      X = RLU (1)

C Pythia/Fritiof or Fritiof

      IF (MSEL .EQ. 1)  THEN
        CALL ALFRIT (LUNDRPART)
      ELSE
        CALL ALPYTH
      END IF

C Number of interactions - delta or Poisson distribution:

      IF (FIOMIX(2) .EQ. 0.)  GO TO 10
      IF (FIOMIX(2) .LT. 0.)  THEN
        NI = - NINT (FIOMIX(2))
      ELSE
        CALL POISSN (FIOMIX(2), NI, I)
      END IF

      DO I = 1, NI
        CALL ALFRIT (0)
      END DO

C random seed for GEANT

 10   CALL RANECQ (LUNDSEED(1), LUNDSEED(2), 1, 'R')
      IQ(IQMCIN_RGEA(1,1)) = LUNDSEED(1)
      IQ(IQMCIN_RGEA(2,1)) = LUNDSEED(2)

      END

************************************************************************
* End of ALEVNT
************************************************************************
