*CMZ :  2.01/02 26/01/96  10.39.50  by  Hartwig Albrecht
*CMZ :  2.01/01 05/12/95  15.05.25  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE ATSTOP (CTXT)
************************************************************************
*
* Description: ARTE termination
*
* Called from: anywhere
*
* External references:
*
* Arguments in/out description
*   CTXT    in     text describing the reason for job termination.
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

      INTEGER DUMMY, FASTOP, DBSTOP
      REAL T
      CHARACTER*(*) CTXT
      CHARACTER*20  C1,C2 

#include "arte/Arte.ff"

      IF (PROGSTAT .GT. 0)  THEN

C prevent recursive calls

        CALL MEALLP
     +    ('=== ATSTOP is called recursively: STOP immediately.')
        CALL MEALLP
     +    ('=== Program may not be properly terminated.')
        GO TO 90
      END IF

      PROGSTAT = 1
      CALL TIMEX (T)
      TIMEEMAX = MAX (TIMEEMAX, T - TIMESTOP)
      TIMESTOP = T
      CALL LISTOP (CTXT)

C Users termination

      CALL USSTOP

C write and drop old event

      IF (JEVHD .NE. 0)  CALL MMWEVT

C Grafic termination
      IF (PRISINIT.NE.0) CALL IGEND

C FARM termination

      DUMMY = FASTOP ()

C DB termination

C      DUMMY = DBSTOP ()

C HBOOK buffers:

      IF (IIOFLG(IIOCUR(LHIST)) .GT. 0)  THEN
        CALL HROUT (0, DUMMY, 'T')
        CALL HREND ('ARTE')
        CALL MEWARC (876349, 'HBOOK file closed')
      END IF

C clear Zebra output buffers

      CALL FZENDO (0, 'TXQ')
      CALL MEWARC (7523434, 'Zebra output files closed')


C remove temporary STAGE files
      C1 = 'DUMMY'
      C2 = 'DUMMY'
      CALL UTSTAGE( -1 , C1 , C2 ) 

C print message summary

      CALL LIMESS ('TPL')

C timing information

      CALL LITIME ('TPL')

      CALL MEALLP ('*-------------------------- ARTE: normal terminatio'
     + // 'n -------------------------')

 90   STOP

      END

************************************************************************
* End of ATSTOP
************************************************************************
