*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDATCC

************************************************************************
*
* Description: make include files *.hh from the DATT command
*
* Called from: DDEXEC
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, K4, IFF, IFH, IFB
      CHARACTER CU*4, CL*4, CA*4, CR*4

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL CHCTOH ('F', IFF, 1)
      CALL CHCTOH ('H', IFH, 1)
      CALL CHCTOH ('B', IFB, 1)

C loop over tables

      DO 90 K1 = 1, NDDUSR
        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 90

C new deck *.h

        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), CU)
        CL = CU
        CALL CUTOL (CL)

        CALL DDOPEN (CU, 'h')
        CALL DDNDEF (CU, 'H')

        CALL DDCSTO ('typedef struct {')

C declarations for attributes

        DO 30 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 40

          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CA)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
            K4 = IDDEF_DIM(K2)
            C78 = 'int'
            IF (HDDEF_NAM2(K2) .EQ. IFF)  THEN
              C78 = 'float'
            ELSE IF (HDDEF_NAM2(K2) .EQ. IFH)  THEN
              C78 = 'char'
              K4 = 4 * MAX (K4, 1)
            ELSE IF (HDDEF_NAM2(K2) .EQ. IFB)  THEN
              C78 = 'unsigned'
            END IF
            CALL CH78BC (CA)

            IF (K4 .NE. 0)  THEN
              CALL CH78AC ('[')
              CALL CH78AI (K4)
              CALL CH78AC (']')
            END IF

            CALL DDCSTS (C78)


          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN

            C78 = 'int o'
            CALL CH78AC (CA)
            CALL DDCSTS (C78)

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            C78 = 'int p'
            CALL CH78AC (CA)
            CALL DDCSTS (C78)

          END IF

 30     CONTINUE

 40     CONTINUE

        CALL DDCSTS ('} ' // CL)

        C78 = '#define  J' // CU // ' (gcbank_.iq+artelink_.j' //
     +    CL // ')'
        CALL DDCSTO (C78)

        C78(10:10) = 'N'
        C78(15:) = '() N_U(J    )'
        C78(23:26) = CU
        CALL DDCSTO (C78)

        C78(9:10) = 'NC'
        C78(20:20) = 'C'
        CALL DDCSTO (C78)

        C78 = '#define     (i) (*((    *)(J    +2)+(i)-1))'
        C78(9:12) = CU
        C78(21:24) = CL
        C78(29:32) = CU
        CALL DDCSTO (C78)

        DO 70 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 80

          CALL CHHTOC (IQ(HQDDEF_NAM3(K2)), CR)
          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CA)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  GO TO 60
          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 70

          DO 50 K3 = K1 + 1, K2 - 1
            IF (IDDEF_FLAG(K3) .NE. LDDEF_REM .OR.
     +          IDDEF_FLAG(K3) .NE. LDDEF_INM)  GO TO 50
            IF (HDDEF_NAM3(K2) .EQ. HDDEF_NAM3(K3))  GO TO 60
 50       CONTINUE

C #include relation.h

          C78 = '#include "auto/' // CR // '.h"'
          CALL DDCSTO (C78)

 60       C78 = '#define ' // CU // '_p' // CA // '(i) ' // CU //
     +      '(i).p' // CA
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN
            C78(14:14) = 'o'
            C78(31:31) = 'o'
          END IF
          CALL DDCSTO (C78)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +       IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            C78(23:) = 'M_R(i,J' // CR // ')'
            CALL DDRTYP (K2, K3)
            IF (K3 .EQ. 4)  THEN
              C78(25:25) = '1'
              IF (IDDEF_FLAG(K2) .EQ. LDDEF_INM)  C78(25:25) = '2'
            END IF

            C78(14:14) = 'm'
            CALL DDCSTO (C78)

            C78(14:14) = 'x'
            C78(23:23) = 'X'
            CALL DDCSTO (C78)

          END IF

 70     CONTINUE

 80     CALL DDCSTO ('#endif')

 90   CONTINUE

C relations

      DO 100 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_RE1 .AND.
     +      IDDEF_FLAG(K1) .NE. LDDEF_REM )  GO TO 100
        CALL DDRTYP (K1, K2)
        IF (K2 .LE. 1)  GO TO 100

        CALL CHHTOC (IQ(HQDDEF_NAM3(K1)), CU)
        CL = CU
        CALL CUTOL (CL)

        CALL DDOPEN (CU, 'h')
        CALL DDNDEF (CU, 'H')

        C78 = '#define  J' // CU // ' (gcbank_.iq+artelink_.j' //
     +    CL // ')'
        CALL DDCSTO (C78)
        CALL DDCSTO ('#endif')

 100  CONTINUE

      END

************************************************************************
* End of DDATCC
************************************************************************
