*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDATTF

************************************************************************
*
* Description: make Fortran sequences from the DATT command
*
* Called from: DDEXEC
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, NN, IFF, LENOCC
      CHARACTER*(N78MAX) CC

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL CHCTOH ('F', IFF, 1)

      DO 200 K1 = 1, NDDUSR

        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 200

C patch/deck for Fortran declarations and parameters

        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), CC(3:6))
        CALL DDOPEN (CC(3:6), 'fi')

C type declaration: integer

        CALL DDFSTM ('INTEGER')

C type declaration: # of columns/row: Ntabl

        CC(1:2) = ' N'
        CALL DDFEXT (CC(2:6))
        CALL DDFEXT (',')
        CC(1:2) = 'NC'
        CALL DDFEXT (CC(1:6))

        CC(7:7) = '_'

        DO 20 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 30
          IF (IDDEF_FLAG(K2) .GE. LDDEF_ATT .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_INM)  THEN

C type declaration for parameters Jtabl_att

            CC(2:2) = 'J'
            CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CC(8:11))
            CC(12:) = ' '
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:11))

          END IF

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN

            IF (IDDEF_DIM(K2) .NE. 0)  THEN

C type declarations for dimensions Ntabl_att

              CC(2:2) = 'N'
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:11))
            END IF

            IF (HDDEF_NAM2(K2) .NE. IFF)  THEN

C type declarations for integer statement functions

              CALL CHHTOC (IQ(HQDDEF_NAM2(K2)), CC(2:2))
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:11))

              CC(1:1) = CC(2:2)
              CC(2:2) = 'Q'
              CALL DDFEXT (',')
              CALL DDFEXT (CC(1:11))

              CALL CHAPPC (CC, '_L')
              CALL DDFEXT (',')
              CALL DDFEXT (CC(1:13))

            ELSE

              CC(2:2) = 'Q'
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:11))

              CALL CHAPPC (CC, '_L')
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:13))

            END IF

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN

            CC(2:2) = 'O'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:11))

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            CC(2:2) = 'P'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:11))
            CC(2:2) = 'M'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:11))
            CC(2:2) = 'X'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:11))

          END IF

 20     CONTINUE

 30     CALL DDFOUT

C type declaration REAL

        CC(2:2) = 'F'
        NN = 0
        DO 40 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +       IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 50
          IF (IDDEF_FLAG(K2) .NE. LDDEF_ATT)  GO TO 40
          IF (HDDEF_NAM2(K2) .NE. IFF)  GO TO 40

          IF (NN .EQ. 0)  THEN
            CALL DDFSTM ('REAL')
          ELSE
            CALL DDFEXT (',')
          END IF
          NN = NN + 1

          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CC(8:11))
          CALL DDFEXT (CC(2:11))

 40     CONTINUE
 50     CALL DDFOUT

C Fortran PARAMETER statement

        NN = 0
        DO 60 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 70
          IF (IDDEF_FLAG(K2) .LT. LDDEF_ATT .OR.
     +        IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 60

          IF (NN .EQ. 0)  THEN
            CALL DDFSTM ('PARAMETER(')
          ELSE
            CALL DDFEXT (',')
          END IF
          NN = NN + 1

C position Jtabl_attr=...

          CC(2:2) = 'J'
          CC(12:) = ' '
          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CC(8:11))
          CALL CHAPPC (CC, '=')
          CALL CHAPPI (CC, IDDEF_POS(K2))
          CALL DDFEXT (CC(2:))

          IF (IDDEF_DIM(K2) .NE. 0 .AND.
     +        IDDEF_FLAG(K2) .EQ.LDDEF_ATT)  THEN

C dimension Ntabl_att=...

            CC(2:2) = 'N'
            CC(12:) = ' '
            CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CC(8:11))
            CALL CHAPPC (CC, '=')
            CALL CHAPPI (CC, IDDEF_DIM(K2))
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))
          END IF

 60     CONTINUE
 70     IF (NN .NE. 0)  THEN
          CALL DDFEXT (' )')
          CALL DDFOUT
        END IF

C patch/deck for Fortran statement functions

        CALL DDOPEN (CC(3:6), 'ff')

C number of columns / row

        CC(1:2) = ' N'
        CC(7:) = '()=N_U(J'
        CC(15:18) = CC(3:6)
        CC(19:19) = ')'
        CALL DDFSTM (CC)
        CALL DDFOUT

        CC(1:2) = 'NC'
        CC(12:12) = 'C'
        CALL DDFSTM (CC)
        CALL DDFOUT

        DO 100 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 110
          IF (IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 100

          CC(7:) = '_'
          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CC(8:11))

          IF (IDDEF_FLAG(K2) .NE. LDDEF_ATT)  GO TO 80

C addresses

          CC(2:2) = 'Q'
          CALL CHHTOC (IQ(HQDDEF_NAM2(K2)), CC(1:1))
          IF (CC(1:1) .EQ. 'F')  CC(1:1) = ' '

C any row: IQtabl_att(...

          NN = LENOCC (CC)
          CC(14:14) = '('
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W,')
          CALL CHAPPC (CC, 'I_R)')
          CC(23:28) = '=L_A(J'
          CALL CHAPPC (CC, CC(3:NN))
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, '-1+I_W')
          CALL CHAPPC (CC, ',I_R,J')
          CALL CHAPPC (CC, CC(3:6))
          CALL CHAPPC (CC, ')')
          CALL DDFSTM (CC)
          CALL DDFOUT

C last row: IQtabl_att_L()

          CC(NN+1:13) = '_L'
          CC(14:) = '('
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W')
          CALL CHAPPC (CC, ')')
          CC(23:28) = '=L_L(J'
          CALL CHAPPC (CC, CC(3:NN))
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, '-1+I_W')
          CALL CHAPPC (CC, ',J')
          CALL CHAPPC (CC, CC(3:6))
          CALL CHAPPC (CC, ')')
          CALL DDFSTM (CC)
          CALL DDFOUT

C statement functions for values

          CC(1:1) = ' '
          CALL CHHTOC (IQ(HQDDEF_NAM2(K2)), CC(2:2))
          CC(NN+1:13) = ' '
          CC(14:) = '('
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W,')
          CALL CHAPPC (CC, 'I_R')
          CALL CHAPPC (CC, ')')
          IF (CC(2:2) .NE. 'F')  THEN
            CC(23:28) = '=IQ( Q'
            CC(27:27) = CC(2:2)
          ELSE
            CC(23:28) = '= Q( Q'
          END IF
          CALL CHAPPC (CC, CC(3:NN))
          CALL CHAPPC (CC, '(')
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W,')
          CALL CHAPPC (CC, 'I_R')
          CALL CHAPPC (CC, '))')
          CALL DDFSTM (CC)
          CALL DDFOUT

          GO TO 100

C statement functions for relations

 80       IF (IDDEF_FLAG(K2) .LT. LDDEF_RE1)  GO TO 100

          CC(1:2) = ' O'
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_INM)  CC(2:2) = 'P'

          NN = LENOCC (CC)
          CC(14:28) = '(I_R)    =I_V(J'
          CC(29:37) = CC(3:11)
          CALL CHAPPC (CC, ',I_R,J')
          CALL CHAPPC (CC, CC(3:6))
          CALL CHAPPC (CC, ')')
          CALL DDFSTM (CC)
          CALL DDFOUT

          IF (CC(2:2) .EQ. 'O')  GO TO 100

          CC(2:2) = 'X'
          CC(24:) = 'X_R(I_R,J    )'
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM)  THEN
            CC(26:26) = '1'
          ELSE IF (IDDEF_REL(K2) .EQ. 4)  THEN
            CC(26:26) = '2'
          END IF
          CALL CHHTOC (IQ(HQDDEF_NAM3(K2)), CC(33:36))
          CALL DDFSTM (CC)
          CALL DDFOUT

          CC(2:2) = 'M'
          CC(24:24) = 'M'
          CALL DDFSTM (CC)
          CALL DDFOUT

 100    CONTINUE

 110    CONTINUE

 200  CONTINUE

      END

************************************************************************
* End of DDATTF
************************************************************************
