
      SUBROUTINE DDTOPS(IMOD)

************************************************************************
*
* Description: makes .ps and .eps files for ARTE tables in the help utility
*
* Called from: DDEXEC
*
* External references: DDCHPS
*
* Arguments: IMOD = 0    - one .ps file for all tables
*                   1      one ps and one .epsfile for every table
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER IR, LENOCC, IATT, ILAST, IUCOMP, I, IFL, ISCAN, IMOD
      INTEGER NB, NM, NFIL(200), NPAR(200), NSUB(200)
      CHARACTER  CDIV(2)*5, CNAME*8,CTEXT*48,CA*40,CS*40
      CHARACTER BNAME*4,CF*4,CMENU*4,CRELAT*4,CEXT*4
      CHARACTER CSTART(4)*80,CMENAM(50,2)*4
      DATA CDIV /'IXCONS','IXEVNT'/
      DATA CSTART / '\\documentstyle[11pt,dina4p,english]{article}', 
     + '\\pagestyle{empty} \\textheight 23.0cm \\textwidth 16.0cm ',
     +                           '\\begin{document} \\footnotesize',
     +                                            '\\end{document}'/
#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IR = 0
      NB = 0
      CALL VZERO(NSUB,200)
      CALL VZERO(NPAR,200)
      CALL VZERO(NFIL,200)
      CALL VFILL(CMENAM,100,'    ') 
      IF(IMOD.EQ.0) THEN
         CALL DDOPEN ('mantab','tex')
         WRITE (LDDEF,'(A)') CSTART(1),CSTART(2),CSTART(3)
      ENDIF 
 10   IR = IR + 1
      IF(IR.GT.NDDEF()) GO TO 100
      IFL = IDDEF_FLAG(IR)
      IF(IFL.EQ.LDDEF_TAB) THEN
         NB= NB + 1
         IF(NB.GT.200) CALL MEERRO('DDTOPS: dimension 200 too small')
      ENDIF
      IF(IFL.EQ.LDDEF_MEN .AND.IQ(HQDDEF_NAM2(IR)).NE.HBLANKSP) THEN
         NM = NM+1
         IF(NM.GT.50) CALL MEERRO('DDTOPS: dimension 50 too small')
         CALL CHHTOC(IQ(HQDDEF_NAME(IR)), CMENAM(NM,1))
         CALL CHHTOC(IQ(HQDDEF_NAM2(IR)), CMENAM(NM,2))
      ENDIF 
      IF(IFL.EQ.LDDEF_FIL) NFIL(NB) = IR
      IF(IFL.EQ.LDDEF_SUB) NSUB(NB) = IR
      IF(IFL.EQ.LDDEF_PAR) NPAR(NB) = IR
      GO TO 10   
 
 100  NB = 0
      DO 200 IR = 1,NDDEF()
      IFL = IDDEF_FLAG(IR)
      IF(IFL .LE. LDDEF_SKP)  GO TO 200
      IF(IFL .EQ. LDDEF_INI)  GO TO 200
      IF(IFL .EQ. LDDEF_TEX)  GO TO 160
      IF(IFL .GE. LDDEF_ATT .AND. IFL .LE. LDDEF_INM)  GO TO 140
      IF(IFL .EQ. LDDEF_TAB)  GO TO 120
      GO TO 200
      
C     Tables
 120  CONTINUE
      IF(NB.NE.0) THEN
         WRITE (LDDEF,'(A)') '\\hline \\end{tabular} \\end{center} ' 
         IF(IMOD.EQ.1) THEN
            WRITE (LDDEF,'(A)') CSTART(4)
            CALL IOCLOS(LDDEF)
            CA = ' '
            CA = 'KUIP/SHELL latex '//BNAME 
            CALL KUEXEC(CA)
            CA = 'KUIP/SHELL dvips '//BNAME 
            CALL KUEXEC(CA)
            CA = 'KUIP/SHELL pstoepsi '//BNAME//'.ps '//BNAME//'.eps' 
            CALL KUEXEC(CA)
      ENDIF
      ENDIF
      NB = NB + 1
      CALL CHHTOC(IQ(HQDDEF_NAME(IR)), BNAME) 
      CALL CHHTOC(IQ(HQDDEF_TEXT(1,IR)),CTEXT)
      CALL CHHTOC(IQ(HQDDEF_NAM2(IR)), CMENU)
      CEXT = '    '
      CALL CSETDI(IDDEF_DIM(IR),CEXT,1,4)
      CNAME = ' '
      IF(NSUB(NB).NE.0) THEN 
         CALL UHTOC (IQ(HQDDEF_NAME(NSUB(NB))),4,CNAME,4)
      ELSEIF(NPAR(NB).NE.0) THEN 
         CALL UHTOC (IQ(HQDDEF_NAME(NPAR(NB))),4,CNAME,4)
      ENDIF
      IF(IMOD.EQ.1) THEN
         CALL DDOPEN (BNAME,'tex')
         WRITE (LDDEF,'(A)') CSTART(1),CSTART(2),CSTART(3)
      ENDIF 
      IF(NSUB(NB).EQ.0.AND.NPAR(NB).EQ.0) THEN   
         WRITE (LDDEF,'(A)') 
     +        '\\begin{center} \\begin{tabular}{|r|l|r|l|l|} \\hline',
     +        '\\multicolumn{5}{|c|}{\\rule[-3mm]{0mm}{8mm}',
     +        '\\bf{'//BNAME//'}:  '// CTEXT(1:LENOCC(CTEXT))//'}\\\\' 
      ELSEIF(NSUB(NB).NE.0) THEN
         WRITE (LDDEF,'(A)') 
     +        '\\begin{center} \\begin{tabular}{|r|l|r|l|l|} \\hline',
     +        '\\multicolumn{5}{|c|}{\\rule[-3mm]{0mm}{8mm}',
     +        '\\bf{'//BNAME//'}:  '// CTEXT(1:LENOCC(CTEXT)) //
     +        ' -  Subtable of ',CNAME(1:lenocc(CNAME)) // '}\\\\' 
      ELSEIF(NPAR(NB).NE.0) THEN
         WRITE (LDDEF,'(A)') 
     +        '\\begin{center} \\begin{tabular}{|r|l|r|l|l|} \\hline',
     +        '\\multicolumn{5}{|c|}{\\rule[-3mm]{0mm}{8mm}',
     +        '\\bf{'//BNAME//'}:  '// CTEXT(1:LENOCC(CTEXT)) //
     +        ' -  parallel table of ',CNAME(1:lenocc(CNAME)) // '}\\\\' 
      ENDIF

      IF(NFIL(NB).NE.0) THEN
         CALL CHHTOC (IQ(HQDDEF_TEXT(1,NFIL(NB))), CTEXT)
         IF(ISCAN(CTEXT,'/').NE.0) NFIL(NB) = 0
      ENDIF
      IF(NFIL(NB).EQ.0) THEN
         WRITE (LDDEF,'(A)') 
     +       '\\multicolumn{5}{|c|}{\\rule[-3mm]{0mm}{8mm}',
     +       'menu: '//CMENU//'      division: ',CDIV(IDDEF_DIV(IR))//
     +       '     extension: '//CEXT//'}\\\\' 
      ELSE
         WRITE (LDDEF,'(A)') 
     +       '\\multicolumn{5}{|c|}{\\rule[-3mm]{0mm}{8mm}',
     +       'menu: '//CMENU//'     division: '//CDIV(IDDEF_DIV(IR))//
     +       '     extension: '//CEXT//
     +       '     IOfiles: '//ctext(1:lenocc(CTEXT))//'}\\\\' 
      ENDIF
      I = IUCOMP(CMENU,CMENAM,NM)
      IF(I.EQ.0) THEN      
         WRITE(LDDEF,'(A)') 
     +  '\\multicolumn{5}{|c|}{\\rule[-3mm]{0mm}{8mm}',
     +  'include files: ( '//BNAME//' or '//CMENU(1:lenocc(CMENU))//
     +  ' ) and ( '//BNAME//'F or '//CMENU(1:lenocc(CMENU))//'F )}\\\\' 
      ELSE
         WRITE(LDDEF,'(A)') 
     +  '\\multicolumn{5}{|c|}{\\rule[-3mm]{0mm}{8mm}',
     +  'include files: ( '//BNAME//' or '//CMENU(1:lenocc(CMENU))//
     +  '  or  '//CMENAM(I,2)//' )  and ('//BNAME//'F or '//
     +   CMENU(1:lenocc(CMENU))//'F or  '//CMENAM(I,2)//' ) }\\\\' 
      ENDIF

      WRITE (LDDEF,'(A)') '\\hline'
      WRITE (LDDEF,'(A)')
     +    'Pos.& Definition  & words & GET-function &PUT-function\\\\'
      WRITE (LDDEF,'(A)') '\\hline'
      ILAST = LDDEF_TAB
      IATT = 0
      GO TO 200

 140  IATT = IATT + 1
      CNAME = ' '
      CALL UHTOC (IQ(HQDDEF_NAME(IR)),4,CNAME,4)
      CALL DDCHPS(CNAME) 
      CTEXT = ' '
      CALL CHHTOC (IQ(HQDDEF_TEXT(1,IR)), CTEXT)
      CALL DDCHPS (CTEXT)
      CALL CHHTOC (IQ(HQDDEF_NAM2(IR)), CF)
      CA = ' '
      CS = ' '     
      IF(IFL.EQ.LDDEF_ATT) THEN 
         IF(CF .EQ. 'I')  THEN
            CA(1:1) = 'I' 
            CS(1:5) = 'IQ(IQ'
         ELSE IF (CF .EQ. 'F') THEN
            CA(1:1) = 'F' 
            CS(1:5) = '  Q(Q'
         ELSE IF (CF .EQ. 'H') THEN
            CA(1:1) = 'H'
            CS(1:5) = 'IQ(HQ'
         ELSE IF (CF .EQ. 'B') THEN
            CA(1:1) = 'B'
            CS(1:5) = 'IQ(BQ'
         END IF
         CA(LENOCC(CA)+1:) = BNAME//'\\_'//CNAME(1:LENOCC(CNAME))
         CA(LENOCC(CA)+1:LENOCC(CA)+4) ='(ir)'
         CS(LENOCC(CS)+1:) = BNAME//'\\_'//CNAME(1:LENOCC(CNAME))
         CS(LENOCC(CS)+1:LENOCC(CS)+5) ='(ir))'
         WRITE (LDDEF,1001)
     +       IATT,ctext(1:LENOCC(CTEXT)),IDDEF_DIM(IR),
     +       CA(1:LENOCC(CA)),CS(1:LENOCC(CS))
 1001 FORMAT(I3,' & ',A,' & ',I3,' & ' ,A,' & ', A ,'\\\\')
         ILAST = LDDEF_ATT
         GO TO 200
      ELSE
         CALL CHHTOC (IQ(HQDDEF_NAM3(IR)), CRELAT) 
         IF(IFL.EQ.LDDEF_RE1) THEN
            CA(1:) = 'O'//BNAME//'\\_'//CNAME(1:LENOCC(CNAME))
            CA(LENOCC(CA)+1:LENOCC(CA)+4) ='(ir)'
            CS(1:) = 'via MMBREL(J'//CRELAT//')'
         ELSE 
            CA(1:) = 'via P/M/X'//BNAME//
     +                            '\\_'//CNAME(1:LENOCC(CNAME))
            CS(1:) = 'via MMBREL(J'//CRELAT//')'  
         ENDIF
         WRITE (LDDEF,1002) IATT,ctext(1:LENOCC(CTEXT)),
     +        CA(1:LENOCC(CA)),CS(1:LENOCC(CS))
 1002 FORMAT(I3,' & ',A,' & ','REL',' & ' ,A,' & ', A ,'\\\\')
         GO TO 200
      ENDIF
 160  IF(ILAST.EQ.LDDEF_ATT) THEN 
         CALL CHHTOC (IQ(HQDDEF_TEXT(1,IR)), CTEXT)
         CALL DDCHPS(CTEXT)
         WRITE (LDDEF,'(A)')' & ',CTEXT(1:LENOCC(CTEXT)),' &  &  &\\\\'  
      ENDIF

 200  CONTINUE
      WRITE (LDDEF,'(A)') '\\hline \\end{tabular} \\end{center} ' 
      WRITE (LDDEF,'(A)') CSTART(4)
      CALL IOCLOS(LDDEF)
      IF(IMOD.EQ.0) THEN
         CALL KUEXEC('KUIP/SHELL latex mantab')
         CALL KUEXEC('KUIP/SHELL dvips mantab')
      ELSE
         CA = ' ' 
         CA = 'KUIP/SHELL latex '//BNAME 
         CALL KUEXEC(CA)
         CA = 'KUIP/SHELL dvips '//BNAME 
         CALL KUEXEC(CA)
         CA = 'KUIP/SHELL pstoepsi '//BNAME//'.ps '//BNAME//'.eps' 
         CALL KUEXEC(CA)
      ENDIF
 999  RETURN
      END

************************************************************************
* End of DDTOPS
************************************************************************
