*CMZ :  2.01/01 29/11/95  11.12.10  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   03/03/95

      SUBROUTINE IOCONC (LUN, CNAM, CZEB, OUTM)

************************************************************************
*
* Description: Concatenate data set CNAM to logical unit LUN.
*              LUN > 0 : append at the end of the concatenation chain
*              LUN < 0 : insert immediately after LUN
*              Does NOT perform any OPEN.
*
* Called from: IO routines
*
* External references: none
*
* Argument in/out description
*   LUN    in     logical unit number (may be < 0; see above)
*   CNAM   in     data set name or comment
*   CZEB   in     IO options for Zebra
*   OUTM   in     maximum number of Mbytes on output files
*
************************************************************************

      IMPLICIT NONE

#include "arte/ZIOCOM.fi"
#include "arte/Arte.fi"

      INTEGER L, LUN
      REAL OUTM
      CHARACTER CNAM*(*), CZEB*(*), CMESS*78

#include "arte/Arte.ff"

      L = ABS(LUN)
      IF (L .LE. 0 .OR. L .GE. 100)  THEN
        CALL MEERRC (55,
     +    'IO: unit number not in the range 1 ... 99')
        GO TO 90
      END IF

      IF (IIOFLG(L) .LE. 0)  THEN
        IIOFLG(L) = 1
        CIONAM(L) = CNAM
        CIOZFL(L) = CZEB
        FIOUTM(L) = OUTM
        GO TO 90
      END IF

      IF (LUN .GT. 0)  THEN
 10       IF (CIONAM(L) .EQ. CNAM)  THEN
          CMESS = 'IO_CONC: file'
          CALL CHAPBC (CMESS, CNAM)
          CALL CHAPBC (CMESS, 'previously concatenated to unit')
          CALL CHAPBI (CMESS, ABS(LUN))
          CALL MEWARC (8735274, CMESS)
        END IF
        IF (IIONXT(L) .EQ. 0)  GO TO 20
        L = IIONXT(L)
        GO TO 10
      END IF

      IF (NIOUSD .EQ. NIOMAX)  THEN
        CALL MEERRC (10,
     +   'IO_CONC: parameter NIOMAX in ZIOCOM is too small')
        GO TO 90
      END IF

 20   NIOUSD = NIOUSD + 1
      IIONXT(NIOUSD) = IIONXT(L)
      IIONXT(L) = NIOUSD
      IIOFLG(NIOUSD) = 1
      CIONAM(NIOUSD) = CNAM
      CIOZFL(NIOUSD) = CZEB
      FIOUTM(NIOUSD) = OUTM

 90   END

************************************************************************
* End of IOCONC
************************************************************************
