*CMZ :  2.01/03 08/02/96  16.12.21  by  Hartwig Albrecht
*CMZ :  2.01/02 28/01/96  16.22.40  by  Hartwig Albrecht
*CMZ :  2.01/01 15/11/95  14.20.07  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   11/07/95

      SUBROUTINE MMIREL (JL)

************************************************************************
*
* Description: invert a relation
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   JL     in     link to the relation bank
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL(1), IL, IPOS, JSUP, K1, K2, LOCF
      CHARACTER CNAME*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      JSUP(I_R) = JLINK(IMEMO_SUP(I_R,IL))
      IPOS(I_R) = IMEMO_POS(I_R,IL)

      IL = LOCF (JL) - LARLN1

C check if JL is a correct Zebra link

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  GO TO 580

C check if JL refers to a relation

      IF (IMEMO_FLAG(IL) .LE. 0)  GO TO 570

      IF (JSUP(1) .EQ. 0 .OR. JSUP(2) .EQ. 0)  GO TO 900
      IF (IMEMO_FLAG(IL) .EQ. 1)  GO TO 100

C relation bank already existing ?

      IF (JL(1) .EQ. 0)  THEN
        IQ(IQMEMO_NWRD(IL)) = 2
        CALL MZLIFT (IMEMO_DIV(IL), JLINK(IL), 0, 2,
     +    IQ(HQMEMO_NAME(IL)), 0)
        IQ(JLINK(IL)+1) = IMEMO_COL(IL)
        IQ(JLINK(IL)+2) = 0

      ELSE
        IF (IQ(JL(1)+1) .NE. 2 .AND. IQ(JL(1)+1) .NE. 4)  GO TO 540
        IF (IMEMO_FLAG(IL) .EQ. 4)  GO TO 400
        IF (IQ(JL(1)+2) .NE. 0)  GO TO 550

      END IF

      GO TO (100,200,300,900), IMEMO_FLAG(IL)

 100  DO 110 K2 = 1, N_U(JSUP(2))
        K1 = I_V(IPOS(2),K2,JSUP(2))
        IF (K1 .EQ. 0)  GO TO 110
        IF (K1 .LT. 0 .OR. K1 .GT. N_U(JSUP(1)))  GO TO 530
        IF (IQ(L_A(IPOS(1),K1,JSUP(1))) .NE. 0)  THEN
          IF (IQ(L_A(IPOS(1),K1,JSUP(1))) .NE. K1)  GO TO 560
          CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
          CALL MEMESC (923445, 20, ILARGEST,
     +      'MMIREL: relation '//CNAME//' has already been set')
        END IF
        IQ(L_A(IPOS(1),K1,JSUP(1))) = K2
 110  CONTINUE
      GO TO 900

 200  DO K2 = 1, N_U(JSUP(1))
        IQ(L_A(IPOS(1),K2,JSUP(1))) = 0
      ENDDO 

      DO 210 K2 = 1, N_U(JSUP(2))
        K1 = I_V(IPOS(2),K2,JSUP(2))
        IF (K1 .EQ. 0)  GO TO 210
        IF (K1 .LT. 0 .OR. K1 .GT. N_U(JSUP(1)))  GO TO 530
        IF (N_F(JL(1)) .EQ. 0)  CALL MZPUSH (IMEMO_DIV(IL), JL, 0,
     +     2 * (IMEMO_EXT(IL) + 1), ' ')
        IQ(JL(1)+2) = IQ(JL(1)+2) + 1
        IQ(L_L(1,JL(1))) = K2
        IQ(L_L(2,JL(1))) = I_V(IPOS(1),K1,JSUP(1))
        IQ(L_A(IPOS(1),K1,JSUP(1))) = N_U(JL(1))
 210  CONTINUE
      GO TO 900

 300  CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL MEERRC (834244,
     +   'MMIREL: relation '//cname//': many to one not supported')
      GO TO 900

 400  IF (JL(1) .EQ. 0)  GO TO 900
      CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL MEMESC (9346435, 1, ILARGEST,
     +   'MMIREL: relation '//cname//': many to many not yet supported')
      GO TO 900

 530  CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL MEERRC (863445,
     +   'MMIREL: relation '//cname//' points to an invalid row number')
      GO TO 900

 540  CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL MEERRC (534634,
     +   'MMIREL: relation '//cname//' has a wrong number of columns')
      GO TO 900

 550  CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL MEERRC (534634,
     +   'MMIREL: relation '//cname//' has already been set')
      GO TO 900

 560  CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL MEERRC (634534,
     +   'MMIREL: relation '//cname//': one-to-... already established')
      GO TO 900

 570  CALL MEERRC (8234645,
     +   'MMIREL: link JL is not a relation')
      GO TO 900

 580  CALL MEERRC (945645,
     +  'MMIREL: link JL not inside link area')

 900  END

************************************************************************
* End of MMIREL
************************************************************************
