*CMZ :  2.01/02 30/01/96  15.23.35  by  Hartwig Albrecht
*CMZ :  2.01/01 20/06/95  13.34.06  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE MMTFIL (JL, CIO)

************************************************************************
*
* Description: handle input/output bits for tables
*
* Called from: ARBANK etc.
*
* External references:
*
* Argument in/out description
* JL       in     link
* CIO      in     'INPUT'  accept input on any file
*                 '/INPUT' skip on input files
*                 The following names refer to symbolic file names:
*                 'DST'    DST output
*                 '/DST'   no output on DST
*                 'GEOM'   geometry output file
*                 '/GEOM'  no output on GEOM
*                 concatenate several options with blanksor commas,
*                 e.g. 'DST /INPUT,GEOM , /ABC'
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZMMCOM.fi"
#include "auto/MEMO.fi"
#include "arte/ZIOCOM.fi"

#ifdef _LINUX_
      INTEGER IOR
#endif
      INTEGER JL, I, IB, IL, IX, INOT, IBIT, LOCF
      CHARACTER CIO*(*),CSYM*(NIOSMX)

#include "arte/Arte.ff"
#include "auto/MEMO.ff"


      IX = LOCF(JL)

      IF (IX .LE. LARLN1 .OR. IX .GT. LARLNL)  THEN
        CALL MEERRC (534872, 'MMTFIL: Zebra link outside link area')
        GO TO 90
      END IF
      IX = IX - LARLN1

C parse CIO

      I = 0
      INOT = 0
 10   CALL CHWORD (CIO, '/,', I, IB, IL)
      IF (IL .EQ. 0)  GO TO 40
      IF (CIO(IB:IL) .EQ. '/')  THEN
        INOT = 1
      ELSE IF (CIO(IB:IL) .NE. ',')  THEN
        CSYM = CIO(IB:IL)
        CALL CLTOU (CSYM)
        IF (CSYM .EQ. 'INPUT')  THEN
          IBIT = 1
        ELSE IF (CSYM .EQ. 'OUTPUT')  THEN
          IBIT = 2
        ELSE
          DO 20 IBIT = 3, NMMLUN
 20       IF (CSYM .EQ. CIOSYM(IMMLUN(IBIT)))  GO TO 30
          IF (NMMLUN .EQ. 32)  THEN
            CALL MEERRC (396745,
     +    'MMTFIL: 30 Zebra input/output units requested - too many')
            GO TO 90
          END IF
          NMMLUN = NMMLUN + 1
          IBIT = NMMLUN
          CALL IOFIND (CSYM, IMMLUN(IBIT))
          IIOBIT(IMMLUN(IBIT)) = NMMLUN
        END IF
 30     IF (INOT .EQ. 0)  THEN
          IQ(BQMEMO_IOD(IX)) = IOR (BMEMO_IOD(IX), BIT(IBIT))
        ELSE
          IQ(BQMEMO_IOD(IX)) = IAND (BMEMO_IOD(IX), NOT(BIT(IBIT)))
          INOT = 0
        END IF
      END IF

      I = IL
      GO TO 10

 40   DO 50 I=1,NARLNK
 50   IQ(BQMEMO_IOA(I)) = BMEMO_IOD(I)

 60   IL = 0
      DO 70 I = 1, NARLNK
        IB = BMEMO_IOA(I)
        IF (IMEMO_SUP(1,I) .NE. 0)  THEN
          IB = IAND (IB, BMEMO_IOA(IMEMO_SUP(1,I)))
        END IF
        IF (IMEMO_SUP(2,I) .NE. 0)
     +    IB = IAND (IB, BMEMO_IOA(IMEMO_SUP(2,I)))
        IF (BMEMO_IOA(I) .NE. IB)  IL = 1
        IQ(BQMEMO_IOA(I)) = IB
 70   CONTINUE
      IF (IL .NE. 0)  GO TO 60

 90   END

************************************************************************
* End of MMTFIL
************************************************************************
