//                              -*- Mode: C++ -*-
//:CareData.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 29/4/97
// Last Update ........
//

#include "care/caredata.hh"
#ifdef __xlC__
#include <vector.h>
#else
#include <vector>
#endif
#include "care/ECBuilder.hh"
#include "care/EMCluster.hh"
#include "auto/HITC.hh"
#include "auto/MVEX.hh"
#include "auto/MCME.hh"
#include "auto/MTMT.hh" 

// In this file there are all the global static data of the
// ECAL reconstruction

////////////////// Data storage for CARE
// constructors for ECAL_Info structure
ECAL_Info::ECAL_Info(){}
ECAL_Info::ECAL_Info(ArteTableIterator<GESL> ec, int nX, int nY,
		     Coord_t x, Coord_t y, Coord_t  xMsz, Coord_t yMsz,  
		     bool in) :
  ecalp(ec), nModX(nX), nModY(nY), x0(x), y0(y),  xMsize(xMsz), 
  yMsize(yMsz), init(in) {}

  

ECAL_Info ECalInfo(1,  // Ecal Pointer to GESL table
                  56, // Number of modules in X direction
                  42, // Number of modules in Y direction
                  0.0, 0.0,   // Center of ECAL
                  0.0, 0.0,   // Modules size
                  false);     // Care initialized or not



