//                              -*- Mode: C++ -*-
//: CmdCareLevel.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "care/CmdCareLevel.hh"
#include "care/ESCorCOGPos.hh"
#include "arte/ArteMessage.hh"

/////////////// The function seen by kuip

extern "C" {
  void carelevel_(){
    CmdCareLevel levCmd;
    levCmd.readAndExe();
  }
}; // end of extern
//////////////////////////////////////////////////////////


/*
CLASS
  CmdCareLevel
  Base class to deal with the Level kuip command
};

*/

unsigned int CmdCareLevel::triglevel = 5;
unsigned int CmdCareLevel::numOfCells = 6000;

CmdCareLevel::CmdCareLevel(){}

CmdCareLevel::~CmdCareLevel(){}

void CmdCareLevel::defValues(){
  triglevel = 5;
  numOfCells = 6000;
}

//--
//   Execute stored command
void CmdCareLevel::execute(){}


#ifdef USEKUIP
//--
//   Read a command from external
void CmdCareLevel::read(){
  triglevel = readInt();
  unsigned int numcell = readInt();
  if( triglevel>1 && numcell>10){
    numOfCells = numcell;
  }
}
#endif
                          
//--
//   Printout Information for the current lambda info stored
void CmdCareLevel::dump(){
  arteMsg<<" Trigger Level :"<<level()
	 <<"  Max number of clustered cells : "<<ncells();
  arteMsg.allp();
}


