//                              -*- Mode: C++ -*-
//:ECDcalIO.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 9/4/97
// Last Update ........
//

#include "care/ECDcalIO.hh"


/*
CLASS
  ECDcalIO


class ECDcalIO {
public:
  // Constructors
  //--
  // Default constructor
  ECdcalIO();
  //
  //--
  //  Start operations
  void start();
  //
  //-- 
  //  Write to DCAL
  ECDcalIO & operator << (unsigned short value);
  //-- 
  //  Read from DCAL
  ECDcalIO & operator >> (unsigned short & value);


private:
  //--
  // Pointer to dcal
  ArtePointer<DCAL> dcal;
  //--
  // pointer to the half word
  int  hfwd;
  // -- 
  //
  union  DCALEntry {
    unsigned  bits;
    unsigned short hfw[2];
  };
};
*/

// -------------------------------
ECDcalIO::ECDcalIO() :  dcal(1), hfwd(0), nrows(0) , current(0){}

void ECDcalIO::start(){
  dcal = 1;
  hfwd = 0;
  nrows = ArtePointer<DCAL>::nrow()*2;
  current = 0;
}

//
//-- 
//  Write to DCAL
ECDcalIO & ECDcalIO::operator << (unsigned short value){
  
  if( hfwd==0 ){  // write the first short
    DCAL Edcal;
    entry.hfw[0] = value;
    entry.hfw[1] = 0;
    Edcal.bits = entry.bits;
    ArtePointer<DCAL>::append(Edcal);
    dcal = ArtePointer<DCAL>::nrow();
    hfwd = 1;
  } else {
    entry.bits = dcal->bits;
    entry.hfw[1] = value;
    dcal->bits = entry.bits;
    hfwd = 0;
  }
  return *this;
}
/*
//
//-- 
//  Read from DCAL
ECDcalIO & ECDcalIO::operator >> (unsigned short & value){
  // if( dcal.index()!=0 && dcal.index()<=nrows) {
    entry.bits = dcal->bits;  // get the bits
    value = entry.hfw[hfwd];  // get the value
    if( hfwd==1 ){  // point to the next DCAL entry
      dcal = dcal.index()+1;
    }
    hfwd = 1-hfwd;   // flip between 1 and 0
    // } else {
    //value = 0;
    //  } 
  return *this;
}

 //--
  //  Test if pointers are still valid
int ECDcalIO::valid() const{  
  int entr = (nrows+1-dcal.index())*2- hfwd;
  if(dcal.index()==0 && (hfwd & 0xFFFE) != 0)
    entr = 0;
  return entr;
}
*/
