//                              -*- Mode: C++ -*-
//:ELNearHitCellFrac.C
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 27/5/97
// Last Update ........
//
//

#include"care/ELNearHitCellFrac.hh"
#include "care/EMClusterTree.hh"
#include "care/EMHitCell.hh"
#include "care/ELLUTsManager.hh"
#include "arte/Arte.hh"
#include "care/ELNearNeiCellLUT.hh"
#include "auto/HITC.hh"
#include "auto/MVEX.hh"
#include "auto/MCME.hh"
#include "auto/MTMT.hh"
#undef WRITE

/*
CLASS 
  ELNearHitCellFrac

*/

///////////////// ELNearHitCellFrac.C member function definitions ////////
//--
//  constructor
ELNearHitCellFrac::ELNearHitCellFrac(){}
//--
//  destructor
ELNearHitCellFrac::~ELNearHitCellFrac(){}


//--
//--
//  Get the neibours of a given cell
void ELNearHitCellFrac::of(const EMHitCell* hcell, const EMClusterTree & tree){
  //--
  // find the index of the cell pointed by the current cell
  of(hcell->cellIdx(), tree);
}

//--
//  Get neibouring cells of a given cell
void ELNearHitCellFrac::of(CellIdx_t cell, const EMClusterTree & tree){

  // get the neighboring cell array
  ELNearHitCells::of(cell, tree);
  //
  // sum the energies of the nearby cells
  Energy_t sum = 0.0;
  for(unsigned int i = 0;  i<howMany(); i++){
    fractions[i] = neibCells[i]->energy();
    sum += fractions[i];
  }
  if( sum>0.0 ){
    for(unsigned int i = 0; i<howMany(); i++){
      fractions[i] = fractions[i]/sum;
    }
  }
  begin();
}
