//                              -*- Mode: C++ -*-
//: CmdCareCalerr.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCARECALERR_HH_
#define CMDCARECALERR_HH_

#include "care/CmdBase.hh" 




/*
CLASS
  CmdCareCalerr
  Class to deal with the care/prec kuip command
  Set the precision of ECAL calibration.
*/

class CmdCareCalerr : public CmdBase {
public:
  //-- Constructors
  CmdCareCalerr();
  //-- Destructor
  // Destructor: currently void
  virtual ~CmdCareCalerr();
  
  //-- Behavioural operations
  //   Reset stored data to default values
  virtual void defValues();
  //--
  //   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  //   Read acommand from external
  virtual void read();
# endif
  //--
  //   Dump internal data
  virtual void dump();
  //--
  //   Static access member function
  float factor();

private:
  ///////////////////// Data Part /////////////////////////////////
  //--
  static  float precision;
};

#endif  //   CMDCARECALERR_HH_

