//                              -*- Mode: C++ -*-
//: CmdCareMerger.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCAREMERGER_HH_
#define CMDCAREMERGER_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"

/*
CLASS
  CmdCareMerger
  Class to deal with the Merger kuip command
*/

class CmdCareMerger : public CmdBase {
public:
  //-- Constructors
  CmdCareMerger();
  //-- Destructor
  // Destructor: currently void
  virtual ~CmdCareMerger();
  
  //-- Behavioural operations
  //   Reset stored data to default values
  virtual void defValues();
  //--
  //   Execute stored command
  virtual void execute();
# ifdef USEKUIP
  //--
  //   Read acommand from external
  virtual void read();
# endif
  //--
  //   Dump internal data
  virtual void dump();

private:
  ///////////////////// Data Part /////////////////////////////////
  //--
  Energy_t  minimum,valley;
};

#endif  //   CMDCAREMERGER_HH_
