// CmdCarePid04.hh
//
// ECAL group 
// HERA-B experiment, Desy
// e-mail: spighi@bo.infn.it
//
// Created 1/9/97
// Last Update ........
//

#ifndef CMDCAREPID04_HH_
#define CMDCAREPID04_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"
#include "care/ESPID04.hh"


/*
CLASS
  CmdCarePid04par
  Class to deal with the CAREPID04PAR kuip command
*/

class CmdCarePid04par : public CmdBase {
public:
  //-- Constructors
  CmdCarePid04par();
  //-- Destructor
  // Destructor: currently void
  virtual ~CmdCarePid04par();
  
  //-- Behavioural operations
  //   Reset stored data to default values
  virtual void defValues();
  //--
  //   Execute stored command
  virtual void execute();
# ifdef USEKUIP
  //--
  //   Read acommand from external
  virtual void read();
# endif
  //--
  //   Dump internal data
  virtual void dump();

private:
  ///////////////////// Data Part /////////////////////////////////
  //--
  int  cal;
  int particle;
  float like04[9];
};

#endif  //  CMDCAREPID04_HH_












