//                              -*- Mode: C++ -*-
//: ECMCDeposit.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 13/10/97
// Last Update ........
//

#ifndef ECMCDEPOSIT_HH_
#define ECMCDEPOSIT_HH_

#include "care/ECALtypes.hh"
#include "arte/Arte.hh"
#include "auto/TOPX.hh"
#include "auto/MTRA.hh"

/**
class  ECMCDeposit.
  Class to find the monte carlo particle that contributes the most to
  the energy released in a cluster.
*/


/// The structure to save the MC information on energy deposits.
class ECMCDeposit {
public:
  /// general constructors
  inline ECMCDeposit();
  inline ECMCDeposit(ArtePointer<MTRA> tra,  Energy_t  en);
  inline ~ECMCDeposit();
  /// to test a track
  inline const ArtePointer<MTRA> & track() const;

  /// to get the energy
  inline Energy_t energy() const;

  /// to add another energy deposit
  inline const ECMCDeposit & operator += (const ECMCDeposit & dep);

private:
  ArtePointer<MTRA> _track;
  Energy_t Energy;

};
#include "care/ECMCDeposit.icc"
#endif // ECMCDeposit
