/*
*************************************************************************
**
** Description: Arte: Error reaction for "Cebra Memory Package"
**                    and initialization function.
**
** Language:	C
**
** Called from: CM package.
**
** Created: 	23 Sep 97
** Updated:	11 May 98
**
** Author:  	Sergey Moukhine
**          	HERA-B Collaboration
**          	JINR-Dubna
**          	Russia
**
*************************************************************************
*/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "cmbook.h"

/*DEBUG
#include <mecCount.h>
*/

void cmArteError(int *errPtr, char *mess);
void cmarteinit_(int *iq);


void cmarteinit_(int *iq)
{
cmSetError(cmArteError);
cminit_(iq);
}


void cmArteError(int *errPtr, char *mess)
{
int id;
int iflag;

mecWarningCount (errPtr, mess);

id = 777;
iflag = 1;
switch (*errPtr)
  {
    case 1:
      /* not enought memory */
      iflag = 1;
      break;
	
    case 2:
      /* CM-package tables are broken?: call to %s" */
      iflag = 3;
      break;
        
    case 3:
      /* CMINIT called twice */
      iflag = 3;
      break;
	
    case 4:
      /* operations before initialization */
      iflag = 3;
      break;
	
    case 5:
      /* bank at NID=%d has a wrong structure */
      iflag = 1;
      break;
	
    case 6:
      /* wrong parameters */
      iflag = 1;
      break;
	
    case 7:
      /* bank at NID=%d does not exist */
      iflag = 1;
      break;
	
    default:
      /* unknown CM-package error */
      iflag = 1;
  }
    
ztell_(&id, &iflag);

}
