#include "arte/Arte.h"
#include "auto/MEMO.h"
#include "database/Lists.h"
#include "database/DbLists.h"
#include "database/DbUtils.h"

char *ku_gets(void);
char *ku_getc(void);
int ku_geti(void);
static List(DbTables) *LastTable;

void dbopenact_(void) {

  char *Name;
  char *Csym;

  Csym = ku_gets();
  Name = ku_gets();

  DbOpen( Csym, Name );

  return;
}

void dbcloseact_(void) {

  char *Csym;

  Csym = ku_gets();

  DbClose( Csym );

  return;
}

void dbtableact_(void) {

  char *Name;
  char *Comm;
  char mess[80];
  List(DbTables) T;

  Name = ku_gets();
  Comm = ku_gets();

  strcpy( T.Name, Name );
  strcpy( T.Comm, Comm );
  strcpy(T.Fmt,"I:NROWS-FIELD ");
  T.Entries = 0;
  LastTable = ListAdd( DbTables, &T );
  return;
}

void dbattribact_(void) {

  char *Name,*Form,AsciiDim[4],Mform[3];
  int Dim,n;

  Name = ku_gets();
  Form = ku_getc();
  Dim  = ku_geti();

  switch(*Form) {
  case 'I':
    strcpy( Mform, "I" );
    break;
  case 'F':
    strcpy( Mform, "F" );
    break;
  case 'B':
  case 'H':
    strcpy( Mform, "UI" );
    break;
  default:
    break;
  }
  if( Dim == 0 ) {
    strcat( LastTable->Fmt, Mform );
    strcat( LastTable->Fmt, ":");
    strcat( LastTable->Fmt, Name);
    strcat( LastTable->Fmt, " ");
  }
  else {
    for( n = 1 ; n <= Dim ; n++ ) {
      strcat( LastTable->Fmt, Mform );
      strcat( LastTable->Fmt, ":" );
      strcat( LastTable->Fmt, Name );
      strcat( LastTable->Fmt, "-" );
      sprintf( AsciiDim,"%d", n );
      strcat( LastTable->Fmt, AsciiDim );
      strcat( LastTable->Fmt, " " );
    }
  }
  LastTable->Type[ LastTable->Entries ] = *Form;
  LastTable->Dim [ LastTable->Entries ] = Dim;
  LastTable->Entries++;
  return;
}

void dbwriteact_(void) {

  char *Csym, *Name, mess[80]="DBWRITEACT: ";
  int Major, Minor, n, nlink;

  Csym   =  ku_gets();
  Name   =  ku_gets();
  Major  =  ku_geti();
  Minor  =  ku_geti();

  ToUpper( Name, strlen(Name) );

  /* Look for bank name in MEMO bank. */

  for( n = 1, nlink = 0 ; n <= NMEMO() ; n++ ) {
    if( strncmp( Name, MEMO(n).NAME, (size_t)4 ) == 0 ) {
      nlink = n; 
      break; 
    } 
  }

  if( nlink == 0 ) {
    strcat( mess, "bank " );
    strcat( mess, Name );
    strcat( mess, " not booked in MEMO bank" );
    meerrc_( "45f", mess, strlen(mess) );
    return;
  }

  DbWriteHeader( Csym, (int *)((artelink_.larln1 + nlink) * 4), 
		 Major, Minor );

  return;
}

void dbreadact_(void) {

  char *Csym, *Name, mess[128]="DBREADACT: ";
  int Major, Minor, n, nlink;

  Csym   =  ku_gets();
  Name   =  ku_gets();
  Major  =  ku_geti();
  Minor  =  ku_geti();

  ToUpper( Name, strlen(Name) );

  /* Look for Bank name in MEMO bank. */

  for( n = 1, nlink = 0 ; n <= NMEMO() ; n++ ) {
    if( strncmp( Name, MEMO(n).NAME, (size_t)4 ) == 0 ) {
      nlink = n; 
      break; 
    } 
  }

  if( nlink == 0 ) {
    strcat( mess, "bank " );
    strcat( mess, Name );
    strcat( mess, " not booked in MEMO bank" );
    meerrc_( "][s", mess, strlen(mess) );
    return;
  }

  DbReadHeader( Csym, (int *)((artelink_.larln1 + nlink) * 4), 
		Major, Minor );

  return;
}

void dbltabact_(void) {

  char *Name, *Csym, mess[80]="DBLTABACT: ";
  int Major, Minor;
  int n, nlink;

  Csym   =  ku_gets();
  Name   =  ku_gets();
  Major  =  ku_geti();
  Minor  =  ku_geti();

  ToUpper( Name, strlen(Name) );

  /* Look for Bank name in MEMO bank. */

  for( n = 1, nlink = 0 ; n <= NMEMO() ; n++ ) {
    if( strncmp( Name, MEMO(n).NAME, (size_t)4 ) == 0 ) {
      nlink = n; 
      break; 
    } 
  }

  if( nlink == 0 ) {
    strcat( mess, "bank " );
    strcat( mess, Name );
    strcat( mess, " not booked in MEMO bank" );
    meerrc_( "sd=", mess, strlen(mess) );
    return;
  }

  DbListTable( Csym, (int *)((artelink_.larln1 + nlink) * 4), 
	       Major, Minor );

  return;
}

void dblfilact_(void) {
  char *Csym;

  Csym   =  ku_gets();

  DbListFile( Csym );

  return;
}
