#ifndef _LISTS_H_
#   define _LISTS_H_

#   include <sys/types.h>
typedef struct { 
  void *__first; 
  void *__last; 
  int __entries; 
  char *__name ; 
  size_t __size; 
  void *__mother; 
} __Base;

typedef struct { 
  void *__prev; 
  void *__next;
} __Links;

typedef struct { 
  void *__first;
  void *__iter;
} ListIterator;

#   ifdef __I_N_I_T__
#      define ListDeclare(__Name__,__Body)\
              struct __Name__ {\
		__Links __links;\
		__Body\
	      };\
              struct {\
		__Base __base;\
		__Body\
	      } __Name__[1]=\
                {0,0,0,"__Name__",sizeof(struct __Name__),0}
#   else
#      define ListDeclare(__Name__,__Body)\
	      struct __Name__{\
		__Links __links;\
		__Body\
	      };\
              extern struct {\
		__Base __base;\
		__Body\
	      } __Name__[1]
#   endif

#   define List(__Name__) struct __Name__

#   define ListFifoPush(__Arg1__,__Arg2__) ListAdd(__Arg1__,__Arg2__)
#   define ListFifoPop(__Arg__) (((__Base *) __Arg__ ->__first))
#   define ListLifoifoPush(__Arg1__,__Arg2__) ListAdd(__Arg1__,__Arg2__)
#   define ListLifoPop(__Arg__) (((__Base *) __Arg__ ->__last)
#   define ListCount(__Arg__) (((__Base *) __Arg__ ->__entries)
#   define ListMore(__Arg__) (__Arg__ .__first!=0 && __Arg__ .__iter!=0)
#   define ListCurrent(__Arg__) ((__Arg__ .__first==0) ? 0 : (__Arg__ .__iter))
#   define ListNext(__Arg__) (__Arg__ \
			.__iter=((__Links *) __Arg__ .__iter)->__next)

int ListInit(void *,char);
void *ListAdd(void *,void *);
int ListRemove(void *,void *);
void *ListAlloc(void *,void *);
int ListDrop(void *);
int ListWipe(char);
int ListClear(void);
ListIterator ListReset(void *);
int ListPrint();
void *ListSearchF();
void *ListSearchS();

ListDeclare (Mother_list,
	     __Base *pointer;
	     char type;
	    );

#endif




