//                              -*- Mode: C++ -*-
//:dgcalche.C
// 
//:description - ADC CHANNEL -> ENERGY CONVERSION
//
// Author: Benedetto Giacobbe   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: giacobbe@bo.infn.it
//
// Created 26/7/97
// Last Update ........
//

//#include <stdlib.h>
#include <math.h>
#include "arte/Arte.hh"
#include "care/dgcal.hh"
#include "auto/ECA.hh"

float dgcalche(int idcell, int ich){
    
  ArtePointer<ECHC> echc(idcell);      
  float ch = (float)(ich)-echc->ped2;
  float q_rec =  echc->pcal[0];
  float ch_red = ch/4095.;
  float ch_redpow = ch_red;
//  float q_mips =  echc->pcal[0];
//  float mipch_red = echc->mip/4095.;
//  float mipch_redpow = mipch_red;
    
  for(int i=1;i<6;i++){
    q_rec += echc->pcal[i]*ch_redpow;
    ch_redpow *= ch_red;
//    q_mips += echc->pcal[i]*mipch_redpow;
//    mipch_redpow *= mipch_red;
    }
  
  float en_rec = q_rec*echc->chmi;   
  //cout<<"Channel: "<<ich<<" Q: "<<echc->chmi<<"  Energy: "<<en_rec<<endl;
  return en_rec;
}

