C************************************************************
      SUBROUTINE DGSIL(IPL)
************************************************************************
*
* DGSIL
* written by Siegmund Nowak
*
* This routines transforms the MIMPs in the silicon into the digit
* and hit structures DIGB / HITB foreseen in the reconstruction program
*
*       called from DGEVNT
*
************************************************************************
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"
C
      INTEGER NHITDE,NMIM,NDIGDE,NWIRPL,LAYER,IFMIMP,MAX,NN,NN1
      INTEGER I,J,K,IH,N,NT,IPL,IFLAG,ISTRIP,MULTI,NMX_MERG,ID,IP
      REAL WIRED,COSX,SINX,ALPHA,XT,YT,ZWIR,DELTAZ,RNDM,X
      REAL PROBEX(4),PR13,DIGLIM
      REAL CHG,PADH(4),DELT,SIG,XHIT,EXPR,DOD,SUM,SUM2,F
      LOGICAL LBIGR

      INTEGER MXHIT,MXDIG,IWIR,IND0,IND1,IXMIMP,IDIGX,IDGOR,IND2,IDUMMY
      REAL XMIMP,DIGX,HTOR,DGOR,WIR,XTT,YTT,XMPL,YMPL
      PARAMETER (MXHIT=200,MXDIG=400)
      COMMON /WRKSP1/ IWIR(2000,2),XMIMP(MXHIT),IXMIMP(MXHIT),
     +                DIGX(8,MXDIG),HTOR(MXHIT),DGOR(MXDIG),IND0(MXHIT),
     +                IND1(MXDIG),IND2(MXHIT),IDUMMY(300)
      DIMENSION IDIGX(8,MXHIT),IDGOR(MXHIT),WIR(2000,2)
      EQUIVALENCE (DIGX,IDIGX),(IDGOR,DGOR),(WIR,IWIR)

      DATA     PROBEX /0.23, 0.5, 0.22, .05/, NMX_MERG/20/
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"

      
c     check whether there are mimps and if so give out the region in JMIMP

      DO 100 IP = 1,2
      IF(IP.eq.1) THEN 
      NMIM = 0
      IFMIMP  = IGEPT_MIM1(IPL)
      IF(IFMIMP.NE.0) NMIM  = IGEPT_MIML(IPL) - IFMIMP + 1
      IF(NMIM.LE.0) GO TO 998
      IF(NMIM.GT.MXHIT) THEN
         C78 = 'DGSIL: NMIM > MAXHIT for IPL '
         CALL CH78AI(NMIM)
         CALL CH78AC(' for ')
         CALL CH78AI(IPL)
         CALL ME78WC(18282800)
         NMIM = MXHIT
      ENDIF
      ENDIF


      WIRED = FGEDE_PIT(IPL)    ! pitch of the chambers
      COSX  = FGEDE_COS(IPL)    ! cosine of the strip angle
      SINX  = FGEDE_SIN(IPL)    ! sine of the strip angle
      LAYER = IGEDE_LAY(IPL)    ! Layer number in the detector
      DOD   = FGEDE_DOD(IPL)    ! double hit resolution
      ZWIR =  FGEDE_ZFW(1,IPL)  ! Z-position of the first wire -
      NWIRPL= IGEDE_NWI(1,IPL)  ! number of wires in that plane
      XMPL  = 0.5*(FGEDE_SXMN(IPL)+FGEDE_SXMX(IPL))
      YMPL  = 0.5*(FGEDE_SYMN(IPL)+FGEDE_SYMX(IPL))
      DELT = 0.5*WIRED

c     check whether sorting of hits should be increasing or decresing
      LBIGR = .FALSE.
      IF(LAYER.EQ.1.OR.LAYER.EQ.3) THEN
         IF(ABS(FGEDE_XMAX(IPL)).LE.ABS(FGEDE_XMIN(IPL))) LBIGR = .TRUE.
      ELSE IF(LAYER.EQ.2.OR.LAYER.EQ.4) THEN
         IF(ABS(FGEDE_YMAX(IPL)).LE.ABS(FGEDE_YMIN(IPL))) LBIGR = .TRUE.
      ENDIF

      PR13 = PROBEX(1)+PROBEX(3)

C*    the first loop over the mimps - check whether the mimps are really
C*    inside the elementary detector, transform  coordinates
      DO 10 I=1,NMIM
      IH = I+IFMIMP-1
      IXMIMP(I) = IH
      DELTAZ = ZWIR - FMIMP_Z(IH)
      XT = FMIMP_X(IH) + FMIMP_TX(IH) * DELTAZ          !swim into the
      YT = FMIMP_Y(IH) + FMIMP_TY(IH) * DELTAZ          !wire plan
      ALPHA = SQRT(FMIMP_TX(IH)**2 + FMIMP_TY(IH)**2)
      XTT = FGEDE_ROT(1,IPL) *XT + FGEDE_ROT(4,IPL)*YT
      YTT = FGEDE_ROT(2,IPL) *XT + FGEDE_ROT(5,IPL)*YT
      XMIMP(I) = FGEDE_COS(IPL)*XTT - FGEDE_SIN(IPL)*YTT
      CALL GRNDM(RNDM,1)
      IF(RNDM.GT.FGEDE_EFF(IPL)) THEN
         IXMIMP(I) = 0
         XMIMP(I) = -100000.
         IF(LBIGR) XMIMP(I) = 100000.
      ENDIF
      HTOR(I) = XMIMP(I)                               !for sorting only
   10 CONTINUE

C--   sort the hits matrix due to increasing x/y and fill vector digx
      IF(LBIGR) THEN
         CALL SORTZV(HTOR,IND0,NMIM,1,0,0)
      ELSE
         CALL SORTZV(HTOR,IND0,NMIM,1,1,0)
      ENDIF

C*  the second loop over the XMIMP fills the data structures ZDIGB

      NDIGDE = 0
      CALL VZERO(IWIR(1,2),2000)

      DO 20 IH=1,NMIM
      I = IND0(IH)
      ID = IXMIMP(I)
      IF(ID.EQ.0) GO TO 20
C     find out into which strip interval the MIMP is going

      XT = XMIMP(I) - (FGEDE_XFW(1,IPL) - DELT)
      IF(XT.GE.-DELT) THEN
        NT = INT(XT/WIRED) + 1
        IF(NT.GT.NWIRPL) THEN
           IXMIMP(I) = 0
           GO TO 20
        ENDIF    
       ELSE
        IXMIMP(I) = 0
        GO TO 20
      ENDIF

C*    distribute the charge over neighbouring strips intervals
C     here a strip interval ranges from -delt to +delt around strip position

      CALL VZERO(IWIR(MAX0(NT-2,1),1),5)
      CHG = 1.
      XHIT = XT - (NT-.5)*WIRED  !exact position of MIMP in the strip interval
      CALL GRNDM(RNDM,1)
      IF(ABS(XHIT).LT.DELT*PR13) THEN
C         MIMP is likely to lie around the center of a strip interval
C         decide whether the hit multiplicity will be 1 or 3
         IF(RNDM.LE.PROBEX(1)/PR13) THEN
            MULTI = 1
            PADH(1) = CHG        ! full charge in this interval
            ISTRIP = NT
         ELSE
            MULTI = 3
            ISTRIP = NT - 1
            SIG = .424 * WIRED
         ENDIF
      ELSE
C         MIMP is likely to lie around the boundary of a strip interval
C         decide whether the multiplicity will be 2 or 4
         IF(RNDM.LE.PROBEX(2)/(1.-PR13)) THEN
            MULTI = 2
            IF(XHIT.LE.0.) THEN
               ISTRIP = NT-1
               PADH(2) = 0.5 * CHG * (2.-PR13- ABS(XHIT)/DELT)/(1-PR13)
               PADH(1) = CHG - PADH(2)    !charge is divided between 1/2
            ELSE
               ISTRIP = NT
               PADH(1) = 0.5 * CHG * (2.-PR13- ABS(XHIT)/DELT)/(1-PR13)
               PADH(2) = CHG - PADH(1)
            ENDIF
         ELSE
            MULTI = 4
            ISTRIP = NT-1
            IF(XHIT.LE.0.) ISTRIP = NT-2
            SIG = .566 * WIRED
            ENDIF
      ENDIF

c     now distribute the charge really
      DO 28 N=ISTRIP,ISTRIP+MULTI-1    ! loop over the strips
      IF(N.LT.1 .OR. N.GT.NWIRPL) GO TO 28
      IF(MULTI.GT.2) THEN
         if (sig.eq.0.) stop 'sig'
         EXPR = AMIN1(160.,(((N-NT+.5)*WIRED-XHIT)/SIG) **2)
         PADH(N-ISTRIP+1) = 0.4*CHG*WIRED/SIG * EXP(-0.5*EXPR)
      ENDIF
      NDIGDE = NDIGDE+1
      IF(NDIGDE.GT.MXDIG) THEN
         NDIGDE = MXDIG
         GO TO 28
      ENDIF
      IDIGX(1,NDIGDE) = N                     ! strip number
      DIGX(2,NDIGDE) = PADH(N-ISTRIP+1)       ! charge
      IDIGX(6,NDIGDE) = IXMIMP(I)            ! MIMP number
      IDIGX(7,NDIGDE) = OMIMP_MTRA(ID)        ! track number
      IDGOR(NDIGDE) = N                       ! for sorting only
      WIR(N,2) = WIR(N,2) +  PADH(N-ISTRIP+1) ! add up charge of the strip
   28 CONTINUE
   20 CONTINUE
      NDIGDE = MIN0(NDIGDE,MXDIG)
      IF(NDIGDE.LE.0) GO TO 997      

C--   sort the digit matrix IDIGX due to increasing x
      IF(LBIGR) THEN
         CALL SORTZV(IDGOR,IND1,NDIGDE,-1,0,0)
      ELSE
         CALL SORTZV(IDGOR,IND1,NDIGDE,-1,1,0)
      ENDIF

C*    The next loop cleans the digits and fills DIGB bank and relations
      IFLAG = 0
      DIGLIM = 0.                 ! can discriminate digits below noise level
      CALL VZERO (IWIR(1,1),2000)
      DO 30 IH = 1,NDIGDE
      I = IND1(IH)
      N = IDIGX(1,I)
      IF(WIR(N,2).LT.DIGLIM) GO TO 30
      IF(IWIR(N,1).EQ.0) THEN
         CALL MMBOOK(JDIGB,1)
         NN1 = NDIGB()
         IF(IFLAG.EQ.0) THEN         ! first digit in this detector
            IQ(IQGEPT_DIG1(IPL)) = NDIGB()
            IFLAG = 1
         ENDIF
         IQ(IQDIGB_ID_L()) = 10000*N + IPL
         Q ( QDIGB_Q_L())   = WIR(N,2)
         IWIR(N,1) = NDIGB()
      ENDIF
      CALL MMBREL(JMIDI,IDIGX(6,I),IWIR(N,1))
 30   CONTINUE

c     now should be included a code which makes clustering of digits to hits
c     since we dont have it at the moment the hits will be obtained directly
c     from the MIMPs

C*    The fourth loop creates hits from XMIMP

      NHITDE = 0
      CALL VZERO(IND2,NMIM)
      IH = 1
      DO WHILE (IH.LE.NMIM)
      I = IND0(IH)
      IF(IXMIMP(I).EQ.0) GO TO 50
      IF(IND2(IH).LT.0) GO TO 50

      IF(IH.EQ.NMIM) GO TO 45           ! check whether last mimp

c     check if next hits are far enough away
c     if not define the number of hits to be merged and mark them
      MAX = 0
      XT = XMIMP(I)
      DO J = 1,NMIM
       K=IND0(J)
       IF(K.NE.I.AND.IXMIMP(K).NE.0) THEN
          IF(ABS(XMIMP(K)-XT).LT.DOD) THEN
             MAX = MAX + 1
             IND2(J) = -I
          ENDIF
       ENDIF
      ENDDO
      IF(MAX.NE.0) THEN

         GO TO 40
      ENDIF

c     last mimp or next mimp far enough, take it and translate into a hit
 45   CALL MMBOOK(JHITB,1)
      NN = NHITB()
      IF(NHITDE.EQ.0) IQ(IQGEPT_HIT1(IPL))=NN
      NHITDE = NHITDE + 1
      IQ(IQHITB_GEDE_L()) = IPL
      Q (QHITB_Z_L()) = ZWIR
      Q (QHITB_Q_L()) = 1.
      Q (QHITB_R_L()) = FGEDE_ACC(IPL)
      CALL GRANOR(F,X)
      Q (QHITB_X_L()) = XMIMP(I) + FGEDE_ACC(IPL)*F
      CALL MMBREL(JMIHI,IXMIMP(I),NN)
      GO TO 50

c        merge a yet unknown number of hits


 40   IF(MAX+1.GT.NMX_MERG) GO TO 50

      IND2(IH) = -I
C     you have to merge mimps from I to I+MAX
      CALL MMBOOK(JHITB,1)
      NN = NHITB()
      IF(NHITDE.EQ.0) IQ(IQGEPT_HIT1(IPL))=NN
      NHITDE = NHITDE + 1
      SUM = 0.
      SUM2 = 0.
      MAX = MAX + 1
      DO J = 1,NMIM
       K=IND0(J)
       IF(IND2(J).EQ.-I) THEN
         SUM = SUM +XMIMP(K)
         SUM2 = SUM2 + XMIMP(K)**2
         CALL MMBREL(JMIHI,IXMIMP(K),NN)
      ENDIF
      ENDDO
      SUM = SUM /MAX
      SUM2 = SUM2/MAX
      IQ(IQHITB_GEDE_L()) = IPL
      Q (QHITB_Z_L()) = ZWIR
      Q (QHITB_Q_L()) = MAX
      Q (QHITB_R_L()) = SQRT((SUM2 - SUM**2)**2 + FGEDE_ACC(IPL)**2)
      CALL GRANOR(F,X)
      Q (QHITB_X_L()) = SUM + Q(QHITB_R_L())*F

 50   IH = IH + 1
      ENDDO                    ! WHILE

c     fill GEPT table for hits and digits
      IQ(IQGEPT_DIGL(IPL)) = NN1
      IQ(IQGEPT_HITL(IPL)) = NN
      GO TO 100

 997  IQ(IQGEPT_DIG1(IPL)) = 0
      IQ(IQGEPT_HIT1(IPL)) = 0
      IQ(IQGEPT_DIGL(IPL)) = -1
      IQ(IQGEPT_HITL(IPL)) = -1
 100  IF(IP.eq.1) IPL = IPL + 1

 999  RETURN

 998  IQ(IQGEPT_DIG1(IPL)) = 0
      IQ(IQGEPT_HIT1(IPL)) = 0
      IQ(IQGEPT_DIGL(IPL)) = -1
      IQ(IQGEPT_HITL(IPL)) = -1
      IPL = IPL + 1
      IQ(IQGEPT_DIG1(IPL)) = 0
      IQ(IQGEPT_HIT1(IPL)) = 0
      IQ(IQGEPT_DIGL(IPL)) = -1
      IQ(IQGEPT_HITL(IPL)) = -1
      RETURN
      END
