/*
*************************************************************************
**
** Description: test program for Evdir Sql
**
** Language:	C++
**
** Created: 20 Aug 97
** Updated:  
**
** Author:  Sergey Moukhine
**          HERA-B Collaboration
**          JINR-Dubna
**          Russia
**
*************************************************************************
*/

#include <string.h>
#include <stdio.h>

#include <evdir/EvdSql.h>
  
main ()
{
  int res;
  char *err;
  
  char bodyFull[10000];
  FILE *f;
       
  if (!(f = fopen("in.txt","r")))
     {
     printf("Can't open file in.txt\n");
     exit(1);
     }
  bodyFull[0] = '\0';
       
  while (fgets(bodyFull+strlen(bodyFull), 100, f));
  fclose(f);
       
  EvdirSql sql;
  int nFields = 5;
  NameAndValueT fields[nFields];
  
  fields[0].kind = ValInt;
  strcpy(fields[0].name,"Class");
  
  fields[1].kind = ValDate;
  strcpy(fields[1].name,"Date");
  
  fields[2].kind = ValTime;
  strcpy(fields[2].name,"Time");
    
  fields[3].kind = ValDouble;
  strcpy(fields[3].name,"E");

  fields[4].kind = ValInt;
  strcpy(fields[4].name,"run");
    
  res = sql.Compile(bodyFull,nFields,fields,&err);
  printf ("res=%d\n", res);
  if (res == -1)
  printf("%s\n",err);


  fields[0].v.intV    = 1 + 8 + 32;
  fields[1].v.dateV   = 19980314;
  fields[2].v.timeV   = 36000.;
  fields[3].v.doubleV = 0.6;
  fields[4].v.intV    = 4377;
  res = sql.Evaluate(nFields,fields,&err);
  printf ("res=%d\n", res);
  if (res == -1)
  printf("%s\n",err);


  int nCall = 0;
  int run;
  while (nCall < 60)
     {
     nCall++;
     run = sql.NextRun();
     printf("%6d", run);
     if (run <= 0)
        break;
     if (nCall%10 == 0)
        printf("\n");
     }
  printf("\n");
  exit(0);
}

