#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "gean/hgdat.h"
#include "arte/Arte.hh"
#include "auto/GMAX.hh"
#include "auto/GSLX.hh"
#include "auto/TMP6.hh"
#include "auto/GCAL.hh"
// ------------------------------------------------------------------------
static int fpp=0;
  FILE *CAL_inp, *utfilp(char*,char*);  
  fpos_t fcalpos;
  
int caldat(char*);
  typedef struct {
    int   color;
    int   seen;
    int   ndiv; 
    int   n_rad, n_sci;
    int   sens_flag;
    float dzrad, dzsci;
    float eff;
    char  volname[4];
    char  mat_rad[12];
    char  mat_sci[12];
    char  mat_all[12];
    } calvol;

  typedef struct {
    int   ncalx, ncaly; 
    float xmin_sl,xmax_sl,ymin_sl,ymax_sl,zmin_sl,zmax_sl;
    float caba_size;
    float z_cal[3];
    float z_wall[6];
    float dz_wall[6]; 
    char  castru[3000];
    } CommonCalPos;


// ------------------------------------------------------------------------  

extern "C" {
  int caldat_(char *name) { return caldat(name);   }
  extern CommonCalPos calpos_;
  void mmbwrk_(class ArteLink const &, int const &, int const &, int const &);
  void mmchtm_(class ArteLink const &, int const &);          }

// ------------------------------------------------------------------------  

int caldat(char* name) {
  int nitem, i, tagid=0, volid=0, sulid=0 ;
  char  buffer[256], tag[80], taga[16], tags[60], C78[120] ;
  char *card, *stop, *slbuf;
  calvol vol;
  CommonCalPos& pos=calpos_;
  if(!fpp){
    CAL_inp =utfilp(name,"\n");
    if(!CAL_inp) {
       strcpy(C78,"Can not open ");
       int len=strlen(name);
       int i;
       for (i=len;i<64;i++) name[i]=' ';
          name[64]='\0';
          strncat(C78,name,len);
          printf(" %s \n", C78);      }
    fpp=1;                              }

  int volength = sizeof(calvol) / 4;

//  if(volid!=0 || sulid!=0) fsetpos(fpca, &fcalpos);  

  for(;;) {
     int i=0;
     fgetpos(CAL_inp, &fcalpos);
     if(fgets(buffer,256,CAL_inp) == NULL) {
        tagid = 0;
        if(feof(CAL_inp)) {
         if(sulid!=0) {
             tagid = -1;}
           if(volid!=0) {
              for( i=0; i<volength; i++)  {
                TMP6 object;
                object.temp = ((int*)&vol)[i]; 
                ArtePointer<TMP6>::append( object ); }
              tagid = -2;   
              mmchtm_(artelink_.jtmp6,volength);} 
           fclose(CAL_inp);
           fprintf(stdout," === CLOSE FILE  %s\n",name);
           return tagid;                    }
                                            }
//     fgetpos(CAL_inp, &fcalpos);
     card=&buffer[0];
     nitem=sscanf(card,"%s",tag);
     if (nitem==-1) continue;   
     ToLower(tag);

    if (!strncmp(tag,"vol",3)) { 
      if(volid!=0) {  
         for( i=0; i<volength; i++)  {
           TMP6 object;
           object.temp = ((int*)&vol)[i]; 
           ArtePointer<TMP6>::append( object ); }
       }
      else  mmbwrk_(artelink_.jtmp6,0,1,volength*10); 
      if(sulid!=0) {  
         tagid = 1;   
         return tagid;       }
      volid = 1;
      sulid = 0;  
      card+=itemlength(card,nitem); 
      nitem=sscanf(card,"%s",taga); 
      if (nitem!=1) inp_error("caldat",tag);
      fillstr(taga,4);
      strncpy(vol.volname,taga,4);
//    ************* default values **********************************   
      vol.seen = vol.color = vol.ndiv = vol.n_rad = 1;
      vol.n_sci = vol.sens_flag = 0;
      vol.dzrad = 0.,  vol.dzsci = 0., vol.eff = 1. ;
      strncpy(vol.mat_rad,"            ",12);      
      strncpy(vol.mat_sci,"            ",12);      
//    ************* end of default values ***************************
    }

    else if(!strncmp(tag,"ndiv",4)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d" ,&vol.ndiv);
      if(nitem!=1) inp_error("caldat",tag);  }

    else if(!strncmp(tag,"nlay",4)||!strncmp(tag,"nrad",4)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d" ,&vol.n_rad);
      if(nitem!=1) inp_error("caldat",tag);  }
 
    else if(!strncmp(tag,"nsci",4)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d" ,&vol.n_sci);
      if(nitem!=1) inp_error("caldat",tag);}

    else if (!strncmp(tag,"dzrad",5)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f",&vol.dzrad); 
      if (nitem!=1) inp_error("caldat",tag);  }  

    else if (!strncmp(tag,"dzsci",5)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f",&vol.dzsci); 
      if (nitem!=1) inp_error("caldat",tag);  }

    else if (!strncmp(tag,"eff",3)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f",&vol.eff); 
      if (nitem!=1) inp_error("caldat",tag);  }

    else if (!strncmp(tag,"sens",4)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s",taga);
      if (nitem!=1) inp_error("caldat",tag);      
      vol.sens_flag = strtol(taga,&stop,0);  }     

    else if (!strncmp(tag,"col",3)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d",&vol.color);
      if (nitem!=1) inp_error("caldat",tag);      
      if(vol.color!=0) vol.seen=1; }

    else if (!strncmp(tag,"mat_rad",7)) { 
      card+=itemlength(card,nitem); 
      nitem=sscanf(card,"%s",taga); 
      if (nitem!=1) inp_error("caldat",tag);
      fillstr(taga,12);
      strncpy(vol.mat_rad,taga,12); }

    else if (!strncmp(tag,"mat_sci",7)) { 
      card+=itemlength(card,nitem); 
      nitem=sscanf(card,"%s",taga); 
      if (nitem!=1) inp_error("caldat",tag);
      fillstr(taga,12);
      strncpy(vol.mat_sci,taga,12); }

    else if (!strncmp(tag,"mat_all",7)) { 
      card+=itemlength(card,nitem); 
      nitem=sscanf(card,"%s",taga); 
      if (nitem!=1) inp_error("caldat",tag);
      fillstr(taga,12);
      strncpy(vol.mat_all,taga,12); }

    else if (!strncmp(tag,"su",2)) { 
      if(sulid!=0) {  
         tagid = 1;
         sulid = 0;
         fsetpos(CAL_inp, &fcalpos);     
         return tagid;       }
    else if(volid!=0) {  
         for( i=0; i<volength; i++)  {
           TMP6 object;
           object.temp = ((int*)&vol)[i]; 
           ArtePointer<TMP6>::append( object ); }      
         mmchtm_(artelink_.jtmp6,volength); 
         volid = 0;
         tagid = 2; 
         fsetpos(CAL_inp, &fcalpos);  
         return tagid;
      }
      sulid = 1;
      volid = 0;  
//    ************* default values **********************************   
      pos.ncalx = pos.ncaly = 1;
      pos.caba_size = 11.15; 
      pos.z_cal[0] = pos.z_cal[1] = pos.z_cal[2] = 0.;   
      pos.z_wall[0] = pos.z_wall[1] = pos.z_wall[2] = 0.;   
      pos.z_wall[3] = pos.z_wall[4] = pos.z_wall[5] = 0.;   
      pos.dz_wall[0] = pos.dz_wall[1] = pos.dz_wall[2] = 0.;   
      pos.dz_wall[3] = pos.dz_wall[4] = pos.dz_wall[5] = 0.;   
//    ************* end of default values ***************************
    }
    else if (!strncmp(tag,"pos_sl",6)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f %f",&pos.xmin_sl,&pos.xmax_sl); 
      if (nitem!=2) inp_error("caldat",tag); 
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f %f",&pos.ymin_sl,&pos.ymax_sl); 
      if (nitem!=2) inp_error("caldat",tag); }

    else if(!strncmp(tag,"ncal",4)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d %d",&pos.ncalx,&pos.ncaly);
      if(nitem!=2) inp_error("caldat",tag);}

    else if (!strncmp(tag,"caba_size",9)) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f",&pos.caba_size); 
      if (nitem!=1) inp_error("caldat",tag); }    

    else if (!strncmp(tag,"z_cal",5)) {
      int j=0;
      while (nitem > 0  && j < 3)  {    
         card+=itemlength(card,nitem);
         nitem=sscanf(card,"%f",&pos.z_cal[j]); 
         if (nitem!=1) inp_error("caldat",tag);    
         j = j+1;              }  } 

    else if (!strncmp(tag,"z_wall",6)) {
      int j=0;
      while (nitem > 0  && j < 6)  {
         card+=itemlength(card,nitem);
         nitem=sscanf(card,"%f",&pos.z_wall[j]); 
         if (nitem!=1) inp_error("caldat",tag);    
           j = j+1;            }  }   

    else if (!strncmp(tag,"dz_wall",6)) {
      int j=0;
      while (nitem > 0  && j < 6)  {
         card+=itemlength(card,nitem);
         nitem=sscanf(card,"%f",&pos.dz_wall[j]); 
           j = j+1;            }  }   

    else if (!strncmp(tag,"cast",4)) {
      card+=itemlength(card,nitem);            
      nitem=sscanf(card,"%s",tags); 
      int j = 1;
      fillstr(tags,60);      
      strncpy(pos.castru,tags,60);
      while (j < pos.ncaly) {
        if(fgets(buffer,256,CAL_inp) == NULL) inp_error("caldat",tags);
        else  {
          card=&buffer[0];
          nitem=sscanf(card,"%s",tags);
          fillstr(tags,60);
          strcat(pos.castru,tags);
          j = j+1; }  } 
                                  }       
     else  {
      if(strncmp(tag,"#",1) &&  strncmp(tag,"*",1))
        printf("tag not found:   %s\n",tag);    }
           
    } }









