
      SUBROUTINE CALGEO

************************************************************************
*
* CALGEO
* written by Sergey Shuvalov 09/94
* updated for new structure by Siegmund Nowak 09/97
*
* This routines defines calorimeter geometry set up for the hera-b detector
*
************************************************************************

      IMPLICIT NONE

      INTEGER K,IVOLU,IVOL(3),ND,icol,irow,iCAL,imed
      INTEGER ISET,IDET,NBITSV(3),IZ,RES,IP6(3)  
      INTEGER CALDAT,IUCOMP,MEDNUM,ITMP6
      REAL PAR(3),PARA(8),XPOSA,YPOSA,ZPOS(3),ZWPOS(3,2),XMS(3),ZP
      REAL DZCAL(3),XSL,YSL,XBL,YBL,XMSPB,XMSTU
      CHARACTER*1 CASE, IEND
      CHARACTER*4 CSL,CNAME,NAMESV(9),NAMRAD(3)
      CHARACTER*12 CMAT
      CHARACTER*60 CALSTR(50)       
      EQUIVALENCE(CASTRU,CALSTR)
      LOGICAL Long
c  just to avoid complications with new calo-structure = "ZGCALO.fi"
      INTEGER CADE
      REAL ZACAL,DLCAL
      COMMON/ZGCALO/CADE,ZACAL(10),DLCAL(10)

      INTEGER NCALX,NCALY
      REAL XMIN_SL,XMAX_SL,YMIN_SL,YMAX_SL,ZMIN_SL,ZMAX_SL
      REAL CABA_SIZE, ZCAL, ZWALL, DZWALL 
      CHARACTER  CASTRU*750 
      COMMON /CALPOS/ NCALX, NCALY,XMIN_SL,XMAX_SL,YMIN_SL,YMAX_SL,
     +                ZMIN_SL,ZMAX_SL, CABA_SIZE,
     +                ZCAL(3), ZWALL(3,2), DZWALL(3,2), CASTRU

      INTEGER   CV_COL ,   CV_SEEN,   CV_NDIV,   CV_NRAD,
     +          CV_NSCI,   CV_SENS,   CV_DRAD,   CV_DSCI,  
     +          CV_EFF,    CV_NAME,   CV_MRAD,   CV_MSCI,
     +          CV_MALL
      PARAMETER(CV_COL = 1,CV_SEEN= 2,CV_NDIV= 3,CV_NRAD= 4,
     +          CV_NSCI= 5,CV_SENS= 6,CV_DRAD= 7,CV_DSCI= 8,
     +          CV_EFF = 9,CV_NAME=10,CV_MRAD=11,CV_MSCI=14,
     +          CV_MALL=17                                          )

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "auto/TMP6.fi"  

      DATA NAMRAD /'CAPB','CAPB','CATU'/
      DATA NAMESV/ 'CAL1','CAX1','CAY1',
     +             'CAL2','CAX2','CAY2',
     +             'CAL3','CAX3','CAY3'/
      DATA NBITSV/    14,     3,     3/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/TMP6.ff"
      ITMP6(K) = JTMP6+(K-1)*NCTMP6() + 2 

      IEND = CHAR(0)
      Long = DETV(LGESL_ECA).EQ.'CALL'

c     table of volumina is read from file and translated into table TMP6  
      IF(INT(GEOMVERS).EQ.97) THEN
         RES = CALDAT('cal97.dat'//IEND)
      ELSE
         RES = CALDAT('calo.dat'//IEND)
      ENDIF
      IF(DETV(LGESL_ECA).EQ.'CALU') THEN
         CALL CAUGEO
         GO TO 999
      ENDIF

      CALL CALMED

c     define and posit the CALW superlayer

      CALL UHTOC(HGESL_NAME(CALOSL),4,CSL,4)
      CURRSL = CALOSL
      CALL CGGESL(CSL,'MOTH',0)
      CALL GSATT(CSL,'COLO',-4)
      CALL GSATT(CSL,'SEEN',0)
c     just to avoid complications with new calo-structure
      ZACAL(1) = FGESL_Z1(CALOSL)       
      DLCAL(1) = FGESL_Z2(CALOSL) - FGESL_Z1(CALOSL)

 20   XSL = .5*(FGESL_X1(CALOSL)+FGESL_X2(CALOSL))
      YSL = .5*(FGESL_Y1(CALOSL)+FGESL_Y2(CALOSL))

c     volumina are filled from JTMP6 into geant tables 
      DO K=1,NTMP6()
      CALL UHTOC(IQ(ITMP6(K)+CV_NAME),4,CNAME,4)
      IF(IUCOMP(CNAME,Q(JVOLUM+1),IQ(JVOLUM-1)).EQ.0) THEN 
        PAR(1) = 0.5*CABA_SIZE
        PAR(2) = PAR(1)
        PAR(3) = .5*(Q(ITMP6(K)+CV_DRAD)*IQ(ITMP6(K)+CV_NRAD)
     +         +     Q(ITMP6(K)+CV_DSCI)*IQ(ITMP6(K)+CV_NSCI))  
        IF(CNAME.EQ.'CAL1') THEN
           DZCAL(1) = 2.*PAR(3)
        ELSEIF(CNAME.EQ.'CAL2') THEN
           DZCAL(2) = 2.*PAR(3)
        ELSEIF(CNAME.EQ.'CAL3') THEN
           DZCAL(3) = 2.*PAR(3)
        ENDIF
        IF(.NOT.LONG) THEN   
          CALL UHTOC(IQ(ITMP6(K)+CV_MALL),4,CMAT,12)
          IMED = MEDNUM(IQ(ITMP6(K)+CV_SENS),CMAT)
          IF(Q(ITMP6(K)+CV_DRAD).GT.0.) THEN
             CALL GSVOLU(CNAME,'BOX ',IMED,PAR,3,IVOLU)
          ELSE
             CALL GSVOLU(CNAME,'BOX ',IMED,PAR,0,IVOLU)
          ENDIF
          CALL GSATT(CNAME,'COLO',IQ(ITMP6(K)+CV_COL))
        ELSE
          IF(IQ(ITMP6(K)+CV_SENS).EQ.3) THEN
             CALL UHTOC(IQ(ITMP6(K)+CV_MSCI),4,CMAT,12)
             IMED = MEDNUM(IQ(ITMP6(K)+CV_SENS),CMAT)
             CALL GSVOLU(CNAME,'BOX ',IMED,PAR,3,IVOLU)
             CALL GSATT(CNAME,'COLO',IQ(ITMP6(K)+CV_COL))

             CALL UHTOC(IQ(ITMP6(K)+CV_MRAD),4,CMAT,12)
             IMED = MEDNUM(1,CMAT)
             PAR(3) =  .5*(Q(ITMP6(K)+CV_DRAD))   
             IF(CMAT(1:4).EQ.'LEAD') THEN
                IF(IUCOMP('CAPB',Q(JVOLUM+1),IQ(JVOLUM-1)).EQ.0) THEN
                   CALL GSVOLU('CAPB','BOX ',IMED,PAR,0,IVOLU)
                   CALL GSATT('CAPB','COLO',IQ(ITMP6(K)+CV_COL))
                   CALL GRADLN(IVOLU,XMSPB)
                ENDIF 
             ELSEIF(CMAT(1:8).EQ.'TUNGSTEN') THEN
                IF(IUCOMP('CATU',Q(JVOLUM+1),IQ(JVOLUM-1)).EQ.0) THEN 
                   CALL GSVOLU('CATU','BOX ',IMED,PAR,0,IVOLU)
                   CALL GSATT('CATU','COLO',IQ(ITMP6(K)+CV_COL))
                   CALL GRADLN(IVOLU,XMSTU)
                ENDIF
             ENDIF
          ELSE
             CALL UHTOC(IQ(ITMP6(K)+CV_MALL),4,CMAT,12)
             IMED = MEDNUM(IQ(ITMP6(K)+CV_SENS),CMAT)
             IF(Q(ITMP6(K)+CV_DRAD).GT.0.) THEN
                CALL GSVOLU(CNAME,'BOX ',IMED,PAR,3,IVOLU)
             ELSE
                CALL GSVOLU(CNAME,'BOX ',IMED,PAR,0,IVOLU)
             ENDIF
             CALL GSATT(CNAME,'COLO',IQ(ITMP6(K)+CV_COL))
          ENDIF
        ENDIF
       ENDIF
       ENDDO

c     read in one group of modules
 10   CONTINUE
      IF(INT(GEOMVERS).EQ.97) THEN
         RES = CALDAT('cal97.dat'//IEND)
      ELSE
         RES = CALDAT('calo.dat'//IEND)
      ENDIF

c     check for group  dimensions
      IF(CABA_SIZE*nCALX.GT.(XMAX_SL-XMIN_SL)+1.E-5) 
     +             CALL MEWARN('CALGEO: Discrepancies in x')
      IF(CABA_SIZE*nCALY.GT.(YMAX_SL-YMIN_SL)+1.E-5)
     +             CALL MEWARN('CALGEO: Discrepancies in y')

      XBL = 0.5*(xmin_sl+XMAX_SL)
      YBL = 0.5*(YMIN_SL+YMAX_SL)

c     define the wall positions
      DO k=1,3
      ZPOS(K)=ZCAL(K)+.5*(DZCAL(K)-(FGESL_Z2(CALOSL)-FGESL_Z1(CALOSL)))
      ZWPOS(K,1) = ZWALL(K,1) + .5* (DZWALL(K,1) 
     +                           - (FGESL_Z2(CALOSL)-FGESL_Z1(CALOSL)))
      ZWPOS(K,2) = ZWALL(K,2) + .5* (DZWALL(K,2) 
     +                           - (FGESL_Z2(CALOSL)-FGESL_Z1(CALOSL)))
      ENDDO

      PARA(7) =  1.
      PARA(8) =  0.

c     look for the pointers to the three calorimeter types in TMP6    
c     and define multiple scattering angles
      IP6(1) = 0
      IP6(2) = 0
      IP6(3) = 0
 15   DO K=1,NTMP6()
      CALL UHTOC(IQ(ITMP6(K)+CV_NAME),4,CNAME,4)      
      IF(.NOT.LONG) THEN 
         IF(CNAME.EQ.'CAL1') THEN
            IP6(1)= K
            IVOL(1) = IUCOMP('CAL1',IQ(JVOLUM+1),IQ(JVOLUM-1))
            CALL GRADLN(IVOL(1),XMS(1))
            XMS(1) = DZCAL(1)/XMS(1)
            XMS(1) = XMS(1)*(.0136*(1.+.038*ALOG(XMS(1))))**2
         ELSEIF(CNAME.EQ.'CAL2') THEN
            IP6(2)= K
            IVOL(2) = IUCOMP('CAL2',IQ(JVOLUM+1),IQ(JVOLUM-1))
            CALL GRADLN(IVOL(2),XMS(2))
            XMS(2) = DZCAL(2)/XMS(2)
            XMS(2) = XMS(2)*(.0136*(1.+.038*ALOG(XMS(2))))**2
         ELSEIF(CNAME.EQ.'CAL3') THEN
            IP6(3)= K
            IVOL(3) = IUCOMP('CAL3',IQ(JVOLUM+1),IQ(JVOLUM-1))
            CALL GRADLN(IVOL(3),XMS(3))
            XMS(3) = DZCAL(3)/XMS(3)
            XMS(3) = XMS(3)*(.0136*(1.+.038*ALOG(XMS(3))))**2
         ENDIF
      ELSE
         IF(CNAME.EQ.'CAL1') THEN
            IP6(1)= K
            IVOL(1) = IUCOMP('CAL1',IQ(JVOLUM+1),IQ(JVOLUM-1))
            CALL GRADLN(IVOL(1),XMS(1))
            XMS(1) = Q(ITMP6(K)+CV_DSCI)*IQ(ITMP6(K)+CV_NSCI)/XMS(1)
     +            +  Q(ITMP6(K)+CV_DRAD)*IQ(ITMP6(K)+CV_NRAD)/XMSPB
            XMS(1) = XMS(1)*(.0136*(1.+.038*ALOG(XMS(1))))**2
         ELSEIF(CNAME.EQ.'CAL2') THEN
            IP6(2)= K
            IVOL(2) = IUCOMP('CAL2',IQ(JVOLUM+1),IQ(JVOLUM-1))
            CALL GRADLN(IVOL(2),XMS(2))
            XMS(2) = Q(ITMP6(K)+CV_DSCI)*IQ(ITMP6(K)+CV_NSCI)/XMS(2)
     +            +  Q(ITMP6(K)+CV_DRAD)*IQ(ITMP6(K)+CV_NRAD)/XMSPB
            XMS(2) = XMS(2)*(.0136*(1.+.038*ALOG(XMS(2))))**2
         ELSEIF(CNAME.EQ.'CAL3') THEN
            IP6(3)= K
            IVOL(3) = IUCOMP('CAL3',IQ(JVOLUM+1),IQ(JVOLUM-1))
            CALL GRADLN(IVOL(3),XMS(3))
            XMS(3) = Q(ITMP6(K)+CV_DSCI)*IQ(ITMP6(K)+CV_NSCI)/XMS(3)
     +            +  Q(ITMP6(K)+CV_DRAD)*IQ(ITMP6(K)+CV_NRAD)/XMSTU
            XMS(3) = XMS(3)*(.0136*(1.+.038*ALOG(XMS(3))))**2
         ENDIF
      ENDIF
      ENDDO

c     define active volumina for inner, medium and outer calorimeters
c     loop over the modules
      DO 30 icol=1,nCALX
      DO 40 irow=1,nCALY

      CASE = CALSTR(irow)(icol:icol)
      IF(CASE.EQ.'H')  GO TO 40
      ical = 0
      IF(CASE.EQ.'1') iCAL = 1
      IF(CASE.EQ.'2') iCAL = 2
      IF(CASE.EQ.'3') iCAL = 3
      if(ical.eq.0) CALL MEERRO('CALGEO: ICAL=0')

      ND = NGCAL() + 1

      XPOSA = 0.5*CABA_SIZE*(2*icol-nCALX-1) + XBL !first column is the left one
      YPOSA =-0.5*CABA_SIZE*(2*irow-nCALY-1) + YBL ! first row is the top one
c     posit the wall equivalents
      PAR(3) = 0.5*DZWALL(iCAL,1)
      CALL CRPOS('CAWA',CSL,1,ND,XPOSA,YPOSA,ZWPOS(iCAL,1),0,'ONLY',PAR)
      PAR(3) = 0.5*DZWALL(iCAL,2)
      CALL CRPOS('CAWA',CSL,2,ND,XPOSA,YPOSA,ZWPOS(iCAL,2),0,'ONLY',PAR)
c     posit the modules
      IF(iCAL.EQ.1)  THEN
         CALL GSPOS('CAL1',ND,CSL,XPOSA,YPOSA,ZPOS(iCAL),0,'ONLY')
      ELSE IF(iCAL.EQ.2)  THEN
         CALL GSPOS('CAL2',ND,CSL,XPOSA,YPOSA,ZPOS(iCAL),0,'ONLY')
      ELSE IF(iCAL.EQ.3)  THEN
         CALL GSPOS('CAL3',ND,CSL,XPOSA,YPOSA,ZPOS(iCAL),0,'ONLY')
      ENDIF
c     fill the ARTE tables
      PARA(1) = XSL+XPOSA-.5*CABA_SIZE
      PARA(2) = XSL+XPOSA+.5*CABA_SIZE
      PARA(3) = YSL+YPOSA-.5*CABA_SIZE
      PARA(4) = YSL+YPOSA+.5*CABA_SIZE
      PARA(5) =  FGESL_Z1(CALOSL) + ZCAL(iCAL)
      PARA(6) =  PARA(5) + DZCAL(iCAL)
      CALL CRGCAL(IQ(ITMP6(IP6(ICAL))+CV_NDIV),IVOL(iCAL),PARA)
      IQ(IQGCAL_NCL_L()) = IQ(ITMP6(IP6(ICAL))+CV_NDIV)
      IQ(IQGCAL_SEC_L()) = 100*IROW + ICOL
      Q ( QGCAL_MS_L())  = XMS(iCAL)
      Q ( QGCAL_EFF_L())= Q(ITMP6(IP6(ICAL))+CV_EFF)

 40   CONTINUE
 30   CONTINUE

      IF (RES.GT.0) GO TO 10      ! go to the next group of modules

c     divide the modules into substructures and make them sensitive
      DO iCAL = 1,3
       CALL GSDVN(NAMESV(iCAL*3-1),NAMESV(iCAL*3-2),
     +                             IQ(ITMP6(IP6(ICAL))+CV_NDIV),1)
       CALL GSDVN(NAMESV(iCAL*3  ),NAMESV(iCAL*3-1),
     +                             IQ(ITMP6(IP6(ICAL))+CV_NDIV),2)
       IF(LONG) THEN
          PAR(1) = 0.5*CABA_SIZE/IQ(ITMP6(IP6(ICAL))+CV_NDIV)
          PAR(2) = PAR(1)
          PAR(3) = 0.5*Q(ITMP6(IP6(ICAL))+CV_DRAD)
          ZP = -0.5*DZCAL(iCAL)+Q(ITMP6(IP6(ICAL))+CV_DSCI)  ! start position
          DO iz = 1,IQ(ITMP6(IP6(ICAL))+CV_NRAD)
           ZP = ZP + PAR(3)
           CALL GSPOSP(NAMRAD(iCAL),iz,NAMESV(iCAL*3),
     +                            0.,0.,ZP,0,'ONLY',PAR,3) 
           ZP = ZP + PAR(3) + Q(ITMP6(IP6(ICAL))+CV_DSCI)
          ENDDO
       ENDIF

c      make modules sensitive
       CALL GSDET('CALO',NAMESV(iCAL*3),3,NAMESV(iCAL*3-2),NBITSV,
     +                                       LGESL_ECA,450,20,ISET,IDET)
      ENDDO

      IF(IDEBUG.NE.0) WRITE(LPRNT,*) 'CALGEO: SUPERLAYER ',NGESL(),
     +     'NPLanes,NSectors = ', IGESL_NPL(NGESL()),NGCAL()

  999 RETURN
      END
