
      SUBROUTINE CAUGEO

************************************************************************
*
* CAUGEO
* written by Sergey Shuvalov 09/94
*
* This routines defines nonstandard .ie user calorimeter geometry 
* the superlayer itself must be defined
* The following indices in ZACAL(start value) and DLCAL(length) are used:
*     1     entire calorimeter
*     2     outer  calorimeter
*     3     medium calorimeter
*     4     inner  calorimeter
*     5     first  alu chip in outer  calorimeter
*     6     second alu chip in outer  calorimeter
*     7     first  alu chip in medium calorimeter
*     8     second alu chip in medium calorimeter
*     9     first  alu chip in inner  calorimeter
*    10     second alu chip in inner  calorimeter
*
* ZACAL(1) is with respect to target, all others with respect to ZACAL(1)
*
************************************************************************

      IMPLICIT NONE

      INTEGER ISL
      CHARACTER*4 CSL 

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGCALO.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

c     define and posit entire CALO volume
      DO ISL=1,NGESL()
       IF(IGESL_CMP(ISL).EQ.LGESL_ECA) GO TO 1
      ENDDO
   
 1    CALL UHTOC(HGESL_NAME(ISL),4,CSL,4)
      CALL CGGESL(CSL,'MOTH',0)
      CALL GSATT(CSL,'COLO',-4)
      CALL GSATT(CSL,'SEEN',0)

      IF(CABA_SIZE*nCALX.GT.(FGESL_X2(ISL)-FGESL_X1(ISL))) 
     +               print*,'CALGEO: Discrepancies in x'
      IF(CABA_SIZE*nCALY.GT.(FGESL_Y2(ISL)-FGESL_Y1(ISL)))
     +               print*,'CALGEO: Discrepancies in y'



  999 RETURN
c
      END


