
      SUBROUTINE CRHIBK(IPROC)

************************************************************************
* written by Siegmund Nowak, 27/10/94 13.00.07
* changed by Olya Igonkina for fast shower algorithm    
*
* This routines fills the GEANT HIT  banks
*
* called from GUSTEP
*
*     IPROC  variable giving what kind of MIMP/MCAL  will be generated
*            1 - normal MIMP
*            2 - MCAL for calorimeter
*            3 - MCAL for scintillation hodoscopes
*            4 - MIMP for TRD (long version)  
*            5 - MTCP start point of cascades in ECAL
************************************************************************

      IMPLICIT NONE

      INTEGER IPROC,IPL,ICUR8,ICUR9,I,IVN,ITMP2,ITMP3,ITMP4,ITMP6,ITMP8
      CHARACTER*4 CCAFM
      COMMON /ZGCAFM/ CCAFM

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gcflag.fi"
#include "gean/gctrak.fi"
#include "gean/gckine.fi"
#include "gean/gcsets.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/TMP2.fi"
#include "auto/TMP3.fi"
#include "auto/TMP4.fi"
#include "auto/TMP6.fi"
#include "auto/TMP7.fi"
#include "auto/TMP8.fi"
#include "auto/TMP9.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/TMP2.ff"
#include "auto/TMP3.ff"
#include "auto/TMP4.ff"
#include "auto/TMP6.ff"
#include "auto/TMP7.ff"
#include "auto/TMP8.ff"
#include "auto/TMP9.ff"

      IF(MIMPSW.EQ.0) GO TO 999
      IPL = NUMBV(1)

C     normal mimps
      IF(IPROC.EQ.1) THEN
         CALL MMBOOK(JTMP6,1)
         CALL MMBOOK(JTMP7,1)
         ITMP6 = JTMP6 + 2 + (NTMP6()-1)*NCTMP6()
         Q(ITMP6+1) = VECT(3) - ZZERO
         Q(ITMP6+2) = VECT(1)
         Q(ITMP6+3) = VECT(2)
         IF(VECT(6).NE.0.) THEN
            Q(ITMP6+4) = VECT(4)/VECT(6)
            Q(ITMP6+5) = VECT(5)/VECT(6)
            Q(ITMP6+6) = SIGN(VECT(7),VECT(6))
         ELSE
            Q(ITMP6+4) = SIGN(1.E+10,VECT(4))
            Q(ITMP6+5) = SIGN(1.E+10,VECT(5))
            Q(ITMP6+6) = VECT(7)
         ENDIF
         Q(ITMP6+7) = TOFG
         IQ(ITMP6+8) = ITRA
         IQ(JTMP7+2+NTMP7()) = NUMBV(1)
         ITMP2 = JTMP2 + 4 + (ITRA-1)*NCTMP2()
         IQ(ITMP2) = IQ(ITMP2) + 1

c     TRD-mimps (long version)
      ELSE IF(IPROC.EQ.4) THEN
         IF(DESTEP.NE.0.) THEN
            CALL MMBOOK(JTMP4,1)
            ITMP4 = JTMP4 + 2 + (NTMP4()-1)*NCTMP4()
            Q(ITMP4+1) = VECT(3) - ZZERO
            Q(ITMP4+2) = VECT(1)
            Q(ITMP4+3) = VECT(2)
            Q(ITMP4+4) = DESTEP*1.E6
            Q(ITMP4+5) = IPART
            IF(VECT(6).NE.0.) THEN
               Q(ITMP4+6) = SIGN(VECT(7),VECT(6))
            ELSE
               Q(ITMP4+6) = VECT(7)
            ENDIF
            Q(ITMP4+7) = TOFG
            IQ(ITMP4+8) = ITRA
            IQ(ITMP4+9) = NUMBV(1)
            ITMP2 = JTMP2 + 4 + (ITRA-1)*NCTMP2()
            IQ(ITMP2) = IQ(ITMP2) + 1
         ENDIF 

c--   calorimeter (entry points of tracks) 
      ELSEIF(IPROC.EQ.5) THEN
         CALL MMBOOK(JTMP3,1)
         ITMP3 = JTMP3 + 2 + (NTMP3()-1)*NCTMP3()
         Q(ITMP3+1) = VECT(3) - ZZERO
         Q(ITMP3+2) = VECT(1)
         Q(ITMP3+3) = VECT(2)
         IF(VECT(6).NE.0.) THEN
            Q(ITMP3+4) = VECT(4)/VECT(6)
            Q(ITMP3+5) = VECT(5)/VECT(6)
            Q(ITMP3+6) = SIGN(VECT(7),VECT(6))
         ELSE
            Q(ITMP3+4) = SIGN(1.E+10,VECT(4))
            Q(ITMP3+5) = SIGN(1.E+10,VECT(5))
            Q(ITMP3+6) = VECT(7)
         ENDIF
         IQ(ITMP3+7) = ITRA
         ITMP2 = JTMP2 + 2 + (ITRA-1)*NCTMP2()
         IQ(ITMP2+2) = IQ(ITMP2+2) + 1
         IQ(ITMP2+5) = IQ(ITMP2+5) + 1

C        calorimeter or scintillation counters
      ELSE IF(IPROC.EQ.2.OR.IPROC.EQ.3) THEN
         ICUR8 = 2 + (NTMP8()-1)*NCTMP8()
         ICUR9 = 2 + NTMP9()
         IF(IPROC.EQ.2) THEN      !  calorimeter
            IVN = 100*NUMBV(1) + NUMBV(2)*IGCAL_NCL(IPL) + NUMBV(3)
            IF(CCAFM.EQ.'ON' .AND.ITRTYP.LE.2.AND.GETOT.GE.4..AND.
     +              (VECT(3)-ZZERO-FGESL_Z1(CALOSL)).LE.11. ) THEN
C               fast MC for electron or photon with energy .GE. 3 GeV
C               and Z coordinate .LE. ZACAL(1)+unsensitive step
                CALL CAFMBK
                GO TO 999
            ENDIF
         ELSE
            IVN = NUMBV(1)
         ENDIF

         IF(DESTEP.LE.0.) GO TO 999

c        check whether track number is the same as previous MCAL
         DO 30 I=1,NTMP8()      ! loop over all calorimeter hits
         IF(ITRA.NE.IQ(JTMP8+ICUR8+2)) THEN
            CALL MMBOOK(JTMP8,1)
            CALL MMBOOK(JTMP9,1)
            ITMP8 = JTMP8 + 2 + (NTMP8()-1) * NCTMP8()
            Q(ITMP8+1) = DESTEP
            IQ(ITMP8+2) = ITRA
            IQ(JTMP9+2+NTMP9()) = IVN
            ITMP2 = JTMP2 + 4 + (ITRA-1)*NCTMP2()
            IQ(ITMP2) = IQ(ITMP2) + 1
            GO TO 999
         ELSE
c           check whether it is the same volume element, if so add energy
            IF(IVN.EQ.IQ(JTMP9+ICUR9)) THEN
               Q(JTMP8+ICUR8+1) = Q(JTMP8+ICUR8+1) +  DESTEP
               GO TO 999
            ELSE
c              go to the previous MCAL
               GO TO 29
            ENDIF
         ENDIF
 29      ICUR8 = ICUR8 - NCTMP8()
 30      ICUR9 = ICUR9 - 1

c        first track, but all MCALs have diff volumina (or first MCAL)

         CALL MMBOOK(JTMP8,1)
         CALL MMBOOK(JTMP9,1)
         ITMP8 = JTMP8 + 2 + (NTMP8()-1)*NCTMP8()
         Q(ITMP8+1) = DESTEP
         IQ(ITMP8+2) = ITRA
         IQ(JTMP9+2+NTMP9()) = IVN
         ITMP2 = JTMP2 + 4 + (ITRA-1)*NCTMP2()
         IQ(ITMP2) = IQ(ITMP2) + 1
         GO TO 999

      ENDIF
 999  RETURN
      END

