      SUBROUTINE CRKIBK

************************************************************************
*
* CRKIBK
* written by Siegmund Nowak, 13/02/96 19.56.54
*
* This routine transforms the GEANT vertex and kinematic banks
* in ARTE banks MVER and MTRA
*
*       called from GUOUT
*
************************************************************************

      IMPLICIT NONE
      INTEGER ITR,IMOVER,IMOTRA,JV,JK,ITMP2,IPART,ITOPP,MPART,MTOPP
      INTEGER NBOOK,TPGEAR,NNT,NNM,NNV,IORIG

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "auto/MC.fi"
#include "auto/TOPP.fi"
#include "auto/TMP1.fi"
#include "auto/TMP2.fi"

#include "arte/Arte.ff"
#include "auto/MC.ff"
#include "auto/TOPP.ff"
#include "auto/TMP1.ff"
#include "auto/TMP2.ff"

      ITMP2() = JTMP2 + 2 + (ITR-1) * NCTMP2()
c     IQ(ITMP2()+1)   ROW in MTRA for GEANT TRACK ITR, if zero not yet booked
c     IQ(ITMP2()+2)   Number of hits, if -1 daughters have hits
c     Q (ITMP2()+3)   Track length
c     IQ(ITMP2()+4)   Track flag

C========================================================================

      IF(MIMPSW.EQ.0. OR. NTRACK.EQ.0) GO TO 999

c     mark tracks with MIMPs or where daughters have MIMPS

      DO 200 ITR=NTRACK,1,-1

      IF(IQ(ITMP2()+2).EQ.0) GO TO 200    !    no hits
      IF(IQ(ITMP2()+1).NE.0) GO TO 200    !    track already booked
      IMOVER = Q(LQ(JKINE-ITR)+6)         !    GEANT orig vertex for ITR
      IF(IMOVER.EQ.0) GO TO 200
      IMOTRA = Q(LQ(JVERTX-IMOVER)+5)     !    GEANT mother track for ITR
      IF(IQ(JTMP2+4+(IMOTRA-1)*NCTMP2()).EQ.0) ! mention in mother about hits
     +            IQ(JTMP2+4+(IMOTRA-1)*NCTMP2()) = -1
 200  CONTINUE

c     install MTRA and MVER and relations

      DO 300 ITR=1,NTRACK
      IF(IQ(ITMP2()+2).EQ.0) GO TO 300    !    no hits
      IF(IQ(ITMP2()+1).NE.0) THEN         !    track already booked
         Q (QMTRA_ML(IQ(ITMP2()+1))) = Q(ITMP2()+3)
         Q (QMTRX_LENG(IQ(ITMP2()+1))) = Q(ITMP2()+3)
         IQ(IQMTRA_FLAG(IQ(ITMP2()+1))) = IQ(ITMP2()+4)
         GO TO 300
      ENDIF

      JK = LQ(JKINE-ITR)
      IPART = Q(JK+5)                   !    define GEANT particle code
      IMOVER = Q(JK+6)                  !    define GEANT vertex origin
      IMOTRA = Q(LQ(JVERTX-IMOVER)+5)   !    define GEANT mother track

c     book and fill track bank
      CALL MMBOOK(JMTRA,1)
      NNT = NMTRA()
      IQ(ITMP2()+1) = NNT
      Q (QMTRA_PX_L()) = Q(JK+1)
      Q (QMTRA_PY_L()) = Q(JK+2)
      Q (QMTRA_PZ_L()) = Q(JK+3)
      Q (QMTRA_ML_L()) = Q(ITMP2()+3)
      Q (QMTRX_LENG_L()) = Q(ITMP2()+3)
      IQ(IQMTRA_FLAG_L()) = IQ(ITMP2()+4)
      IF(IMOTRA.NE.0) THEN
         NNM = IQ(JTMP2+3+(IMOTRA-1)*NCTMP2())
         CALL MMBREL(JMTMT,NNM,NNT)
      ENDIF

c     redefine particle ID from GEANT (IPART) to ARTE ITOPP
      ITOPP = TPGEAR(IPART)
      IF(ITOPP.EQ.0) CALL MEWARC (8762135, 'CRKIBK: PARTICLE CODE = 0')
      CALL MMBREL (JMTTO,ITOPP,NNT)

c     if it is a resonance
      IF(FTOPP_WID(ITOPP).GT.1.E-9) THEN
         IQ(IQMTRA_FLAG_L()) = 2
         Q(QMTRX_MASS_L()) = FTOPP_MASS(ITOPP)
      ENDIF

c     to define MTRA_ORIG  check whether  IMOTRA is a resonce
      IORIG= 0
      IF(IMOTRA.GT.0) THEN                   ! mother exists
         MPART = Q(LQ(JKINE-IMOTRA)+5)       ! define mothers particle ID
         MTOPP = TPGEAR(MPART)
         IF(FTOPP_WID(MTOPP).GT.1.E-9) THEN  ! mother is a resonance
            IORIG = -IQ(JTMP2+3+(IMOTRA-1)*NCTMP2())
c           for vertex origin you have to go one step back
1           IMOVER = Q(LQ(JKINE-IMOTRA)+6)       ! go one step back
            IMOTRA = Q(LQ(JVERTX-IMOVER)+5)
            IF(IMOTRA.NE.0) THEN             ! grand mother exist
               MPART = Q(LQ(JKINE-IMOTRA)+5)
               MTOPP = TPGEAR(MPART)
            ENDIF
            IF(IMOTRA.EQ.0.OR.FTOPP_WID(MTOPP).LT.1.E-9) GO TO 10
            GO TO 1   ! grandmother is also a resonance - one step back
         ENDIF
      ENDIF

c     primary vertex or no resonance - look for the vertex origin

10    IF(IQ(JTMP1-1).GE.(IMOVER+2).AND.IQ(JTMP1+2+IMOVER).NE.0) GO TO 20
     +                                           ! vertex already booked

      NBOOK = IMOVER - NTMP1()
C     book and fill JTMP1 and MVER
      IF(NBOOK.GT.0) CALL MMBOOK(JTMP1,NBOOK)
      CALL MMBOOK(JMVER,1)
      NNV = NMVER()
      JV = LQ(JVERTX-IMOVER)
      Q (QMVER_X_L()) = Q(JV+1)
      Q (QMVER_Y_L()) = Q(JV+2)
      Q (QMVER_Z_L()) = Q(JV+3) - ZZERO
      IQ(JTMP1+2+IMOVER) = NNV
      IF(IMOTRA.EQ.0) THEN
c        hier muss gecheckt werden
      ELSE
         IQ(IQMVER_FLAG_L()) = 4
         NNM = IQ(JTMP2+3+(IMOTRA-1)*NCTMP2())
         IF(IORIG.LT.0.OR.IMTRA_FLAG(NNM).EQ.3) IQ(IQMVER_FLAG_L()) = 2
         CALL MMBREL(JMTMV,NNM,NNV)
      ENDIF

 20   CONTINUE
c     fill MTRA_ORIG and relation MTMV
      NNV = IQ(JTMP1+2+IMOVER)
      IF(IORIG.LT.0) THEN
         CALL MMBREL(JMVMT,NNV,NNT)
         IQ(IQMTRA_ORIG_L()) = IORIG
      ELSE
         IQ(IQMTRA_ORIG_L()) = NNV
         CALL MMBREL(JMVMT,NNV,NNT)
      ENDIF

 300  CONTINUE

 999  CALL MMFREE(JMTRA)
      CALL MMFREE(JMVER)
      RETURN
      END









