*-- Author :    Siegmund Nowak   10/11/95
************************************************************************
*
* CRLVBK
* written by Siegmund Nowak, 10/11/95 13.26.15 (partly taken from GLMOTH)
*
* This routine loads for a volume given by its hollerith name IUDET and
* user number NCOPY the top part of the Volume tree in LVOLS (hollerith
* volume names) and LCOPY (user copy numbers. In gives also the link
* number within the mother bank, where the daughter bank JIN is installed*
*
*       called from CRGEDE
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* IUDET      in           hollerith name of the volume under consideration
* NCOPY      in           user number of this volumen
* INDAUT     out          serial number of link in its mother volume (in)
* LVOLS      out          hollerith volume names of the top tree
* LCOPY      out          user numbers for the top tree (incl. NCOPY)
************************************************************************

      SUBROUTINE CRLVBK (IUDET, NCOPY, INDAUT, NLEV, LVOLS , LCOPY)

      INTEGER  IUDET,NCOPY,INDAUT,NLEV,LVOLS(*),LCOPY(*),I,J,NLV,IUCOMP
      INTEGER MULT,MULTI,NLDV,IVOS,IVO,IVOT,JVO,NIN,IN,JIN,JDIV,LID,LVO
      CHARACTER*4 NAME
      SAVE MULT
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "arte/Arte.ff"
C.    ------------------------------------------------------------------

      NLEV = 1
      MULT = NCOPY
      NLDV = 0
      CALL UHTOC (IUDET,4, NAME, 4)
      IVOS = IUCOMP (NAME, IQ(JVOLUM+1), IQ(JVOLUM-1))
      LVOLS(1) = IVOS
*
* *** Scan all volumes to check if it could be mother
*       of the current volume

   10 IF (IVOS.GT.1) THEN
         DO 25 IVO = 1, IQ(JVOLUM-1)
            IF (IVO.EQ.IVOS) GO TO 25
            JVO = LQ(JVOLUM-IVO)
            NIN = Q(JVO+3)
            IF (NIN.EQ.0)               GO TO 25
*
            IF (NIN.LT.0) THEN
               JDIV = LQ(JVO-1)
               IVOT = Q(JDIV+2)
               IF (IVOT.NE.IVOS)        GO TO 25
               IF (MULT.EQ.0) THEN
                  IN   = 1
                  MULT = 1
               ELSE
                  IN   = MULT
               ENDIF
*
            ELSE
               DO 15 IN = 1, NIN
                  JIN  = LQ(JVO-IN)
                  IVOT = Q(JIN+2)
                  IF (IVOT.NE.IVOS)     GO TO 15
                  MULTI = Q(JIN+3)
                  IF (MULT.EQ.0) THEN
                     MULT = MULTI
                  ELSE
                     IF (MULT.NE.MULTI) GO TO 15
                  ENDIF
                  GO TO 20
   15          CONTINUE
               GO TO 25
            ENDIF
*
   20       LCOPY(NLEV) = MULT
            IF(NLEV.EQ.1) INDAUT = IN
            IF (NLDV.NE.0)              GO TO 30
            NLEV = NLEV + 1
            LVOLS(NLEV) = IVO
            IVOS = IVO
            MULT = 0
            IF (LQ(JVO).NE.0) NLDV = NLEV
            GO TO 10
   25    CONTINUE
      ENDIF
*
* *** Now rearrange the order of the volumes
*
   30 IF (IVOS.EQ.1) LCOPY(NLEV) = 1
      NLV  = NLEV/2
      IF (NLV.GT.0) THEN
         DO 35 I = 1, NLV
            J   = NLEV - I + 1
            LID = LCOPY(I)
            LVO = LVOLS(I)
            LCOPY(I) = LCOPY(J)
            LVOLS(I) = LVOLS(J)
            LCOPY(J) = LID
            LVOLS(J) = LVO
   35    CONTINUE
      ENDIF
      DO I=1,NLEV
      LVOLS(I)= IQ(JVOLUM+LVOLS(I))
      ENDDO
c      IF (LQ(LQ(JVOLUM-LV1)).EQ.0) NLEV = 0
*                                                             END CRLVBK
 999  RETURN
      END






