
      SUBROUTINE CRMIBK
************************************************************************
*
* CRMIBK
* written by Siegmund Nowak, 27/10/94 13.00.07
*
* This routines creates the MIMP ZEBRA banks according to increasing
* detector numbers
*
* called from GUOUT
************************************************************************
      IMPLICIT NONE

      INTEGER NOHIT
      PARAMETER (NOHIT = 100000)
      INTEGER K,IND(NOHIT),ITMP3,ITMP4,ITMP5,ITMP6,ITMP8,IMIMP,IMCAL,
     +        NN3,NN4,NN5,NN7,NN9,NNEND,IFIRST,RICH_PLANE,IFILT

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGCALO.fi"
#include "gean/ZGESL.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "auto/TMP2.fi"
#include "auto/TMP3.fi"
#include "auto/TMP4.fi"
#include "auto/TMP5.fi"
#include "auto/TMP6.fi"
#include "auto/TMP7.fi"
#include "auto/TMP8.fi"
#include "auto/TMP9.fi"
      SAVE IFIRST
      DATA IFILT/65535/               ! equivalent to /Z0000FFFF/ 
      DATA IFIRST /0/
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/TMP2.ff"
#include "auto/TMP3.ff"
#include "auto/TMP4.ff"
#include "auto/TMP5.ff"
#include "auto/TMP6.ff"
#include "auto/TMP7.ff"
#include "auto/TMP8.ff"
#include "auto/TMP9.ff"

      IF(MIMPSW.EQ.0) GO TO 999
      NN3 = NTMP3()
      NN4 = NTMP4()
      NN5 = NTMP5()
      NN7 = NTMP7()
      NNEND = 0

      IF(NN7.GT.0) THEN
         IF(NN7.GT.NOHIT) THEN
            C78 = 'due to sorting limitations only the first'
            CALL CH78BI(nohit)
            CALL CH78BC('hits will be registered')
            CALL ME78WA
            NN7 = NOHIT
         ENDIF
         CALL MMBOOK(JMIMP,NN7)
         CALL SORTZV(IQ(JTMP7+3),IND,NN7,-1,0,0)
         DO K = 1,NN7
          ITMP6 = JTMP6 + 2 + (IND(K)-1) * NCTMP6()
          IMIMP = JMIMP + 2 + (K-1) * NCMIMP()
          Q(IMIMP+JMIMP_Z) = Q(ITMP6+1)
          Q(IMIMP+JMIMP_X) = Q(ITMP6+2)
          Q(IMIMP+JMIMP_Y) = Q(ITMP6+3)
          Q(IMIMP+JMIMP_TX) = Q(ITMP6+4)
          Q(IMIMP+JMIMP_TY) = Q(ITMP6+5)
          Q(IMIMP+JMIMP_P) = Q(ITMP6+6)
          Q(IMIMP+JMIMP_TIME) = Q(ITMP6+7)
          IQ(IMIMP+JMIMP_GEDE) = IQ(JTMP7+2+IND(K))
          IQ(IMIMP+JMIMP_MTRA) = IQ(JTMP2+3+(IQ(ITMP6+8)-1)*NCTMP2())
         ENDDO
      ENDIF
      NNEND = NNEND + NN7       

      IF(NN5.GT.0) THEN
         CALL MMBOOK(JMIMP,NN5)
         DO K = 1,NN5
          ITMP5 = JTMP5 + 2 + (K-1) * NCTMP5()
          IMIMP = JMIMP + 2 + (NNEND+K-1) * NCMIMP()
          Q(IMIMP+JMIMP_Z) = Q(ITMP5+1)
          Q(IMIMP+JMIMP_X) = Q(ITMP5+2)
          Q(IMIMP+JMIMP_Y) = Q(ITMP5+3)
          Q(IMIMP+JMIMP_TX) = Q(ITMP5+4)
          Q(IMIMP+JMIMP_TY) = Q(ITMP5+5)
          Q(IMIMP+JMIMP_P) = Q(ITMP5+6)
          Q(IMIMP+JMIMP_TIME) = IQ(ITMP5+7)
          IQ(IMIMP+JMIMP_GEDE) = IGESL_FPL(RICHSL)
          IQ(IMIMP+JMIMP_MTRA) = IQ(JTMP2+3+(IQ(ITMP5+8)-1)*NCTMP2())
         ENDDO
      ENDIF
      NNEND = NNEND + NN5       

      IF(NN4.NE.0) THEN
         CALL MMBWRK(JTMP5,0,1,NN4)    ! intermediate store for sorting
         IF(NN4.GT.NOHIT) THEN
            C78 = 'due to sorting limitations only the first'
            CALL CH78BI(nohit)
            CALL CH78BC('hits will be registered')
            CALL ME78WA
            NN4 = NOHIT
         ENDIF
         CALL MMBOOK(JTMP5,NN4)
         CALL MMBOOK(JMIMP,NN4)
         DO K=1,NN4
          IQ(JTMP5+2+K) = IAND(IQ(JTMP4+11+(K-1)*NCTMP4()),IFILT)
         ENDDO  
         CALL SORTZV(IQ(JTMP5+3),IND,NN4,-1,0,0)
         DO K=1,NN4
          ITMP4 = JTMP4 + 2 + (IND(K)-1) * NCTMP4()          
          IMIMP = JMIMP + 2 + (NNEND+K-1) * NCMIMP()
          Q(IMIMP+JMIMP_Z) = Q(ITMP4+1)
          Q(IMIMP+JMIMP_X) = Q(ITMP4+2)
          Q(IMIMP+JMIMP_Y) = Q(ITMP4+3)
          Q(IMIMP+JMIMP_TX) = Q(ITMP4+4)
          Q(IMIMP+JMIMP_TY) = Q(ITMP4+5)
          Q(IMIMP+JMIMP_P) = Q(ITMP4+6)
          Q(IMIMP+JMIMP_TIME) = IQ(ITMP4+7)
          IQ(IMIMP+JMIMP_GEDE) = IQ(ITMP4+9)
          IQ(IMIMP+JMIMP_MTRA) = IQ(JTMP2+3+(IQ(ITMP4+8)-1)*NCTMP2())
          
         ENDDO
      ENDIF
      NNEND = NNEND + NN4       

      IF(NNEND.NE.0) THEN
         CALL MMIREL(JMTMI)
      ELSE
         C78 ='no entries in MIMP bank !!!'
         CALL ME78PC(310364,3)
      ENDIF

      IF(NN3.NE.0) THEN
         CALL MMBOOK(JMTCP,NN3)
         DO K=1,NN3
          ITMP3 = JTMP3 + 2 + (K-1) * NCTMP3()          
          Q(QMTCP_Z(K))  = Q(ITMP3+1)
          Q(QMTCP_X(K))  = Q(ITMP3+2)
          Q(QMTCP_Y(K))  = Q(ITMP3+3)
          Q(QMTCP_TX(K)) = Q(ITMP3+4)
          Q(QMTCP_TY(K)) = Q(ITMP3+5)
          Q(QMTCP_P(K))  = Q(ITMP3+6)
          IQ(JMTCP+2+(K-1)*NCMTCP()+JMTCP_MTRA) = 
     +                 IQ(JTMP2+3+(IQ(ITMP3+7)-1)*NCTMP2())
         ENDDO
         CALL MMIREL(JMTMP)
      ENDIF

      NN9 = NTMP9()
      IF(NN9.GT.0) THEN
         IF(NN9.GT.NOHIT) THEN
            C78 = 'due to sorting limitations only the first'
            CALL CH78BI(nohit)
            CALL CH78BC('hits will be registered')
            CALL ME78WA
            NN9 = NOHIT
         ENDIF
         CALL MMBOOK(JMCAL,NN9)
         CALL SORTZV(IQ(JTMP9+3),IND,NN9,-1,0,0)
         DO K = 1,NTMP9()
          ITMP8 = JTMP8 + 2 + (IND(K)-1) * NCTMP8()
          IMCAL = JMCAL + 2 + (K-1) * IQ(JMCAL+1)
          Q(IMCAL+JMCAL_DE) = Q(ITMP8+1)
          IQ(IMCAL+JMCAL_GCAL) = IQ(JTMP9+2+IND(K))
          IQ(IMCAL+JMCAL_MTRA) = IQ(JTMP2+3+(IQ(ITMP8+2)-1)*NCTMP2())
         ENDDO
         CALL MMIREL(JMTMC)

      ELSE
         C78 = 'NO entries in MCAL bank !!!'
         CALL ME78PC(320364,3)
      ENDIF

 999  RETURN
      END




