*CMZ :  3.01/00 14/08/96  16.07.16  by  Siegmund Nowak
*-- Author :    Siegmund Nowak   14/08/96
      SUBROUTINE CRTMED(I,MEDFLG)
*
***********************************************************************
*                                                                     *
*       Store tracking media parameters for HERA-B in JTMED                   *
*       deviated from GSTMED                                          *
*       Specialities for HERA-B:                                      *
*       FIELDM    maximum field value  set to 10 kG                   *
*       TMAXFD    maximum angle due to field deviation permitted in   *
*                 one step  set to 10 degrees                         *
*       DEEMAX    set to -1 for automatic calculation                 *
*       STMIN     minimal step due to energy loss or multiple         *
*                 scattering   set to -1 for automatic calculation    *
*       UBUF      no array of NWBUF additional parameters             *
*                                                                     *
*  Input parameters:                                                  *
*  NMED     tracking medium number 0<NMED<100                       *
*  NATMED    tracking medium name (up to 20 characters ended by $)    *
*  NMAT      material number corresponding to NMED                   *
*  ISVOL     =0 if not a sensitive volume                             *
*  IFIELD    = 0  if no magnetic field                                *
*            = 1  tracking performed with GRKUTA                      *
*            = 2  tracking performed with GHELIX                      *
*            = 3  tracking performed with GHELX3                      *
*  STEMAX    Maximum step allowed (in cm)                             *
*  EPSIL     tracking precision (in cm)                               *
*                                                                     *
*                                                                     *
* Tracking Medium data structure JTMED (see GSTMED)                   *
*    ==>Called by : <USER>, MEDCON,CRMIXT                             *
*       Author    R.Brun  changed by S.Nowak                          *
*                                                                     *
***********************************************************************
      IMPLICIT NONE

      INTEGER NMED,ISVOL,IFIELD,MECA(5,13),JTM
      INTEGER I,MEDFLG,L,LENOCC,J,JBIT,K
      EQUIVALENCE (MECA(1,1),IPAIR)
      REAL STEMAX,CUTVEC(10)
      EQUIVALENCE (CUTVEC,CUTGAM)
      CHARACTER CNAME*12, CNAM*20
      SAVE NMED
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcnum.fi"
#include "gean/gccuts.fi"
#include "gean/gcphys.fi"
#include "gean/gcmzfo.fi"
#include "auto/GMAT.fi"
#include "auto/TMP0.fi"
#include "gean/ZGDETV.fi"
#include "gean/ZGESL.fi"

#include "arte/Arte.ff"
#include "auto/GMAT.ff"
#include "auto/TMP0.ff"

C.
C.    ------------------------------------------------------------------
C.

      IF(MEDFLG.EQ.0) GO TO 99
      CALL UHTOC (IQ(HQGMAT_NAME(1,I)),4,CNAME,12)
      L = LENOCC(CNAME)

      IF(JTMED.LE.0)THEN
         CALL MZBOOK(IXCONS,JTMED,JTMED,1,'TMED',NTMED,NTMED,40,3,0)
         CALL UCOPY(CUTVEC,Q(JTMED+1),10)
         IQ(JTMED-5)=0
         DO 10 K=1,13
            Q(JTMED+10+K)=MECA(1,K)
   10    CONTINUE
         Q(JTMED+10+21)=ILABS
         Q(JTMED+10+22)=ISYNC
         Q(JTMED+10+23)=ISTRA
         NMED = 0
      ENDIF

      IF((I-NTMP0()).GT.0) CALL MMBOOK(JTMP0,I-NTMP0())
      DO J=1,4
      IF(JBIT(IGMAT_FLAG(I),J).EQ.1) THEN
         NMED = NMED + 1
         IF(NMED.GT.NTMED) THEN
            CALL MZPUSH(IXCONS,JTMED,NMED-NTMED,0,'I')
            NTMED=NMED
         ENDIF
         CALL MZBOOK(IXCONS,JTM,JTMED,-NMED,'TMED',10,10,14,IOTMED,0)
         IF(J.EQ.1) THEN
            CNAM(1:L) = CNAME(1:L)
            CNAM(L+1:20) = ' '
            ISVOL = 0
            IFIELD = 0
            STEMAX = 1.E+10
            IQ(IQTMP0_TEMP(I)  ) = NMED
         ELSEIF(J.EQ.2) THEN
            CNAM(1:L) = CNAME(1:L)
            CNAM(L+1:L+5) = '_MAGN'
            CNAM(L+6:20) = ' '
            ISVOL = 0
            IF(DETV(LGESL_FLD).EQ.'FLDS') THEN
               IFIELD = 2
            ELSEIF(DETV(LGESL_FLD).EQ.'FLDL') THEN
               IFIELD = 1
            ENDIF
            STEMAX = 10.
            IQ(IQTMP0_TEMP(I)+1) = NMED
         ELSEIF(J.EQ.3) THEN
            CNAM(1:L) = CNAME(1:L)
            CNAM(L+1:20) = ' '
            ISVOL = 1
            IFIELD = 0
            STEMAX = 1.E+10
            IQ(IQTMP0_TEMP(I)+2) = NMED
         ELSEIF(J.EQ.4) THEN
            CNAM(1:L) = CNAME(1:L)
            CNAM(L+1:L+5) = '_MAGN'
            CNAM(L+6:20) = ' '
            ISVOL = 1
            IF(DETV(LGESL_FLD).EQ.'FLDS') THEN
               IFIELD = 2
            ELSEIF(DETV(LGESL_FLD).EQ.'FLDL') THEN
               IFIELD = 1
            ENDIF
            STEMAX = 10.
            IQ(IQTMP0_TEMP(I)+3) = NMED
         ENDIF

         CALL UCTOH(CNAM,IQ(JTM+1),4,20)
         Q(JTM + 6) = I
         Q(JTM + 7) = ISVOL
         Q(JTM + 8) = IFIELD
         Q(JTM + 9) = 10.
         Q(JTM + 10) = 10.
         Q(JTM + 11) = STEMAX
         Q(JTM + 12) = -1.
         Q(JTM + 13) = .01
         Q(JTM + 14) = -1.

      ENDIF
      ENDDO


  99  END



************************************************************************
* End of CRTMED
************************************************************************
