
      SUBROUTINE G00MAIN

************************************************************************
*
* G00MAIN
* written by Siegmund Nowak
*
* This routines is the routine for generating the detector geometry of
* run 00 i.e. TDR design 
*
* called from GEOMAIN
************************************************************************

      IMPLICIT NONE

      INTEGER I,ISL,IND(100),UTCURSL
      REAL ZNXT(100)
      CHARACTER*1 IEND

#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gclist.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGDETV.fi"
#include "gean/ZGESL.fi"
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/GEO.fi"


#include "arte/Arte.ff"
#include "auto/GEO.ff"

      IEND = CHAR(0) 

      DO I=1,NGESL()
       ZNXT(I) = FGESL_Z1(I)
      ENDDO
      CALL SORTZV(ZNXT,IND,NGESL(),1,0,0)      

C***  Roman pot side walls and target
      CURRSL = UTCURSL(LGESL_RPOT)
      CALL POTGEO('RING')
      CURRSL = UTCURSL(LGESL_TAR)
      CALL TARGEO
      CURRSL = UTCURSL(LGESL_RPOT)
      CALL RFSGEO

C***  silicon-vertex-detector

      DO I=1,NGESL()
       ISL = IND(I)
       CURRSL = ISL
       IF(IGESL_CMP(ISL).EQ.LGESL_SIL) THEN
         IF(IGESL_MFL(ISL).EQ.1) GO TO 4
         IF(DETV(LGESL_SIL).EQ.'SIDS') THEN
            CALL SILGEO(ISL)
         ELSE IF(DETV(LGESL_SIL).EQ.'SIDL') THEN
           CALL SILGEO(ISL)
         ELSE IF(DETV(LGESL_SIL).EQ.'SIDU') THEN
           CALL SIUGEO(ISL)
         ENDIF
       ENDIF
      ENDDO 

C***  roman pot end plate,magnet components and beam pipes
 4    CURRSL = UTCURSL(LGESL_RPOT)
      CALL POTGEO('SEND')
      CURRSL = UTCURSL(LGESL_MAG)
      CALL MAGGEO
      CURRSL = UTCURSL(LGESL_PPIP)
      CALL PIPGEO
      CURRSL = UTCURSL(LGESL_EPIP)
      CALL EBMGEO('MAGN')

C***  Tracker
      I = 0
 10   I = I + 1
      IF(I.GT.NGESL()) GO TO 20
      ISL = IND(I)
      CURRSL = ISL
 
C***  Silicon in Magnet
      IF(IGESL_CMP(ISL).EQ.LGESL_SIL.AND.IGESL_MFL(ISL).EQ.1) THEN
         IF(DETV(LGESL_SIL).EQ.'SIDS') THEN
            CALL SMLGEO(ISL)
         ELSE IF(DETV(LGESL_SIL).EQ.'SIDL') THEN
            CALL SMLGEO(ISL)
         ELSE IF(DETV(LGESL_SIL).EQ.'SIDU') THEN
            CALL SIUGEO(ISL)
         ENDIF
         GO TO 10

C***  Inner Tracker
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_MSG) THEN
         IF(DETV(LGESL_MSG).EQ.'MTDS') THEN
            CALL ITLGEO(ISL)
         ELSEIF(DETV(LGESL_MSG).EQ.'MTDL') THEN
            CALL ITRGEO(ISL)
         ELSEIF(DETV(LGESL_MSG).EQ.'MTDU') THEN
            CALL MTUGEO(ISL)
         ENDIF
         GO TO 10

C***  Outer Tracker
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_WCH) THEN
         IF(DETV(LGESL_WCH).EQ.'WTDL')THEN
            CALL WTLGEO(ISL)
         ELSE IF(DETV(LGESL_WCH).EQ.'WTDS')THEN
            CALL OTRGEO(ISL)
         ELSE IF(DETV(LGESL_WCH).EQ.'WTDU') THEN
            CALL OTUGEO(ISL)
         ENDIF
         GO TO 10

C***  PT chambers
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_PTC) THEN 
         IF(DETV(LGESL_PTC).EQ.'PTLS'.OR.DETV(LGESL_PTC).EQ.'PTLL')THEN
            CALL PTLGEO(ISL)
         ELSE IF(DETV(LGESL_PTC).EQ.'PTLU') THEN
            CALL PTUGEO(ISL)
         ENDIF
         GO TO 10

C***  RICH counter 
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_RIC) THEN
         IF(DETV(LGESL_RIC).EQ.'RICS'.OR.DETV(LGESL_RIC).EQ.'RICL')THEN
            CALL RILGEO
         ELSEIF(DETV(LGESL_RIC).EQ.'RICU') THEN
            CALL RIUGEO
         ENDIF
         GO TO 10

C***  TRD
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_TRSL) THEN
        IF(DETV(LGESL_TRSL).EQ.'TRDS') THEN
           CALL TRDGEO
        ELSEIF(DETV(LGESL_TRSL).EQ.'TRDL') THEN
           CALL TRDGEO
           CALL TRINIT
        ELSEIF(DETV(LGESL_TRSL).EQ.'TRDU') THEN
           CALL TRUGEO
        ENDIF
        GO TO 10

C***  ECAL - electromagnetic calorimeter
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_ECA) THEN
         CALL CALGEO
C--      electron beam pipe inside CAL
         CURRSL = UTCURSL(LGESL_EPIP)
         CALL EBMGEO('CALO')
         GO TO 10

C***  MUON - muon spectrometer
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_MUON) THEN
       IF(DETV(LGESL_MUON).EQ.'MUDS'.OR.DETV(LGESL_MUON).EQ.'MUDL')THEN
            CALL MUOGEO
            CALL MUOSET
         ELSEIF(DETV(LGESL_MUON).EQ.'MUDU') THEN
            CALL MUUGEO
         ENDIF
c--      electron beam pipe inside MUON
         CURRSL = UTCURSL(LGESL_EPIP)
         CALL EBMGEO('MUON')
         GO TO 10
      ENDIF
      GO TO 10

 20   CALL SILSET
      CALL MTSET
      IF(DETV(LGESL_WCH).EQ.'WTDL') CALL WTLSET

 999  RETURN
      END
