
      SUBROUTINE G97MAIN

************************************************************************
*
* G97MAIN
* written by Siegmund Nowak
*
* This routines is the routine for generating the detector geometry
* for run97
* called from GEOMAIN
*
************************************************************************

      IMPLICIT NONE

      INTEGER I,ISL,IND(100),NSIRP
      REAL ZNXT(100)

#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gclist.fi"
#include "gean/gcnum.fi"
#include "gean/ZGDETV.fi"
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      DO I=1,NGESL()
       ZNXT(I) = FGESL_Z1(I)
      ENDDO
      CALL SORTZV(ZNXT,IND,NGESL(),1,0,0)      

C***  Roman pot side walls and target
      CALL POTGEO('RING')
      CALL TARGEO
      CALL RFSG96

C***  silicon-vertex-detector
      NSIRP = 0
      DO  I=1, NGESL()
       ISL = IND(I)
       IF(IGESL_CMP(ISL).EQ.LGESL_SIL) THEN
         IF(IGESL_MFL(ISL).EQ.1) GO TO 4
         IF(DETV(LGESL_SIL).EQ.'SIDS'.OR.DETV(LGESL_SIL).EQ.'SIDL')THEN
           CALL SILG96(ISL)
         ELSE IF(DETV(LGESL_SIL).EQ.'SIDU') THEN
           CALL SIUGEO(ISL)
         ENDIF
         NSIRP = ISL
       ENDIF
      ENDDO 

C***  roman pot end plate,magnet components and beam pipes
 4    CALL POTGEO('SEND')
      IF(DETV(LGESL_HOD2).EQ.'SZ1L') CALL SZ1G96
      IF(DETV(LGESL_HOD1).EQ.'SZ0L') CALL SZ0G96

      CALL MAGGEO
      CALL PIPGEO                     !   pure tube
      CALL PIPG96                     !   support and blind flange
      CALL EBMGEO('MAGN')

C***  Tracker

      I = 0
 10   I = I + 1
      IF(I.GT.NGESL()) GO TO 20
      ISL = IND(I)

C***  Silicon in Magnet
      IF(IGESL_CMP(ISL).EQ.LGESL_SIL.AND.ISL.GT.NSIRP) THEN
         IF(DETV(LGESL_SIL).EQ.'SIDS'.OR.DETV(LGESL_SIL).EQ.'SIDL')THEN
            IF(IGESL_MFL(ISL).EQ.1) THEN
               CALL SIPG96(ISL)
            ELSE
               CALL SOTR96(ISL)
            ENDIF
         ELSE IF(DETV(LGESL_SIL).EQ.'SIDU') THEN
            CALL SIUGEO(ISL)
         ENDIF
         GO TO 10

C***  Inner Tracker
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_MSG) THEN
         IF(DETV(LGESL_MSG).EQ.'MTDS'.OR.DETV(LGESL_MSG).EQ.'MTDL')THEN
            CALL MTLG96(ISL)
         ELSEIF(DETV(LGESL_MSG).EQ.'MTDU') THEN
            CALL MTUGEO(ISL)
         ENDIF
         GO TO 10

C***  Outer Tracker
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_WCH) THEN
         IF(DETV(LGESL_WCH).EQ.'WTDS'.OR.DETV(LGESL_WCH).EQ.'WTDL')THEN
            CALL OTRGEO(ISL)
         ELSE IF(DETV(LGESL_WCH).EQ.'WTDU') THEN
            CALL OTUGEO(ISL)
         ENDIF
         GO TO 10

C***  PT chambers
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_PTC) THEN
         IF(DETV(LGESL_PTC).EQ.'PTLS'.OR.DETV(LGESL_PTC).EQ.'PTLL')THEN
            CALL PTLGEO(ISL)
         ELSE IF(DETV(LGESL_PTC).EQ.'PTLU') THEN
            CALL PTUGEO(ISL)
         ENDIF
         GO TO 10

C***  RICH counter or SZ counters in RICH region
 
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_HOD3) THEN
         IF(DETV(LGESL_HOD3).EQ.'SZ2L') CALL SZ2G96(ISL)
         GO TO 10

      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_HOD2.AND.IGESL_NSL(ISL).EQ.2)THEN
          IF(DETV(LGESL_HOD2).EQ.'SZ1L') CALL SZ3G96(ISL)
          GO TO 10

C***  TRD
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_TRSL) THEN
         IF(DETV(LGESL_TRSL).EQ.'TRDS'.OR.DETV(LGESL_TRSL).EQ.'TRDL')
     +                                                           THEN
            CALL TRDG97
         ELSE IF(DETV(LGESL_TRSL).EQ.'TRDU') THEN
            CALL TRUGEO
         ENDIF
         GO TO 10

C***  CAL - electromagnetic calorimeter
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_ECA) THEN
         CALL CALGEO
C--   electron beam pipe inside CAL
         CALL EBMGEO('CALO')
         GO TO 10

C***  MUON - muon spectrometer
      ELSEIF(IGESL_CMP(ISL).EQ.LGESL_MUON) THEN
       IF(DETV(LGESL_MUON).EQ.'MUDS'.OR.DETV(LGESL_MUON).EQ.'MUDL')THEN
            CALL MUOG96
            CALL MUOSET
         ELSEIF(DETV(LGESL_MUON).EQ.'MUDU') THEN
            CALL MUUGEO
         ENDIF
c--   electron beam pipe inside MUON
         CALL EBMGEO('MUON')
         GO TO 10
      ENDIF 
      GO TO 10

C***  define sensitive TRACKER detectors
 20   CALL SILSET

 999  RETURN
      END



