#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <math.h>
#include "gean/hgdat.h"
#include "arte/Arte.hh"
#include "auto/GESL.hh"
/*
    written by Siegmund Nowak
    This routine reads in the ASCII files with GESL informations and stores 
    them into the GESL-bank. It is called from GEOMAIN.
    The input parameter must be the ascii file name.
*/
// ------------------------------------------------------------------------
  FILE *GESL_input, *utfilp(char*,char*);
  struct GESL gesl;

// ------------------------------------------------------------------------  
  extern "C" {
  void meerro_(char*);
  void gesldat_(char *name); }

// ------------------------------------------------------------------------  
  void gesldat_(char* name) {
  int isl[32]={0};
  char   buffer[256], C78[78],  tag[4], taga[16];

  GESL_input = utfilp(name,"\n"); 
  if(!GESL_input) {
     strcpy(C78,"Can not open ");
     int len=strlen(name);
     int i;
     for (i=len;i<64;i++) name[i]=' ';
     name[64]='\0';
     strncat(C78,name,len);
     meerro_(C78);      }
  
  for(;;) {
     int i=0;
     if(fgets(buffer,256,GESL_input) == NULL) {
        if(feof(GESL_input)) {
           fclose(GESL_input);
           fprintf(stdout," === CLOSE FILE  %s\n",name);    
           break;                                    }}
          
     char   *card=&buffer[0];
     int nitem=sscanf(card,"%s",tag);
     if (nitem!=1 || strstr(tag,"#")!=0){} 
     else{
     char *stop;
     fillstr(tag,4);
     strcpy(gesl.name,tag);
     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.cmp = strtol(taga,&stop,0);
     isl[gesl.cmp-1]=isl[gesl.cmp-1]+1;
     gesl.nsl=isl[gesl.cmp-1]; 

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",tag);
     fillstr(tag,4);
     if (!strcmp(tag,"BOX "))      gesl.shp = 1;
     else if(!strcmp(tag,"TRD2"))  gesl.shp = 3;
     else if(!strcmp(tag,"TUBE"))  gesl.shp = 5;
     else                          gesl.shp = 0; 

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.lay  = strtol(taga,&stop,0);

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.ltyp = strtol(taga,&stop,0); 

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.mfl= strtol(taga,&stop,0);

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.x1 = strtod(taga,&stop);

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.x2 = strtod(taga,&stop);

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.y1  = strtod(taga,&stop);

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.y2  = strtod(taga,&stop);

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.z1 = strtod(taga,&stop); 

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",taga);
     gesl.z2 = strtod(taga,&stop); 

     if(gesl.shp==3) {
        card+=itemlength(card,nitem);
        nitem = sscanf(card,"%s",taga);
        gesl.dx = strtod(taga,&stop);

        card+=itemlength(card,nitem);
        nitem = sscanf(card,"%s",taga);
        gesl.dy = strtod(taga,&stop);
     }        

     gesl.fpl = 0;
     gesl.npl = 0;
     gesl.fwl = 0;
     gesl.nwl = 0;

      ArtePointer<GESL>::append(gesl);                         
   }}
}


