      SUBROUTINE HGKINE

************************************************************************
*
* HGKINE
* written by Siegmund Nowak
*
* This routines translates ARTE tables (MTRA,MVER) from event
* generator into GEANT structures JVERT, JTRACK  
*
*       called from HGEVNT
************************************************************************

      IMPLICIT NONE

      REAL PLAB(3),VERTEX(3),UBUF(1)
      INTEGER I, ILL, J, I1, I2, IL1, NBOOK, IPNUCL
      INTEGER NVX,KFA,NT,NVORIG,ITORIG,IPORIG
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gckine.fi"
#include "gean/gclist.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGDETV.fi"
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "gean/ZGESL.fi"
#include "auto/MC.fi"
#include "auto/TOPP.fi"
#include "auto/TMP1.fi"
#include "auto/TMP2.fi"

#include "arte/Arte.ff"
#include "auto/MC.ff"
#include "auto/TOPP.ff"
#include "auto/TMP1.ff"
#include "auto/TMP2.ff"

C---       INITIALISATION

      IF(JMVER.EQ.0) CALL MMBOOK(JMVER,0)
      IF(JMTRA.EQ.0) CALL MMBOOK(JMTRA,0)
      IF(JMIMP.NE.0) CALL MMDROP(JMIMP)
      IF(JMCAL.NE.0) CALL MMDROP(JMCAL)

      CALL MMBOOK(JMIMP,0)
      CALL MMBOOK(JMCAL,0)

c     TMP1 .. TMP2 will be used  for relations :

      CALL MMBWRK(JTMP0,0,1,100)     ! temporary ARTE MVER - GEANT NVERTX
      CALL MMBOOK(JTMP0,100)
      CALL MMBWRK(JTMP9,0,1,500)
      CALL MMBOOK(JTMP9,500)
      CALL MMBWRK(JTMP1,0,1,500)     ! GEANT NVERTX - ARTE MVER
      CALL MMBWRK(JTMP2,0,5,1000)
c     JTMP2 is foreseen for: 1  relation GEANT ITRA - ARTE MTRA
c                            2  number of mimps/mcals on itra
c                            3  length of the track
c                            4  ARTE flag of the track
C                            5  cascade point in calorimeter
    
      IQ(JHEAD+6) = 0

      I2 = 0
      DO J = 1, NMCME()
       I1 = I2 + 1
       IF(IMVER_FLAG(I1) .EQ. 0) THEN
          CALL VERDIS(VERTEX)
          IF(J .NE. NMCME())  THEN
             I2 = OMCME_MVER(J+1) - 1
          ELSE
             I2 = NMVER()
          END IF
          DO I=I1,I2
           Q(QMVER_X(I)) = FMVER_X(I) + VERTEX(1)
           Q(QMVER_Y(I)) = FMVER_Y(I) + VERTEX(2)
           Q(QMVER_Z(I)) = FMVER_Z(I) + VERTEX(3)
          ENDDO
          IQ(IQMVER_FLAG(I1)) = 1
       ENDIF
      ENDDO

      DO 1 ILL = 1,NMTRA()               ! loop over all tracks
      NT = 0

      IF(IMTRA_FLAG(ILL).EQ.2) GO TO 2   ! the particle is a resonance

      NVORIG = IMTRA_ORIG(ILL)           ! no resonance - find vertex
 10   CONTINUE
      IF(NVORIG .GT. 0) THEN
         IF(IQ(JTMP0-1).LT.(NVORIG+2)) CALL MMBOOK(JTMP0,100)
         IF(IQ(JTMP0+2+NVORIG).EQ.0) THEN  ! vertex is not translated to GEAN
            VERTEX(1) = FMVER_X(NVORIG)
            VERTEX(2) = FMVER_Y(NVORIG)
            VERTEX(3) = FMVER_Z(NVORIG) + ZZERO
            ITORIG = OMVER_BTRA(NVORIG)  ! find the vertex origin
            IF(ITORIG.GT.0) THEN
               IPORIG = OMTRA_TOPP(ITORIG) ! find particle ID
               IPORIG = ITOPP_GEAN(IPORIG) ! and  delete decay products of K0
               IF(IPORIG.EQ.10.OR.IPORIG.EQ.16) GO TO 2
               ITORIG = IQ(JTMP9+2+ITORIG)
            ENDIF
            CALL GSVERT(VERTEX,ITORIG, 0, UBUF,0 , NVX ) ! register in GEANT
            IQ(JTMP0+2+NVORIG) = NVX       ! fill vertex rel ARTE -GEANT
            NBOOK = NVX - NTMP1()
            IF(NBOOK.GT.0) CALL MMBOOK(JTMP1,NBOOK)
            IQ(JTMP1+2+NVX) = NVORIG
         ELSE
            NVX = IQ(JTMP0+2+NVORIG)       ! vertex was already translated
         ENDIF
      ELSE
         IL1 = - NVORIG                    ! ORIG is a resonance, go back
         NVORIG = IMTRA_ORIG(IL1)          ! to a real vertex
         GO TO 10
      ENDIF

c     the particle is no resonance - make an entry for GEANT

      KFA = OMTRA_TOPP(ILL)                ! translate
      IF(KFA.EQ.20.OR.KFA.EQ.21 .OR. KFA.EQ.24.OR.KFA.EQ.25 .OR.
     +   KFA.EQ.28.OR.KFA.EQ.29)   KFA = 17      ! all neutrinos 
      IPART = ITOPP_GEAN(KFA)              ! particle ID to GEAN
      IF(IPART.GT.58) IPART = 0  ! preliminary: resonances are not inside geant
      IF(KFA.GE.497) IPART = IPNUCL(KFA) !preliminary: for Ions no itopp_gean

      IF(IPART.EQ.0) THEN 
         C78 = 'HGKINE: Particle '
         CALL CH78AI(KFA)
         CALL CH78BC('is not foreseen in GEANT')
         CALL ME78PC(878797,10)
         GO TO 2
      ENDIF 

      IF(IPART.EQ.10.OR.IPART.EQ.16) IQ(IQMTRA_FLAG(ILL)) = 0

      PLAB(1)      = FMTRA_PX(ILL)
      PLAB(2)      = FMTRA_PY(ILL)
      PLAB(3)      = FMTRA_PZ(ILL)
      CALL GSKINE( PLAB, IPART, NVX, UBUF, 0, NT ) ! register track in GEAN
      IF(NT.EQ.0) THEN
         C78 = 'HGKINE: TRACK BOOKING ERROR AT ILL = '
         CALL CH78AI(ILL)
         CALL CH78BC('for IPART = ')
         CALL CH78AI(IPART)
         CALL ME78MC(878798,10,1000)
         GO TO 2
      ENDIF

      NBOOK = NT - NTMP2()
      IF(NBOOK.GT.0) CALL MMBOOK(JTMP2,NBOOK)
      IQ(JTMP2+3+(NT-1)*NCTMP2()) = ILL
      IQ(JTMP2+4+(NT-1)*NCTMP2()) = 0
      Q (JTMP2+5+(NT-1)*NCTMP2()) = FMTRA_ML(ILL)
      IQ(JTMP2+6+(NT-1)*NCTMP2()) = IMTRA_FLAG(ILL)
      IQ(JTMP2+7+(NT-1)*NCTMP2()) = 0
 2    IF(IQ(JTMP9-1).LT.(ILL+2)) CALL MMBOOK(JTMP9,500) 
      IQ(JTMP9+2+ILL) = NT                 ! fill track rel ARTE - GEAN
 1    CONTINUE

 999  IQ(JHEAD+7) = NVERTX
      IQ(JHEAD+8) = NTRACK

      CALL MMDROP(JTMP0)
      CALL MMDROP(JTMP9)

      CALL MMBWRK(JTMP3,0,7,1000) ! intermediate store for calorimeter points (MTCP) 
      CALL MMBWRK(JTMP4,0,9,1000) ! intermediate store for TRD HITs(long version)
      CALL MMBWRK(JTMP5,0,8,1000) ! intermediate store for RICH hits
      CALL MMBWRK(JTMP6,0,8,1000) ! intermediate store for DET HITs
      CALL MMBWRK(JTMP7,0,1,1000) ! GEANT HIT  - DET plane
      CALL MMBWRK(JTMP8,0,2,1000) ! intermediate store for calorimeter MCALs
      CALL MMBWRK(JTMP9,0,1,1000) ! GEANT HIT  - CAL plane
      RETURN
      END
