// 
// Boris Fominykh  18.01.1998
//

extern "C" {
  void mustini_();
  void mustprint_();
  int mustadd_(char*);
  void gsvolu_();
  void gsatt_();
  void cggesl_();
  void crpos_();
  void crrotm_();
  void mednumc_();
  void muomed_();
};

struct MuMothVol {
  char NameMoth[5];
  float Zmoth;
  int MothSL;
  int SupLayCheck[4][2];
  int Ndsl[4], Ncsl[4];
  float Zdsl[4], Zcsl[4];
  char NameDSL[4][5], NameCSL[4][5];
  int Mother();
  int SupLay(int,int);
};

class MuGeoSimple {
  char Mother[5], Shape[5], Volname[5], MaOn[5], Colo[5];
  char Mater[13];
  int Sens,Mednum,Ncopy,Irotm,Ncolo;
  float Angl,Zmuon;

  int  NvolD;
  char GeaVolD[30][5]; 
  char ManyD[30][5]; 
  char MednD[30][13]; 
  int  NcopyD[30];
  int  SensD[30];
  int  ColoD[30];
public: 
// constructor
  MuGeoSimple(MuMothVol*,char*);

  void Print(int);
  int  Position(char*,char*,int,int,float,float*);
private:
  int  GeanVolume();
  void GetName(int);
};


class MuGeoChamTube {

  char Mother[2][5];
  char Volname[2][5];
  float Zmother[2];
  int  Ncopy[2];

  char Shape[5], MaOn[5], Colo[5];
  char Mater[13];
  char Type[5];
  char Version[6];
  char MatWall[13];
  char MatGas[13];
  char ChambName[9];
  int  Sens, Mednum, Irotm, Ncolo;
  float Angl;
  float Efficiency;
  float Pitch, DriftDist, Xwidth, Zwidth, Wall, Overlap; 
  int Nwire;

  char ShapePlate[5];
  char MatPlate[13];
  char VolNamePlate[5];
  float ZmothPl;
  int NcopyPlate;
  int MedNumPlate;
  float PlateLeng[3], PlateBase[3];
  float PlateWid, PlateThick, PlateShift;

public: 
// constructor
  MuGeoChamTube(MuMothVol*, char*);

  void Print(int);
  void Param(char*,char*,char*,float*);
  int  Position(MuMothVol*,int,int,int,float,float*);
private:
  void ChamberName(int);
  void FillGede(int);
};

class MuGeoChamPad {

  char Shape[5], MaOn[5], Colo[5];
  char Mater[13];
  char Type[5];
  char Version[6];
  char MatWall[13];
  char MatGas[13];
  char ChambName[9];
  int Sens, Mednum, Irotm, Ncolo;
  float Angl;
  float Efficiency;
  float Pitch, DriftDist, Xwidth, Zwidth, Wall, Overlap; 
  int Nwire;

  char Mother[2][5];
  char Volname[2][5];
  float Zmother[2];
  int  Ncopy[2];
  float Npad[2];
  float ZPadSh[2], ZPwirPad[2], XPsize[2], XPedge[2], XPgap[2];
  float YP1size[2], YP2size[2], YPedge[2], YPgap[2];
  float YPeff0[2], EffPmid[2];

  char ShapePlate[5];
  char MatPlate[13];
  char VolNamePlate[5];
  float ZmothPl;
  int NcopyPlate;
  int MedNumPlate;
  float PlateLeng[2], PlateBase[2];
  float PlateWid, PlateThick, PlateShift;

public: 
// constructor
  MuGeoChamPad(MuMothVol*, char*);

  void Print(int);
  void Param(char*,char*,char*,int,float*);
  int  Position(MuMothVol*,int,int,float*);
private:
  void ChamberName(int);
  int  FillGede(int,int,float);
};

class MuGeoChamPix {

  char Shape[5], MaOn[5], Colo[5];
  char Mater[13];
  char Type[5];
  char Version[6];
  char ChambName[9];
  int Sens, Mednum, Irotm, Ncolo;
  float Angl;
  float Efficiency;

  char Mother[4][5];
  char Volname[4][5];
  float Zmother[4];
  int  Ncopy[4];
  float Xwidth[4], Ywidth[4], Zwidth[4]; 
  float NXpix[4], NYpix[4], NXpixCon[4], NYpixCon[4]; 
  float XpixSize[4], YpixSize[4], RholeSens[4];

public: 
// constructor
  MuGeoChamPix(MuMothVol*, char*);

  void Print(int);
  void Param(char*,int,float*);
  int  Position(MuMothVol*,int,int,float*);
private:
  void ChamberName(int);
};
