
      SUBROUTINE KAGMAT

************************************************************************
*-- Author :    Siegmund Nowak   12/07/96
*
* Description:  action routine for KUIP command gmat, reads in material
*               constants and stores them into ARTE table GMAT
*
* Called from:  KUIP
*
* External references:
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/GMAT.fi"
#include "auto/GMIX.fi"
      INTEGER MEDFLG,L,LL,IX,I,NMIX,INMIX,ILAST,IFIRST
      REAL A_MEAN,Z_MEAN,DENS,DNSOLD,RADLEN,ABSLEN,AEFF,ZEFF,REFF,ALEFF
      REAL A_MIX(10),Z_MIX(10),W_MIX(10),D_MIX(10),WEIGHT,VOL,AMOL
      REAL DEDX 
      CHARACTER*12 NAM_MIX(10),CNAME,CNU,CC
      SAVE IFIRST
      DATA IFIRST /0/
#include "arte/Arte.ff"
#include "auto/GMAT.ff"
#include "auto/GMIX.ff"

      IF(IFIRST.EQ.0) THEN
         IF(JGMAT.EQ.0) CALL MMBOOK(JGMAT,0)
         IF(JGMIX.EQ.0) CALL MMBOOK(JGMIX,0)
         IFIRST = 1
      ENDIF

      CALL KUGETC (CNAME, L)
      CALL KUGETR (A_MEAN)
      CALL KUGETR (Z_MEAN)
      CALL KUGETR (DENS)
      DNSOLD = DENS
      CALL KUGETR (RADLEN)
      CALL KUGETR (ABSLEN)
      CALL KUGETR (DEDX)
      CALL KUGETI (MEDFLG)
      CALL KUGETI (NMIX)
      INMIX = IABS(NMIX)
      IF(INMIX.GT.1) THEN
         WEIGHT = 0.
         VOL = 0.
         AMOL = 0
         DO I = 1,INMIX
          CALL KUGETC (NAM_MIX(I),LL)
          DO IX =1,NGMAT()
           CALL CHHTOC (IQ(HQGMAT_NAME(1,IX)), CC)
           CALL CLTOU (CC)
           IF(NAM_MIX(I) .EQ. CC)  THEN
              A_MIX(I) = FGMAT_A(IX)
              Z_MIX(I) = FGMAT_Z(IX)
              D_MIX(I) = FGMAT_DENS(IX)
              GO TO 5
           ENDIF
          ENDDO
          IF(NMIX.GT.0) THEN
             C78 = 'Mixture component'
             CALL CH78BC(NAM_MIX(I))
             CALL CH78BC('with volume weights must be defined before')
             CALL ME78ER
          ENDIF
          CALL KUGETR (A_MIX(I))
          CALL KUGETR (Z_MIX(I))
 5        CALL KUGETR (W_MIX(I))
          IF(NMIX.GT.0) THEN
             VOL    = W_MIX(I) + VOL
             W_MIX(I) = W_MIX(I)* D_MIX(I)
             WEIGHT = W_MIX(I) + WEIGHT
          ELSE
             AMOL = AMOL + W_MIX(I)*A_MIX(I)
          ENDIF
         ENDDO
         DO I=1,INMIX
          IF(NMIX.GT.0) THEN
             W_MIX(I) = W_MIX(I)/WEIGHT
          ELSE
             W_MIX(I)= W_MIX(I)*A_MIX(I)/AMOL
          ENDIF
         ENDDO
         IF(NMIX.GT.0) DENS = WEIGHT/VOL
      ENDIF

      CNU = CNAME
      CALL CLTOU (CNU)
      DO 10 IX = 1, NGMAT()
        CALL CHHTOC (IQ(HQGMAT_NAME(1,IX)), CC)
        CALL CLTOU (CC)
        IF(CNU .EQ. CC)  THEN
           C78 = CNAME(1:L)
           CALL CH78BC('has been already booked - see entry')
           CALL CH78BI(IX)
           CALL ME78WA
           GO TO 20
        ENDIF
 10   CONTINUE

      CALL MMBOOK (JGMAT, 1)
      CALL CHCTOH (CNAME, IQ(HQGMAT_NAME(1,IX)), 3)
      IX = NGMAT()
 20   ILAST = NGMIX()
      IF(INMIX.GT.1) THEN
         CALL MEDMIX(A_MIX,Z_MIX,W_MIX,DENS,INMIX,AEFF,ZEFF,REFF,ALEFF)
         IF(ABS(AEFF-A_MEAN)/(AEFF+A_MEAN).GT..001 .OR.
     +      ABS(ZEFF-Z_MEAN)/(ZEFF+Z_MEAN).GT..001 .OR.
     +      ABS(REFF-RADLEN)/(REFF+RADLEN).GT..001 .OR.
     +      ABS(ALEFF-ABSLEN)/(ALEFF+ABSLEN).GT..001 .OR.
     +      ABS(DENS-DNSOLD)/(DENS+DNSOLD).GT..001) THEN
            C78 = 'FOR'
            CALL CH78BC(CNAME(1:L))
            CALL CH78BC('new mixture parameters were calculated:')
            CALL ME78WA
            print *, 'old: ', A_MEAN,Z_MEAN,DNSOLD,RADLEN,ABSLEN
            print *, 'new: ', AEFF,ZEFF,DENS,REFF,ALEFF
         ENDIF
         A_MEAN = AEFF
         Z_MEAN = ZEFF
         RADLEN = REFF
         ABSLEN = ALEFF
         IQ(IQGMAT_GMIX(IX)) = ILAST + 1
         CALL MMBOOK(JGMIX,INMIX)
         DO I = 1, INMIX
         CALL CHCTOH (NAM_MIX(I), IQ(HQGMIX_NAME(1,ILAST+I)), 3)
         Q(QGMIX_A(ILAST+I)) = A_MIX(I)
         Q(QGMIX_Z(ILAST+I)) = Z_MIX(I)
         Q(QGMIX_W(ILAST+I)) = W_MIX(I)
         ENDDO
      ENDIF

      IF (A_MEAN .GT. 0.)      Q( QGMAT_A   (IX)) = A_MEAN
      IF (Z_MEAN .GT. 0.)      Q( QGMAT_Z   (IX)) = Z_MEAN
      IF (DENS   .GT. 0.)      Q( QGMAT_DENS(IX)) = DENS
      IF (RADLEN .GT. 0.)      Q( QGMAT_RADL(IX)) = RADLEN
      IF (ABSLEN .GT. 0.)      Q( QGMAT_ABSL(IX)) = ABSLEN
      IF (DEDX  .GT. 0 )      Q( QGMAT_LOSS(IX)) = DEDX
      IQ(IQGMAT_FLAG(IX)) = MEDFLG
      IQ(IQGMAT_NMIX(IX)) = INMIX

      RETURN
      END

************************************************************************
* End of KAGMAT
************************************************************************
