
      SUBROUTINE  MTLG96(ISL)

************************************************************************
* MTLGEO
* written by Siegmund Nowak 11/93
*
* this routines defines microstrip gas chamber geometry
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* ISL         in          MT superlayer number
************************************************************************

      IMPLICIT NONE

      INTEGER IFIRST,ISL,NSL,IVOL,IVOLS,IMFLAG,JSG,MEDNUM,NSEC
      REAL PAR(3),PARSV(3),PAREL(3),PARG1(3),PARG2(3),PARG3(3)
      REAL XMIN,XMAX,YMIN,YMAX,XUPWIR,XLOWIR,ZP
      REAL XPEL,YPEL,ZPEL,XELMN,XELMX,XPSV,YPSV,ZPSV,XMS
      REAL XPG1,YPG1,XPG2U,YPG2U,XPG2L,YPG2L,XPG3,YPG3
      CHARACTER*4  NAM
      SAVE IFIRST
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGITR.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA IFIRST/0/,JSG/0/
#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--          DEFINE VOLUMINA FOR CHAMBERS AT FIRST ENTRY

      IF(IFIRST.EQ.0) THEN
         CALL ITRDAT('mtl97.dat')
         CALL MTLMED

         CALL GSVOLU('MTWM','BOX ',MEDNUM(2,'ROHACELL'),PAR,0,IVOL)
         CALL GSVOLU('MTLM','BOX ',MEDNUM(4,'ITR_LAYER'),PAR,0,IVOLS)
         CALL GSVOLU('MTEM','BOX ',MEDNUM(2,'AL2O3'),PAR,0,IVOL)
         CALL GSVOLU('MTG2','BOX ',MEDNUM(2,'GLASS'),PAR,0,IVOL)
         CALL GSVOLU('MTKM','BOX ',MEDNUM(2,'MYLAR'),PAR,0,IVOL)
         CALL GSVOLU('MTHM','BOX ',MEDNUM(2,'ROHACELL'),PAR,0,IVOL)
         IFIRST = 1
      ENDIF

C--          DEFINE THE SUPERLAYER VOLUMINA AND POSITION
      CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,NAM,4)
      IMFLAG = IGESL_MFL(ISL)
      IF(IMFLAG.EQ.0) THEN
         CALL CGGESL(NAM,'MOTH',0)
      ELSE
         CALL CGGESL(NAM,'MAGN',0)
      ENDIF
      CALL GSATT(NAM,'COLO',-7)
      NSL = IGESL_NSL(ISL)

      IF(IDEBUG.NE.0) WRITE(LPRNT,*)
     +  'START ',NAM,' ',FGESL_Z1(ISL),FGESL_Z2(ISL)

      ZP = 0.

      PAR(1) =  XMMT(ISL)
      PAR(2) =  YMMT(ISL)
      PAR(3) = .5 * DWALMT
c      CALL GSPOSP('MTWM',NGEDE()+1,NAM,0.,2.5,ZP,0,'MANY',PAR,3)
      ZPSV = ZP
      ZPEL = ZP

c     each real sector is divided into two GEAN sectors, nsec = 1
c     stands for the leftmost of these two sectors
      NSEC = 1
      XMS=0.

 70   XMIN = XLMT(NSL,NSEC)
      XMAX = XRMT(NSL,NSEC)
      YMIN = YLMT(NSL,NSEC)
      YMAX = YRMT(NSL,NSEC)

c     first the chambers itself will be generated
      PARSV(1) = .5 * (XMAX-XMIN)
      PARSV(2) = .5 * (YMAX-YMIN)
      PARSV(3) = .5 * DCELMT
      XPSV = .5*(XMIN+XMAX)
      YPSV = .5*(YMIN+YMAX)
      CALL CRPOS('MTLM',NAM,1,NSEC,XPSV,YPSV,ZPSV,0,'ONLY',PARSV)
      Q(QGEDE_ACC_L()) = SIGMT
      Q(QGEDE_EFF_L()) = EFFMT
      Q(QGEDE_PIT_L()) = PITMT
      Q(QGEDE_DOD_L()) = DIMXMT
      IQ(IQGEDE_NSL_L())  = 1

      IF(NSEC.EQ.1) THEN
         Q(QGEDE_SXMN_L()) = XMIN + RANDMT
         Q(QGEDE_SXMX_L()) = XMAX
         XLOWIR            = XMIN + RANDMT + .5*PITMT
         XUPWIR            = XMAX          - .5*PITMT
      ELSE
         Q(QGEDE_SXMN_L()) = XMIN
         Q(QGEDE_SXMX_L()) = XMAX - RANDMT
         XLOWIR            = XMIN          + .5*PITMT
         XUPWIR            = XMAX - RANDMT + .5*PITMT
      ENDIF
      Q(QGEDE_SYMN_L()) = YMIN + RANDMT
      Q(QGEDE_SYMX_L()) = YMAX - RANDMT

      Q(QGEDE_XFW_L(1))  = XLOWIR
      Q(QGEDE_ZFW_L(1))  = FGEDE_ZMIN(NGEDE()) + DGL1MT + DAUXMT
      Q(QGEDE_ZFW_L(2))  = FGEDE_ZFW(1,NGEDE()) + DGASMT
      IQ(IQGEDE_NWI_L(1)) = (XUPWIR-XLOWIR)/PITMT + 1.001

      IF(NSEC.EQ.1) THEN
         CALL GRADLN(IVOLS,XMS)
         XMS = DCELMT/XMS
      ENDIF
      Q(QGEDE_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2

c     next create the electronics. Here only one board is created for
c     both sectors, associated to the second sector
      IF(NSEC.EQ.1) THEN
         XELMN = XMIN
         XELMX = XMAX
      ELSE
         XELMN = AMIN1(XELMN,XMIN)
         XELMX = AMAX1(XELMX,XMAX)
         PAREL(1) = .5 * (XELMX-XELMN)
         PAREL(2) = .5 * BRELMT
         PAREL(3) = .5 * DECHMT
         XPEL = .5 * (XELMN+XELMX)
         YPEL = YLMT(NSL,NSEC) - YEOVMT - 0.5* BRELMT
         CALL GSPOSP('MTEM',NGEDE(),NAM,
     +                   XPEL,YPEL,ZPEL,0,'ONLY',PAREL,3)

      ENDIF

c     glas border on the left and right hand side of the MSGC
      PARG1(1) = .165
      PARG1(2) = PARSV(2) + .33
      PARG1(3) = .043

      IF(NSEC.EQ.2) THEN
         XPG1 = XMAX + PARG1(1)
         YPG1 = YPSV
      ELSEIF(NSEC.EQ.1) THEN
         XPG1 = XMIN - PARG1(1)
         YPG1 = YPSV
      ENDIF

      CALL GSPOSP('MTG2',4*NGEDE()-3,NAM,XPG1,YPG1,ZPSV,
     +                                            0,'ONLY',PARG1,3)

c     glas border on top and bottom of the MSGC
      PARG2(1) = PARSV(1)
      PARG2(2) = .165
      PARG2(3) = .043
      XPG2U = XPSV
      YPG2U = YMAX + PARG2(2)
      XPG2L = XPSV
      YPG2L = YMIN - PARG2(2)
      CALL GSPOSP('MTG2',4*NGEDE()-2,NAM,XPG2U,YPG2U,ZPSV,
     +                                              0,'ONLY',PARG2,3)
      CALL GSPOSP('MTG2',4*NGEDE()-1,NAM,XPG2L,YPG2L,ZPSV,
     +                                              0,'ONLY',PARG2,3)

c     glas border on left/right side for inner part
      PARG3(1) = .165
      PARG3(3) = .043
      PARG3(2) = .5 * (YMAX-YRMT(NSL,2))
      XPG3 = XMAX + PARG3(1)
      YPG3 = YMAX - PARG3(2)
      CALL GSPOSP('MTG2',4*NGEDE(),NAM,XPG3,YPG3,ZPSV,0,'ONLY',PARG3,3)
      NSEC = NSEC + 1
      IF(NSEC.EQ.2) GO TO 70

 90   RETURN
      END


