      SUBROUTINE MUGEDE(CHTYPE,ILAY)
************************************************************************
*
* MUGEDE
* written by Siegmund Nowak 97/01/08
*
* This routines supplements muon chamber specifics to GEDE banks 
*
*       called from MUOGEO
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*  chtype     in          chamber type 
************************************************************************

      IMPLICIT NONE
      INTEGER CHTYPE,J,NPADS,ILAY
      REAL ALPADS,WW,WWX,WWY,ZPOS,FACTOR
#include "arte/Arte.fi"
#include "gean/ZGMUON.fi"
#include "auto/GEDE.fi"
#include "arte/Arte.ff"
#include "auto/GEDE.ff"

      IF(CHTYPE.EQ.1) THEN
         Q(QGEDE_ACC_L()) = ACMU
         Q(QGEDE_EFF_L()) = EFMU(1)
         Q(QGEDE_PIT_L()) = PIMU
         Q(QGEDE_DOD_L()) = DMMU
         IQ(IQGEDE_NWI_L(1)) = NUMWMU
         Q(QGEDE_XFW_L(1)) = DXFWMU
         Q(QGEDE_ZFW_L(1)) =.5*(FGEDE_ZMIN(NGEDE())+FGEDE_ZMAX(NGEDE())) 
         Q(QGEDE_XFW_L(4)) = OVMUO

         Q(QGEDE_SXMN_L()) = FGEDE_XMIN(NGEDE())+DXFWMU-DMMU
         Q(QGEDE_SXMX_L()) = FGEDE_XMAX(NGEDE())-DXFWMU+DMMU
         Q(QGEDE_SYMN_L()) = FGEDE_YMIN(NGEDE())
         Q(QGEDE_SYMX_L()) = FGEDE_YMAX(NGEDE())


      ELSEIF(CHTYPE.EQ.2.OR.CHTYPE.EQ.3) THEN
         J=CHTYPE
         Q(QGEDE_ACC_L()) = ACMU      ! measurement accuracy
         Q(QGEDE_EFF_L()) = EFMU(2)   ! efficiency
         Q(QGEDE_PIT_L()) = PIMU      ! pitch
         Q(QGEDE_DOD_L()) = DMMU      ! max drift distance
 
         Q(QGEDE_SXMN_L()) = FGEDE_XMIN(NGEDE())+DXMUPD(6*(J-2)+2)
         Q(QGEDE_SXMX_L()) = FGEDE_XMAX(NGEDE())-DXMUPD(6*(J-2)+2)
         Q(QGEDE_SYMN_L()) = FGEDE_YMIN(NGEDE())+DYMUPD(6*(J-2)+3)
         Q(QGEDE_SYMX_L()) = FGEDE_YMAX(NGEDE())-DYMUPD(6*(J-2)+3)

         ALPADS=FGEDE_YMAX(NGEDE())-FGEDE_YMIN(NGEDE())
     +                       -2.*DYMUPD(6*(J-2)+3)
         NPADS=INT((ALPADS-DYMUPD(6*(J-2)+1)+0.1)/(DYMUPD(6*(J-2)+2)+
     +                                         DYMUPD(6*(J-2)+4)))+1
         IF(NPADS.GT.INT(DXMUPD(6*(J-2)+6))) 
     +                                      NPADS=INT(DXMUPD(6*(J-2)+6))
 
         IQ(IQGEDE_NWI_L(1)) = NUMWMU ! number of wires
         IQ(IQGEDE_NWI_L(2)) = 2      ! number of pads in x-direction
         IQ(IQGEDE_NWI_L(3)) = NPADS  ! number of pads in y-direction
         IQ(IQGEDE_NWI_L(4)) = INT(100.*DYMUPD(6*(J-2)+4)) ! 100*(y-dist between pads) 

         Q(QGEDE_XFW_L(1)) = DXFWMU             ! x-position of first wire
         Q(QGEDE_XFW_L(2)) = DXMUPD(6*(J-2)+1)  ! x-size of pad
         IF(NPADS.LT.INT(DXMUPD(6*(J-2)+6))-1.AND.NPADS.GT.10) THEN
            Q(QGEDE_XFW_L(3)) = DYMUPD(6*(J-2)+2)  ! y-size of 1st pad
         ELSE
            Q(QGEDE_XFW_L(3)) = DYMUPD(6*(J-2)+1)  ! y-size of 1st pad
         ENDIF
         Q(QGEDE_XFW_L(4)) = DYMUPD(6*(J-2)+2)  ! y-size of standard pad

         WW=DXMUPD(6*(J-2)+5)                   ! dist wire-pad

         ZPOS = .5*(FGEDE_ZMIN(NGEDE())+FGEDE_ZMAX(NGEDE()))
         FACTOR = 1.
         IF(ILAY.EQ.2) FACTOR = -1. 
         Q(QGEDE_ZFW_L(1)) = ZPOS + FACTOR*(DXMUPD(6*(J-2)+4)-WW) !z-pos of wire
         Q(QGEDE_ZFW_L(2)) = ZPOS + FACTOR *DXMUPD(6*(J-2)+4)     !z-pos of pad
         Q(QGEDE_ZFW_L(3)) = DYMUPD(6*(J-2)+5)  ! y-dist to point eff=0.
         Q(QGEDE_ZFW_L(4)) = DYMUPD(6*(J-2)+6)  ! efficiency between two pads


      ELSEIF(CHTYPE.GE.4) THEN 
         J=CHTYPE-3
         Q(QGEDE_ACC_L()) = ACMU       ! accuracy
         Q(QGEDE_EFF_L()) = EFMU(3)    ! efficiency
         Q(QGEDE_PIT_L()) = DXMUPX(J)  ! pitch
         Q(QGEDE_DOD_L()) = DXMUPX(J)  ! max drift dist

      WWX=(XRMUX(4*(J-1)+1)-XLMUX(4*(J-1)+1)
     +                               -REAL(NXMUTO(J))*DXMUPX(J))*.5
      Q(QGEDE_XFW_L(1)) = WWX              ! X-dist from edge to pixel
      WWY=(YUMUX(4*(J-1)+1)-YLMUX(4*(J-1)+1)
     +                               -REAL(NYMUTO(J))*DYMUPX(J))*.5
      Q(QGEDE_XFW_L(2)) = WWY              ! Y-dist from edge to pixel
      Q(QGEDE_XFW_L(3)) = DXMUPX(J)        ! x-size of pixel
      Q(QGEDE_XFW_L(4)) = DYMUPX(J)        ! y-size of pixel

      Q(QGEDE_ZFW_L(1)) = .5*(FGEDE_ZMIN(NGEDE())+FGEDE_ZMAX(NGEDE()))! z wire middle
      Q(QGEDE_ZFW_L(2)) =  RSENMX(J)       ! rad of hole in sensitive vol

      IQ(IQGEDE_NWI_L(1)) = NXMUTO(J)  ! number of pixels on X
      IQ(IQGEDE_NWI_L(2)) = NYMUTO(J)  ! number of pixels on Y
      IQ(IQGEDE_NWI_L(3)) = NXMUPX(J)  ! number of connected pixels on X
      IQ(IQGEDE_NWI_L(4)) = NYMUPX(J)  ! number of connected pixels on Y

      Q(QGEDE_SXMN_L()) = FGEDE_XMIN(NGEDE())+WWX
      Q(QGEDE_SXMX_L()) = FGEDE_XMAX(NGEDE())-WWX
      Q(QGEDE_SYMN_L()) = FGEDE_YMIN(NGEDE())+WWY
      Q(QGEDE_SYMX_L()) = FGEDE_YMAX(NGEDE())-WWY

      ENDIF


      RETURN
      END
