// 
// Boris Fominykh  18.01.1998
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <math.h>
#include "gean/hgdat.h"
#include "arte/Arte.hh"
#include "auto/GEDE.hh"
#include "auto/GESL.hh"
#include "gean/ZGESL.h"
#include "gean/ZGMOTH.h"
#include "arte/ArteMessage.hh"
#include "gean/MuGeo.h"
#include "gean/MuGeoMother.icc"
#include "gean/MuGeoSimple.icc"
#include "gean/MuGeoChamTube.icc"
#include "gean/MuGeoChamPad.icc"
#include "gean/MuGeoChamPix.icc"

static char fname[256];
FILE *fmu0; 

extern "C" {
void mugeo_(char* version,char* name) {

// clear the stack list of GEANT volumes
  mustini_();

// control parameter of the card print
  int PrintCont = 0;

// make mother volume
  struct MuMothVol Vol;
  int icheck=Vol.Mother();
  if(icheck != 0) {
    arteMsg << "MUGEO: problems with overall volumes";
    arteMsg.error();
    return ;
  };

// make the objects for dead material
  char* BoxCh = "BOX";
  char* BoxSh = "BOX ";
  MuGeoSimple box(&Vol,BoxSh);
  char* TubeCh = "TUBE";
  MuGeoSimple tube(&Vol,TubeCh);
  char* TubsCh = "TUBS";
  MuGeoSimple tubs(&Vol,TubsCh);
  char* ConeCh = "CONE";
  MuGeoSimple cone(&Vol,ConeCh);

// make the objects for muon chambers
  char* TubChambCh = "TUBE";
  char* PadChambCh = "PAD";
  char* PixChambCh = "PIX";
  char  Version[6];
  if(strcmp(version,"SHORT") && strcmp(version,"LONG")) {
    arteMsg << "MUGEO - unknown version: " << version;
    arteMsg.error();
    return ;
  };
  strcpy(Version,version);
  MuGeoChamTube chamtub(&Vol,Version);
  MuGeoChamPad  champad(&Vol,Version);
  MuGeoChamPix  champix(&Vol,Version);

// offset and rotation parameters
  float Xofs=0.;
  float Yofs=0.;
  float Zofs=0.;
  int  Irotm=0;
  float Angle=0.;
  int   NrotmD=0;
  int   IrotmD[20];
  float AnglD[20];

// layer of chambers
  char ChamMat[15];
  char ChamGas[15];
  char ChamWall[15];
  strcpy(ChamMat,"NOTHING");
  strcpy(ChamGas,"NOTHING");
  strcpy(ChamWall,"NOTHING");
  int Nchpar=36;
  float ChamPar[Nchpar];
  for(int i=0; i<Nchpar; i++) ChamPar[i]=100000.;
  char Type[5];
  int NumCham=0;
  int IdNum[100];
  float PlateCode[100];
  float UpDown[100];
  float LenCham[100];
  float DLenCham[100];
  float XposCham[100];
  float YposCham[100];
  float XbaseCham=0.;
  float YbaseCham=0.;
  float ZbaseCham=0.;
  int Musl=-1;
// open the input file
  char* slbuf;
  char buffer[256];
  int tagid=0;
  strcpy(fname,name);
  fmu0=fopen(fname,"r");
  if(!fmu0) {
    slbuf = getenv("HB");
    strcpy(buffer,slbuf);
    strcat(buffer,"/");
    slbuf = getenv("HBVERS");
    strcat(buffer,slbuf);
    strcat(buffer,"/geo/");  
    strcat(buffer,fname);
    strcpy(fname,buffer);
    fmu0=fopen(fname,"r"); 
    if(!fmu0) {
      arteMsg << "MUGEO: can not open file " << fname;
      arteMsg.error();
      exit(1);}
    else {
      arteMsg << "MUGEO: open file " << fname;
      arteMsg.warn();}
  }
  else {
      arteMsg << "MUGEO: open file " << fname;
      arteMsg.warn();}
  fseek(fmu0,0L,0);

// read the file contents line by line
  int icd=0;
  int npar=0;
  float par[10];
// simbols interpreted as a start of comment
  char idcom1='#';
  char idcom2='*';
  char idcom3='/';
// loops over lines: max 5000 lines
  for(int icc=0; icc<5000; icc++) {
    if(fgets(buffer,256,fmu0) == NULL) {
      fclose(fmu0);
      arteMsg << "MUGEO: close file " << fname;
      arteMsg.warn();
      if(feof(fmu0)) {
        tagid = -1;
        return;
      }
      else { 
        tagid = 1;
        arteMsg << "MUGEO: error in reading " << fname;
        arteMsg.error();
        return ;
      };
    };

// card number
    ++icd;
    char *card;
    card=&buffer[0];
    int sens=0;
// read the first key word 
    char idr[13];
    int nitem=sscanf(card,"%s",idr);
// pass the blank lines
    if(nitem == -1) goto m1;
    if(nitem != 1) goto m2;
// pass the comments
    if(idr[0]==idcom1||idr[0]==idcom2||idr[0]==idcom3){goto m1;};
    card+=itemlength(card,nitem);

// print first 80 characters of card contents
    if(PrintCont == 1) {
      char prbuf[82];
      for(int ipr=0; ipr<80; ipr++) {
        prbuf[ipr]=buffer[ipr];
      };
      arteMsg << icd << ": " << prbuf;
      arteMsg.warn();
    };

// end of file
    if(!strcmp(idr,"end")) {
      fclose(fmu0);
      arteMsg << "MUGEO: close file " << fname;
      arteMsg.warn();
      return ;
    };

// control parameters
    if(!strcmp(idr,"print")) {
      PrintCont = 1;
      arteMsg << "MUGEO: print the cards";
      arteMsg.warn();
      goto m1;
    };

    if(!strcmp(idr,"no_print")) {
      PrintCont = 0;
      arteMsg << "MUGEO: no card print";
      arteMsg.warn();
      goto m1;
    };

// frame
    if(!strcmp(idr,"frame")) {
      nitem=sscanf(card,"%f %f %f",&Xofs,&Yofs,&Zofs);
      if(nitem != 3) goto m2;
      goto m1;
    };

// frame_end
    if(!strcmp(idr,"frame_end")) {
      Xofs=0.; Yofs=0.; Zofs=0.;
      goto m1;
    };

// rotation angle in degrees
    if(!strcmp(idr,"rotation")) {
      nitem=sscanf(card,"%f",&Angle);
      if(nitem != 1) goto m2;
// is it zero?
      if(Angle == 0.) {
        Irotm=0;
        goto m1;}
      else {        
// check if the rotation matrix exists?
       if(NrotmD > 0) {
         for(int i=0; i<NrotmD; i++) {
           if(AnglD[i] == Angle) {
             Irotm=IrotmD[i];
             goto m1;
           };
         };
       };
// book a new rotation matrix
       float fzero=0.;
       float f90=90.;
       float f90p=90.-Angle;
       float anglm=-Angle;
       crrotm_(&Irotm,&f90,&anglm,&f90,&f90p,&fzero,&fzero);
// add it to the list of used rotation matrixes
       AnglD[NrotmD]=Angle;
       IrotmD[NrotmD]=Irotm;
       NrotmD+=1;
       goto m1;
     };
    };

// rotation_end
    if(!strcmp(idr,"rotation_end")) {
      Angle=0.;
      Irotm=0;
      goto m1;
    };
// chamber structure
    char type[5];
    if(!strcmp(idr,"CHAMB_STRUCT")) {
      nitem=sscanf(card,"%s",type);
      if(nitem != 1) goto m2;
      if(strcmp(type,TubChambCh) && strcmp(type,PadChambCh) && strcmp(type,PixChambCh)) {
       arteMsg << "MUGEO: unknown chamber type - " << type;
       arteMsg << " - in CHAMB_STRUCT";
       arteMsg.warn();
       goto m2;
      };
      card+=itemlength(card,nitem);
// loops over parameters
      char key[10];
      Musl=-1;
  mk1:;
      nitem=sscanf(card,"%s",key);
      if(!strcmp(key,"End")) {
       if(!strcmp(type,TubChambCh)) chamtub.Param(ChamMat,ChamGas,ChamWall,ChamPar);
       if(!strcmp(type,PadChambCh)) champad.Param(ChamMat,ChamGas,ChamWall,Musl,ChamPar);
       if(!strcmp(type,PixChambCh)) champix.Param(ChamMat,Musl,ChamPar);
       strcpy(ChamMat,"NOTHING");
       strcpy(ChamGas,"NOTHING");
       strcpy(ChamWall,"NOTHING");
       Musl=-1;
       for(int i=0; i<Nchpar; i++) ChamPar[i]=100000.;
       goto m1;
      };
      card+=itemlength(card,nitem);
      if(!strcmp(key,"Mater")) {
        nitem=sscanf(card,"%s",ChamMat);
        if(nitem != 1) goto mk2;
        card+=itemlength(card,nitem);
        goto mk1;
      };
      if(!strcmp(key,"MU1")) { Musl=0; goto mk1;};
      if(!strcmp(key,"MU2")) { Musl=1; goto mk1;};
      if(!strcmp(key,"MU3")) { Musl=2; goto mk1;};
      if(!strcmp(key,"MU4")) { Musl=3; goto mk1;};
      if(!strcmp(key,"MatWall")) {
        nitem=sscanf(card,"%s",ChamWall);
        if(nitem != 1) goto mk2;
        card+=itemlength(card,nitem);
        goto mk1;
      };
      if(!strcmp(key,"MatGas")) {
        nitem=sscanf(card,"%s",ChamGas);
        if(nitem != 1) goto mk2;
        card+=itemlength(card,nitem);
        goto mk1;
      };

      float param;
      nitem=sscanf(card,"%f",&param);
      if(nitem != 1) goto m1;
      card+=itemlength(card,nitem);
      if(!strcmp(key,"Eff"))         { ChamPar[0]=param; goto mk1; };
      if(!strcmp(key,"Xwidth"))      { ChamPar[1]=param; goto mk1; };
      if(!strcmp(key,"Zwidth"))      { ChamPar[2]=param; goto mk1; };
      if(!strcmp(key,"Overlap"))     { ChamPar[3]=param; goto mk1; };
      if(!strcmp(key,"Pitch"))       { ChamPar[4]=param; goto mk1; };
      if(!strcmp(key,"DriftDist"))   { ChamPar[5]=param; goto mk1; };
      if(!strcmp(key,"Wall"))        { ChamPar[6]=param; goto mk1; };
      if(!strcmp(key,"Zpad_shift"))  { ChamPar[7] =param; goto mk1; };
      if(!strcmp(key,"Zwire_pad"))   { ChamPar[8] =param; goto mk1; };
      if(!strcmp(key,"Xsize"))       { ChamPar[9] =param; goto mk1; };
      if(!strcmp(key,"Xedge"))       { ChamPar[10]=param; goto mk1; };
      if(!strcmp(key,"Xgap"))        { ChamPar[11]=param; goto mk1; };
      if(!strcmp(key,"Y1size"))      { ChamPar[12]=param; goto mk1; };
      if(!strcmp(key,"Y2size"))      { ChamPar[13]=param; goto mk1; };
      if(!strcmp(key,"Yedge"))       { ChamPar[14]=param; goto mk1; };
      if(!strcmp(key,"Ygap"))        { ChamPar[15]=param; goto mk1; };
      if(!strcmp(key,"Yeff0"))       { ChamPar[16]=param; goto mk1; };
      if(!strcmp(key,"Eff_middle"))  { ChamPar[17]=param; goto mk1; };
      if(!strcmp(key,"Ywidth"))      { ChamPar[18]=param; goto mk1; };
      if(!strcmp(key,"NXpix"))       { ChamPar[19]=param; goto mk1; };
      if(!strcmp(key,"NYpix"))       { ChamPar[20]=param; goto mk1; };
      if(!strcmp(key,"NXpixCon"))    { ChamPar[21]=param; goto mk1; };
      if(!strcmp(key,"NYpixCon"))    { ChamPar[22]=param; goto mk1; };
      if(!strcmp(key,"Ysize"))       { ChamPar[23] =param; goto mk1; };
      if(!strcmp(key,"RholeSens"))   { ChamPar[24] =param; goto mk1; };
      if(!strcmp(key,"Npad"))        { ChamPar[25] =param; goto mk1; };
      if(!strcmp(key,"Nwire"))       { ChamPar[26] =param; goto mk1; };
      if(!strcmp(key,"PlLen1"))      { ChamPar[27] =param; goto mk1; };
      if(!strcmp(key,"PlBas1"))      { ChamPar[28] =param; goto mk1; };
      if(!strcmp(key,"PlLen2"))      { ChamPar[29] =param; goto mk1; };
      if(!strcmp(key,"PlBas2"))      { ChamPar[30] =param; goto mk1; };
      if(!strcmp(key,"PlLen3"))      { ChamPar[31] =param; goto mk1; };
      if(!strcmp(key,"PlBas3"))      { ChamPar[32] =param; goto mk1; };
      if(!strcmp(key,"PlWid"))       { ChamPar[33] =param; goto mk1; };
      if(!strcmp(key,"PlThick"))     { ChamPar[34] =param; goto mk1; };
      if(!strcmp(key,"PlShift"))     { ChamPar[35] =param; goto mk1; };

      arteMsg << "MUGEO - unknown key word: " << key;
      arteMsg.warn();
      goto m2;
    };
  mk2:;
// chamber layer
    if(!strcmp(idr,"CHAMB_LAYER")) {
      int nchlay;
      float xchlay,ychlay,zchlay;
      char msl[4];
      nitem=sscanf(card,"%s %s %d %f %f %f",type,msl,&nchlay,&xchlay,&ychlay,&zchlay);
      if(nitem != 6) goto m2;
      card+=itemlength(card,nitem);
      if(strcmp(type,TubChambCh) && strcmp(type,PadChambCh) && strcmp(type,PixChambCh)) {
       arteMsg << "MUGEO - unknown chamber type: " << type;
       arteMsg.warn();
       goto m2;
      };
      card+=itemlength(card,nitem);
      NumCham=nchlay;
      if(!strcmp(msl,"MU1")) Musl=0;
      if(!strcmp(msl,"MU2")) Musl=1;
      if(!strcmp(msl,"MU3")) Musl=2;
      if(!strcmp(msl,"MU4")) Musl=3;
      for(int ii=0; ii<NumCham; ii++) {
        UpDown[ii]=0.;
        IdNum[ii]=0;
        PlateCode[ii]=100000.;
        LenCham[ii]=100000.;
        DLenCham[ii]=100000.;
        XposCham[ii]=100000.;
        YposCham[ii]=100000.;
      };
      XbaseCham=xchlay;
      YbaseCham=ychlay;
      ZbaseCham=zchlay;
      strcpy(Type,type);
      goto m1;
    };
// chamber parameters
    if(!strcmp(idr,"CHAMB")) {
      char lexy[10];
      int nchmin, nchmax;
      nitem=sscanf(card,"%d %d %s",&nchmin,&nchmax,lexy);
      if(nitem != 3) goto m2;
      card+=itemlength(card,nitem);
      if(nchmin > nchmax) goto m2;
      if(nchmin < 1 || nchmin > NumCham) goto m2;
      if(nchmax < 1 || nchmax > NumCham) goto m2;
      for(int ichb=0; ichb<nchmax-nchmin+1; ichb++) {
        if(!strcmp(lexy,"ID_NUM")) {
          nitem=sscanf(card,"%d",&IdNum[nchmin+ichb-1]);
          goto mcp1;
        };
        if(!strcmp(lexy,"PLATE")) {
          nitem=sscanf(card,"%f",&PlateCode[nchmin+ichb-1]);
          goto mcp1;
        };
        if(!strcmp(lexy,"LENGTH")) {
          nitem=sscanf(card,"%f",&LenCham[nchmin+ichb-1]);
          goto mcp1;
        };
        if(!strcmp(lexy,"DLENDN")) {
          UpDown[nchmin+ichb-1]=-1.;
          nitem=sscanf(card,"%f",&DLenCham[nchmin+ichb-1]);
          goto mcp1;
        };
        if(!strcmp(lexy,"DLENUP")) {
          UpDown[nchmin+ichb-1]=1.;
          nitem=sscanf(card,"%f",&DLenCham[nchmin+ichb-1]);
          goto mcp1;
        };
        if(!strcmp(lexy,"X-POS")) {
          nitem=sscanf(card,"%f",&XposCham[nchmin+ichb-1]);
          goto mcp1;
        };
        if(!strcmp(lexy,"Y-POS")) {
          nitem=sscanf(card,"%f",&YposCham[nchmin+ichb-1]);
          goto mcp1;
        };
       arteMsg << "MUGEO: parameter " << lexy << " is unknown";
       arteMsg.warn();
       goto m2;
       mcp1: if(nitem != 1) goto m2;
       card+=itemlength(card,nitem);
      };
      goto m1;
    };
// end of chamber layer
    if(!strcmp(idr,"CHAMB_END")) {
// check that all parameters are filled
      int ierr=0;
      for(int ii=0; ii<NumCham; ii++) {
        if(IdNum[ii] == 0.) {
          ierr+=1;
          arteMsg << "MUGEO: ID_NUMBER of chamber ";
          arteMsg << dec << ii+1 << " is unknown";
          arteMsg.warn();
        };
        if(XposCham[ii] == 100000.) {
          ierr+=1;
          arteMsg << "MUGEO: X-pos of chamber ";
          arteMsg << dec << ii+1 << " is unknown";
          arteMsg.warn();
        };
        if(YposCham[ii] == 100000.) {
          ierr+=1;
          arteMsg << "MUGEO: Y-pos of chamber ";
          arteMsg << dec << ii+1 << " is unknown";
          arteMsg.warn();
        };
        if(!strcmp(Type,TubChambCh) || !strcmp(Type,PadChambCh)) {
          if(LenCham[ii] == 100000.) {
            ierr+=1;
            arteMsg << "MUGEO: LENGTH of chamber ";
            arteMsg << dec << ii+1 << " is unknown";
            arteMsg.warn();
          };
        };
        if(!strcmp(Type,TubChambCh)) {
          if(PlateCode[ii] == 100000.) {
            ierr+=1;
            arteMsg << "MUGEO: PLATE code of tube chamber ";
            arteMsg << dec << ii+1 << " is unknown";
            arteMsg.warn();
          };
          if(UpDown[ii] == 0.) {
            ierr+=1;
            arteMsg << "MUGEO: UpDown of tube chamber ";
            arteMsg << dec << ii+1 << " is unknown";
            arteMsg.warn();
          };
          if(DLenCham[ii] == 100000.) {
            ierr+=1;
            arteMsg << "MUGEO: DLENgth of tube chamber ";
            arteMsg << dec << ii+1 << " is unknown";
            arteMsg.warn();
          };
        };
      };
      if(ierr > 0) {
        arteMsg << "MUGEO: " << dec << ierr;
        arteMsg << " errors - don't create the chamber layer";
        arteMsg.warn();
        goto m1;
      };
// book the chambers
      for(int ichm=0; ichm<NumCham; ichm++) {
        int Chamid=IdNum[ichm];
        par[0]=XposCham[ichm]+XbaseCham+Xofs;
        par[1]=YposCham[ichm]+YbaseCham+Yofs;
        par[2]=ZbaseCham+Zofs;
        par[3]=LenCham[ichm];
        if(!strcmp(Type,TubChambCh)) {
          par[4]=DLenCham[ichm];
          par[5]=UpDown[ichm];
          par[6]=PlateCode[ichm];
          icheck = chamtub.Position(&Vol,Chamid,Musl,Irotm,Angle,par);
	  if(icheck != 0) goto m2;
        };
        if(!strcmp(Type,PadChambCh)) {
          par[4]=0.; par[5]=1.;
          par[6]=PlateCode[ichm];
          icheck = champad.Position(&Vol,Chamid,Musl,par);
	  if(icheck != 0) goto m2;
        };
        if(!strcmp(Type,PixChambCh)) {
          par[3]=0.; par[4]=0.; par[5]=1.;
          icheck = champix.Position(&Vol,Chamid,Musl,par);
	  if(icheck != 0) goto m2;
        };
      };
      goto m1;
    };

// analysis of the rest of the card in the case of dead material
    char shape[5];
    strcpy(shape,idr);
// material & manon
    char matname[20];
    char manon[5];
    nitem=sscanf(card,"%s %s",matname,manon) ;
    if(nitem != 2) goto m2;
    card+=itemlength(card,nitem);
// the case of box or tube segments
    if(!strcmp(shape,BoxCh) || !strcmp(shape,TubsCh)) {
      if(!strcmp(shape,BoxCh)) npar=6;
      if(!strcmp(shape,TubsCh)) npar=8;
      for(int i=0; i<npar; i++) {
       nitem=sscanf(card,"%f",&par[i]);
       if(nitem != 1) goto m2;
       card+=itemlength(card,nitem);
      };
      par[0]=par[0]+Xofs;
      par[1]=par[1]+Yofs;
      par[2]=par[2]+Zofs;
      if(!strcmp(shape,BoxCh)) {
        icheck = box.Position(matname,manon,sens,Irotm,Angle,par);
      };
      if(!strcmp(shape,TubsCh)) {
        icheck = tubs.Position(matname,manon,sens,0,0.,par);
      };
      goto m1;
    };
// the case of tube or cone
    if(!strcmp(shape,TubeCh) || !strcmp(shape,ConeCh)) {
// vacuum or air inside
      char vacuum[10];
      nitem=sscanf(card,"%s",vacuum) ;
      if(nitem != 1) goto m2;
      card+=itemlength(card,nitem);
      int ivacuum=-1;
      if(!strcmp(vacuum,"VACONLY"))  ivacuum=1;
      if(!strcmp(vacuum,"VACMANY"))  ivacuum=2;
      if(!strcmp(vacuum,"AIRONLY"))  ivacuum=3;
      if(!strcmp(vacuum,"AIRMANY"))  ivacuum=4;
      if(!strcmp(vacuum,"NOTHING"))  ivacuum=0;
      if(ivacuum < 0 || ivacuum > 4) goto m2;
// parameters
      if(!strcmp(shape,TubeCh)) npar=6;
      if(!strcmp(shape,ConeCh)) npar=8;
      for(int i=0; i<npar; i++) {
        nitem=sscanf(card,"%f",&par[i]);
        if(nitem != 1) goto m2;
        card+=itemlength(card,nitem);
      };

      par[0]=par[0]+Xofs;
      par[1]=par[1]+Yofs;
      par[2]=par[2]+Zofs;
// the case of tube
      if(!strcmp(shape,TubeCh)) {
        icheck = tube.Position(matname,manon,sens,0,0.,par);
      };
// the case of cone
      if(!strcmp(shape,ConeCh)) {
        icheck = cone.Position(matname,manon,sens,0,0.,par);
      };
// positioning of vacuum or air inside
      if(ivacuum > 0) {
        par[5]=par[4];
        par[4]=0.;
        char insname[10];
        char insmaon[5];
        if(ivacuum < 3)  strcpy(insname,"VACUUM_MU");
        if(ivacuum > 2)  strcpy(insname,"AIR_MU");
        if(ivacuum == 1 || ivacuum == 3) strcpy(insmaon,"ONLY");
        if(ivacuum == 2 || ivacuum == 4) strcpy(insmaon,"MANY");
// the case of tube
        if(!strcmp(shape,TubeCh)) {
          icheck = tube.Position(insname,insmaon,0,0,0.,par);
        };
// the case of cone
        if(!strcmp(shape,ConeCh)) {
          par[7]=par[6];
          par[6]=0.;
          icheck = cone.Position(insname,insmaon,0,0,0.,par);
        };
      };
      goto m1;
    };
    arteMsg << "MUGEO: shape " << dec << shape;
    arteMsg << " is unknown - pass the line";
    arteMsg.warn();
// end of the line analysis
 m1:;
  };
// output in the case of error
 m2:
    arteMsg << "MUGEO: input data error in card " << dec << icd;
    arteMsg.warn();
    fclose(fmu0);
    arteMsg << "MUGEO: close file " << fname;
    arteMsg.error();
  return ;
};
};
