*-- Author :    B.Fominykh 15/04/96
*
      SUBROUTINE  MUOG96
C     ==================
*
C     DEFINE MUON DETECTOR GEOMETRY FOR HERA-B RUN/96
*
      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMUON.fi"
#include "auto/GEO.fi"
#include "gean/ZGDETV.fi"
#include "gean/ZGESL.fi"
      INTEGER I,J,K,II,I0DEG,MEDNUM,ISL
      INTEGER IVOL, NGEDEF, NGEDEL, NPADS, NDSL(4)
      REAL PAR(8), ZPOSM, ZPOSD
      REAL XMUSL,X_POS, Y_POS, Z_POS, WW, ALPADS
      CHARACTER*4 MUNAM
#include "arte/Arte.ff"
#include "auto/GEO.ff"
* ---------------------------
      IF(IDEBUG.NE.0) WRITE(LPRNT,*) ' Muon initialization. '
*
      CALL muodat('muo97.dat')
      CALL MUOMED

      DO I=1,NGESL()
       IF(IGESL_CMP(I).EQ.LGESL_MUON) THEN 
          ISL = I
       ELSEIF(IGESL_CMP(I).EQ.LGESL_MUO) THEN
          NDSL(IGESL_NSL(I)) = I
       ENDIF           
      ENDDO

C- overall volume MUON
      CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,MUNAM,4)
      CALL CGGESL(MUNAM,'MOTH',0)
      ZPOSM =.5*(FGESL_Z2(ISL) - FGESL_Z1(ISL))

* proton beam pipe inside muon detector

      CALL MUPIPE

      IF(DETV(LGESL_MUO).EQ.'MUDL') THEN
         NGEDEF = NGEDE()
         NGEDEL = NGEDEF
      ENDIF


* muon protection shield for 1st muon superlayer
      CALL MUSHIL(1)
*** first superlayer contains no chambers

* muon protection shield for 2nd muon superlayer
      CALL MUSHIL(2)
      CALL MUSHIL(3)
*** second superlayer contains 2 layers of vertical tube chambers

*** SECOND SUPERLAYER - DEAD MATERIAL AND VERTICAL TUBE CHAMBERS

*     define the superlayer overall volume and the chamber volume
        CALL GSVOLU(MU00(2),'BOX ',MEDNUM(3,'MU_WIRE_CHAM'),PAR,0,IVOL)
        CALL GSATT(MU00(2),'COLO',60)

C***     DETECTORS
C***  installation of superlayers
      CURRSL = NDSL(1)
      CALL UHTOC(HGESL_NAME(CURRSL),4,MUNAM,4)
      CALL CGGESL(MUNAM,'MUON',0)
      CALL GSATT(MUNAM,'COLO',-5)
      XMUSL = .5*(FGESL_X1(CURRSL)+FGESL_X2(CURRSL))
      ZPOSD = .5*(FGESL_Z1(CURRSL)+FGESL_Z2(CURRSL))

      IF(IDEBUG.NE.0)WRITE(LPRNT,*) 'DEMU=',MUNAM,FGESL_Z1(CURRSL),
     +                                            FGESL_Z2(CURRSL)

*  superlayer 2 - vertical tube chambers
*  there are two shifted layers
      K=0
      DO I=1,NMU0(3)    ! loops over all chamber in the raw
*     X_POSition, Y_POSition and  Z_POSition of chamber center
      X_POS=XMU0(3)+DXMUO(2)*.5-XMUSL
      Y_POS=YMU0(3)+DYMU0(MUMAXC+I,1)*.5
      DO II=1,I
        X_POS=X_POS+DDXU0(MUMAXC+II)
        Y_POS=Y_POS+DDYU0(MUMAXC+II)
      ENDDO
      Z_POS = -ZPOSD+ZMU0(3)+DZMU0(3)*.25
*     the sizes of chamber
      PAR(1) = DXMUO(2)*.5
      PAR(2) = DYMU0(MUMAXC+I,1)*.5
      PAR(3) = DZMU0(3)*.25

      DO I0DEG=1,2          ! loops over two shifted layers of muon chamber
      NGEDEL = NGEDEL + 1   ! create new volume in GEANT and in GEDE bank
      K=K+1
      CALL CRPOS(MU00(2),MUNAM,1,K,X_POS,Y_POS,Z_POS,0,'ONLY',PAR)

*     write parameters to GEDE bank
      Q(QGEDE_ACC_L()) = ACMU
      Q(QGEDE_EFF_L()) = EFMU(1)
      Q(QGEDE_PIT_L()) = PIMU
      Q(QGEDE_DOD_L()) = DMMU
      IQ(IQGEDE_NWI_L(1)) = NUMWMU
      Q(QGEDE_XFW_L(1)) = DXFWMU
      Q(QGEDE_ZFW_L(1)) = Z_POS+ZPOSD
      Q(QGEDE_XFW_L(4)) = OVMUO
      Q(QGEDE_SXMN_L()) = FGEDE_XMIN(NGEDE())+DXFWMU-DMMU
      Q(QGEDE_SXMX_L()) = FGEDE_XMAX(NGEDE())-DXFWMU+DMMU
      Q(QGEDE_SYMN_L()) = FGEDE_YMIN(NGEDE())
      Q(QGEDE_SYMX_L()) = FGEDE_YMAX(NGEDE())
*     change size and position for second shifted layer of top chamber
      PAR(2) = PAR(2)+DYMU0(MUMAXC+I,2)*.5
      X_POS=X_POS+OVMUO
      Y_POS=Y_POS- DYMU0(MUMAXC+I,2)*.5
      Z_POS=Z_POS+PAR(3)*2.
      ENDDO      ! end of loops over two shifted layers
      ENDDO      ! end of loops over top 0-degree chambers
C***********

* 0-degree down raw of second layer

      DO I=NMU0(3)+1,NMU0(4)    ! loops over muon tube chambers
*     X_POSition, Y_POSition and  Z_POSition of chamber centers
      X_POS=XMU0(4)+DXMUO(2)*.5-XMUSL
      Y_POS=YMU0(4)+DYMU0(MUMAXC+I,1)*.5
      DO II=NMU0(3)+1,I
        X_POS=X_POS+DDXU0(MUMAXC+II)
        Y_POS=Y_POS+DDYU0(MUMAXC+II)
      ENDDO
      Z_POS = -ZPOSD+ZMU0(4)+DZMU0(4)*.25
*     the sizes of chamber
      PAR(1) = DXMUO(2)*.5
      PAR(2) = DYMU0(MUMAXC+I,1)*.5
      PAR(3) = DZMU0(4)*.25

      DO I0DEG=1,2             ! loops over two shifted layers of muon chamber
      NGEDEL = NGEDEL + 1
      K=K+1
      CALL CRPOS(MU00(2),MUNAM,1,K,X_POS,Y_POS,Z_POS,0,'ONLY',PAR)
*     write parameters to GEDE bank
      Q(QGEDE_ACC_L()) = ACMU
      Q(QGEDE_EFF_L()) = EFMU(1)
      Q(QGEDE_PIT_L()) = PIMU
      Q(QGEDE_DOD_L()) = DMMU
      IQ(IQGEDE_NWI_L(1)) = NUMWMU
      Q(QGEDE_XFW_L(1)) = DXFWMU
      Q(QGEDE_ZFW_L(1)) = Z_POS+ZPOSD
      Q(QGEDE_XFW_L(4)) = OVMUO

      Q(QGEDE_SXMN_L()) = FGEDE_XMIN(NGEDE())+DXFWMU-DMMU
      Q(QGEDE_SXMX_L()) = FGEDE_XMAX(NGEDE())-DXFWMU+DMMU
      Q(QGEDE_SYMN_L()) = FGEDE_YMIN(NGEDE())
      Q(QGEDE_SYMX_L()) = FGEDE_YMAX(NGEDE())

*     change parameters of second part of chamber
      PAR(2) = PAR(2)+DYMU0(MUMAXC+I,2)*.5
      X_POS=X_POS+OVMUO
      Y_POS=Y_POS+ DYMU0(MUMAXC+I,2)*.5
      Z_POS=Z_POS+PAR(3)*2.

      ENDDO  ! end of loops over two shifted layers of tube chamber
      ENDDO  ! end of loops over muon tube chambers in down raw

      IF(IDEBUG.NE.0)WRITE(LPRNT,*)' SUPERLAYER ',J,' LAYER 1 CONTAINS',
     +                    K,' 0-DEGREE CHAMBERS'

C**** the end of superlayer 2

C**** superlayers 3 and 4
* superlayers 3 and 4 contain only pad chambers

* muon protection shield
      CURRSL = ISL
      CALL MUSHIL(4)
      CALL MUSHIL(5)
      CALL MUSHIL(6)

      DO 20 J=3,4               ! loop over superlayers 3 and 4
*     define overall tube chambers volume and their components
      CALL GSVOLU(MU00(J),'BOX ',MEDNUM(3,'MU_PAD_CHAM'),PAR,0,IVOL)
      CALL GSATT(MU00(J),'COLO',60)


C***  DETECTORS
C***  installation of superlayers
      CURRSL = NDSL(J-1)
      CALL UHTOC(HGESL_NAME(CURRSL),4,MUNAM,4)
      CALL CGGESL(MUNAM,'MUON',0)
      CALL GSATT(MUNAM,'COLO',-5)
      XMUSL = .5*(FGESL_X1(CURRSL)+FGESL_X2(CURRSL))
      ZPOSD = .5*(FGESL_Z1(CURRSL)+FGESL_Z2(CURRSL))

      IF(IDEBUG.NE.0)WRITE(LPRNT,*) 'DEMU=',MUNAM,FGESL_Z1(CURRSL),
     +                                            FGESL_Z2(CURRSL)

*     superlayers MU3 and MU4  contain only 1 pad chamber layer

C* 0-degree up raw of superlayer j (3 or 4)

      K=0
      DO I=1,NMU0(2*J-1)    !  loops over all chambers in the raw
*     X_POSition, Y_POSition and  Z_POSition of chamber centers
      X_POS=XMU0(2*J-1)+DXMUO(J)*.5-XMUSL
      Y_POS=YMU0(2*J-1)+DYMU0((J-1)*MUMAXC+I,1)*.5
      DO II=1,I
        X_POS=X_POS+DDXU0((J-1)*MUMAXC+II)
        Y_POS=Y_POS+DDYU0((J-1)*MUMAXC+II)
      ENDDO
      Z_POS = -ZPOSD+ZMU0(2*J-1)+DZMU0(2*J-1)*.25
*     the sizes of chamber
      PAR(1) = DXMUO(J)*.5
      PAR(2) = DYMU0((J-1)*MUMAXC+I,1)*.5
      PAR(3) = DZMU0(2*J-1)*.25

      DO I0DEG=1,2         ! loops over 2 shifted layers of up-raw
      NGEDEL = NGEDEL + 1
      K=K+1
*     positioning of pad chamber volume
      CALL CRPOS(MU00(J),MUNAM,1,K,X_POS,Y_POS,Z_POS,0,'ONLY',PAR)
*     save parameters of created volume to bank GEDE
      Q(QGEDE_ACC_L()) = ACMU      ! measurement accuracy
      Q(QGEDE_EFF_L()) = EFMU(2)   ! efficiency
      Q(QGEDE_PIT_L()) = PIMU      ! pitch
      Q(QGEDE_DOD_L()) = DMMU      ! max drift distance

      Q(QGEDE_SXMN_L()) = FGEDE_XMIN(NGEDE())+DXMUPD(6*(J-3)+2)
      Q(QGEDE_SXMX_L()) = FGEDE_XMAX(NGEDE())-DXMUPD(6*(J-3)+2)
      Q(QGEDE_SYMN_L()) = FGEDE_YMIN(NGEDE())+DYMUPD(6*(J-3)+3)
      Q(QGEDE_SYMX_L()) = FGEDE_YMAX(NGEDE())-DYMUPD(6*(J-3)+3)

      ALPADS=FGEDE_YMAX(NGEDE())-FGEDE_YMIN(NGEDE())
     +  -2.*DYMUPD(6*(J-3)+3)
      NPADS=INT((ALPADS-DYMUPD(6*(J-3)+1)+0.1)/(DYMUPD(6*(J-3)+2)+
     +  DYMUPD(6*(J-3)+4)))+1
      IF(NPADS.GT.INT(DXMUPD(6*(J-3)+6)))
     +      NPADS=INT(DXMUPD(6*(J-3)+6))

      IQ(IQGEDE_NWI_L(1)) = NUMWMU ! number of wires
      IQ(IQGEDE_NWI_L(2)) = 2      ! number of pads in x-direction
      IQ(IQGEDE_NWI_L(3)) = NPADS  ! number of pads in y-direction
      IQ(IQGEDE_NWI_L(4)) = INT(100.*DYMUPD(6*(J-3)+4)) ! 100*(y-dist between pads)

      Q(QGEDE_XFW_L(1)) = DXFWMU             ! x-position of first wire
      Q(QGEDE_XFW_L(2)) = DXMUPD(6*(J-3)+1)  ! x-size of pad
      Q(QGEDE_XFW_L(3)) = DYMUPD(6*(J-3)+1)  ! y-size of small pad
      Q(QGEDE_XFW_L(4)) = DYMUPD(6*(J-3)+2)  ! y-size of large pad

      WW=DXMUPD(6*(J-3)+5)                   ! dist wire-pad
      Q(QGEDE_ZFW_L(1)) =Z_POS+ZPOSD+
     +  2.*(1.5-REAL(I0DEG))*(DXMUPD(6*(J-3)+4)-WW)  ! z-position of wire
      Q(QGEDE_ZFW_L(2)) =Z_POS+ZPOSD+
     +  2.*(1.5-REAL(I0DEG))*DXMUPD(6*(J-3)+4)       ! z-position of pad
      Q(QGEDE_ZFW_L(3)) = DYMUPD(6*(J-3)+5)  ! y-dist to point eff=0.
      Q(QGEDE_ZFW_L(4)) = DYMUPD(6*(J-3)+6)  ! efficiency between two pads

*     change parameters for second shifted layer of top chamber
      PAR(2) = PAR(2)+DYMU0((J-1)*MUMAXC+I,2)*.5
      X_POS=X_POS+OVMUO
      Y_POS=Y_POS- DYMU0((J-1)*MUMAXC+I,2)*.5
      Z_POS=Z_POS+PAR(3)*2.
      ENDDO                    !  end of loops over two shifted layers
      ENDDO                    !  end of loops over top 0-degree chambers

C***********
      IF(IDEBUG.NE.0)WRITE(LPRNT,*)' SUPERLAYER ',J,' LAYER 1 CONTAINS',
     +                    K,' 0-DEGREE CHAMBERS'

 20   CONTINUE
 15   CONTINUE

* proton beam pipe inside muon detector (position for drawing)
***      CALL MUPIPE


      RETURN
      END


