      subroutine otropen(lun,cname,subdir)
************************************************************************
* written by A.Lanyov (from S.Nowak geopen.F (from H.Albrechts ddopen.F))
* Description: open file for OTR geometry input
*
* Called from: OTR routines
*
* Argument in/out description
*   LUN    in     lun
*   CNAME  in/out file name with extension (on error CNAME is blanked)
*   SUBDIR in     subdirectory in system directory for looking the files
*
************************************************************************
      implicit none

#include "arte/Arte.fi"
#include "gean/otrgeo.fi"

        integer lun,ios,lenocc,l,idir,idirold
        character*100 cname,fulnam,dir,dir1
        character*(*) subdir
        logical exist
        save idir

        data idir/0/

#include "arte/Arte.ff"

        call ioclos(lun)

        idirold = idir
        idir = 0

c Check current directory
        fulnam=cname
        inquire(file=fulnam(:lenocc(fulnam)),exist=exist,iostat=ios)
        if (exist) then
           idir = 1
           goto 1
        end if

c Check environment variable $otrgeom
        call getenvf('otrgeom',dir)
        l = lenocc(dir)
        dir(l+1:l+1) = '/'
        fulnam = dir(:lenocc(dir)) // cname

        inquire(file=fulnam(:lenocc(fulnam)),exist=exist,iostat=ios)
        if (exist) then
           idir = 2
           goto 1
        end if

c Check corresponding system directory $HB/$HBVERS/geo/subdir
c  where subdir is a parameter

        call getenvf('HB',dir)
        l = lenocc(dir)
        dir(l+1:l+1) = '/'
        call getenvf('HBVERS',dir1)
        if (lenocc(dir1).le.1) then
           dir1 = 'dev'
        end if
        dir(l+2:) = dir1
        l = lenocc(dir)
        dir(l+1:) = '/geo/' // subdir(:lenocc(subdir)) // '/'
        fulnam = dir(:lenocc(dir)) // cname


        inquire(file=fulnam(:lenocc(fulnam)),exist=exist,iostat=ios)
        if (exist) then
           idir = 3
           goto 1
        end if

        c78 = 'File ' // cname(:lenocc(cname)) // ' not found'
        idir = idirold
	cname = ' ' // cname
cccc        call meerro(c78)
        return

1       call ioconc (lun, fulnam(:lenocc(fulnam)), ' ', 0)
        call ioopen (lun, 'fo', 0, ios)

        if (idir .ne. idirold) then
           c78 = 'File ' // cname(:lenocc(cname)) // ' is opened in'
           if (idir.eq.1) then
              call ch78bc('current directory.')
           else if (idir.eq.2) then
              call ch78bc('$otrgeom = ' // dir(:lenocc(dir)))
           else if (idir.eq.3) then
              call ch78bc('system directory.')
           end if
           call me78wa
        end if

999     return
        end
