        subroutine  otwall(isl)
******************************************************************
*
* Defines walls for run 98.
* Geant volumes are defined and the corresponding Arte tables.
*
* Now, only superlayer cover is defined.
* To do next: inner frame, outer frame.
*
* Called from: otrgeo.F
*
* External references:
*
* Arguments  in/out       Description
*
* isl        in           superlayer number (index for GESL table)
*
* Alexander Lanyov     Aug 1997
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGOTR.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

#include "gean/otrgeo.fi"

        integer isl,nsl
        real par(8),xp,yp,zp,wcomb
        character*4 csl,comb

#include "arte/Arte.ff"
#include "auto/GEO.ff"

c-- install the superlayer volume
        currsl = isl
        call uhtoc(hgesl_name(isl),4,csl,4)
        nsl = igesl_nsl(isl)

	if (csl(:2).eq.'MC') then
	   comb = 'WTCF'
	   wcomb = 0.1
	else if (csl(:2).eq.'PC') then
	   comb = 'WTPH'
	   wcomb = 1.
	else if (csl(:2).eq.'TC') then
	   comb = 'WTAH'
	   wcomb = 1.8
	else
	   call meerro('OTWALL: Wrong superlayer name: '//csl)
	end if

c-- install the front plate of the gas box
        par(1) =  0.5*(xmax_all - xmin_all)
        par(2) =  0.5*(ymax_all - ymin_all)
        xp =  0.5*(xmax_all + xmin_all) - xp_sl
        yp =  0.5*(ymax_all + ymin_all) - yp_sl

        par(3) =  0.5 * 0.1
        zp =  zmin_all - 0.5 - zp_sl
        call crpos('WTGF',csl,0,0,xp,yp,zp-par(3),0,'ONLY',par)	! glass fiber
        zp =  zp - 2*par(3)
        par(3) =  0.5 * wcomb

        call crpos(comb,csl,0,0,xp,yp,zp-par(3),0,'ONLY',par)
        zp =  zp - 2*par(3)
        par(3) =  0.5 * 0.1

        call crpos('WTGF',csl,0,0,xp,yp,zp-par(3),0,'ONLY',par)

c-- install the back of the gas box
        par(3) =  0.5 * 0.1
        zp =  zmax_all + 0.5 - zp_sl
        call crpos('WTGF',csl,0,0,xp,yp,zp+par(3),0,'ONLY',par)
        zp =  zp + 2*par(3)
        par(3) =  0.5 * wcomb

        call crpos(comb,csl,0,0,xp,yp,zp+par(3),0,'ONLY',par)
        zp =  zp + 2*par(3)
        par(3) =  0.5 * 0.1

        call crpos('WTGF',csl,0,0,xp,yp,zp+par(3),0,'ONLY',par)

        return
        end
