
      LOGICAL FUNCTION PTLCHK( iOBJ, iSL ) 
*************************************************************************
*                                                                       *
* PPPPPPPPP   TTTTTTTTTT  LL         CCCCCCCC   HH      HH  KK       KK *
* PPPPPPPPPP  TTTTTTTTTT  LL        CCCCCCCCCC  HH      HH  KK      KK  *
* PP      PP      TT      LL        CC      CC  HH      HH  KK     KK   *
* PP      PP      TT      LL        CC          HH      HH  KK    KK    *
* PP      PP      TT      LL        CC          HH      HH  KK   KK     *
* PPPPPPPPPP      TT      LL        CC          HHHHHHHHHH  KKKKKK      *
* PPPPPPPPP       TT      LL        CC          HHHHHHHHHH  KKKKKK      *
* PP              TT      LL        CC          HH      HH  KK   KK     *
* PP              TT      LL        CC          HH      HH  KK    KK    *
* PP              TT      LL        CC      CC  HH      HH  KK     KK   *
* PP              TT      LLLLLLLL  CCCCCCCCCC  HH      HH  KK      KK  *
* PP              TT      LLLLLLLL   CCCCCCCC   HH      HH  KK       KK *
*                                                                       *
*************************************************************************
*                                                                       *
* Author: I.Belyaev                                                     *
* Date: 1996/11/06 09:52:46 $                                           *
*                                                                       *
* Created: Apr 4, 1997 by Ivan Belyaev                                  *
*                                                                       *
* Description:                                                          *
*                                                                       *     
* Called from: PTLGEO                                                   *
*                                                                       *
* Arguments:                                                            *
* name       in/out/update Argument description                         *
*                                                                       *
*************************************************************************

      IMPLICIT NONE

C**************************************************************************

#include "arte/Arte.fi"
#include "auto/GESL.fi"
#include "auto/PTGE.fi"

C**************************************************************************

      INTEGER       iOBJ   , iSL 
      CHARACTER*4   CSHAP  , CMOTH , CSUPL , CNAME 

      LOGICAL       LWALL, LCHAMBER 
      INTEGER       idCHAMBER 
      PARAMETER(    idCHAMBER=1)

      INTEGER       LENOCC 
      EXTERNAL      LENOCC 

C**************************************************************************
       
#include "arte/Arte.ff"
#include "auto/GESL.ff"
#include "auto/PTGE.ff"

C**************************************************************************

      PTLCHK = .TRUE. 
C* temporary!!!     
      RETURN 

      IF( JPTGE .LE. 0 )THEN 
       C78='PTLCHK Error! PTGE table does not exist!'
       CALL ME78EC( 9824789 ) 
       PTLCHK = .FALSE. 
       RETURN 
      ELSEIF( NPTGE() .LE. 0 )THEN
       C78='PTLCHK Error! PTGE table is empty!'
       CALL ME78EC( 982413459 ) 
       PTLCHK = .FALSE. 
       RETURN  
      ENDIF 

      IF( JGESL .LE. 0 )THEN 
       C78='PTLCHK Error! GESL table does not exist!'
       CALL ME78EC( 982423 ) 
       PTLCHK = .FALSE. 
       RETURN 
      ENDIF 

      IF( iOBJ .LE. 0 .OR. iOBJ .GT. NPTGE())THEN
       C78='PTLCHK Error! Wrong OBJECT form PTGE Table!'
       CALL ME78EC( 43878 ) 
       PTLCHK = .FALSE. 
       RETURN 
      ENDIF 

      IF( iSL  .LE. 0 .OR. iSL  .GT. NGESL())THEN
       C78='PTLCHK Error! Wrong SL from GESL Table!'
       CALL ME78EC( 9312341 ) 
       PTLCHK = .FALSE. 
       RETURN 
      ENDIF 


      
      CALL CHHTOC( IQ(HQPTGE_NAME(iOBJ)),CNAME) 

C*    Chamber?Wall?Unknown?
      LCHAMBER = .FALSE. 
      LWALL    = .FALSE.  
      IF(     IPTGE_FLAG( iOBJ ) .EQ. 1  )THEN
       LCHAMBER = .TRUE. 
       LWALL    = .FALSE. 
      ELSEIF( IPTGE_FLAG( iOBJ ) .EQ. -1 )THEN 
       LCHAMBER = .FALSE. 
       LWALL    = .TRUE. 
      ELSE
       LCHAMBER = .FALSE. 
       LWALL    = .FALSE. 
      ENDIF 
    
      IF( .NOT. LCHAMBER .AND. 
     &    .NOT. LWALL           )THEN
       C78='PTLCHK Error!'
       CALL CH78AC( 'Obj=' ) 
       CALL CH78AI( iOBJ   ) 
       CALL CH78CC( 'Name='  ) 
       CALL CH78AC( CNAME    ) 
       CALL CH78BC( 'Unknown(probably Comment) FLAG=' ) 
       CALL CH78AI( IPTGE_FLAG( iOBJ ) ) 
       CALL ME78EC( 9238574  ) ! in BATCH mode STOP 
       PTLCHK = .FALSE. 
       RETURN 
      ENDIF 


C*    Checks for chambers: 
      IF( LCHAMBER ) THEN 
C*     Rotation is not allowed (Yet)! 
       IF( IPTGE_IROT( iOBJ ) .NE. 0 )THEN
        C78='PTLCHK Error!'
        CALL CH78AC( 'Obj=' ) 
        CALL CH78AI( iOBJ   ) 
        CALL CH78CC( 'Name='  ) 
        CALL CH78AC( CNAME    ) 
        CALL CH78AC('Rotation is not allowed for CHAMBER (yet)!')
        CALL ME78EC( 12354 ) 
        PTLCHK = .FALSE. 
        RETURN 
       ENDIF 
C*     "Superlayer" must be equal to "Mother" ! 
       CALL CHHTOC( IQ(HQPTGE_SUPL(iOBJ)),CSUPL) 
       CALL CHHTOC( IQ(HQPTGE_MOTH(iOBJ)),CMOTH) 
       IF( CSUPL .NE. CMOTH )THEN 
        C78='PTLCHK Error!'
        CALL CH78AC( 'Obj=' ) 
        CALL CH78AI( iOBJ   ) 
        CALL CH78CC( 'Name='  ) 
        CALL CH78AC( CNAME    ) 
        CALL CH78AC('Superlayer is not equal to Mother!')
        CALL ME78EC( 3212354 ) 
        PTLCHK = .FALSE. 
        RETURN 
       ENDIF 
C*     "Shape" must be "BOX"! 
       CALL CHHTOC( IQ(HQPTGE_SHAP(iOBJ)),CSHAP) 
       IF( CSHAP .NE. 'BOX ' )THEN
        C78='PTLCHK Error!'
        CALL CH78AC( 'Obj=' ) 
        CALL CH78AI( iOBJ   ) 
        CALL CH78CC( 'Name='  ) 
        CALL CH78AC( CNAME    ) 
        CALL CH78AC('Shape is not BOX!')
        CALL ME78EC( 3234354 ) 
        PTLCHK = .FALSE. 
        RETURN 
       ENDIF 

C* Geometry checks:
C* new version MUST? be written as soon as possible!
C* previous one was extremly bugged! 
      ENDIF 
 

C**************************************************************************

      RETURN 
      END

C**************************************************************************


