
      SUBROUTINE PTLGEO( iSL )
**************************************************************************
*                                                                        *
* PPPPPPPPP   TTTTTTTTTT  LL         GGGGGGGGG   EEEEEEEEEE  OOOOOOOOOOO *
* PPPPPPPPPP  TTTTTTTTTT  LL        GGGGGGGGGGG  EEEEEEEEEE  OOOOOOOOOOO *
* PP      PP      TT      LL        GG       GG  EE          OO       OO *
* PP      PP      TT      LL        GG           EE          OO       OO *
* PP      PP      TT      LL        GG           EE          OO       OO *
* PPPPPPPPPP      TT      LL        GG           EEEEEE      OO       OO *
* PPPPPPPPP       TT      LL        GG    GGGGG  EEEEEE      OO       OO *
* PP              TT      LL        GG    GGGGG  EE          OO       OO *
* PP              TT      LL        GG       GG  EE          OO       OO *
* PP              TT      LL        GG       GG  EE          OO       OO *
* PP              TT      LLLLLLLL  GGGGGGGGGGG  EEEEEEEEEE  OOOOOOOOOOO *
* PP              TT      LLLLLLLL   GGGGGGGGG   EEEEEEEEEE  OOOOOOOOOOO *
*                                                                        *
**************************************************************************
*                                                                        *
* Author: I.Belyaev                                                      *
* Date: 1997/10/04 09:52:46                                              *
*                                                                        *
* Created: Apr 10, 1997 by I.Belyaev                                     *
*                                                                        *
* Description:                                                           *
*                                                                        *
* Called from: GEOMAIN                                                   *
*                                                                        *
* Arguments: iSL - Supelrlayer number (row in GESL table)                *
* name       in/out/update Argument description                          *
*                                                                        *
**************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGMOTH.fi"
#include "gean/PTGEA.fi"


C*******************************************
      INTEGER       iSL
      
      INTEGER       idWALL 
      PARAMETER(    idWALL    = -1 )     
      INTEGER       idCHAMBER 
      PARAMETER(    idCHAMBER =  1 )
      
      INTEGER       iOBJ,IVOL,LVOL,I,IMAT,IMED,ILAY,ISEC 
      INTEGER       ISET , IDET , IROT 
      REAL          XPOS,YPOS,ZPOS,XMID,YMID,ZMID,PAR(12),XMS
      CHARACTER*4   SLNAME,CNAMe,CSUPL,CSHAP,CMAON,CMOTH,C4,CGSHAP
      CHARACTER*12  CMATE
      LOGICAL       OK 
      
      
      LOGICAL       PTLCHK 
      INTEGER       IUCOMP
      INTEGER       LENOCC
      INTEGER       MEDNUM
      INTEGER       MATNUM

      EXTERNAL      PTLCHK
      EXTERNAL      IUCOMP
      EXTERNAL      LENOCC
      EXTERNAL      MEDNUM
      EXTERNAL      MATNUM

 

#include "arte/Arte.ff"
#include "auto/GEO.ff"

#include "gean/PTGEA.ff"

      
      
      IF(     iSL .LE. 0 .OR. iSL .GT. NGESL() )THEN
         C78='PTLGEO Error! iSL='
         CALL CH78AI( iSL ) 
         CALL CH78BC( 'is out of allowed range' ) 
         CALL CH78BI( 1   ) 
         CALL CH78AC( '-' )
         CALL CH78AI( NGESL() )  
         CALL ME78EC(1274984)   !        in batch mode STOP
      ENDIF 
      
      
      CALL CHHTOC(IQ(HQGESL_NAME(iSL)),SLNAME)
      IF(   SLNAME   .NE. 'PTL1' .AND. 
     &     SLNAME   .NE. 'PTL2' .AND. 
     &     SLNAME   .NE. 'PTL3' )THEN 
         C78='PTLGEO Error! Superlayer name'
         CALL CH78BC( SLNAME     ) 
         CALL CH78BC( 'for iSL=' ) 
         CALL CH78AI( iSL        ) 
         CALL CH78BC( 'is not'   ) 
         CALL CH78BC( 'PTL1'     )  
         CALL CH78BC( 'PTL2'     )  
         CALL CH78BC( 'PTL3'     )  
         CALL ME78EC( 293847918) ! in BATCH mode STOP
      ENDIF 
      
      IF( IGESL_CMP(iSL) .NE. LGESL_PTC )THEN
         C78='PTLGEO error! Superlayer'
         CALL CH78BI( iSL                 )
         CALL CH78BC( SLNAME              ) 
         CALL CH78BC( 'has CMP attribute' ) 
         CALL CH78BI( IGESL_CMP(iSL)      )
         CALL CH78BC( '(should be'        )
         CALL CH78BI( LGESL_PTC           ) 
         CALL CH78AC( ')'                 ) 
         CALL ME78EC( 2934543)  ! in BATCH mode STOP
      ENDIF   
      
C*    Check for the Geometry information 
      IF(     JPTGE   .LE. 0 )THEN
         CALL PTLDAT 
      ELSEIF( NPTGE() .LE. 0 )THEN
         CALL PTLDAT
      ENDIF 
      
      IF( JPTGE .LE. 0 .OR. NPTGE() .LE. 0 )THEN
         C78='PTLGEO Error!'
         CALL CH78BC( 'No geometry information'    )
         CALL CH78BC( 'about PTL System is Found!' ) 
         CALL ME78EC( 84981798 ) ! in BATCH mode STOP 
      ENDIF 
      
      
C     *      IF ( IDEBUG  .NE. 0 )THEN 
C     *       C78='PTLGEO START, iSL='
C     *       CALL CH78AI( iSL     ) 
C     *       CALL CH78CC( 'name=' ) 
C     *       CALL CH78AC( SLNAME  )
C     *       CALL CH78CC( 'type=' ) 
C     *       CALL CH78AI( IGESL_CMP(iSL)  )
C     *       CALL ME78AP 
C     *      ENDIF 
      
C     *    Check weather a GEANT volume with name SLNAME exists 
      LVOL  = 0 
      IVOL  = IUCOMP( IQ(HQGESL_NAME(iSL)) , 
     &     IQ( JVOLUM + 1     ) ,       
     &     IQ( JVOLUM - 1     ) )
      IF( IVOL .NE. 0 ) LVOL = LQ(JVOLUM - IVOL ) 
      IF( IVOL .NE. 0 .OR. LVOL .NE. 0 )THEN
         C78='PTLGEO warning! GEANT volume for HGESL_NAME('
         CALL CH78AI( iSL                ) 
         CALL CH78AC( ')=' ) 
         CALL CH78AI( SLNAME ) 
         CALL CH78BI( 'is exist!IVOL=' ) 
         CALL CH78AI( IVOL ) 
         CALL ME78WC( 348794 )  !produce warning! 
      ELSE 
C     *     Create the GEANT volume from ARTE  
         CALL CGGESL( SLNAME , 'MAGN' ,  0 ) 
         CALL GSATT ( SLNAME , 'COLO' , -4 )  
      ENDIF 
      
      CURRSL = ISL 
      
      ISEC = 0       
      DO iOBJ = 1 , NPTGE()
         CNAME=' ' 
         CMATE=' ' 
         CMOTH=' ' 
         CSHAP=' ' 
         CMAON=' ' 
         CALL CHHTOC( IQ(HQPTGE_NAME(     iOBJ ) ) , CNAME ) 
         CALL CHHTOC( IQ(HQPTGE_SUPL(     iOBJ ) ) , CSUPL ) 
         CALL CHHTOC( IQ(HQPTGE_MOTH(     iOBJ ) ) , CMOTH ) 
         CALL CHHTOC( IQ(HQPTGE_SHAP(     iOBJ ) ) , CSHAP ) 
         CALL CHHTOC( IQ(HQPTGE_MATE( 1 , iOBJ ) ) , CMATE ) 
         CALL CHHTOC( IQ(HQPTGE_MAON(     iOBJ ) ) , CMAON ) 
         
C     *     Select chambers and walls for this superlayer 
         IF( CSUPL .NE. SLNAME ) GO TO 100 
C     *     Select only chambers and walls - nothing else
         IF( IPTGE_FLAG( iOBJ ) .NE. idWALL     .AND. 
     &        IPTGE_FLAG( iOBJ ) .NE. idCHAMBER )THEN
            C78='PTLGEO Warning!Unknowg flag='
            CALL CH78AI( IPTGE_FLAG( iOBJ ) ) 
            CALL CH78BC( 'for OBJECT='      ) 
            CALL CH78AI( iOBJ               )
            CALL CH78CC( 'skip it!'         )
            CALL ME78WC(124784710           ) !print warning!         
            GO TO 100 
         ENDIF 
C     *     Check the SHAPE, only BOX,TUBE and TRD2 are allowed now. 
         IF( CSHAP(1:LENOCC(CSHAP)) .NE. 'BOX' .AND. 
     &        CSHAP(1:LENOCC(CSHAP)) .NE. 'TRD2'.AND. 
     &        CSHAP(1:LENOCC(CSHAP)) .NE. 'TUBE' )THEN 
            C78='PTLGEO warning! Unknowh SHAPE='
            CALL CH78AC( CSHAP ) 
            CALL CH78BC( 'for OBJECT='      ) 
            CALL CH78AI( iOBJ               )
            CALL CH78CC( 'skip it!'         )
            CALL ME78WC(126666333           ) !print warning!            
            GO TO 100 
         ENDIF        
C     *     Check the MAON flag, only MANY and ONLY is allowed 
         IF( CMAON(1:LENOCC(CMAON)) .NE. 'MANY' .AND. 
     &        CMAON(1:LENOCC(CMAON)) .NE. 'ONLY')THEN 
            C78='PTLGEO warning! Unknowh MAON='
            CALL CH78AC( CMAON ) 
            CALL CH78BC( 'for OBJECT='      ) 
            CALL CH78AI( iOBJ               )
            CALL CH78CC( 'skip it!'         )
            CALL ME78WC(134522233           ) !print warning!            
            GO TO 100 
         ENDIF        
C     *     Check the GEANT MOTHer name 
         IF( CMOTH(1:LENOCC(CMOTH)) .NE. SLNAME .AND.
     &        CMOTH(1:LENOCC(CMOTH)) .NE. 'MOTH' .AND. 
     &        CMOTH(1:LENOCC(CMOTH)) .NE. 'MAGN' )THEN
            C78='PTLGEO warning! MOTHER='
            CALL CH78AC( CMOTH ) 
            CALL CH78BC( 'for OBJECT='      ) 
            CALL CH78AI( iOBJ               )
            CALL CH78BC( 'is not allowed'   )
            CALL CH78CC( 'skip it!'         )
            CALL ME78WC(134522244           ) !print warning!            
            GO TO 100 
         ENDIF   
C     *     For Chambers GEANT MOTHer must be SUPerlayer! 
         IF( IPTGE_FLAG(iOBJ) .EQ. idCHAMBER .AND. 
     &        ( CMOTH(1:LENOCC(CMOTH)) .NE. SLNAME) ) THEN
            C78='PTLGEO Warning! MOTH='
            CALL CH78AC( CMOTH        ) 
            CALL CH78CC( 'SUPL='      )
            CALL CH78AC(  CSUPL       ) 
            CALL ME78WC(1345222123    ) !print warning!            
            GO TO 100 
         ENDIF  
C     *     For Chambers SHAPE must be 'BOX'
         IF( IPTGE_FLAG(iOBJ) .EQ. idCHAMBER .AND. 
     &        ( CSHAP(1:LENOCC(CSHAP)) .NE. 'BOX')) THEN
            C78='PTLGEO Warning! SHAPE='
            CALL CH78AC( CSHAP                 ) 
            CALL CH78CC( ' for chamber OBJECT=')
            CALL CH78AI(  iOBJ                 ) 
            CALL ME78WC(  1243                 ) !print warning!            
            GO TO 100 
         ENDIF  
C     *     For Chambers MAON must be 'ONLY'
         IF( IPTGE_FLAG(iOBJ) .EQ. idCHAMBER .AND. 
     &        ( CMAON(1:LENOCC(CMAON)) .NE. 'ONLY') ) THEN
            C78='PTLGEO Warning! MAON='
            CALL CH78AC( CMAON                 ) 
            CALL CH78CC( ' for chamber OBJECT=')
            CALL CH78AI(  iOBJ                 ) 
            CALL ME78WC(  1243345              ) !print warning!            
            GO TO 100 
         ENDIF  
C     *     Currently ROTATION is not allowed for CHAMBER 
         IF( IPTGE_FLAG(iOBJ) .EQ. idCHAMBER .AND. 
     &        IPTGE_IROT(iOBJ) .NE. 0 )THEN
            C78='PTLGEO Warning! Rotation is not allowed, OBJECT='
            CALL CH78AI( iOBJ ) 
            CALL ME78WC(  773345              ) !print warning!            
            GO TO 100 
         ENDIF          
C     *     Check the geometry! 
         OK = PTLCHK( iOBJ , iSL ) 
         IF( .NOT. OK )THEN 
            C78='PTLGEO warning! PTLCHK for OBJECT='
            CALL CH78AI( iOBJ         ) 
            CALL CH78BC( 'is not OK!' ) 
            CALL ME78WC(   545784     )
            GO TO 100 
         ENDIF 
C     *     Get the parameters of MOTHER volume 
         DO i = 1 , NGESL() 
            CALL CHHTOC(IQ(HQGESL_NAME(i)),C4) 
            IF( C4 .EQ. CMOTH )THEN
               XMID = 0.5*(FGESL_X1(i)+FGESL_X2(i))
               YMID = 0.5*(FGESL_Y1(i)+FGESL_Y2(i))
               ZMID = 0.5*(FGESL_Z1(i)+FGESL_Z2(i))
               GO TO 10 
            ENDIF 
         ENDDO 
         C78='PTLGEO warning! No such MOTH=' 
         CALL CH78AC( CMOTH       )
         CALL CH78BC( 'is found!OBJECT=' )
         CALL CH78AI( iOBJ ) 
         GO TO 100   
 10      CONTINUE
C     *     Check for MATHERIAL field
         IMAT =  MATNUM( CMATE(1:LENOCC(CMATE) ) )
         IF( IMAT .LE. 0 .OR. IMAT .GT. NGMAT() )THEN
            C78='PTLGEO warning! No such MATHERIAL='
            CALL CH78AC( CMATE ) 
            CALL CH78BC( 'in table GMAT!OBJECT=' ) 
            CALL CH78AI( iOBJ ) 
            CALL ME78WC( 83748 ) 
            GO TO 100 
         ENDIF  
         IMED = 0 
         IF(IPTGE_FLAG(iOBJ).EQ.idCHAMBER)IMED=MEDNUM(4,CMATE)
         IF(IPTGE_FLAG(iOBJ).EQ.idWALL   )IMED=MEDNUM(2,CMATE)
         IF( IMED .LE. 0 )THEN
            C78='PTLGEO warning! No such MEDIA='
            CALL CH78AC( CMATE  ) 
            CALL CH78CI( IMED   ) 
            CALL CH78CI( IMAT   ) 
            CALL CH78BC( 'in table GMAT!OBJECT=' )
            CALL CH78AI( iOBJ   ) 
            CALL ME78WC( 833445 ) 
            GO TO 100 
         ENDIF  
C     *     Check weather the GEANT volume with NAME=CNAME exists
         LVOL = 0 
         IVOL = IUCOMP(IQ( HQPTGE_NAME(iOBJ) ) ,
     &        IQ( JVOLUM+1          ) , 
     &        IQ( JVOLUM-1          ) ) 
         IF( IVOL .NE. 0 ) LVOL = LQ( JVOLUM - IVOL )
         IF( IVOL .EQ. 0 .OR. LVOL .EQ. 0 )THEN
C     *      GEANT volume must be created! 
            CGSHAP= '   '
            CGSHAP(1:LENOCC(CSHAP))=CSHAP(1:LENOCC(CSHAP)) 
            CALL GSVOLU(CNAME,CGSHAP,IMED,PAR,0,IVOL)
            IF( IVOL .LE. 0)THEN
               C78='PTLGEO error from GSVOLU('
               CALL CH78AC( CNAME  ) 
               CALL CH78CC( CSHAP  )
               CALL CH78CC( CMATE  )
               CALL CH78AC( '='    ) 
               CALL CH78AI( iMED   ) 
               CALL CH78CC( '...)' )
               CALL CH78CC( 'IVOL=')
               CALL CH78AI(  IVOL  ) 
               CALL ME78EC( 8983   ) ! in BATCH mode STOP! 
               GO TO 100 
            ENDIF 
C     *      Declare volume to be sensitive
            IF( IPTGE_FLAG(iOBJ).EQ. iDChamber) THEN
               CALL GSDET('DEPT',CNAME,1,CNAME
     &              ,15,LGESL_PTC,
     &              450,20,ISET,IDET)
               IF( ISET .LE. 0 .OR. IDET .LE. 0 )THEN
                  C78='PTLDAT error! ISET=' 
                  CALL CH78AI( ISET         ) 
                  CALL CH78CC( ' IDET='     )
                  CALL CH78AI( IDET         ) 
                  CALL CH78BC( 'for VOLUM=' ) 
                  CALL CH78AC( CNAME        )
                  CALL ME78EC( 345235       ) 
                  GO TO 100
               ENDIF 
            ENDIF       
C     *      Set the GEANT/DRAW attributes 
            CALL GSATT(CNAME,'SEEN',IPTGE_SEEN(iOBJ))
            CALL GSATT(CNAME,'COLO',IPTGE_COLO(iOBJ))
            CALL GSATT(CNAME,'FILL',IPTGE_FILL(iOBJ))
         ENDIF 
         LVOL = 0 
         IVOL = IUCOMP(IQ( HQPTGE_NAME(iOBJ) ) ,
     &        IQ( JVOLUM+1          ) , 
     &        IQ( JVOLUM-1          ) ) 
         IF( IVOL .NE. 0 ) LVOL = LQ( JVOLUM - IVOL )
         IF( IVOL .EQ. 0 .OR. LVOL .EQ. 0 )THEN
            C78='PTLGEO error! GEANT volume with NAME=' 
            CALL CH78AC( CNAME                  ) 
            CALL CH78BC( 'does not exist! IVOL=')
            CALL CH78AI( IVOL                   )
            CALL CH78CC( 'LVOL='                )
            CALL CH78AI( LVOL                   ) 
            CALL ME78EC( 8983234   ) ! in BATCH mode STOP! 
            GO TO 100 
         ENDIF 
C     *     Here we are ready to put volum into 
C     *     JVOLU(GEANT) and JGEDE/JGWAL(ARTE) data structures 
         XPOS = 0.5*(FPTGE_XMAX(iOBJ)+FPTGE_XMIN(iOBJ))-XMID 
         YPOS = 0.5*(FPTGE_YMAX(iOBJ)+FPTGE_YMIN(iOBJ))-YMID 
         ZPOS = 0.5*(FPTGE_ZMAX(iOBJ)+FPTGE_ZMIN(iOBJ))-ZMID 
         IF(     CSHAP(1:LENOCC(CSHAP)) .EQ. 'BOX'  )THEN
            PAR( 1 ) = 0.5*(FPTGE_XMAX(iOBJ)-FPTGE_XMIN(iOBJ))
            PAR( 2 ) = 0.5*(FPTGE_YMAX(iOBJ)-FPTGE_YMIN(iOBJ))
            PAR( 3 ) = 0.5*(FPTGE_ZMAX(iOBJ)-FPTGE_ZMIN(iOBJ))
            XPOS = 0.5*(FPTGE_XMAX(iOBJ)+FPTGE_XMIN(iOBJ))-XMID 
            YPOS = 0.5*(FPTGE_YMAX(iOBJ)+FPTGE_YMIN(iOBJ))-YMID 
            ZPOS = 0.5*(FPTGE_ZMAX(iOBJ)+FPTGE_ZMIN(iOBJ))-ZMID 
         ELSEIF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TRD2' )THEN
            PAR( 1 ) = 0.5 * FPTGE_XLEN( iOBJ ) 
            PAR( 2 ) = PAR( 1 ) + FPTGE_DX( iOBJ ) 
            PAR( 3 ) = 0.5 * FPTGE_YLEN( iOBJ ) 
            PAR( 4 ) = PAR( 3 ) + FPTGE_DY( iOBJ ) 
            PAR( 5 ) = 0.5 * FPTGE_ZLEN( iOBJ )
            XPOS     =  FPTGE_XPOS( iOBJ ) - XMID 
            YPOS     =  FPTGE_YPOS( iOBJ ) - YMID 
            ZPOS     =  FPTGE_ZPOS( iOBJ ) - ZMID 
         ELSEIF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TUBE' )THEN
            PAR( 1 ) =       FPTGE_ORAD( iOBJ ) - FPTGE_THIK( iOBJ ) 
            PAR( 2 ) =       FPTGE_ORAD( iOBJ ) 
            PAR( 3 ) = 0.5 * FPTGE_ZLEN( iOBJ )
            XPOS     =       FPTGE_XPOS( iOBJ ) - XMID 
            YPOS     =       FPTGE_YPOS( iOBJ ) - YMID 
            ZPOS     =       FPTGE_ZPOS( iOBJ ) - ZMID 
         ELSE 
            C78='PTLGEO error! Unknown SHAPE='
            CALL CH78AC( CSHAP         ) 
            CALL CH78BC( 'for OBJECT=' )
            CALL CH78AI( iOBJ          ) 
            CALL ME78EC( 982749847     ) ! in BATCH mode STOP!   
            GO TO 100 
         ENDIF 
         iLAY = 1 
         IF( IPTGE_FLAG( iOBJ ) .EQ. idCHAMBER ) iSEC = iSEC + 1
         IROT = IPTGE_IROT( iOBJ ) 
         CALL CRPOS( CNAME , CMOTH ,          
     &        iLAY  , iSEC  , 
     &        XPOS  , YPOS  , ZPOS , 
     &        IROT                 , 
     &        CMAON , PAR          ) 
         IF( IPTGE_FLAG( iOBJ ) .EQ. idCHAMBER )THEN
C     *     Parameters which are not filled in CRPOS/CRGEDE routines
            IQ(IQGEDE_NWI_L(1)) = IPTGE_NX(iOBJ)
            IQ(IQGEDE_NWI_L(2)) = IPTGE_NY(iOBJ)
            Q( QGEDE_SXMN_L()) = FGEDE_XMIN(NGEDE())
            Q( QGEDE_SXMX_L()) = FGEDE_XMAX(NGEDE())
            Q( QGEDE_SYMN_L()) = FGEDE_YMIN(NGEDE())
            Q( QGEDE_SYMX_L()) = FGEDE_YMAX(NGEDE())
C     *    Multiple scattering
            IVOL = IUCOMP(IQ( HQPTGE_NAME(iOBJ) ) ,
     &           IQ( JVOLUM+1          ) , 
     &           IQ( JVOLUM-1          ) ) 
            IF( IVOL .GT. 0 )THEN 
               CALL GRADLN( IVOL , XMS )
               XMS = MAX( 1.0E-10 , ABS( ( FPTGE_ZMAX( iOBJ ) 
     &              - FPTGE_ZMIN( iOBJ ) ) / XMS  ) )
               Q(QGWAL_MS_L())=  XMS * ( 0.0136 * 
     &              ( 1.0 + 0.038 * ALOG( XMS ) ) ) ** 2
            ELSE 
               C78='PTLGEO Error! Volume'
               CALL CH78BC( CNAME ) 
               CALL CH78BC( 'must exist in GEANT')
               CALL ME78EC( 8932174 ) ! in BATCH mode STOP!
            ENDIF 
         ENDIF 
 100     CONTINUE               ! End  of loop over
      ENDDO                     ! the PTGE table 
      
      IF ( IDEBUG  .NE. 0 )THEN 
         C78='PTLGEO END, iSL='
         CALL CH78AI( iSL     ) 
         CALL CH78CC( 'name=' ) 
         CALL CH78AC( SLNAME  )
         CALL CH78CC( 'type=' ) 
         CALL CH78AI( IGESL_CMP(iSL)  )
         CALL ME78AP 
      ENDIF 
      
      RETURN
      END
