#include "rich/PhotonDetection.h"
#include "rich/vessel.h"

extern "C" {


void F77NAME(ricini)() {
  if (RICH_Detector) return;

  char configdir[256];
  
  char* RICHconfigdir=getenv("RICH_CONFIGDIR");
  if (RICHconfigdir) {
    strcpy(configdir,RICHconfigdir);
    if (configdir[strlen(configdir)-1]!='/') strcat(configdir,"/");
    }
  else {
    char *hb=getenv("HB");
    char *hbvers=getenv("HBVERS");
    if (!hb||!hbvers) {
      fprintf(stderr,"RICINI:  $HB/$HBVERS is not defined. Abort.\n");
      exit(1);
      }
    strcpy(configdir,hb);
    strcat(configdir,"/");
    strcat(configdir,hbvers);
    strcat(configdir,"/geo/rich/");
    }
  printf(" === RICH configuration directory: %s\n",configdir);
  RICH_Detector=new RICHDetector(configdir);
  if (!RICH_Vessel) RICH_Vessel=new RICHVessel(configdir);
  }

void F77NAME(rgnini)() {
  F77NAME(ricini)();
  
  double lmin=240E-9;
  double lmax=740E-9;
  double  effmax=1; 
  Table eff;
  eff.append(239E-9,0.0);
  eff.append(240E-9,effmax);
  eff.append(740E-9,effmax);
  eff.append(741E-9,0.0); 
  RICH_Vessel->Radiator().gsckov(200,eff);
  }

  
void F77NAME(ricexi)() {
  if (RICH_Detector) { delete RICH_Detector; RICH_Detector=0;}
  if (RICH_Vessel) { delete RICH_Vessel;  RICH_Vessel=0; }
  }


} // extern "C"
