
      SUBROUTINE  SMLG98(ISL)

************************************************************************
*
* SMLG98
* written by Siegmund Nowak 12/92
*
* This routines defines silicon detector geometry  for the HERA-B detector
*
*       called from G98MAIN
*
* Arguments  kind         description
*
*-----------------------------------------------------------------------
*   IS1      in           first silicon superlayer
*   IS2      in           last silicon superlayer
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGSMLD.fi"
#include "gean/ZGMAGN.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

      INTEGER NSL,ISL,IFIRST,IVOL,ISEC,IRS,NPL,NSEC,MEDNUM,IROTM(4)
      INTEGER IUCOMP,ILAY,MG,NN
      REAL XPL, YPL, PXMOD, PYMOD, PZMOD, PZPLAN, XP(3)
      REAL PARSI(3), PARCA(3), PARAD(3), PARHY(3)
      REAL POSSI(3), POSCA(3), POSAD(3), POSHY(3)
      REAL ANG,COSX,SINX, XMINEF,XMAXEF, YMINEF,YMAXEF
      CHARACTER*4 CNAM
      DATA IFIRST /0/
      SAVE IFIRST

#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--   initialisation (volume definition,rad-length,angles etc)

      IF(IFIRST.EQ.0) THEN
         IROTM(1) = 0
         CALL CRROTM(IROTM(2), 90., 270.,  90.,   0.,  0.,  0.)
         CALL CRROTM(IROTM(3), 90., 180.,  90., 270.,  0.,  0.)
         CALL CRROTM(IROTM(4), 90.,  90.,  90., 180.,  0.,  0.)
         CALL SMLDAT('sml98.dat')
         CALL GSVOLU('SMLZ','BOX ',MEDNUM(4,'SILICON'),PARSI,0,IVOL)
         CALL GSVOLU('SMCA','BOX ',MEDNUM(2,'CARBONFIBRE'),PARSI,0,IVOL)
         CALL GSVOLU('SMAD','BOX ',MEDNUM(2,'AL2O3'),PARSI,0,IVOL)
         CALL GSVOLU('SMHY','BOX ',MEDNUM(2,'AL2O3'),PARSI,0,IVOL)

         ANG = ANGSM/180.*PI
         COSX = COS(ANG)
         SINX = SIN(ANG)
         IFIRST = 1
      ENDIF

      CURRSL = ISL 
      IF(IGESL_LAY(ISL).EQ.0) GO TO 90
 
      CALL UHTOC(HGESL_NAME(ISL),4,CNAM,4)

      NSL = IUCOMP(CNAM,DESM,NSLSM)
      IF(NSL.EQ.0) CALL MEERRO('SMLG98: '//CNAM//' not found in DESM')
      NPL  = IGESL_LAY(ISL)
      NSEC = 4
      CALL CGGESL(CNAM,'MAGN',0)
      CALL GSATT(CNAM,'COLO',-5)

C--   loop over the four sectors
      XPL = XRSM(NSL) + OVSM(NSL) - .5*DXSMSI    
      YPL = XRSM(NSL)

      DO ISEC = 1,4
      IRS = IROTM(ISEC)  

       IF(ISEC.EQ.1) THEN
          PZPLAN = -PZLYSM(NSL)
       ELSEIF(ISEC.EQ.2) THEN
          PZPLAN = PZLYSM(NSL)
       ELSEIF(ISEC.EQ.3) THEN
          PZPLAN = -PZLYSM(NSL)
       ELSEIF(ISEC.EQ.4) THEN
          PZPLAN = PZLYSM(NSL)
       ENDIF

       PXMOD = -XPL 
       PYMOD =  YPL

C--    DIMENSIONS AND x/y POSITIONS

       DO ILAY =1,3,2

       IF(ILAY.EQ.1) PZMOD = PZPLAN - PZC1SM(NSL)
       IF(ILAY.EQ.3) PZMOD = PZPLAN + PZC1SM(NSL) 


C--    silicon:
       PYSMSI(NSL) = .5*DYSMSI
       PARSI(1) = .5 * DXSMSI
       PARSI(2) = .5 * DYSMSI
       PARSI(3) = .5 * DZSMSI
       POSSI(1) = PXMOD
       POSSI(2) = PYSMSI(NSL) + PYMOD
       POSSI(3) = PZMOD -.5*(DZC1SM+DZSMSI)
       CALL GUROT(IRS,POSSI,XP)       
       CALL CRPOS('SILZ',CNAM,ILAY,ISEC,
     +                            XP(1),XP(2),XP(3),IRS,'ONLY',PARSI)

       XMINEF = FGEDE_XMIN(NGEDE()) + RANDSM
       XMAXEF = FGEDE_XMAX(NGEDE()) - RANDSM
       YMINEF = FGEDE_YMIN(NGEDE()) + RANDSM
       YMAXEF = FGEDE_YMAX(NGEDE()) - RANDSM
       Q (QGEDE_SXMN_L()) = XMINEF
       Q (QGEDE_SXMX_L()) = XMAXEF
       Q (QGEDE_SYMN_L()) = YMINEF
       Q (QGEDE_SYMX_L()) = YMAXEF
       Q (QGEDE_ACC_L()) = SIGSM
       Q (QGEDE_EFF_L()) = EFFSM
       Q (QGEDE_PIT_L()) = PITSM
       Q (QGEDE_DOD_L()) = DMSM
       IQ(IQGEDE_NSL_L())  = 1

       IF(ILAY .EQ. 1) THEN
          Q (QGEDE_COS_L()) = COSX
          Q (QGEDE_SIN_L()) = -SINX
       ELSE IF(ILAY.eq.3) THEN
          Q (QGEDE_COS_L()) = COSX
          Q (QGEDE_SIN_L()) = SINX
       ENDIF

       Q (QGEDE_XFW_L(1)) = XMINEF*FGEDE_COS(NGEDE()) + 
     +                      YMINEF*FGEDE_SIN(NGEDE()) + 0.5*PITSM
       Q (QGEDE_ZFW_L(1)) = FGEDE_ZMIN(NGEDE())
       IQ(IQGEDE_NWI_L(1)) = ((XMAXEF-XMINEF)*FGEDE_COS(NGEDE()) 
     +                      + (YMAXEF-YMINEF)*FGEDE_SIN(NGEDE()))/PITSM

       CALL MMBOOK(JGEDE,1)
       NN = NGEDE()
       CALL UCOPY(Q(JGEDE+(NN-2)*NCGEDE()+3),
     +            Q(JGEDE+(NN-1)*NCGEDE()+3),NCGEDE())
       IQ(JGEDE+(NN-1)*NCGEDE()+2 + JGEDE_GESL) = 0
       CALL MMBREL(JGSGD,CURRSL,NN)
       MG = OGEDE_GMAT(NN-1) 
       IQ(JGEDE+(NN-1)*NCGEDE()+2 + JGEDE_GMAT) = 0
       CALL MMBREL(JGMGD,MG,NN)
       IQ(IQGESL_NPL(CURRSL)) = IQ(IQGESL_NPL(CURRSL)) + 1

       IF(ILAY .EQ. 1) THEN
          Q (QGEDE_COS_L()) = -SINX
          Q (QGEDE_SIN_L()) = -COSX
       ELSE IF(ILAY.eq.3) THEN
          Q (QGEDE_COS_L()) = SINX
          Q (QGEDE_SIN_L()) = -COSX
       ENDIF
       IQ(IQGEDE_LAY_L()) = ILAY + 1 
       Q (QGEDE_XFW_L(1)) = -XMINEF*FGEDE_COS(NGEDE())  
     +                      -YMINEF*FGEDE_SIN(NGEDE()) + 0.5*PITSM
       Q (QGEDE_ZFW_L(1)) = FGEDE_ZMAX(NN)
       IQ(IQGEDE_NWI_L(1)) =-((XMAXEF-XMINEF)*FGEDE_COS(NGEDE()) 
     +                      + (YMAXEF-YMINEF)*FGEDE_SIN(NGEDE()))/PITSM

C--   adapter -front side
       PARAD(1) = .5 * DXA1SM
       PARAD(2) = .5 * DYA1SM
       PARAD(3) = .5 * DZA1SM
       POSAD(1) = PXMOD
       POSAD(2) = PYA1SM(NSL) + PYMOD
       POSAD(3) = PZMOD - .5*(DZC1SM+DZA1SM)
       CALL GUROT(IRS,POSAD,XP)              
       CALL CRPOS('SMAD',CNAM,ILAY,ISEC,
     +                   XP(1),XP(2),XP(3),IRS,'ONLY',PARAD)

c--   hybrid - front side  
       PARHY(1) = .5 * DXHYSM
       PARHY(2) = .5 * DYHYSM
       PARHY(3) = .5 * DZHYSM
       POSHY(1) = -PXH1SM(NSL) + PXMOD
       POSHY(2) =  PYH1SM(NSL) + PYMOD
       POSHY(3) = PZMOD - .5*(DZC1SM+DZHYSM)
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                         XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)
       POSHY(1) = PXH1SM(NSL) + PXMOD
       POSHY(2) = PYH1SM(NSL) + PYMOD
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                         XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)

C--    Carrier (beam-side)
       PARCA(1) = .5 * DXC1SM
       PARCA(2) = .5 * DYC1SM
       PARCA(3) = .5 * DZC1SM
       POSCA(1) = PXMOD
       POSCA(2) = PYC1SM(NSL) + PYMOD
       POSCA(3) = PZMOD
       CALL GUROT(IRS,POSCA,XP)
       CALL CRPOS('SMCA',CNAM,ILAY,ISEC,
     +                         XP(1),XP(2),XP(3),IRS,'ONLY',PARCA)

C--    Carrier (beam off-side)
       PARCA(1) = .5 * DXC2SM
       PARCA(2) = .5 * DYC2SM
       PARCA(3) = .5 * DZC2SM
       POSCA(1) = PXMOD
       POSCA(2) = PYC2SM(NSL) + PYMOD
       POSCA(3) = PZMOD
       CALL GUROT(IRS,POSCA,XP)
       CALL CRPOS('SMCA',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARCA)

C--    Adapter (back side)
       PARAD(1) = .5 * DXA2SM
       PARAD(2) = .5 * DYA2SM
       PARAD(3) = .5 * DZA2SM
       POSAD(1) = PXMOD
       POSAD(2) = PYA2SM(NSL) + PYMOD
       POSAD(3) = PZMOD + .5*(DZC1SM+DZA1SM)
       CALL GUROT(IRS,POSAD,XP)
       CALL CRPOS('SMAD',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARAD)

C--     hybrid (back side)
       POSHY(1) = -PXH2SM(NSL) + PXMOD
       POSHY(2) =  PYH2SM(NSL) + PYMOD
       POSHY(3) = PZMOD + .5*(DZC1SM+DZHYSM)
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)
       POSHY(1) = PXH2SM(NSL) + PXMOD
       POSHY(2) = PYH2SM(NSL) + PYMOD
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)
       enddo             ! end loop over layers


      ENDDO               ! end loop over sectors ISEC

 90   RETURN
      END

