
      SUBROUTINE SZ2G96(ISL)

************************************************************************
*
* SZ2G96
* written by Siegmund Nowak, 01/07/96
*
* This routines generates the geometry for the 'PK's scint hodoscope
*
*       called from GEOMAIN
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*    ISL      in          superlayer number in GESL table 
*************************************************************************

      IMPLICIT NONE

      INTEGER I,IVOL,IVOLC,IROT,ISET,IDET,MEDNUM,ISL
      REAL PAR(3),PARA(8),XMSC,XMSG,XMSP
      REAL XPOS,YPOS,ZPOS
      REAL XSZHL, YSZHL, ZSZHL, XSZHR, YSZHR, ZSZHR, DXSC, DYSC, DZSC 
      REAL DXSG , DYSG , DZSG , DRSP , DZSP, PXSC(4), PYSC(4), PZSC(4)
      CHARACTER*4 CSL
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA XSZHL /-50./, YSZHL /-170./, ZSZHL / 890./
      DATA XSZHR / 50./, YSZHR /-130./, ZSZHR /1030./
      DATA DXSC /36./, DYSC /3.0/, DZSC /1.0/
      DATA DXSG / 7./, DYSG /3.0/, DZSG /1.0/
      DATA DRSP /2.85/,DZSP /10./
      DATA PXSC /   -3.,    .5,   1.1,    0./,
     +     PYSC /-137.5,-158.2,-158.8,-157.9/,
     +     PZSC /  904.,  904.,  936., 1023./
#include "arte/Arte.ff"
#include "auto/GEO.ff"

c     install rotation matrices  
      CALL CRROTM(IROT,180.,0, 90.,90.,90.,0.)

c     install superlayer volume for the P.K. counter
      CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,CSL,4)
      CALL CGGESL(CSL,'MOTH',0)

c     horizontal counter
      PAR(1) = .5* DXSC
      PAR(2) = .5* DYSC
      PAR(3) = .5* DZSC
      CALL GSVOLU('SZ2C', 'BOX ', MEDNUM(3,'LUCITE'),PAR,3,IVOLC)
      CALL GSATT('SZ2C','COLO',4)
      CALL GRADLN(IVOLC,XMSC)
      XMSC = DZSC/XMSC

c     light guide
      PAR(1) = .5* DXSG
      PAR(2) = .5* DYSG
      PAR(3) = .5* DZSG
      CALL GSVOLU('SZ2G', 'BOX ', MEDNUM(1,'LUCITE'),PAR,3,IVOL)
      CALL GSATT('SZ2G','COLO',110)
      CALL GRADLN(IVOL,XMSG)
      XMSG = DZSC/XMSG

c     photomultiplier
      PAR(1) = 0.
      PAR(2) = DRSP
      PAR(3) = .5*DZSP
      CALL GSVOLU('SZ2P', 'TUBE', MEDNUM(1,'ALUMINIUM'),PAR,3,IVOL)
      CALL GRADLN(IVOL,XMSP)
      XMSP = DRSP/XMSP

      DO I=1,4
       XPOS =  PXSC(I) - .5*(XSZHR+XSZHL)
       YPOS =  PYSC(I) - .5*(YSZHR+YSZHL)
       ZPOS =  PZSC(I) - .5*(ZSZHR+ZSZHL)

       CALL GSPOS('SZ2C',NGCAL()+1,CSL,XPOS, YPOS,ZPOS,0,'ONLY')
       PARA(1) = PXSC(I) - .5*DXSC
       PARA(2) = PXSC(I) + .5*DXSC
       PARA(3) = PYSC(I) - .5*DYSC
       PARA(4) = PYSC(I) + .5*DYSC
       PARA(5) = PZSC(I) - .5*DZSC
       PARA(6) = PZSC(I) + .5*DZSC
       CALL CRGCAL(1,IVOLC,PARA)
       IQ(IQGCAL_NCL_L()) = I
       IQ(IQGCAL_SEC_L()) = 1
       Q(QGCAL_EFF_L()) = 1.
       Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

       XPOS = XPOS + .5*(DXSC+DXSG)
       CALL GSPOS('SZ2G',NGCAL()+1,CSL,XPOS, YPOS,ZPOS,0,'ONLY')
       XPOS = XPOS + .5*(DXSG+DZSP)
       CALL GSPOS('SZ2P',NGCAL()+1,CSL,XPOS, YPOS,ZPOS,IROT,'ONLY')
      ENDDO

      CALL GSDET(CSL,'SZ2C',1,'SZ2C',5,LGESL_HOD3,50,20,ISET,IDET)

      RETURN
      END




