 /*
************************************************************************
*
* TARGEO
* written by Siegmund Nowak
*
* This routines defines geometry of the beam pipe outside the si-region
* and up to the muon system
*
*       called from G..MAIN
*
************************************************************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/Arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteUtil.h"
#include "gean/gclink.hh"
#include "gean/ZGMOTH.hh"
#include "auto/GEO.hh"
#include "auto/GTAR.hh"
#include "gean/ZGTAR.hh"


  struct GTAR gtar; 
 
  extern "C" {
    void targeo_();
    void gsvolu_();
    void me78er_();
    void gsatt_();
    void crpos_();
    void crrotm_();    
    void mednumc_();
    void matnumc_();
    void ch78bi_();
    int  tardat_();
    extern ZGTAR tarbuf_;
    extern CommonZGMOTH zgmoth_;
    extern Commongclink gclink_;
  }

void targeo_() {
//  targ buf;

    ZGTAR&  targ=tarbuf_;
    CommonZGMOTH& mut=zgmoth_;
    Commongclink& glink=gclink_;
    int ivol, imed, imat, irot, len; 
    int zero=0, one=1; 
    char shap[4], colo[4],  only[4], mot[4],  vol[5],  mat[13];
    float fzero =0., fninety=90.;
    float par[3], xp, yp, zp;
    double vers;

// standard definitions 
    strncpy(shap,"BOX ",4); 
    strncpy(colo,"COLO",4);
    strncpy(only,"ONLY",4);
    crrotm_(&irot , &fzero, &fzero, &fninety,&fzero, &fninety, &fninety);

//  select file name 
    static char filnam[16];
    vers = 1;
    double vv= modf(arteflag_.geomvers,&vers);
    if (vers==0) strcpy(filnam,"tar.dat");           
    else if (vers==98) strcpy(filnam,"tar98.dat");           
    else if (vers==97) strcpy(filnam,"tar97.dat");
    else printf("no filnam defined");

//  posit volumes within mother 
    int wnr=0; 

    for (;;)   {
    int fi = tardat_(filnam);
    if (fi == 0) continue;
    if (fi != 0) {
      union  { int ii; char bla[4];};
      int i=0, k=0;
      int nvol=*(gcbank_.iq + glink.jvolum -2); 
      while( i<nvol) {
        ii = *(gcbank_.iq+glink.jvolum+i);
        if(!strncmp(bla,targ.object,4)) {
           k=i+1; 
           break; }
        i++; }

      wnr = wnr + 1;
      strncpy(mot,targ.mother,4);
      strncpy(vol,targ.object, 4);
      strncpy(shap,targ.shape, 4);
      len = strlen(targ.material);
      if(len >12) len=12;
      strncpy(mat,targ.material, len);
      matnumc_(&mat,&len,&imat);
      if (k == 0)  { 
         mednumc_(&one, &mat, &len, &imed);
	 gsvolu_(&vol,&shap, &imed, &par, &zero, &ivol);
         gsatt_(&vol, &colo, &one); }
         
      par[0] = 0.5 * targ.dx;
      par[1] = 0.5 * targ.dy;
      par[2] = 0.5 * targ.dz;
      xp = targ.xpos;
      yp = targ.ypos;
      zp = targ.zpos + mut.ZZERO;
      if(targ.rotation == 0)
         crpos_(&vol,&mot,&wnr,&zero,&xp,&yp,&zp,&zero,&only, &par);
      else
         crpos_(&vol,&mot,&wnr,&zero,&xp,&yp,&zp,&irot,&only, &par);

      gtar.cmp  = imat;   
      gtar.wnr  = wnr;
      gtar.dx   = targ.dx;
      gtar.dy   = targ.dy;
      gtar.dz   = targ.dz;
      gtar.x    = xp;
      gtar.y    = yp;
      gtar.z    = targ.zpos; 
      gtar.rot[0] = 1.;
      gtar.rot[4] = 1.;
      gtar.rot[8] = 1.;
      gtar.x0bm   = targ.xb;
      gtar.y0bm   = targ.yb;
      gtar.sxbm   = targ.sxb;
      gtar.sybm   = targ.syb;
      ArtePointer<GTAR>::append(gtar); 
      if ( fi <= 0 ) break;
}}}  
 /* pipgeo_ */






