
        SUBROUTINE T R D G E N (GAMMA,COR,STEP,NTR,ETR,STR)

************************************************************************
* written by Valeri Saveliev,  24/03/97  14.04.26
*
* This routines simulates TR-photon in STEP-length radiator
* called from TRDSIM
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*  GAMMA     - Lorentz factor,
*  COR       - correction factor,
*  NTR       - number   TR photons,
*  ETR       - energy   TR photons (GeV),
*  STR       - distance of each photon.
************************************************************************
        IMPLICIT NONE
#include "gean/ZGTRDE.fi"
C...
        INTEGER NTR,NFOIL,JG,JG1,I,N,IER,K1,K2,K,TRJTAB
        REAL ETR(1000),STR(1000),DNWMG(81),RNDM(2)
        REAL GAMMA,COR,STEP,GAMTAB,GL,ANMIN,ANMAX,DGG,DAN,AM,R,E
        DATA GAMTAB/0./,DNWMG/81*0./,ANMIN/0./,ANMAX/0./
        DATA JG/0/,GL/0./
C...
        NTR     = 0
        NFOIL   = STEP/(FOIL+GAS)
        IF(GAMMA.LT.EXP(GINWM(1)).OR.NFOIL.LE.0 ) RETURN
        IF(ABS(GAMMA-GAMTAB).LE.5.              ) GO TO 6
C...
        GAMTAB  = GAMMA
        GL      = ALOG(GAMMA)
        IF(GL.LT.GINWM(20)) GO TO 3
        DO 2 I  = 1,81
2       DNWMG(I)= DNM(I,20)
        JG      = 20
        GO TO 5
C...
3       JG      = TRJTAB(GL,20,GINWM)
        JG1     = JG+1
        DGG     = (GL-GINWM(JG))/(GINWM(JG1)-GINWM(JG))
        DO 4 I  = 1,81
4       DNWMG(I)= (DNM(I,JG1)-DNM(I,JG))*DGG+DNM(I,JG)
C...
5       ANMIN   = EXP(DNWMG(81))
        ANMAX   = EXP(DNWMG(1 ))
C...
6       DAN     = ANMAX-ANMIN
        AM      = COR*DAN*NFOIL
        CALL POISSN(AM,N,IER)
        IF(N.LE.0) RETURN
C...
        N       = MIN(N,1000)
        DO 10 I = 1,N
        K1      = 1
        K2      = 81
        CALL GRNDM(RNDM,2)
        R       = ALOG(RNDM(1)*DAN+ANMIN)
7       K       = (K1+K2)/2
        IF(R.NE.DNWMG(K)) GO TO 8
        E       = EXP(WTR(K))
        K2      = K
        GO TO 9
8       IF(R.GT.DNWMG(K)) K2 = K
        IF(R.LT.DNWMG(K)) K1 = K
        IF(K2-K1.GT.1) GO TO 7
C...
        E       = WTR(K2)+(R-DNWMG(K2))*(WTR  (K1)-WTR  (K2))/
     +                                  (DNWMG(K1)-DNWMG(K2))
        E       = EXP(E)
C...
9       NTR         = NTR+1
        ETR(NTR)    = E*1.E-6
        STR(NTR)    = STEP*RNDM(2)
10      CONTINUE
C...
        RETURN
        E N D
