
      SUBROUTINE VERDIS (XM)

************************************************************************
*-- Author :    A. Pose/Siegmund Nowak
*
* This routines makes a random distribution of interaction vertices 
* on wire targets
*
*       called from HGKINE
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*   XM       out          position vector of an interaction 
*
************************************************************************
      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "gean/ZGTARG.fi"
      INTEGER IW,IFIRST,NUBUF
      REAL AR(3),RN,WL1,WL2,XD(3),XM(3),PROB(NMXTAR),PROBTOT,DUMMY
      REAL A,Z,DENS,RADL,ABSL,UBUF(1)
      CHARACTER*20 CHNAM
      SAVE IFIRST,PROB,PROBTOT
      DATA IFIRST/0/
#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--   TARGET PARAMETERS

C--        RANDOM  NUMBER VECTOR for wire number/x/y/z
      IF(IFIRST.EQ.0) THEN
         PROBTOT = 0.0
         DO IW=1,NGTAR()
          CALL GFMATE(IGTAR_CMP(IW),CHNAM,A,Z,DENS,RADL,ABSL,UBUF,NUBUF)
          IF(FGTAR_DX(IW).GT.FGTAR_DY(IW))THEN
             PROB(IW) = EXP(-0.5*((FGTAR_Y(IW)-FGTAR_Y0BM(IW)) /
     +            FGTAR_SYBM(IW))**2) / (FGTAR_SYBM(IW)*ABSL)
             PROB(IW) = PROB(IW)*FGTAR_DY(IW)
          ELSE
             PROB(IW) = EXP(-0.5*((FGTAR_X(IW)-FGTAR_X0BM(IW)) /
     +            FGTAR_SXBM(IW))**2) / (FGTAR_SXBM(IW)*ABSL)
             PROB(IW) = PROB(IW)*FGTAR_DX(IW)
          ENDIF
          PROBTOT = PROBTOT + PROB(IW)
         ENDDO
         DO IW=1,NGTAR()
          PROB(IW)=PROB(IW)/PROBTOT
         ENDDO
         DO IW=1,NGTAR()
          IF(IW.GT.1)  PROB(IW)=PROB(IW)+PROB(IW-1)
         ENDDO
         IFIRST = 1
      ENDIF

      CALL GRNDM(AR,3)
      IW=0
1     CONTINUE
      IW=IW+1
      IF(AR(1).GT.PROB(IW))GO TO 1
      IF(IW.LT.1) IW = 1
      IF(IW.GT.NMXTAR) IW = NMXTAR
      IF(FGTAR_DX(IW).GT.FGTAR_DY(IW)) THEN
C         horizontal wires
         WL1 = ( .5*FGTAR_DX(IW)-FGTAR_X0BM(IW))/FGTAR_SXBM(IW)
         WL2 = (-.5*FGTAR_DX(IW)-FGTAR_X0BM(IW))/FGTAR_SXBM(IW)
 30      CALL GRANOR(RN,DUMMY)
         IF(RN.GT.WL1.OR.RN.LT.WL2) GO TO 30
         XD(1) = RN * FGTAR_SXBM(IW) + FGTAR_X0BM(IW)
         XD(2) = (AR(2)-.5) * FGTAR_DY(IW)
      ELSE
C         vertical wires
         WL1 = ( .5*FGTAR_DY(IW)-FGTAR_Y0BM(IW))/FGTAR_SYBM(IW)
         WL2 = (-.5*FGTAR_DY(IW)-FGTAR_Y0BM(IW))/FGTAR_SYBM(IW)
 32      CALL GRANOR(RN,DUMMY)
         IF(RN.GT.WL1.OR.RN.LT.WL2) GO TO 32
         XD(1) = (AR(2)-.5) * FGTAR_DX(IW)
         XD(2) = RN * FGTAR_SYBM(IW) + FGTAR_Y0BM(IW)
      ENDIF
      XD(3) = (AR(3)-.5) * FGTAR_DZ(IW)

      XM(1) = XD(1) + FGTAR_X(IW)
      XM(2) = XD(2) + FGTAR_Y(IW)
      XM(3) = XD(3) + FGTAR_Z(IW)

 90   RETURN
      END



