#ifndef FILE_STREAM_HH
#define FILE_STREAM_HH

#include <sys/types.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include "gpack/gpack.h"

typedef enum LockBehavior 
{ 
  NoLock, 
  WaitLock, 
  NoWaitLock 
} LockBehavior;

class filestream
{

private:

  int         fd;
  size_t      pos;
  size_t      filesize;
  char        *fname;         // full path name
  int         omode;
  int         locktype;
  char        *buffer;
  int         bufsize;
  int         used;
  int         cursor;
  char        errmsg[256];

public:

              filestream();
             ~filestream();
  char*       getErrorMsg()          { return errmsg; }
  StreamType  getStreamType()        { return FileStream; }
  int         receive()              { return GP_NOT_IMPLEMENTED; }
  void        setbuf(int size)       { bufsize = size; }
  int         setname(char *name, int omode);
  char*       getname()              { return fname; }
  int         getmode()              { return omode; }
  void        setkey(int)            {};
  int         create()               { return GP_NOT_IMPLEMENTED; }
  int         destroy()              { return GP_NOT_IMPLEMENTED; }
  void        lock(LockBehavior lck) { locktype = lck; }
  int         open(void);
  int         close(void);
  int         is_open(void);
  int         is_room(int size);
  int         InfoDisk(int* total, int* used);
  int         get(char *array, int length);
  int         put(char *array, int length);
  int         buflush();
  size_t      getpos();
  int         setpos(size_t ps);
};

#include "gpack/filestream.icc"

#endif  /* FILE_STREAM_HH */
