#ifndef GPACKPROTO_H
#define GPACKPROTO_H

#include "gpack/gpack.h"

#ifdef __cplusplus
extern "C" {
#endif

  /*  HERA-B I/O package.  */ 
  /*  ===================  */

  /*    C-functions prototypes  */

  int   gp_setstream(StreamType type);
  int   gp_settarget(int stream, TargetType target);
  int   gp_setname(int stream, char* filename, int openmode);
  int   gp_setkey(int stream, int key);
  int   gp_setbuf(int stream, int size);
  int   gp_create_ring(int stream);
  int   gp_destroy_ring(int stream);
  int   gp_open(int stream);
  int   gp_close(int stream);
  int   gp_getevt(int  stream, EventHdr *h); 
  int   gp_putevt(int  stream, EventHdr *h);
  int   gp_gettabinfo(int stream, char *name, int *ncols, int *nrows);
  int   gp_skiptab(int stream);
  int   gp_gettab(int   stream,
		  char* name,
		  int   ncols,
		  int   nrows,
		  char* description,
		  void* data
		  );
  int   gp_puttab(int   stream,
		  char* name,
		  int   ncols,
		  int   nrows,
		  char* description,
		  void* data
		  );
  int   gp_flush(int stream);
  int   gp_setevtype(int stream, EventType type);
  int   gp_getevtype(int stream, EventType* type);
  int   gp_getevtpos(int stream);
  char* gp_errmsg(int stream);
  int   gp_select(int stream, char *criteria);

#ifdef __cplusplus
}
#endif

#endif /* GPACKPROTO_H */
