*CMZ :          02/05/96  17.05.20  by  Hartwig Albrecht
*CMZ :  2.01/02 25/01/96  19.17.29  by  Hartwig Albrecht
*CMZ :  2.01/01 01/12/95  14.36.08  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   04/10/95

      SUBROUTINE KAEDEC

************************************************************************
*
* Description: ENDDECAY command
*
* Called from: KUIP
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/TOPP.fi"
#include "auto/TOPX.fi"
#include "auto/TDEC.fi"
#include "auto/TDEX.fi"
#include "jets/LUDAT1.fi"

      INTEGER TPNAM1, I, J, L, L1, QSUM, LUCOMP, KC, LC, LM
      REAL SUMMASS
      CHARACTER CN*12

#include "arte/Arte.ff"
#include "auto/TOPP.ff"
#include "auto/TOPX.ff"
#include "auto/TDEC.ff"
#include "auto/TDEX.ff"

      CALL KUGETS (CN, L)
      I = TPNAM1 (CN)
      IF (DECAINIT .NE. I)  THEN

        C78 = 'ENDdecay:'
        CALL CH78BC (CN)
        CALL CH78BC ('is not the same particle as on BEGdecay')
        CALL ME78EC (6348546)

      END IF

      DECAINIT = 0
      LM = 0
      LC = 0

C perform checks on decay table (this code is derived from LUUPDA)

      L = ITOPX_TDEC(I)
      IF (L .EQ. 0)  GO TO 90

 10   IF (ITDEC_MDME(2,L) .GE. 84 .AND. ITDEC_MDME(2,L) .LE. 88)
     +  GO TO 50

      IF (ITDEC_DAUG(1,L) .EQ. 0)  THEN
        CALL LITDEC (I, 'TPL')
        CALL MEERRC (13641354, 'KAEDEC: no decay particle given')
        GO TO 50
      END IF

C continuation cards: there are bugs in LUUPDA -> forbidden

      IF (ITDEC_MDME(2,L) .EQ. 101)  THEN
        CALL LITDEC (I, 'TPL')
        CALL MEERRC (872346,
     +   'KAEDEC: continuation cards are not accepted in this version')
        GO TO 50
      END IF

C skip 'one-body' decays and quark decays and continuation lines

      IF (ITDEC_MDME(2,L) .GT. 80)  GO TO 50
      IF (ITDEC_DAUG(2,L) .EQ. 0)  GO TO 50

      KC = LUCOMP (ITOPP_LUND(I))
      QSUM = ITOPP_CHRG(I) - ITOPP_CHRG(ITDEC_DAUG(1,L))
      SUMMASS = FTOPP_MASS(I) - FTOPP_TRBW(I) - PARJ(64) -
     +       FTOPP_MASS(ITDEC_DAUG(1,L))

      DO 20 J = 2, 5
        IF (ITDEC_DAUG(J,L) .EQ. 0)  GO TO 20
        IF (ITDEC_DAUG(J-1,L) .EQ. 0)  THEN
          CALL LITDEC (I, 'TPL')
          CALL MEERRC (634534,
     +      'KAEDEC: list of decay particles contains 0')
          GO TO 20
        END IF

        QSUM = QSUM - ITOPP_CHRG(ITDEC_DAUG(J,L))
        SUMMASS = SUMMASS - FTOPP_MASS(ITDEC_DAUG(J,L))

 20   CONTINUE

      IF (QSUM .NE. 0)  LC = 1

C skip bosons and unphysical particles

      IF (KC .GE. 21 .AND. KC .LT. 39)  GO TO 50
      IF (KC .GE. 11 .AND. KC .LE. 99)  GO TO 50

      IF (SUMMASS .LT. 0.)  LM = 1

 50   L = ITDEX_NEXT(L)
      IF (L .NE. 0)  GO TO 10

      IF (LC .NE. 0)  THEN
        C78 = 'KAEDEC: Sum (charges of decay products) not 0 for'
        CALL CH78BC (CN)
        CALL ME78EC (7623456)
      END IF

      IF (LM .NE. 0)  THEN
        C78 = 'KAEDEC: Sum (masses of decay products) too large for'
        CALL CH78BC (CN)
        CALL ME78WC (235345)
      END IF

 90   END

************************************************************************
* End of KAEDEC
************************************************************************
