*CMZ :          04/09/96  19.59.46  by  Fedor Ratnikov
*CMZ :  1.01/02 05/02/96  23.28.21  by  Fedor Ratnikov
*CMZ :  1.01/01 06/01/96  20.31.06  by  Fedor Ratnikov
*CMZ :  1.01/00 19/12/95  14.51.19  by  Fedor Ratnikov
*-- Author :    Fedor Ratnikov   28/10/95
************************************************************************
*
* L1PRXMF
* written by Fedor Ratnikov, 28/10/95 19.47.45
*
* This routines action:
* simulates inner muon pixel chambers pretrigger
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iP         in           pointer to pretrigger processor
* iErr       out          #0 when error
*
************************************************************************
c
      SUBROUTINE L1PRXMF(iP,iErr)
c
      IMPLICIT NONE
c
      INTEGER iP,iErr
c
#include "gean/gcbank.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1detmu.fi"
#include "l1si/l1clink.fi"
#include "l1si/rclink.fi"
#include "l1si/rcfdef.fi"

c
      INTEGER MaxPadNumber
      PARAMETER (MaxPadNumber=100)
      INTEGER iHit3(L1hitlen,MaxPadNumber),iHit4(L1hitlen)
      LOGICAL inited
      CHARACTER*10 NameProg
      CHARACTER*4 MXName(2)
      INTEGER iDetMX(2),iSecMX(2,2,2),nColMX(2,2,2),nRowMX(2,2,2)
      INTEGER ich,isec
      INTEGER idx34min,idx34max,idy34min,idy34max
      INTEGER icell3,icell3x,icell3y,icell4,icell4x,ice4x,icell4y,
     &     ix,iy,ix3,iy3,ix4,iy4,iHitPoi3,iHitPoi4,
     &     iTime,MessPo,iPRE,iPoPo,JobPo
      INTEGER jMuGeo,jMuInf,jCellGeo,iDetSpe(L1DETSPElen)
      REAL  PoiMX3(L1GEOINFlen),PoiMX4(L1GEOINFlen)
      INTEGER l1detsl
      EXTERNAL l1detsl
c
      DATA inited /.FALSE./
      DATA NameProg /'L1PRXMU==>'/
      DATA MXName /'MXP3','MXP4'/
      DATA idx34min /-1/, idx34max /1/
      DATA idy34min / 0/, idy34max /1/
c
#include "l1si/l1mesdf.ff"
c
      iErr = 0  ! no errors so far
      IF (L1PARprnlev.ge.1) THEN
       WRITE (L1LUNprn,'(A11,'' START '',58(''#''))') NameProg
      END IF
      IF(.NOT.inited)  THEN     ! initialization
       CALL VZERO(iSecMX,8)
       DO ich=1,2
        iDetMX(ich) = l1detsl(MXName(ich))
        IF(iDetMX(ich).LE.0)  THEN ! not found
         WRITE (L1LUNprn,*) NameProg,
     &        ' Superlayer ',MXName(ich),' not found'
         GOTO 777
        ENDIF
        iDetSpe(L1DETSPEdet) = iDetMX(ich)
        iDetSpe(L1DETSPElayer) = 1
        DO isec = 1,4           ! 4 sections in a superlayer
         iDetSpe(L1DETSPEsection) = isec
         CALL l1detif(iDetSpe,jMuGeo,jMuInf,jCellGeo)
         IF(jMuGeo.EQ.0)    THEN
          WRITE (L1LUNprn,*) NameProg,
     &         'Section not found:',MXName(ich),isec
          GOTO 777
         ENDIF
         IF(Q(jMuGeo+L1GEOINFx0)+0.5*Q(jMuGeo+L1GEOINFsx).LT.0) THEN
          ix = 1                ! left section
         ELSE
          ix = 2                ! right section
         ENDIF
         IF(Q(jMuGeo+L1GEOINFy0)+0.5*Q(jMuGeo+L1GEOINFsy).LT.0) THEN
          iy = 1                ! down section
         ELSE
          iy = 2                ! up section
         ENDIF
         iSecMX(ich,ix,iy) = isec  ! save section number
         nColMX(ich,ix,iy) = IQ(jMuInf+L1DETINFnCol)
         nRowMX(ich,ix,iy) = IQ(jMuInf+L1DETINFnRow)
        ENDDO
        DO ix=1,2               ! safety check
         DO iy=1,2
          IF(iSecMX(ich,ix,iy).EQ.0)  THEN
           WRITE (L1LUNprn,*) NameProg,
     &          'Section not inited:',MXName(ich),ix,iy
           GOTO 777
          ENDIF
         ENDDO
        ENDDO
       ENDDO
       inited = .TRUE.
      ENDIF
c
c       Pretrigger itself
c
      DO ix3=1,2                !loop over MX3 sections
       DO iy3=1,2
        CALL l1higet(iP,iSecMX(1,ix3,iy3),iDetMX(1),L1RUNcuBX,1,
     &       MaxPadNumber,iHit3) ! read all hits for MX3
        DO icell3y=1,nColMX(1,ix3,iy3)
         DO icell3x=1,nRowMX(1,ix3,iy3)
          icell3 = (icell3y-1)*nRowMX(1,ix3,iy3)+icell3x
          IF(iHit3(L1HITpos,icell3).GT.0) THEN ! PAD is hitted
           DO icell4y=icell3y+idy34min,icell3y+idy34max
            IF(icell4y.LT.1.OR.icell4y.GT.nColMX(2,ix3,iy3))
     &           GOTO 100       !Y ROI inside MX4 section
            iy4 = iy3           !the same section in Y
            DO icell4x=icell3x+idx34min,icell3x+idx34max
             IF(icell4x.GT.nRowMX(2,ix3,iy3).AND.ix3.EQ.1) THEN
              ix4 = 2
              ice4x = 1         ! first PAD of the left section
             ELSEIF(icell4x.LT.1.AND.ix3.EQ.2) THEN
              ix4 = 1           !last PAD of the right section
              ice4x = nRowMX(2,ix4,iy4)
             ELSE
              ix4 = ix3  ! the same section
              ice4x = icell4x
             ENDIF
             icell4 = (icell4y-1)*nRowMX(1,ix4,iy4)+ice4x
             CALL l1higet(iP,iSecMX(2,ix4,iy4),iDetMX(2),L1RUNcuBX,
     &            icell4,1,iHit4) ! hit in MX4
             IF(iHit4(L1HITpos).GT.0) THEN ! Coincidence: TRIGGER!!!
c
c             TRIGGER found: fill message
c
              IF (L1PARprnlev.ge.1) THEN
               WRITE (L1LUNprn,*) NameProg,
     &              'MX3:isx/isy/ix/iy',ix3,iy3,icell3x,icell3y
               WRITE (L1LUNprn,*) NameProg,
     &              'MX4:isx/isy/ix/iy',ix4,iy4,ice4x,icell4y
              ENDIF
c
c             coordinates in MX4
c
              ich = 2           ! MX4
              iDetSpe(L1DETSPEdet) = iDetMX(ich)
              iDetSpe(L1DETSPElayer) = 1
              iDetSpe(L1DETSPEsection) = iSecMX(ich,ix4,iy4)
              CALL l1detif(iDetSpe,jMuGeo,jMuInf,jCellGeo)
              CALL UCOPY(Q(jCellGeo+1),PoiMX4(1),L1GEOINFlen) ! cell
              PoiMX4(L1GEOINFx0) = Q(jMuGeo+L1GEOINFx0)+
     &             Q(jMuInf+L1DETINFxspace)*(ice4x-1)
              PoiMX4(L1GEOINFy0) = Q(jMuGeo+L1GEOINFy0)+
     &             Q(jMuInf+L1DETINFyspace)*(icell4y-1)
c
              iHitPoi4=iHit4(L1HITpos) ! MC track reference
c
c             coordinates in MX3
c
              ich = 1           ! MX3
              iDetSpe(L1DETSPEdet) = iDetMX(ich)
              iDetSpe(L1DETSPElayer) = 1
              iDetSpe(L1DETSPEsection) = iSecMX(ich,ix3,iy3)
              CALL l1detif(iDetSpe,jMuGeo,jMuInf,jCellGeo)
              CALL UCOPY(Q(jCellGeo+1),PoiMX3(1),L1GEOINFlen) ! cell
              PoiMX3(L1GEOINFx0) = Q(jMuGeo+L1GEOINFx0)+
     &             Q(jMuInf+L1DETINFxspace)*(icell3x-1)
              PoiMX3(L1GEOINFy0) = Q(jMuGeo+L1GEOINFy0)+
     &             Q(jMuInf+L1DETINFyspace)*(icell3y-1)
c
              iHitPoi3=iHit3(L1HITpos,icell3) ! MC track reference
c
              IF (L1PARprnlev.ge.2) THEN
               WRITE (L1LUNprn,'(A11,''MX3 x/sx/y/sy/z:'',5f9.3)')
     &              NameProg,PoiMX3(L1GEOINFx0),PoiMX3(L1GEOINFsx),
     &              PoiMX3(L1GEOINFy0),PoiMX3(L1GEOINFsy),
     &              PoiMX3(L1GEOINFz)
               WRITE (L1LUNprn,'(11X,''MX4 x/sx/y/sy/z:'',5f9.3)')
     &              PoiMX4(L1GEOINFx0),PoiMX4(L1GEOINFsx),
     &              PoiMX4(L1GEOINFy0),PoiMX4(L1GEOINFsy),
     &              PoiMX4(L1GEOINFz)
              END IF
c
              CALL l1mesne(L1RUNcuBX,MessPo) ! get new message
              IF ( MessPo.le.0 ) THEN ! message storage exceeded
               ierr = 1
               RETURN
              END IF
              iTime = L1RUNcutime+L1DEFmuotim ! time after Pretrigger
c             --- set flags
              L1MEstor(MessPo+L1MElast)    = 0 ! last point was pretrigger
              L1MEstor(MessPo+L1MEcreated) = 0 ! first point was pretrigger
              L1MEstor(MessPo+L1MEnextPC)  = iP ! set active proc.
              L1MEstor(MessPo+L1MEactive)  = L1MEacPRE ! last processed

c             --- fill soft message
              L1MEstor(MessPo+L1MEprid) = L1PREpxmuon
c
              L1MEstor(MessPo+L1MEprbx) = L1RUNcuBX
              T1MEstor(MessPo+L1MEpren) = 100. ! Some
              T1MEstor(MessPo+L1MEprth) = 2. !reasonable
              T1MEstor(MessPo+L1MEpreth)= 1. ! values (for safity...)
c             c
c             Now we get detector information concerning MU3 and MU4
c             superlayers
c

c
c             MU4 part
c
              iPRE = L1PCstor(iP+L1PCnum) ! pretrigger number
              iPoPo = L1MEpoint(0)+MessPo
              L1MEstor(iPoPo+L1POpcpo) = iP
              L1MEstor(iPoPo+L1POtrkn) = 0
              L1MEstor(iPoPo+L1POtrk0) = iHitPoi4 ! reference on track bank
              L1MEstor(iPoPo+L1POtrkp) = 0
              L1MEstor(iPoPo+L1POsup)  = L1DEFpredef(L1PREsl,iPRE)
              L1MEstor(iPoPo+L1POtime) = iTime
              iPoPo = iPoPo+L1POreg
c
              T1MEstor(iPoPo+L1GEOINFx0) = PoiMX4(L1GEOINFx0)
              T1MEstor(iPoPo+L1GEOINFsx) = PoiMX4(L1GEOINFsx)
              T1MEstor(iPoPo+L1GEOINFy0) = PoiMX4(L1GEOINFy0)
c             slight decrease to do not touch the next row of pixels
              T1MEstor(iPoPo+L1GEOINFsy) = PoiMX4(L1GEOINFsy)*0.999
              T1MEstor(iPoPo+L1GEOINFz) = PoiMX4(L1GEOINFz)
c
c             MU3 part
c
              L1MEstor(MessPo+L1MElast) = L1MEstor(MessPo+L1MElast)+1 ! last point was pretrigger
              iPRE = L1PCstor(iP+L1PCnum) ! pretrigger number
              iPoPo = L1MEpoint(1)+MessPo
c
              L1MEstor(iPoPo+L1POpcpo) = iP
              L1MEstor(iPoPo+L1POtrkn) = 0
              L1MEstor(iPoPo+L1POtrk0) = iHitPoi3 ! reference on track bank
              L1MEstor(iPoPo+L1POtrkp) = 0
              L1MEstor(iPoPo+L1POsup)  = L1DEFpredef(L1PREsl,iPRE)-1
              L1MEstor(iPoPo+L1POtime) = iTime
c
              iPoPo = iPoPo+L1POreg
              T1MEstor(iPoPo+L1GEOINFx0) = PoiMX3(L1GEOINFx0)
              T1MEstor(iPoPo+L1GEOINFsx) = PoiMX3(L1GEOINFsx)
              T1MEstor(iPoPo+L1GEOINFy0) = PoiMX3(L1GEOINFy0)
c             slight decrease to do not touch the next row of pixels
              T1MEstor(iPoPo+L1GEOINFsy) = PoiMX3(L1GEOINFsy)*0.999
              T1MEstor(iPoPo+L1GEOINFz) = PoiMX3(L1GEOINFz)
c             --- fill hard message
              L1MEstor(MessPo+L1HAprbx)  = L1RUNcuBX
              L1MEstor(MessPo+L1HAprid)  = L1PREmuon
c             T1MEstor(MessPo+L1HApren)  = 100. ! some reasonable value...
              T1MEstor(MessPo+L1HAtxi)  =
     &             T1MEstor(iPoPo+L1GEOINFx0)+
     &             0.5*T1MEstor(iPoPo+L1GEOINFsx)
              T1MEstor(MessPo+L1HAteta)  =
     &             T1MEstor(iPoPo+L1GEOINFy0)+
     &             0.5*T1MEstor(iPoPo+L1GEOINFsy)
c
              CALL l1mesup(MessPo,iTime,ierr) ! update message (get ROI(s))
              IF ( ierr.ge.2 ) RETURN ! fatal error
              IF ( ierr.eq.1 ) THEN
               IF ( L1PARprnlev.gt.0 )
     &              WRITE(L1LUNprn,*) 'L1PRXMF==> Connection error'
               CALL l1mesde(MessPO,L1MEDEnoscr) ! delete message, do not drop data...
               ierr = 0
              ELSE
               CALL l1jobsb(MessPo,iTime,JobPo) ! submitt job
               IF ( JobPo.le.0 ) THEN
                CALL l1mesde(MessPo,L1MEDEnoscr)
               ELSE
                CALL l1usrpr(MessPo,0.,0.,0.,0.,0.)
               ENDIF
              ENDIF
             ENDIF
            ENDDO
           ENDDO
 100       CONTINUE
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      IF (L1PARprnlev.ge.1) THEN
       WRITE (L1LUNprn,'(A11,'' END '',58(''#''))') NameProg
      END IF
      RETURN
 777  CONTINUE   ! error exit
      iErr = 1
      RETURN
c
      END




















