*CMZ :          09/09/96  21.12.41  by  Fedor Ratnikov
*CMZ :  1.01/00 26/12/95  18.30.09  by  Fedor Ratnikov
*CMZ :  1.00/05 19/09/95  12.28.56  by   Ivan Belyaev
*CMZ :  1.00/01 17/08/95  12.38.20  by   Ivan Belyaev
*-- Author :    Dominik Ressing   28/11/94
************************************************************************
*
* L1TABRD
* written by Dominik Ressing, 28/11/94 18.48.30
*
* This routines action:
* read data from HB-bnks into L1 hit-tables
*
*
************************************************************************
c
      SUBROUTINE L1TABRD
c
      IMPLICIT NONE
c
#include "arte/Arte.fi"
#include "l1si/ydef.fi"
#include "l1si/l1param.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1detmu.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1banks.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1detuse.fi"
#include "l1si/l1geodf.fi"
#include "l1si/rcfdef.fi"
c
      INTEGER iTFU,nCon,iDet(L1DETSPElen),iCon,iGeo,iInf,iCell,iPo,
     &        iType,iPlate,iDig,iFLT,iHBid,
     &        iFLTf,iFLTl,nFou,IUCOMP,iStored,iStor,iLL,iLay,nMax,
     &        isl,iFirstPlate,nPlate,ndim,imimp,
     &        ix,iy,iBX,iHBplate,jAux,iSRow,jRel,kPo,iFiThis,iCtype,
     &        iPreNum,iPretCheck,nProjec,isec,nsec,iFLTdet
      REAL RNDM,Ecal,dEcal,ranor1,ranor2,comp,
     &     CellGeo(L1GEOINFlen)
      CHARACTER*4 CQ(100), cdetname
      EQUIVALENCE(Q(1),CQ(1))
      CHARACTER*4 CMuPreName(2),CMuPreXName(2)
      LOGICAL MuOut


      REAL z_Proj( 3 ) , x , y , x_PTC( 3 ) , y_PTC( 3 ) ,
     & pX , pY , xCell , yCell , xPos , yPos
      INTEGER i , iX_PTC( 3 ) , iY_PTC( 3 ) , i_odd_even ,
     &     nX , nY , nCell , iLayer , maxCells , iiCell,
     &     iCell_ID, ipl, IMTRA
      PARAMETER (maxCells=5000)
      real Escale(3)
      INTEGER kCell(maxCells)
      LOGICAL empty
      EXTERNAL IUCOMP
c
      DATA CMuPreName /'MUP3','MUP4'/
      DATA CMuPreXName /'MXP3','MXP4'/
      data Escale / 6.7,6.7,30./
c
#include "arte/Arte.ff"
#include "l1si/ydef.ff"
#include "l1si/rcfunc.ff"
c
c  Use the original MIMP bank for the ECAL
c
cPRINT *,'L1TABRD=> START....'
      iBX = L1RUNcuBX           ! store for current BX
c
      iPretCheck=0

      DO iPreNum=1,L1PARnpre    ! loop over all pretriggers

       if(L1DEFpredef(L1PREkind,iPreNum).eq.L1PREelec) then ! electron
                                ! pretrigger

        iPretCheck=1            !pretrigger found

          IF (L1PARprnlev.EQ.7) THEN ! l1simu hit printout
           WRITE (L1LUNprn,*) ' L1TABRD==>',
     &          ' Ecal pretrigger hits (E>0.5GeV):'
           WRITE (L1LUNprn,995)
          ENDIF

        DO isl=1,N_U(JGESL)     ! Loop over all detector ``superlayers''
         iType = IGESL_CMP(isl) ! type of detector
         IF(iType.EQ.LGESL_ECA)   THEN ! is Calorimeter SL
          iFirstPlate = IGESL_FPL(isl) ! first ECAL module
          nPlate = IGESL_NPL(isl) ! number of ECAL modules
c
          DO iPlate=1,nPlate    !Loop over all EC sections
           iHBplate = iFirstPlate+iPlate-1
           ndim = IGCAL_NCL(iHBplate)
           L1HI_E_PO(iBX,iPlate) = IQ(JL1HI_E+2)+1 ! save location
c
           DO ix = 1,ndim       ! loop over all cells in module
            DO iy = 1,ndim
             empty = .TRUE.     ! nothing found (so far)
c
             IF(IGEPC_MIM1(iHBplate).GT.0)   THEN  ! mimp exists
              DO imimp=IGEPC_MIM1(iHBplate),IGEPC_MIML(iHBplate) ! loop over impacts
               IF(IMCAL_GCAL(imimp).EQ.
     &              iHBplate*100+ndim*ix+iy)   THEN ! mimp belongs to cell studied
                IF (empty) THEN ! first impact ?
                 IF ( N_F(JL1HI_E).lt.1 ) ! table full?
     &                CALL UTETAB(IXDIV,JL1HI_E,100) ! get 100 new rows
                 IQ(JL1HI_E+2) = IQ(JL1HI_E+2)+1 ! add hit
                 IQ(L_L(L1HI_E_CELL,JL1HI_E)) = ndim*(ix-1)+iy
                 Ecal = 0.      ! clear energy
                 empty = .FALSE. ! cell found
                ENDIF
                Ecal = Ecal+FMCAL_DE(imimp) ! add energy to the cell
                CALL l1exrel(IXDIV, ! relation with MC track
     &               JL1HI_E_MTRA,N_U(JL1HI_E),OMCAL_MTRA(imimp))
               ENDIF
              ENDDO
             ENDIF
             IF(.NOT.empty)   THEN
c
c             include the ECALO energy resolution
c
              iCtype = ndim
              IF(iCtype.EQ.5) iCtype = 3
c
              IF(L1DEFnewold)  goto 771    ! use long ECAL version
c             
c             smear the ECAL energy
c
 1            CONTINUE
              IF ( ecal.gt.0. ) THEN
               comp = T1DEFstares(iCtype)/SQRT(Ecal)
              ELSE
               comp = 9999999.
              END IF
              IF(comp.GT.1.)  THEN    !Uniform deviation at low energies
               dEcal = -1.+2.*RNDM(iPlate)
              ELSE
               CALL  RANNOR(ranor1,ranor2)
               dEcal = T1DEFstares(iCtype)*ranor1/SQRT(Ecal)+
     &              T1DEFconres(iCtype)*ranor2
              ENDIF
              IF(dEcal.LE.-1.)    GOTO 1 ! avoid negative energy
              goto 772
 771          continue
c
c             Consider ECAL sampling ratio
c

              dEcal = 0.
              Ecal = Ecal*Escale(iCtype)
 772          continue

              Q(L_L(L1HI_E_E,JL1HI_E)) = Ecal*(1.+dEcal) ! store the energy
              IF (L1PARprnlev.EQ.7) THEN ! FLT hit printout
               IF(Q(L_L(L1HI_E_E,JL1HI_E)).GT.0.5)   THEN  ! >0.5GeV
                WRITE (L1LUNprn,994) iHBplate,ndim,ix,iy,
     &               FGCAL_XMIN(iHBplate)+(FGCAL_XMAX(iHBplate)-
     &               FGCAL_XMIN(iHBplate))/ndim*(ix-1),
     &               (FGCAL_XMAX(iHBplate)-FGCAL_XMIN(iHBplate))/ndim,
     &               FGCAL_YMIN(iHBplate)+(FGCAL_YMAX(iHBplate)-
     &               FGCAL_YMIN(iHBplate))/ndim*(iy-1),
     &               (FGCAL_YMAX(iHBplate)-FGCAL_YMIN(iHBplate))/ndim,
     &               Q(L_L(L1HI_E_E,JL1HI_E))
               ENDIF
              ENDIF
             ENDIF
            ENDDO
           ENDDO
           L1HI_E_NN(iBX,iPlate) = ! save number of found hits
     &          IQ(JL1HI_E+2) - L1HI_E_PO(iBX,iPlate) + 1
          ENDDO
         ENDIF
        ENDDO
       ELSEIF( L1DEFpredef( L1PREkind , iPreNum )
     &                             .EQ. L1PREpipi ) THEN
        IF (L1PARprnlev.EQ.7) THEN ! l1simu hit printout
         WRITE (L1LUNprn,*) ' L1TABRD==> High Pt pretrigger hits:'
         WRITE (L1LUNprn,997)
        ENDIF
        iPretCheck = 1 ! Pretrigger found
        DO iSL = 1, NGESL()
         IF( IGESL_CMP(iSL).EQ.LGESL_PTC)THEN
          iLayer      = IGESL_NSL( iSL )
          iFirstPlate = IGESL_FPL( iSL )
          nPlate      = IGESL_NPL( iSL )
          DO iPlate = 1 , nPlate
           L1HI_P_PO( iBX,iLayer,iPlate)=
     &      IQ(JL1HI_P+2)+1
           iHBPlate = iPlate - 1 + iFirstPlate
           nX = IGEDE_NWI(1,iHBPlate)
           nY = IGEDE_NWI(2,iHBPlate)
           IF( IGEPT_DIG1( iHBPlate).GE.1.AND.
     &         IGEPT_DIG1( iHBPlate).Le.NDIGB())THEN
            nFou = N_U(JL1HI_P) ! hits found so far
            iFiThis = nFou+1
cc            CALL VZERO(kCell,maxCells)
            DO iDIG = IGEPT_DIG1(iHBPlate) ,
     &                IGEPT_DIGL(iHBPlate)
             iCell_ID = IDIGB_ID( iDIG )
             iX  = FLOAT(iCell_ID)/1000000.0
             iY  = FlOAT(iCell_ID-iX*1000000)/10000.0
             iPl = iCell_ID-iX*1000000-iY*10000
             IF( iPL .NE. iHBPlate )THEN
              WRITE(L1LUNprn,*)'L1TABRD Error in PT! iPL=',iPL
             ENDIF
             IF( iX .LE.0 .OR. iX .GT. nX  )THEN
              WRITE(L1LUNprn,*)'L1TABRD Error in PT! iX=',iX
              iX = 1
             ENDIF
             IF( iY .LE.0 .OR. iY .GT. nY  )THEN
              WRITE(L1LUNprn,*)'L1TABRD Error in PT! iY=',iY
              iY = 1
             ENDIF
             iFLT = ( iX - 1) * nY + iY
c
             DO iStored=iFiThis,nFou ! search allready stored:
              iStor = I_V(L1HI_P_CELL,iStored,JL1HI_P) ! id of stored
              IF ( iFLT.eq.iStor ) THEN ! match ??
               iSRow = iStored  ! go to relations
               GO TO 103
              END IF
             END DO
c            --- row position to store next hit
             nFou = nFou + 1
             IF ( N_F(JL1HI_P).le.0 ) THEN ! space in table ?
              CALL UTETAB(IXDIV,JL1HI_P,100) ! expand table
             END IF
c            --- store :
              IQ(JL1HI_P+2) = nFou
              IQ(L_L(L1HI_P_CELL,JL1HI_P))=iFLT
              iSRow         = nFou
c
              IF (L1PARprnlev.EQ.7) THEN ! FLT hit printout
               WRITE (L1LUNprn,996) HGESL_NAME(iSL),
     &              iLayer,iPlate,iX,iY
             ENDIF
 103         CONTINUE           ! build relation(s) for this hit
             jAux = PDIGB_MIMP(iDig)
             DO WHILE (jAux.GT.0)
              iMimp = MDIGB_MIMP(jAux)
              CALL l1exrel(IXDIV, ! relation with MC track
     &             JL1HI_P_MTRA,iSRow,OMIMP_MTRA(iMimp))
              jAux = XDIGB_MIMP(jAux)
             ENDDO
            ENDDO
           ENDIF
           L1HI_P_NN( iBX , iLayer , iPlate ) =
     &          N_U(JL1HI_P) - L1HI_P_PO( iBX ,
     &          iLayer , iPlate ) + 1
          ENDDO
         ENDIF
        ENDDO
       else if(L1DEFpredef(L1PREkind,iPreNum).eq.L1PREmuon.or.
     &       L1DEFpredef(L1PREkind,iPreNum).eq.L1PREpxmuon ) then
c
c       Storing information for muon pretrigger
c
        IF (L1PARprnlev.EQ.7) THEN ! l1simu hit printout
         WRITE (L1LUNprn,*) ' L1TABRD==> Muon pretrigger hits:'
         WRITE (L1LUNprn,993)
        ENDIF
        DO iFLTdet = 1,L1nDetUsed ! loop over L1SIMU detectors
         IF(IUCOMP(CQ(L1JDET+iFLTdet),CMuPreName,2).GT.0.AND. !Outer muons
     &        L1DEFpredef(L1PREkind,iPreNum).eq.L1PREmuon )  THEN
          MuOut = .TRUE.
         ELSEIF(IUCOMP(CQ(L1JDET+iFLTdet),CMuPreXName,2).GT.0.AND. !Inner muons
     &         L1DEFpredef(L1PREkind,iPreNum).eq.L1PREpxmuon )  THEN
          MuOut = .FALSE.
         ELSE
          GOTO 100              ! skip others
         ENDIF
         iPretCheck=1           ! pretrigger found
         iDet(L1DETSPEdet) = iFLTdet
         iDet(L1DETSPElayer) = 1
         iDet(L1DETSPEsection) = 1
         CALL L1DETIF(iDet,iGeo,iInf,iCell) ! get det info
         nsec = IQ(iInf+l1DETINFnsec)
         iPlate = IQ(iInf+L1DETINFplate)    ! HB plate
         isl = OGEDE_GESL(iPlate)           ! HB SL
         DO isec=1,nsec
          iDet(L1DETSPEsection) = isec
          nFou = IQ(JL1HI_MU+2) ! hits found so far
          iFiThis = nFou+1
          DO iPlate=IGESL_FPL(isl),IGESL_FPL(isl)+IGESL_NPL(isl)-1
           IF(IGEPT_DIG1(iPlate).GT.0)   THEN   ! digit exists
            DO iDig=IGEPT_DIG1(iPlate),IGEPT_DIGL(iPlate)
             iHBid = IDIGB_ID(iDig)
             IF(MuOut.AND.iHBid.GT.0)  GOTO 101 ! wire hit: skip
             CALL l1trace(iDet,iHBid,iFLTf,iFLTl) ! transform to FLT id
             IF(iFLTf.LE.0)   GOTO 101 ! not interesting: skip
             iFLT = iFLTf
c
             DO iStored=iFiThis,nFou ! search allready stored:
              iStor = I_V(L1HI_MU_PAD,iStored,JL1HI_MU) ! id of stored
              IF ( iFLT.eq.iStor ) THEN ! match ??
               iSRow = iStored  ! go to relations
               GO TO 102
              END IF
             END DO
c            --- row position to store next hit
             nFou = nFou + 1
             IF ( N_F(JL1HI_MU).le.0 ) THEN ! space in table ?
              CALL UTETAB(IXDIV,JL1HI_MU,100) ! expand table
             END IF
c            --- store :
             IQ(JL1HI_MU+2)                = nFou
             IQ(L_L(L1HI_MU_PAD,JL1HI_MU)) = iFLT
             iSRow                        = nFou
c
             IF (L1PARprnlev.EQ.7) THEN ! FLT hit printout
              CALL L1HITIF(iDet,iflt,CellGeo) ! get hit cell geometry
              WRITE (L1LUNprn,992) iDet(L1DETSPEdet),
     &             iDet(L1DETSPElayer),iDet(L1DETSPEsection),
     &             ihbid,iflt,CellGeo(L1GEOINFx0),CellGeo(L1GEOINFsx),
     &             CellGeo(L1GEOINFy0),CellGeo(L1GEOINFsy),
     &             CellGeo(L1GEOINFz)
             ENDIF
c
 102         CONTINUE           ! build relation(s) for this hit
             jAux = PDIGB_MIMP(iDig)
             DO WHILE (jAux.GT.0)
              iMimp = MDIGB_MIMP(jAux)
              CALL l1exrel(IXDIV, ! relation with MC track
     &             JL1HI_MU_MTRA,iSRow,OMIMP_MTRA(iMimp))
              jAux = XDIGB_MIMP(jAux)
             ENDDO
 101         CONTINUE
            ENDDO
           ENDIF
          ENDDO
          L1HI_MU_PO(iBX,iFLTDet,isec) = iFiThis
          L1HI_MU_NN(iBX,iFLTDet,isec) = IQ(Jl1HI_MU+2)+1-iFiThis
c         print *,'L1TABRD=>idet/isec/po/nn',iFLTdet,isec,
c         &           L1HI_MU_PO(iBX,iFLTDet,isec),
c         &           L1HI_MU_NN(iBX,iFLTDet,isec)
         ENDDO
 100     CONTINUE
        ENDDO
c
c       End of storing of information for muon pretrigger
c
       endif

      enddo

      if(iPretCheck.lt.1) then
       WRITE(L1LUNprn,*)
     $      ' L1TABRD ==> There is no pretrigger chosen !!!! '
      endif





c
c     Now the hit-bank of the TFU
c
      IF ( JL1HI_T.le.0 ) GO TO 999
      nFou = IQ(JL1HI_T+2)      ! number of allready found hits
c
      IF ( nFou.ne.0 ) THEN
       WRITE (L1LUNprn,*)
     &      ' L1TABRD==> expand allready existing table!!',
     &      iBX,nFou
      END IF
c
      IF (L1PARprnlev.EQ.7) THEN ! l1simu hit printout
       WRITE (L1LUNprn,*) ' L1TABRD==> TFU hits:'
       WRITE (L1LUNprn,991)
      ENDIF
      DO iTFU = 1,L1DEFmaxtfu
c
       nCon = L1DEFtfudef(L1TFUnsec,iTFU)
       iDet(L1DETSPEdet) = L1DEFtfudef(L1TFUdetsl,iTFU) ! detector
       DO iCon = 1,nCon         ! loop over all connections
        iPo = L1DETCONdetpo(iCon,iTFU) ! get pointer to range info
        kPo = iPo + L1DETCONrange ! first connection      ! pointer to first range

c
c
c
        iDet(L1DETSPElayer) = 1
        iDet(L1DETSPEsection) = 1
        CALL l1detif(iDet,iGeo,iInf,iCell)
        if(IQ(iInf+L1DETINFwirepad).gt.1) then
         nProjec=1              ! for pad-like  only 1 projection
        else
         nProjec=3              ! for wire-like 3 projections
        endif
c
        iPlate = IQ(iInf+L1DETINFplate) ! HB plate
        isl = OGEDE_GESL(iPlate) ! HB SL
c
        DO iLL=1,nProjec        ! loop over  projections
         L1HI_T_PO(iBX,iTFU,iCon,iLL) = IQ(JL1HI_T+2) + 1 ! pos. to store first hit
         iLay = L1DETCONstor(kPo+L1DETCONlayer) ! laye number for range
         kPo = kPo + L1DETCONrangelen ! next  range pointer
         iDet(L1DETSPElayer) = iLay
c
         iDet(L1DETSPEsection) = L1DETCONstor(iPo+L1DETCONsec) ! section
         CALL l1detif(iDet,iGeo,iInf,iCell) ! obtain detector data
         IF ( iGeo.le.0 ) THEN  ! success ??
          WRITE(L1LUNprn,*)
     &         'L1TABRD ==> invalid detector',iTFU
          GO TO 888
         END IF
c
c
c
         iFiThis = IQ(JL1HI_T+2) + 1 ! pos. to store first hit
c
         DO iPlate=IGESL_FPL(isl),IGESL_FPL(isl)+IGESL_NPL(isl)-1
          IF(IGEPT_DIG1(iPlate).GT.0)   THEN    ! digits exist
           DO iDig=IGEPT_DIG1(iPlate),IGEPT_DIGL(iPlate)
            iHBid = IDIGB_ID(iDig)
c           search hit
            CALL l1trace(iDet,iHBid,iFLTf,iFLTl) ! transform to FLT id
            IF ( iFLTf.le.0 ) GO TO 666 ! not of intrest ->
            DO iFLT = iFLTf,iFLTl ! store FLT id:
c
             DO iStored=iFiThis,nFou ! search allready stored:
              iStor = I_V(L1HI_T_CELL,iStored,JL1HI_T) ! id of stored
              IF ( iFLT.eq.iStor ) THEN ! match ??
               iSRow = iStored  ! go to relations
               GO TO 555
              END IF
             END DO
c
c            --- row position to store next hit
             nFou = nFou + 1
             IF ( N_F(JL1HI_T).le.0 ) THEN ! space in table ?
              CALL UTETAB(IXDIV,JL1HI_T,100) ! expand table
              IF ( N_F(JL1HI_T).le.0 ) THEN ! expand successfull ?
               WRITE(L1LUNprn,*)
     &              'L1TABRD ==> now table storage',
     &              iTFU,N_F(JL1HI_T),nFou
               GO TO 888
              END IF
             END IF
c
c            --- store :
             IQ(JL1HI_T+2)                = nFou
             IQ(L_L(L1HI_T_CELL,JL1HI_T)) = iFLT
             iSRow                        = nFou
c
             IF (L1PARprnlev.EQ.7) THEN ! FLT hit printout
              CALL L1HITIF(iDet,iflt,CellGeo) ! get hit cell geometry
              WRITE (L1LUNprn,990) iTFU,iDet(L1DETSPEdet),
     &             iDet(L1DETSPElayer),iDet(L1DETSPEsection),
     &             ihbid,iflt,CellGeo(L1GEOINFx0),CellGeo(L1GEOINFsx),
     &             CellGeo(L1GEOINFy0),CellGeo(L1GEOINFsy),
     &             CellGeo(L1GEOINFz),CellGeo(L1GEOINFsin_al)
             ENDIF
c
c
 555         CONTINUE           ! build relation(s) for this hit
             jAux = PDIGB_MIMP(iDig)
             DO WHILE (jAux.GT.0)
              iMimp = MDIGB_MIMP(jAux)
              CALL l1exrel(IXDIV, ! relation with MC track
     &             JL1HI_T_MTRA,iSRow,OMIMP_MTRA(iMimp))
              jAux = XDIGB_MIMP(jAux)
             ENDDO
c
            END DO
 666        CONTINUE
           END DO
          ENDIF
         ENDDO
         L1HI_T_PO(iBX,iTFU,iCon,iLL) = iFiThis ! pos. to store first hit
         L1HI_T_NN(iBX,iTFU,iCon,iLL) = ! number of found hits for this ``detector''
     &        IQ(JL1HI_T+2) + 1 - iFiThis
c
        END DO
       END DO
c
 888   CONTINUE
c
      END DO
c
 999  CONTINUE
c
      CALL l1trkrd              ! buildt l1-track table
c
      RETURN
c
 990  FORMAT(' TFU',i2,3i3,i9,i5,
     &     f8.2,f6.2,f8.2,f7.2,f6.0,f6.2)
 991  FORMAT(' TFU#  de/la/sec   hbid  l1id',
     &     '     x0    sx      y0    sy    z     SIN')
 992  FORMAT(' MUPRE',3i3,i9,i5,
     &     f8.2,f6.2,f8.2,f7.2,f6.0)
 993  FORMAT('       de/la/sec   hbid  l1id',
     &     '     x0    sx      y0    sy    z')
 994  FORMAT(' EPRE',i7,3i4,
     &     f8.2,f6.2,f8.2,f6.2,f8.2)
 995  FORMAT('         hbid ndim ix  iy',
     &     '     x0    sx      y0    sy    E')
 996  FORMAT(' PIPRE',A6,2i6,2i4)
 997  FORMAT('       plane layer  plate  ix  iy')
      END


