*CMZ :          04/09/96  20.30.46  by  Fedor Ratnikov
*CMZ :  1.00/00 13/01/95  18.47.28  by  Dominik Ressing
*-- Author :    Dominik Ressing   11/12/94
************************************************************************
*
* L1TRKRD
* written by Dominik Ressing, 11/12/94 17.32.03
*
* This routines action:
* Read track table and store relevant information for FLT
*
*
************************************************************************
c
      SUBROUTINE L1TRKRD
c
      IMPLICIT NONE
c
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1clink.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
#include "l1si/l1banks.fi"
#include "arte/Arte.fi"
c
      INTEGER Itrk,Nfou,Nmax,Jpoi,IH,Iver,ifla,Ilost,ID,Iout
      REAL    P,xf,yf,zf,xl,yl,zl,tx,ty,PP,tol1,tol2,Dtx,fx,fy
      LOGICAL first,Valid
      CHARACTER*4 cname
      INTEGER IOR
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/ydef.ff"
c
      Nfou = 0
      Jpoi = L_A(1,1,JL1_TRACKS) - 1  ! pointer to first row
      DO itrk=1,NMTRA()
c
         Iver = IMTRA_ORIG(itrk)
            ifla = 0
         IF ( Iver.gt.0 .and. Iver.le.N_U(JMVER) ) THEN
            IF ( FMVER_Z(Iver).lt.5. ) Ifla = 1 ! primary track
         END IF
         IF ( itrk.lt.100 .or. ifla.gt.0 ) THEN   ! we are intrested in all 1st 100
c
            zf = 0.
            zl = 0.
            tx = 0.
            ty = 0.
            Ilost = 0
            Iout = 0
            first = .true.
            call l1cpart(OMTRA_TOPP(itrk),ID,cname)
            DO IH = 1,NMIMP()
               IF ( OMIMP_MTRA(IH).eq.itrk ) THEN
c
                  IF ( zf.lt.1. .and. FMIMP_Z(IH).gt.700. ) THEN
                     zf = FMIMP_Z(IH)
                     xf = FMIMP_X(IH)
                     yf = FMIMP_Y(IH)
                     P  = FMIMP_P(IH)
                     tx  = FMIMP_TX(IH)
                     ty  = FMIMP_TY(IH)
                  END IF
                  Dtx = SQRT((FMIMP_TX(IH)-tx)**2+(FMIMP_TY(IH)-ty)**2)
c
c                 --- number below are pure phenomenolopy !!
                  IF ( FMIMP_Z(IH).gt.1100. and. zl.lt.1000. ) THEN
                     tol1=0.001 ! over RICH
                     tol2=0.005 ! over RICH
                  ELSE IF ( FMIMP_Z(IH).gt.1400.) THEN
                     tol1=0.005  ! over ECAL/MU (3*sqrt(10))
                     tol2=0.010  ! over ECAL/MU (3*sqrt(10))
                  ELSE
                     tol1=0.0005 ! else
                     tol2=0.005 ! else
                  END IF
c
                  IF ( FMIMP_Z(IH).gt.700. ) THEN
                     IF ( Dtx.lt.tol2 ) THEN
                        IF ( Dtx.gt.tol1 ) THEN
                           IF ( FMIMP_Z(IH).lt.1350. ) THEN
                              Ilost = 2 ! lost before ECAL
                           ELSE IF ( Ilost.eq.0 ) THEN
                              Ilost = 1 ! lost in or behind ECAL
                           END IF
                        END IF
                        Valid = .true.
                     ELSE
                        Valid = .false.
                     END IF
                  END IF
                  IF ( FMIMP_Z(IH).gt.450.  .and.
     &                 FMIMP_Z(IH).lt.2500. ) THEN
                     IF ( Valid ) THEN
                        zl = FMIMP_Z(IH)
                        xl = FMIMP_X(IH)
                        yl = FMIMP_Y(IH)
                        tx = FMIMP_TX(IH)
                        ty = FMIMP_TY(IH)
                        fx = ABS(xl/zl)
                        fy = ABS(yl/zl)
                        IF ( fx.lt.0.01 .and. fy.lt.0.01 ) Iout = 1
                        IF ( zl.lt.1000. ) THEN
                           IF ( fx.gt.0.25 .or. fy.gt.0.16 ) Iout = 2
                        ELSE
                           IF ( fx.gt.0.22 .or. fy.gt.0.16 ) Iout = 3
                        END IF
                     END IF
                     IF ( L1PARprnlev.eq.7 ) THEN
                        PP = FMIMP_P(IH)
                        IF ( first ) WRITE (L1LUNprn,998)
                        first = .false.
                        WRITE (L1LUNprn,900)
     &                    itrk,cname,Ilost,Valid,FMIMP_X(IH),
     &                    FMIMP_Y(IH),FMIMP_Z(IH),PP,
     &                    FMIMP_TX(IH),FMIMP_TY(IH),Dtx,
     &                    HGESL_NAME(OGEDE_GESL(IMIMP_GEDE(IH)))
                     END IF
c
                  END IF
               END IF
              END DO
 998        FORMAT(3x,'it  ID Fl V',7x,'x',7x,'y',7x,'z',7x,'P',4x,
     &           'tangX',4x,'tangY',4x,'dTang',6x,'det')
 900        FORMAT(1x,i4,a4,i3,1x,1l2,4f8.2,3E9.3E1,A8)
c
            IF ( zf.gt.600. and. zl.gt.zf ) THEN
c
               Nfou = Nfou + 1
               Jpoi = Jpoi + L1_TRK_LEN              ! point to next row
               IF ( N_F(JL1_TRACKS).le.0 ) THEN      ! table full?
                  CALL UTETAB(IXDIV,JL1_TRACKS,100)     ! get 100 new rows
                  Jpoi = L_A(1,Nfou,JL1_TRACKS) - 1     ! update row pointer
               END IF
c
               IF ( zf.lt.750. ) THEN                    ! from first layer ??
               IF ( ID.eq.5 .or. ID.eq.6 .and. zl.gt.2000.) THEN
                  IF (Ilost.eq.0) THEN
                     ifla = IOR(ifla,2)                  ! muons have to survive all
                  END IF
                  IF ( Iout.eq.0 ) ifla = IOR(ifla,4)    ! also in geometry
               ELSE IF ( zl.gt.1200. ) THEN
                  IF (Ilost.lt.2) THEN
                     ifla = IOR(ifla,2)                  ! others till ECAL
                  END IF
                  IF ( Iout.eq.0 ) ifla = IOR(ifla,4)    ! also in geometry
               END IF
               END IF
c
               IQ(JL1_TRACKS+2) = Nfou
               IQ(Jpoi+L1_TRK_TRK) = itrk
               IQ(Jpoi+L1_TRK_FLAG) = ifla
               Q(Jpoi+L1_TRK_PAFTER) = P
               Q(Jpoi+L1_TRK_X1) = xf
               Q(Jpoi+L1_TRK_Y1) = yf
               Q(Jpoi+L1_TRK_Z1) = zf
               Q(Jpoi+L1_TRK_X2) = xl
               Q(Jpoi+L1_TRK_Y2) = yl
               Q(Jpoi+L1_TRK_Z2) = zl
               Q(Jpoi+L1_TRK_DIFF) = -1.
c
               IF ( L1PARprnlev.ge.1 )
     &              CALL l1prtrk(itrk,1300.)
c
            END IF
c
         END IF
c
      END DO
c
      RETURN
c
      END
