*CMZ :  2.01/03 02/02/96  17.38.22  by  Hartwig Albrecht
*CMZ :  2.01/02 30/01/96  16.25.16  by  Hartwig Albrecht
*CMZ :  2.01/01 20/12/95  17.27.09  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   19/10/95

      SUBROUTINE KALUND

************************************************************************
*
* Description: LUND command
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/TOPP.fi"
#include "pyth/PYSUBS.fi"
#include "pyth/PYPARS.fi"

      INTEGER L, TPNAM1
      CHARACTER*12 CH

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

C Lund initialization:

      IF (FIOMIX(5) .NE. 0.)  CALL MEERRC (9134563,
     +  'IOMIX and LUND commands are mutually exclusive')
      IF (LUNDINIT .NE. 1)  THEN
        CALL ALTOPP
        CALL ALTDEC
        LUNDINIT = 1
      END IF

      FIOMIX(1) = 1.
      FIOMIX(2) = 0.
      FIOMIX(3) = 0.
      FIOMIX(4) = 0.
      FIOMIX(5) = 0.

      CALL KUGETC (CH, L)

      IF (CH(1:2) .EQ. 'CC')  THEN
        MSEL = 4
      ELSE IF (CH(1:2) .EQ. 'BB')  THEN
        MSEL = 5
      ELSE IF (CH(1:2) .EQ. 'IN')  THEN
        MSEL = 1
      ELSE IF (CH(1:1) .EQ. 'J')  THEN
        MSEL = 0
        MSUB(86) = 1
        MSUB(87) = 1
        MSUB(88) = 1
        MSUB(89) = 1
      ELSE
        MSEL = 1
        CALL MEERRC (1634659,
     +    'LUND: phys. process must be one of cc, bb, inelastic')
      END IF

      CALL KUGETC (CH, L)
      IF (L .NE. 0 .AND. CH(1:2) .NE. 'IN')  THEN
        CALL MEERRC (936446,
     +    'LUND: 2nd phys. process must be inelastic')
        GO TO 90
      END IF

      CALL KUGETR (FIOMIX(2))
      IF (L .EQ. 0)  FIOMIX(2) = 0.

      LUNDRPART = 0
      CALL KUGETS (CH, L)
      IF (L .NE. 0)  THEN
        LUNDRPART = TPNAM1 (CH)
        IF (LUNDRPART .NE. 0)  THEN
          LUNDRPART = ITOPP_LUND(LUNDRPART)
        ELSE
          CALL MEERRC (56345345, 'LUND: required particle is unknown')
        END IF
      END IF

 90   END

************************************************************************
* End of KALUND
************************************************************************
