*CMZ :          19/03/96  14.33.04  by  Hartwig Albrecht
*CMZ :  2.01/01 20/12/95  13.12.08  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   05/11/95

      SUBROUTINE LIMCTR (ITR, CTPL)

************************************************************************
*
* Description: list Monte-Carlo truth
*
* Called from:
*
* External references: LIMTR1, LIMVE1
*
* Argument in/out description
*   ITR    in     track number in MTRA
*   CTPL   in     print-out destination (Terminal, Printer, Log_file)
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "auto/MVEX.fi"

      INTEGER ITR, I, II, I1, I2, K
      CHARACTER*(*) CTPL

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"
#include "auto/MVEX.ff"

      IF (JMTRA .EQ. 0 .OR. JMVER .EQ. 0)  THEN
        CALL MEWARN ('LIMCTR: no MC tracks / vertices')
        GO TO 90
      END IF

      CALL MESELP
     +  ('  itr px/x    py/y    pz/z    m ia   len  flg   vx imp cal',
     +  CTPL)

      IF (ITR .EQ. 0)  THEN
        I1 = 1
        I2 = NMTRA()
      ELSE
        I1 = ITR
        I2 = ITR
      END IF

C flag: vertex already printed ?

      CALL MMBWRK (JTMP0, NMVER(), 1, 0)

      DO 80 I = I1, I2

C mother particle

        IF (I .NE. ITR .AND. OMTRX_BTRA(I) .NE. 0)  GO TO 80

        IF (OMTRX_BVER(I) .NE. 0 .AND.
     +    I_V(1,OMTRX_BVER(I),JTMP0) .EQ. 0)  THEN
          IQ(L_A(1,OMTRX_BVER(I),JTMP0)) = 1
          CALL LIMVE1 (OMTRX_BVER(I), CTPL)
        END IF
        CALL LIMTR1 (I, 0, CTPL)

C are there daughter particles ?

        K = PMTRX_ETRA(I)
        IF (K .EQ. 0)  GO TO 80

C use TEMP as stack of infinite length

        CALL MMBWRK (JTEMP, 0, 1, 20)

 10     II = MMTRX_ETRA(K)

        IF (OMTRX_BVER(II) .NE. 0 .AND.
     +    I_V(1,OMTRX_BVER(II),JTMP0) .EQ. 0)  THEN
          IQ(L_A(1,OMTRX_BVER(II),JTMP0)) = 1
          CALL LIMVE1 (OMTRX_BVER(II), CTPL)
        END IF
        CALL LIMTR1 (II, 2 * N_U(JTEMP) + 2, CTPL)

C are other grand, great-grand, etc daughters ?

        IF (PMTRX_ETRA(II) .NE. 0)  THEN
          CALL MMBOOK (JTEMP, 1)
          IQ(L_L(1,JTEMP)) = XMTRX_ETRA(K)
          K = PMTRX_ETRA(II)
          GO TO 10

        ELSE

C are there sisters ?

          K = XMTRX_ETRA(K)
          IF (K .NE. 0)  GO TO 10

C go back to the mother of the present generation

 20       IF (N_U(JTEMP) .EQ. 0)  GO TO 80
          K = IQ(L_L(1,JTEMP))
          CALL MMBOOK (JTEMP, -1)
          IF (K .NE. 0)  GO TO 10
          GO TO 20
        END IF

 80   CONTINUE

      CALL MMBWRK (JTEMP, 0, 1, 0)
      CALL MMBWRK (JTMP0, 0, 1, 0)

 90   END

************************************************************************
* End of LIMCTR
************************************************************************
