*CMZ :  2.01/01 29/11/95  18.45.53  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE LITABL (IL, CTPL)

************************************************************************
*
* Description: List IOstatus of Zebra banks
*
* Called from: anywhere
*
* External references:
*
* Argument in/out description
*   IL     in     ILth link; 0 -> all banks
*   CTPL   in     printer option (Terminal, Printer, Log_file)
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZMMCOM.fi"
#include "arte/ZIOCOM.fi"
#include "auto/SUBT.fi"
#include "auto/MEMO.fi"

      INTEGER IL, I1, I2, IH, L, NR, NC, K1, K2, LENOCC, CHIND1
      CHARACTER CTPL*(*),C1*4,C2*4,CD*4,CH*4,CN*4,CSYM*(NIOSMX),
     +  CSUB(3)*3
      DATA CSUB /'par','sub','rel'/

#include "arte/Arte.ff"
#include "auto/SUBT.ff"
#include "auto/MEMO.ff"

      IF (IL .EQ. 0)  THEN
        I1 = 1
        I2 = NARLNK
      ELSE
        IF (IL .LT. 0 .OR. IL .GT. NARLNK)  THEN
          CALL MEERRO ('LITABL: invalid link address')
          GO TO 900
        END IF
        I1 = IL
        I2 = IL
      END IF

      CALL MESELP
     +  ('Link Name Div  Head Sup1 Sup2 Col  Rows  Input Output', CTPL)

      DO 100 K1 = I1, I2
        IF (HMEMO_NAME(K1) .EQ. HBLANKSP)  GO TO 100
        IH = K1
        C1 = ' '
        IF (IMEMO_SUP(1,IH) .NE. 0)  THEN
          IH = IMEMO_SUP(1,IH)
          CALL CHHTOC (IQ(HQMEMO_NAME(IH)), C1)
        END IF
 10     IF (IMEMO_SUP(1,IH) .EQ. 0)  GO TO 20
        IH = IMEMO_SUP(1,IH)
        GO TO 10

 20     CALL CHHTOC (IQ(HQMEMO_NAME(IH)), CH)
        IF (IH .EQ. K1)  CH = 'head'
        C2 = ' '
        IF (IMEMO_SUP(2,K1) .NE. 0)
     +    CALL CHHTOC (IQ(HQMEMO_NAME(IMEMO_SUP(2,K1))), C2)

C        CD = '????' <== xlf does not like this, why?

C*      temporary solution...   10.8.97 
        CD = '?'//'?'//'?'//'?'

        IF (IMEMO_DIV(K1) .EQ. IXEVNT)  CD = 'evnt'
        IF (IMEMO_DIV(K1) .EQ. IXCONS)  CD = 'cons'

        NR = -1
        IF (JLINK(K1) .NE. 0)  NR = N_U (JLINK(K1))

        CALL CHHTOC (IQ(HQMEMO_NAME(K1)), CN)
        WRITE (C78, 1001)  K1, CN, CD, CH, C1, C2, IMEMO_COL(K1), NR,
     +    IMEMO_NIN(K1), IMEMO_NOUT(K1)

        CALL ME78SP (CTPL)

        DO 40 NR = -1, 1

          IH = 0
          C78 = ' '
          C78(16:18) = CSUB(NR+2)

          DO 30 L = IMEMO_SUB1(K1), IMEMO_SUB2(K1)

            K2 = ISUBT_SUB(L)
            NC = MIN (IMEMO_FLAG(K2),1)
            IF (IMEMO_SUP(1,K2) .NE. K1)  NC = MAX (NC, 0)
            IF (NR .NE. NC)  GO TO 30

            IH = 1
            CALL CHHTOC (IQ(HQMEMO_NAME(K2)), CN)
            CALL CH78BC (CN)

            IF (LENOCC(C78) .LE. 72)  GO TO 30
            CALL ME78SP (CTPL)
            IH = 0
            C78 = ' '
            C78(16:18) = CSUB(NR+2)

 30       CONTINUE

          IF (IH .NE. 0)  CALL ME78SP (CTPL)

 40     CONTINUE

        C78 = ' '
        C78(16:17) = 'io'
        IH = 0

        DO 50 L = 1, NMMLUN

          IF (L .EQ. 1)  THEN
            CSYM = 'input'
            IF (BITTEST(BMEMO_IOD(K1),1) .NE. 0 .AND.
     +          BITTEST(BMEMO_IOA(K1),1) .NE. 0)  GO TO 50
          ELSE IF (L .EQ. 2)  THEN
            CSYM = 'output'
            IF (BITTEST(BMEMO_IOD(K1),2) .NE. 0 .AND.
     +          BITTEST(BMEMO_IOA(K1),2) .NE. 0)  GO TO 50
          ELSE
            CSYM = CIOSYM(IMMLUN(L))
            IF (BITTEST(BMEMO_IOD(K1),L) .EQ. 0 .AND.
     +          BITTEST(BMEMO_IOA(K1),L) .EQ. 0)  GO TO 50
          END IF

          IH = 1
          IF (BITTEST(BMEMO_IOA(K1),L) .EQ. 0)  THEN
            CALL CH78BC ('/' // CSYM)
          ELSE
            CALL CH78BC (CSYM)
          END IF
          IF (CHIND1 (CIOZFL(IMMLUN(L)), 'I') .NE. 0)
     +      CALL CH78AC ('<')
          IF (CHIND1 (CIOZFL(IMMLUN(L)), 'O') .NE. 0)
     +      CALL CH78AC ('>')

          IF (LENOCC(C78) .LE. 68)  GO TO 50

          CALL ME78SP (CTPL)
          C78(18:) = ' '
          IH = 0

 50     CONTINUE

        IF (IH .NE. 0)  CALL ME78SP (CTPL)

 100  CONTINUE

 1001 FORMAT (I4,5A5,I4,I6,2I7)

 900  END

************************************************************************
* End of LITABL
************************************************************************
