#ifndef _MARPLEOBJECTS_HH_
#define _MARPLEOBJECTS_HH_
//---------------------------------------------------------------------
// Created: 15.10.97  by   Olya Igonkina for MARPLE

// MARPLE default objects for reconstruction functions 

//---------------------------------------------------------------------

#include "marple/marple.hh"
#include "marple/RcMatchBuilder.hh"

/// object matched two sets ( vectors) of segments (RSEG)
extern RcMatchBuilder< RcSegPoint, RcSegPoint>  SegmentsMatch;

/// object matched set( vector) of segments (RSEG) with set of clusters (RCCL)
extern RcMatchBuilder< RcSegPoint, RcClusPoint> SegmentClusterMatch;

/// object matched set( vector) of tracks (RTRA) with set of segments (RSEG)
extern RcMatchBuilder< RcTraPoint, RcSegPoint>  TrackSegmentMatch;

/// object matched set( vector) of tracks (RTRA) with set of clusters (RCCL)
extern RcMatchBuilder< RcTraPoint, RcClusPoint> TrackClusterMatch;

/// object matched two sets ( vectors) of tracks (RTRA)
extern RcMatchBuilder< RcTraPoint, RcTraPoint>  TracksMatch;

/// object matched two sets ( vectors) of clusters (RCCL)
extern RcMatchBuilder< RcClusPoint, RcClusPoint>  ClustersMatch;

extern "C"
{
  void FORTRAN_ROUTINE( maputconst)(int* , int* , float* );
  void FORTRAN_ROUTINE( maputleft )(int* , int* ,int* , int* );
  void FORTRAN_ROUTINE( maputright)(int* , int* ,int* , int* );
  void FORTRAN_ROUTINE( madomatch )(int* );
  void FORTRAN_ROUTINE( mastat    )(int* , int* );
  void FORTRAN_ROUTINE( masaverel )(int* , int* );
  void FORTRAN_ROUTINE( maclear   )(int* , int* );

} 

#endif
