//**********************************************************************/
//Created: 15.11.97 by Olya Igonkina
//
// MARPLE Fortran interface
//
//**********************************************************************/


#include "marple/marple.hh"
#include "marple/marpleobjects.hh"

#include "arte/ArteMessage.hh"
extern "C"
{
  void FORTRAN_ROUTINE( maputconst)(int*   typeMatch, 
				    int*   iConst, 
				    float* fConst)
    {
      RcMatchConst * ptMatchConst =  new 
		RcMatchConst();
      (*ptMatchConst).flag          = iConst[0];
      (*ptMatchConst).use_pair_cut  = iConst[1];
      (*ptMatchConst).n_pair_left   = iConst[2];
      (*ptMatchConst).n_pair_right  = iConst[3];
      (*ptMatchConst).use_delta_cut = iConst[4];

      (*ptMatchConst).z_plane       = fConst[0];
      (*ptMatchConst).z_min         = fConst[1];
      (*ptMatchConst).z_max         = fConst[2];
      (*ptMatchConst).delta_x       = fConst[3];
      (*ptMatchConst).delta_y       = fConst[4];
      (*ptMatchConst).delta_tx      = fConst[5];
      (*ptMatchConst).delta_ty      = fConst[6];
      (*ptMatchConst).delta_pe      = fConst[7];
      (*ptMatchConst).chi2          = fConst[8];
      
      int itypeMatch = *typeMatch;
      switch (itypeMatch)
	{
	case 11 :
	  TracksMatch.setConst((*ptMatchConst));
	  break; 
	case 22 :
	  SegmentsMatch.setConst((*ptMatchConst));
	  break; 
	case 33 :
	  ClustersMatch.setConst((*ptMatchConst));
	  break; 

	case 12 :
	case 21 :
	  TrackSegmentMatch.setConst((*ptMatchConst));
	  break; 
	case 13 :
	case 31 :
	  TrackClusterMatch.setConst((*ptMatchConst));
	  break; 
	case 23 :
	case 32 :
	  SegmentClusterMatch.setConst((*ptMatchConst));
	  break; 

	default :
	  arteMsg << "MARPLE: type of match = " << typeMatch 
	       << " is unknown" ;
	  arteMsg.allp();
	  break;
	}
    }
  

  //*************************************************************
  //
  //*************************************************************
  // 
  void FORTRAN_ROUTINE( maputleft)(int *   typeMatch, 
				   int *   arteEntry, 
				   int *   endPoint, 
				   int *   Err)
    {
      int itypeMatch = *typeMatch;
      int iarteEntry = *arteEntry;
      int iEndPoint  = *endPoint;
      int iErr = 1;
      Err = &iErr;
      int num;
      switch (itypeMatch) 
	{
	case 11 :
	  if( ArtePointer<RTRA>(iarteEntry) != 0 && 
	      ArtePointer<RTRA>(iarteEntry).index() < 
	      ArtePointer<RTRA>(iarteEntry).nrow() )
	    {
	      RcTraPoint * ptPoint =  new 
		RcTraPoint( ArtePointer<RTRA>( iarteEntry ));
	      (*ptPoint).setmark((*TracksMatch.ptToMatchConst()).n_pair_left);
	      TracksMatch.addPointLeft( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 
	case 22 :
	  if( ArtePointer<RSEG>(iarteEntry) != 0 && 
	      ArtePointer<RSEG>(iarteEntry).index() < 
	      ArtePointer<RSEG>(iarteEntry).nrow() )
	    {
	      RcSegPoint * ptPoint = new 
		RcSegPoint( ArtePointer<RSEG>( iarteEntry), iEndPoint );
	      (*ptPoint).setmark(
	      	   (*SegmentsMatch.ptToMatchConst()).n_pair_left);
	      SegmentsMatch.addPointLeft( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 
	case 33 :
	  if( ArtePointer<RCCL>(iarteEntry) != 0 && 
	      ArtePointer<RCCL>(iarteEntry).index() < 
	      ArtePointer<RCCL>(iarteEntry).nrow() )
	    {
	      RcClusPoint *ptPoint = new 
		RcClusPoint( ArtePointer<RCCL>( iarteEntry ));
	      (*ptPoint).setmark(
		   (*ClustersMatch.ptToMatchConst()).n_pair_left);
	      ClustersMatch.addPointLeft( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 

	case 12 :
	  if( ArtePointer<RTRA>(iarteEntry) != 0 && 
	      ArtePointer<RTRA>(iarteEntry).index() < 
	      ArtePointer<RTRA>(iarteEntry).nrow() )
	    {
	      RcTraPoint * ptPoint =  new 
		RcTraPoint( ArtePointer<RTRA>( iarteEntry ));
	      (*ptPoint).setmark(
		    (*TrackSegmentMatch.ptToMatchConst()).n_pair_left);
	      TrackSegmentMatch.addPointLeft( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 
	case 21 :
	  num = 12;
	  FORTRAN_ROUTINE(maputright)(&num, &iarteEntry, &iEndPoint, Err );
	  break; 

	case 13 :
	  if( ArtePointer<RTRA>(iarteEntry) != 0 && 
	      ArtePointer<RTRA>(iarteEntry).index() < 
	      ArtePointer<RTRA>(iarteEntry).nrow() )
	    {
	      RcTraPoint * ptPoint =  new 
		RcTraPoint( ArtePointer<RTRA>( iarteEntry ));
	      (*ptPoint).setmark(
	          (*TrackClusterMatch.ptToMatchConst()).n_pair_left);
	      TrackClusterMatch.addPointLeft( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break;
	case 31 :
	  num = 13;
	  FORTRAN_ROUTINE(maputright)(&num, &iarteEntry, &iEndPoint, Err );
	  break; 

	case 23 :
	  if( ArtePointer<RSEG>(iarteEntry) != 0 && 
	      ArtePointer<RSEG>(iarteEntry).index() < 
	      ArtePointer<RSEG>(iarteEntry).nrow() )
	    {
	      RcSegPoint * ptPoint = new 
		RcSegPoint( ArtePointer<RSEG>( iarteEntry), iEndPoint );
	      (*ptPoint).setmark(
		    (*SegmentClusterMatch.ptToMatchConst()).n_pair_left);
	      SegmentClusterMatch.addPointLeft( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break;
	case 32 :
	  num =23;
	  FORTRAN_ROUTINE(maputright)(&num, &iarteEntry, &iEndPoint, Err );
	  break; 

	default :
	  arteMsg << "MARPLE: type of match = " << itypeMatch 
	       << " is unknown" ;
	  arteMsg.allp();
	  break;
	}
    }
  //*************************************************************
  //
  //*************************************************************
  void FORTRAN_ROUTINE( maputright)(int *   typeMatch, 
				    int *   arteEntry, 
				    int *   endPoint,
				    int *   Err)
    {
      int itypeMatch = *typeMatch;
      int iarteEntry = *arteEntry;
      int iEndPoint  = *endPoint;
      int iErr = 1;
      Err = &iErr;
      int num;
      switch (itypeMatch) 
	{
	case 11 :
	  if( ArtePointer<RTRA>(iarteEntry) != 0 && 
	      ArtePointer<RTRA>(iarteEntry).index() < 
	      ArtePointer<RTRA>(iarteEntry).nrow() )
	    {
	      RcTraPoint * ptPoint =  new 
		RcTraPoint( ArtePointer<RTRA>( iarteEntry ));
	      (*ptPoint).setmark(
		    (*TracksMatch.ptToMatchConst()).n_pair_right);
	      TracksMatch.addPointRight( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 
	case 22 :
	  if( ArtePointer<RSEG>(iarteEntry) != 0 && 
	      ArtePointer<RSEG>(iarteEntry).index() < 
	      ArtePointer<RSEG>(iarteEntry).nrow() )
	    {
	      RcSegPoint * ptPoint = new 
		RcSegPoint( ArtePointer<RSEG>( iarteEntry), iEndPoint );
	      (*ptPoint).setmark(
	          (*SegmentsMatch.ptToMatchConst()).n_pair_right);
	      SegmentsMatch.addPointRight( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 
	case 33 :
	  if( ArtePointer<RCCL>(iarteEntry) != 0 && 
	      ArtePointer<RCCL>(iarteEntry).index() < 
	      ArtePointer<RCCL>(iarteEntry).nrow() )
	    {
	      RcClusPoint *ptPoint = new 
		RcClusPoint( ArtePointer<RCCL>( iarteEntry ));
	      (*ptPoint).setmark(
		    (*ClustersMatch.ptToMatchConst()).n_pair_right);
	      ClustersMatch.addPointRight( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 

	case 12 :
	  if( ArtePointer<RSEG>(iarteEntry) != 0 && 
	      ArtePointer<RSEG>(iarteEntry).index() < 
	      ArtePointer<RSEG>(iarteEntry).nrow() )
	    {
	      RcSegPoint * ptPoint = new 
		RcSegPoint( ArtePointer<RSEG>( iarteEntry), iEndPoint );
	      (*ptPoint).setmark(
		    (*TrackSegmentMatch.ptToMatchConst()).n_pair_right);
	      TrackSegmentMatch.addPointRight( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break; 
	case 21 :
	  num = 12;
	  FORTRAN_ROUTINE(maputleft)(&num, &iarteEntry, &iEndPoint, Err );
	  break; 

	case 13 :
	  if( ArtePointer<RCCL>(iarteEntry) != 0 && 
	      ArtePointer<RCCL>(iarteEntry).index() < 
	      ArtePointer<RCCL>(iarteEntry).nrow() )
	    {
	      RcClusPoint *ptPoint = new 
		RcClusPoint( ArtePointer<RCCL>( iarteEntry ));
	      (*ptPoint).setmark(
		    (*TrackClusterMatch.ptToMatchConst()).n_pair_right);
	      TrackClusterMatch.addPointRight( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break;
	case 31 :
	  num = 13;
	  FORTRAN_ROUTINE(maputleft)(&num, &iarteEntry, &iEndPoint, Err );
	  break; 

	case 23 :
	  if( ArtePointer<RCCL>(iarteEntry) != 0 && 
	      ArtePointer<RCCL>(iarteEntry).index() < 
	      ArtePointer<RCCL>(iarteEntry).nrow() )
	    {
	      RcClusPoint *ptPoint = new 
		RcClusPoint( ArtePointer<RCCL>( iarteEntry ));
	      (*ptPoint).setmark(
		    (*SegmentClusterMatch.ptToMatchConst()).n_pair_right);
	      SegmentClusterMatch.addPointRight( *ptPoint);
	    }else{
	      iErr = 0;
	    }
	  break;
	case 32 :
	  num = 23;
	  FORTRAN_ROUTINE(maputleft)(&num, &iarteEntry, &iEndPoint, Err );
	  break; 

	default :
	  arteMsg << "MARPLE: type of match = " << itypeMatch 
	       << " is unknown" ;
	  arteMsg.allp();
	  break;
	}

    }

  //*************************************************************
  //
  //*************************************************************

  void FORTRAN_ROUTINE( mastat)(int *   typeMatch, 
				int *   Stat)
    {
      int itypeMatch = *typeMatch;
      int iStat = *Stat;
      switch (itypeMatch)
	{
	case 11 :
	  TracksMatch.stat(iStat);
	  break; 
	case 22 :
	  SegmentsMatch.stat(iStat);
	  break; 
	case 33 :
	  ClustersMatch.stat(iStat);
	  break; 

	case 12 :
	case 21 :
	  TrackSegmentMatch.stat(iStat);
	  break; 
	case 13 :
	case 31 :
	  TrackClusterMatch.stat(iStat);
	  break; 
	case 23 :
	case 32 :
	  SegmentClusterMatch.stat(iStat);
	  break; 

	default :
	  arteMsg << "MARPLE: type of match = " << itypeMatch 
	       << " is unknown" ;
	  arteMsg.allp();
	  break;
	}
    }
  //*************************************************************
  //
  //*************************************************************

  void FORTRAN_ROUTINE( madomatch)(int *   typeMatch)
    {
      int itypeMatch = *typeMatch;
      switch (itypeMatch)
	{
	case 11 :
	  TracksMatch.doMatch();
	  break; 
	case 22 :
	  SegmentsMatch.doMatch();
	  break; 
	case 33 :
	  ClustersMatch.doMatch();
	  break; 

	case 12 :
	case 21 :
	  TrackSegmentMatch.doMatch();
	  break; 
	case 13 :
	case 31 :
	  TrackClusterMatch.doMatch();
	  break; 
	case 23 :
	case 32 :
	  SegmentClusterMatch.doMatch();
	  break; 

	default :
	  arteMsg << "MARPLE: type of match = " << itypeMatch 
	       << " is unknown" ;
	  arteMsg.allp();
	  break;
	}
    }
  //*************************************************************
  //
  //*************************************************************
  void FORTRAN_ROUTINE( masaverel)(int *   typeMatch,
				   int * Err)
    {
      int itypeMatch = *typeMatch;
      int iErr = 1;
      Err = &iErr;
      switch (itypeMatch)
	{
	case 11 :
	  arteMsg << "MARPLE: relation RTRA-RTRA is not maintained by ARTE" ;
	  arteMsg.allp();
	  break; 
	case 22 :
	  //SegmentsMatch.saveRelation(iErr);
	  break; 
	case 33 :
	  arteMsg << "MARPLE: relation RCCL-RCCL is not maintained by ARTE"; 
	  arteMsg.allp();
	  break; 

	case 12 :
	case 21 :
	  //TrackSegmentMatch.saveRelation(iErr);
	  break; 
	case 13 :
	case 31 :
	  //TrackClusterMatch.saveRelation(iErr);
	  break; 
	case 23 :
	case 32 :
	  //SegmentClusterMatch.saveRelation(iErr);
	  break; 

	default :
	  arteMsg << "MARPLE: type of match = " << itypeMatch 
	       << " is unknown" ;
	  arteMsg.allp();
	  break;
	}
    }
  //*************************************************************
  //
  //*************************************************************
  void FORTRAN_ROUTINE( maclear)(int *   typeMatch,
				 int * Stat)
    {
      int itypeMatch = *typeMatch;
      int iStat = 1;
      Stat = &iStat;
      switch (itypeMatch)
	{
	case 11 :
	  TracksMatch.deleteAll(iStat);
	  break; 
	case 22 :
	  SegmentsMatch.deleteAll(iStat);
	  break; 
	case 33 :
	  ClustersMatch.deleteAll(iStat);
	  break; 

	case 12 :
	case 21 :
	  TrackSegmentMatch.deleteAll(iStat);
	  break; 
	case 13 :
	case 31 :
	  TrackClusterMatch.deleteAll(iStat);
	  break; 
	case 23 :
	case 32 :
	  SegmentClusterMatch.deleteAll(iStat);
	  break; 

	default :
	  arteMsg << "MARPLE: type of match = " << itypeMatch 
	       << " is unknown" ;
	  arteMsg.allp();
	  break;
	}
    }
}
