*
* B.Fominykh  20.08.97
*
* kalman filter refit and filling of RHIT
      SUBROUTINE MUREFIT(NHT,IHT,ISG,CHI,PARE,COVE)
*     =============================================
* input:  IHT(NHT) - hits
*         ISG      - #segment in RSEG
* output: CHI - chi**2 of refit
*         PARE - parameters at the end of track
*         COVE - covariance at the end of track
*
      IMPLICIT NONE
#include "murec/MUCKALF.fi"
#include "murec/MUCPAR.fi"
#include "arte/Arte.fi"
#include "auto/RHIT.fi"
      INTEGER NHT,IHT(50),ISG
      INTEGER I,J,IHH,IH,JH,IRH,JRH,IHB,ITP,IOUT
      REAL ERMSC1,ERMSC2,DD,SIGE,DD1,DD2,CHI1,CHI2,CHI
      REAL Z,Z1,Z2,THETS,PARE(5),COVE(4,4)
C----+===1=========2=========3=========4=========5=========6=========7==********
* check-point
      IF(NHT.LE.3) GOTO 900
* book RHIT
      IF(JRHIT.LE.0) THEN
        CALL MMBOOK(JRHIT,0)
        IF(JRHIT.LE.0) GOTO 900
      ENDIF
      IF(IQ(JRHIT+1).LE.0) GOTO 900
*
* kalman filter fit - loops over hits

      CHI=0.
      Z2=2150.
      DO 150 IHH=1,2*NHT-1

***      PRINT 1005, IHH,(PARAM(J),J=1,5)
*** 1005 FORMAT(1X,I3,'  Z0,Cx,Cy,Tx,Ty:',5E11.3)

        IF(IHH.LE.NHT) THEN
          IH=IHT(IHH)
        ELSE
          IH=IHT(2*NHT-IHH)
        ENDIF
        JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
        IHB=IQ(JH+1)
        Z=Q(JH+6)
* calculate multiple scattering error
        Z1=Z2
        Z2=Z
        CALL MURMSC(Z1,Z2,ERMSC1,ERMSC2,THETS)
*
        ITP=IQ(JH+5)
* the case of wire
        IF(ITP.EQ.1) THEN
* fill COMMON/MUCKALF/
          SIGMS1=ERMSC1
          SIGMS2=ERMSC2
          THTMSC=THETS
          ZMEAS=Q(JH+6)
          SINROT =Q(JH+7)
          COSROT =SQRT(1.-SINROT*SINROT)
          DMEAS=Q(JH+8)
          SMEAS=Q(JH+11)
          ITMEAS=1
          IF(SINROT.NE.0.) ITMEAS=3
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD,SIGE,CHI1)
          IF(IOUT.NE.0) GOTO 900
          CHI=CHI+CHI1
          GOTO 100
        ENDIF
*
* the case of pads and pixels
        IF(ITP.EQ.2.OR.ITP.EQ.3) THEN
* fill COMMON/MUCKALF/
          SIGMS1=ERMSC1
          SIGMS2=ERMSC2
          THTMSC=THETS
          ZMEAS=Q(JH+6)
          SINROT =0.
          COSROT =1.
          DMEAS=Q(JH+8)
          SMEAS=Q(JH+11)
          ITMEAS=1
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD1,SIGE,CHI1)
          IF(IOUT.NE.0) GOTO 900
*
          DMEAS=Q(JH+9)
          SMEAS=Q(JH+12)
          ITMEAS=2
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD2,SIGE,CHI2)
          IF(IOUT.NE.0) GOTO 900
          CHI=CHI+CHI1+CHI2
          GOTO 100
        ENDIF
 100  CONTINUE
*
* fill RHIT
      IF(IHH.LE.NHT) THEN
* add one raw 
        CALL MMBOOK(JRHIT,1)
* fill the raw
        IRH=IQ(JRHIT+2)
        JRH=JRHIT+IQ(JRHIT+1)*(IRH-1)+2

        Q(JRH+JRHIT_X) = PARAM(2)
        Q(JRH+JRHIT_Y) = PARAM(3)
        Q(JRH+JRHIT_TX) = PARAM(4)
        Q(JRH+JRHIT_TY) = PARAM(5)
        Q(JRH+JRHIT_P) = 0.
        Q(JRH+JRHIT_Q) = 0.
        IQ(JRH+JRHIT_RTRA) = 0
* relation "track segment" - "fit.hit"
        CALL MMBREL(JRSRH,ISG,IRH)   ! #segment - #fit.hit
* relation "fitted hit" - "measured hit"
        CALL MMBREL(JHIRH,IHB,IRH)   ! #meas.hit - #fit.hit
*
      ENDIF
* save parameter and covariance at the end of track
      IF(IHH.EQ.NHT) THEN
        DO I=1,5
         PARE(I)=PARAM(I)
        ENDDO
        DO I=1,4
         DO J=1,4
           COVE(I,J)=COV(I,J)
         ENDDO
        ENDDO
      ENDIF
 150  CONTINUE
*
* write the impact point into table RPNT
      CALL MUREXCAL(ISG)
* transport the parameters to OT
      ZMEAS=ZOTEXT
      CALL MURKALF(1,IOUT,DD,SIGE,CHI1)
*
 900  CONTINUE
      RETURN
      END









