*
* B.Fominykh  16.11.97
*
* initial track parameters
      SUBROUTINE MURFIT0(NHT,IHT,PAR,COV,IOUT)
*     ========================================
* input:  NHT  - number of hits
*         IHT(NHT) - list of hits ordered on Z
* output: PAR(6)   - track parameters (Z0,Cx,Cy,Tx,Ty,Zmax)
*         COV(4,4) - covariance
*         IOUT=0   - O.K.
*
      IMPLICIT NONE
      INTEGER NHT,IHT(50),IOUT,IHC,IH,JH,NSL
      INTEGER ISL,NWOR,NWOR1,NWOR2,NWOR3,I,J
      DOUBLE PRECISION AS,BS,CS,DS1,DS2,DD
      DOUBLE PRECISION XMSL(4),YMSL(4),ZMSL(4),DXMSL(4),DYMSL(4)
      DOUBLE PRECISION SNR,SNR2,CSR,CSR2
      DOUBLE PRECISION SVW,XSVW,XSVW2,SXPP,XSPP,XSPP2,SYPP,YSPP,YSPP2
      DOUBLE PRECISION SZ,ZS,DZ,DX,DY,WW,XS,YS,XMID,YMID
      REAL XSL(4),YSL(4),ZSL(4),ERX(4),ERY(4)
      REAL AX,TX,AY,TY,COVX(3),COVY(3),CHIX,CHIY
      DOUBLE PRECISION PAR(6),COV(4,4)
*
#include "murec/MUCONT.fi"
#include "arte/Arte.fi"
C----+===1=========2=========3=========4=========5=========6=========7==********
      IOUT=1

      IF(IPRSC.GE.4)
     + PRINT 1001, NHT,(IHT(J),J=1,NHT)
      IF(IPRLG.GE.4)
     + WRITE(LLOGF,1001) NHT,(IHT(J),J=1,NHT)
 1001 FORMAT(1X,'MURFIT0:',I3,' hits:',50I4)

      IF(NHT.LT.4) GOTO 900
* Zmin, Zmax
      IH=IHT(NHT)
      JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
      PAR(6)=Q(JH+6)
      JH=JTMP9+2
      PAR(1)=Q(JH+6)
* 4 space points
      DO 100 ISL=1,4
        XMSL(ISL)=0.
          DXMSL(ISL)=0.
            YMSL(ISL)=0.
              DYMSL(ISL)=0.
                ZMSL(ISL)=0.
        AS=0.
          BS=0.
            CS=0.
        DS1=0.
          DS2=0.
        SVW=0.
          XSVW=0.
            XSVW2=0.
        SXPP=0.
          XSPP=0.
            XSPP2=0.
        SYPP=0.
          YSPP=0.
            YSPP2=0.
        SZ=0.
          ZS=0.
        NWOR1=0        
        NWOR2=0        
        NWOR3=0        
* loops over hits
        DO 50 IHC=1,NHT
          IH=IHT(IHC)
          JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
          NSL=IQ(JH+3)
          IF(NSL.GT.ISL) GOTO 51
          IF(NSL.LT.ISL) GOTO 50
* weight
          WW=1./Q(JH+11)**2
* X-coordinate
          DX =Q(JH+8)                    
* Z-coordinate
          DZ=Q(JH+6)                    
          SZ=SZ+WW
          ZS=ZS+DZ*WW
* the case of wire
          IF(IQ(JH+5).NE.1) GOTO 30
          SNR=-Q(JH+7)                    
          IF(SNR.EQ.0.)    NWOR1=NWOR1+1
          IF(SNR.GT.0.01)  NWOR2=NWOR2+1
          IF(SNR.LT.-0.01) NWOR3=NWOR3+1
* vertical wires
          IF(DABS(SNR).LT.1.D-5) THEN
            SVW=SVW+WW
            XSVW=XSVW+DX*WW
            XSVW2=XSVW2+DX*DX*WW
          ENDIF
* all wires
          SNR2=SNR*SNR
          CSR2=1.-SNR2
          CSR=DSQRT(CSR2)
          AS=AS+CSR2*WW
            BS=BS+SNR2*WW
              CS=CS+SNR*CSR*WW
                DS1=DS1+DX*CSR*WW
                   DS2=DS2+DX*SNR*WW
          GOTO 50
* pad and pixels
  30      CONTINUE
          SXPP=SXPP+WW
            XSPP=XSPP+DX*WW
              XSPP2=XSPP2+DX*DX*WW
          WW=1./Q(JH+12)**2
          DY =Q(JH+9)                    
          SYPP=SYPP+WW
            YSPP=YSPP+DY*WW
              YSPP2=YSPP2+DY*DY*WW
  50    CONTINUE
  51    CONTINUE
        IF(SZ.LT.0.001) GOTO 100
        ZMSL(ISL)=ZS/SZ
        IF(NWOR1.GT.0) NWOR1=1
        IF(NWOR2.GT.0) NWOR2=1
        IF(NWOR3.GT.0) NWOR3=1
        NWOR=NWOR1+NWOR2+NWOR3
* mean X and Y of superlayer
        IF(AS.GT.0.01.AND.BS.GT.0.01) THEN
* all wires
          IF(NWOR.GT.1) THEN
           DD=AS*BS-CS*CS
           IF(DABS(DD).GT.1.D-10) THEN
            XMSL(ISL) =(DS1*BS-DS2*CS)/DD
            DXMSL(ISL)=1./DSQRT(AS)
            YMSL(ISL)=(DS2*AS-DS1*CS)/DD
            DYMSL(ISL)=1./DSQRT(BS)
           ENDIF
          ENDIF
        ELSE
* only vertical wires
          IF(NWOR.EQ.1.AND.NWOR1.EQ.1) THEN
           IF(SVW.GT.1.D-12) THEN
            XMID=XSVW/SVW
            DD=1./SVW
**            DD=XSVW2/SVW-XMID**2
            IF(DD.GT.0.) THEN
              XMSL(ISL)=XMID
              DXMSL(ISL)=DSQRT(DD)
            ENDIF            
           ENDIF            
          ENDIF
        ENDIF
* pad and pixels
        IF(SXPP.GT.1.D-12) THEN
          XMID=XSPP/SXPP
          DX=1./SXPP
**          DX=XSPP2/SXPP-XMID**2
          IF(DX.GT.0.00001) THEN
            IF(DXMSL(ISL).LT.0.0001) THEN
              XMSL(ISL)=XMID
              DXMSL(ISL)=DSQRT(DX)
            ELSE
              WW=1./DXMSL(ISL)**2
              XS=XMSL(ISL)*WW
              WW=WW+1./DX
              XS=XS+XMID/DX
              XMSL(ISL)=XS/WW
              DXMSL(ISL)=1./DSQRT(WW)
            ENDIF            
          ENDIF            
        ENDIF
        IF(SYPP.GT.1.D-12) THEN
          YMID=YSPP/SYPP
          DY=1./SYPP
**          DY=YSPP2/SYPP-XMID**2
          IF(DY.GT.0.001) THEN
            IF(DYMSL(ISL).LT.0.001) THEN
              YMSL(ISL)=YMID
              DYMSL(ISL)=DSQRT(DY)
            ELSE
              WW=1./DYMSL(ISL)**2
              YS=YMSL(ISL)*WW
              WW=WW+1./DY
              YS=YS+YMID/DY
              YMSL(ISL)=YS/WW
              DYMSL(ISL)=1./DSQRT(WW)
            ENDIF            
          ENDIF            
        ENDIF
 100  CONTINUE
*

      IF(IPRSC.GE.4)
     + PRINT 1002, (ZMSL(J),J=1,4),
     +             (XMSL(J),DXMSL(J),J=1,4),
     +             (YMSL(J),DYMSL(J),J=1,4)
      IF(IPRLG.GE.4)
     + WRITE(LLOGF,1002) (ZMSL(J),J=1,4),
     +             (XMSL(J),DXMSL(J),J=1,4),
     +             (YMSL(J),DYMSL(J),J=1,4)
 1002 FORMAT(1X,'MURFIT0: Z=',4(F8.2,8X),
     +     /,7X,'X,DX='8F8.3,
     +     /,7X,'Y,DY='8F8.3)

      NSL=0
      DO J=1,4
        IF(XMSL(J).NE.0..OR.YMSL(J).NE.0.) THEN
          NSL=NSL+1
          XSL(NSL)=XMSL(J)
          YSL(NSL)=YMSL(J)
          ZSL(NSL)=ZMSL(J)
          ERX(NSL)=DXMSL(J)
          ERY(NSL)=DYMSL(J)
        ENDIF
      ENDDO      
      IF(NSL.LT.2) GOTO 900
      CALL MURLFIT(ZSL,XSL,ERX,NSL,TX,AX,COVX,CHIX)
      CALL MURLFIT(ZSL,YSL,ERY,NSL,TY,AY,COVY,CHIY)
      PAR(2)=AX
       PAR(3)=AY
        PAR(4)=TX
         PAR(5)=TY
      COV(1,1)=COVX(3)
       COV(3,3)=COVX(1)
        COV(1,3)=COVX(2)
         COV(3,1)=COV(1,3)
      COV(2,2)=COVY(3)
       COV(4,4)=COVY(1)
        COV(2,4)=COVY(2)
         COV(4,2)=COV(2,4)
      IOUT=0

      IF(IPRSC.GE.4) THEN
        PRINT 1003, (PAR(J),J=1,6)
        PRINT 1004, ((COV(I,J),I=1,4),J=1,4)
      ENDIF
      IF(IPRLG.GE.4) THEN
        WRITE(LLOGF,1003) (PAR(J),J=1,6)
        WRITE(LLOGF,1004) ((COV(I,J),I=1,4),J=1,4)
      ENDIF
 1003 FORMAT(1X,'MURFIT0: par',F7.1,4E12.4,' Zmax',F7.1)
 1004 FORMAT(1X,'MURFIT0: cov',4(4E12.4,/,13X))

*
 900  CONTINUE
      RETURN
      END









