*-- Author :    Rainer Mankel   16/12/95

      subroutine dihit(pl,hit,idmc,chopt)

*     **** draw all hits in plane pl
*     **** if hit.ne.0, draw only hit "hit"
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"
#include "pris/zmh.fi"

      character*(*) chopt
      real xxx(21),yyy(21),wcw1(3),wcw2(3),sintot,costot,ri,ro,xxxw(5),
     +     yyyw(5),size_x,size_y,x1,x2,x3,x4,y1,y2,y3,y4,xmin,xmax,
     +     ymin,ymax 

      integer ii,pl,idmc,imc,hit,hit1,hit2
      integer ih,cmp,isl,tumchit
      integer xsig(4),ysig(4)
      logical lb0,trmcor,ltop,lside

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
      data xsig /-1, +1, +1, -1/, ysig /-1, -1, +1, +1/

      lb0     = lb0zg .or. index(chopt,'B').gt.0
      isl = ogede_gesl(pl)
      cmp = igesl_cmp(isl)

      xmin = 1.5 * xminzg - 0.5 * xmaxzg ! prepare SW clipping
      xmax = 1.5 * xmaxzg - 0.5 * xminzg
      ymin = 1.5 * yminzg - 0.5 * ymaxzg
      ymax = 1.5 * ymaxzg - 0.5 * yminzg

      if (isl.le.0) print *,' () dihit: pl,isl=',pl,isl

      if (cmp.gt.4.and.cmp.le.7) then
         go to 999              ! unsupported plane type
      endif

      sintot = fgede_sin(pl) * fgede_rot(1,pl) ! total coordinate angle
     +     + fgede_cos(pl) * fgede_rot(2,pl)

      costot = fgede_cos(pl) * fgede_rot(1,pl)
     +     - fgede_sin(pl) * fgede_rot(2,pl)

      if (.not.lstereozg) then
*        **** bypass stereo planes
         if (cmp.ne.1) then
            if (abs(sintot).gt.0.001) go to 999
         endif
      endif

*     **** decide kind of view
      ltop = (abs(sintot).lt.0.01.and.iviewzg.eq.1)
     +     .or. (sintot.gt.0.01.and.iviewzg.eq.7)
     +     .or. (sintot.lt.-0.01.and.iviewzg.eq.8)

      lside = (.not.ltop) .and.
     +     iviewzg.eq.0 .or. (iviewzg.ge.3 .and. iviewzg.le.6)

      if (hit.eq.0) then
         if (igept_hit1(pl).gt.0) then
            hit1 = igept_hit1(pl)
            hit2 = igept_hitl(pl)
         else
            hit1 = 0
            hit2 = -1
         endif
      else
         hit1 = hit
         hit2 = hit
      endif

*     **** loop over hits
      do 10 ih=hit1,hit2
         if (ih.eq.0) go to 11

*        **** check associated MC particle
         if (idmc.ne.0) then
*        **** discard if no match with MC particle
            if (.not.trmcor(ih,idmc)) go to 10
         endif

         if (lb0) then          ! check B0 option
            imc = tumchit(ih)
            if (.not.gold_mh(imc)) go to 10
         endif

         if (lwirezg.or.index(chopt,'W').gt.0) then ! check wire option

            call igsg(1)

            if (cmp.ne.9.and.cmp.ne.4.and.
     +           (cmp.ne.8.or.fhitb_y(ih).eq.0.))  then ! wire-like

               call digetw(ih,wcw1(1),wcw2(1)) ! get wire endpoints
               call dipro(wcw1(1),xxxw(1),yyyw(1))
               call dipro(wcw2(1),xxxw(2),yyyw(2))

               if (lsclipzg) then
                  x1 = xxxw(1)  ! SW clipping
                  x2 = xxxw(2)
                  y1 = yyyw(1)
                  y2 = yyyw(2)
                  if (amax1(x1,x2).lt.xmin) go to 10
                  if (amin1(x1,x2).gt.xmax) go to 10
                  if (amax1(y1,y2).lt.ymin) go to 10
                  if (amin1(y1,y2).gt.ymax) go to 10
               endif

               if (ltop) then   ! view is along channel
                  if (cmp.eq.2) then ! draw honeycomb cell
                     ri = fgede_dod(pl) ! inner radius of hexagon
                     ro = ri * 1.1547 ! outer radius of hexagon
                     do ii=1,6  ! corners of hexagon
                        xxx(ii) = xxxw(1) + ro * cos((ii-0.5)*3.1415/3.)
                        yyy(ii) = yyyw(1) + ro * sin((ii-0.5)*3.1415/3.)
                     enddo
                     xxx(7) = xxx(1) ! close the hexagon
                     yyy(7) = yyy(1)
                     call igset('FACI',cowirzg)
                     call igset('FAIS',1.)
                     call ifa(7,xxx,yyy)
                     call igset('PLCI',1.)
                     call igset('LTYP',1.)
                     call igset('LWID',1.)
                     call ipl(7,xxx,yyy)
                  elseif (cmp.eq.8) then ! draw muon tube
                     do ii=1,4
                        wcw1(1) = fhitb_x(ih) + xsig(ii)
     +                       * fgede_dod(pl)
                        wcw1(2) = 0.
                        if (ysig(ii).eq.-1) then
                           wcw1(3) = fgede_zmin(pl)
                        else
                           wcw1(3) = fgede_zmax(pl)
                        endif
                        call dipro(wcw1,xxx(ii),yyy(ii))
                     enddo
                     xxx(5) = xxx(1)
                     yyy(5) = yyy(1)
                     call igset('PLCI',cowirzg) !
                     call igset('FACI',cowirzg) !
                     call igset('FAIS',1.)
                     call igset('LTYP',1.)
                     call igset('LWID',1.)
                     call ifa(5,xxx,yyy)
                     call ipl(5,xxx,yyy)
                  else
                     call ismk(4) ! Si, MSGC or other
                     call igset('PMCI',cowirzg)
                     call igset('LTYP',1.)
                     call igset('LWID',1.)
                     call ipm(1,xxxw,yyyw)
                  endif
               elseif (lside) then
                  call igset('PLCI',cowirzg) ! both wire ends visible
                  call igset('LTYP',1.)
                  call igset('LWID',1.)
                  call ipl(2,xxxw,yyyw)
               endif
            else                ! pixel-like detector

               if (cmp.eq.4) then ! special for 97 run
                  size_x=(fgede_sxmx(pl)-fgede_sxmn(pl))/
     +                 float(igede_nwi(1,pl))
                  size_y=(fgede_symx(pl)-fgede_symn(pl))/
     +                 float(igede_nwi(2,pl))
               else
                  size_x = fhitb_q(ih)
                  size_y = fhitb_r(ih)
               endif
               if (size_x.le.0.) then ! fixup if pad sizes are missing
                  size_x = 0.4
               endif
               if (size_y.le.0.) size_y = size_x

               do ii=1,4
                  wcw1(1) = fhitb_x(ih) + xsig(ii) * 0.5 * size_x
                  wcw1(2) = fhitb_y(ih) + ysig(ii) * 0.5 * size_y
                  wcw1(3) = fhitb_z(ih)
                  call dipro(wcw1,xxx(ii),yyy(ii))
               enddo
               xxx(5) = xxx(1)
               yyy(5) = yyy(1)

               if (lsclipzg) then
                  x1 = xxx(1)  ! SW clipping
                  x2 = xxx(2)
                  x3 = xxx(3)
                  x4 = xxx(4)
                  y1 = yyy(1)
                  y2 = yyy(2)
                  y3 = yyy(3)
                  y4 = yyy(4)
                  if (amax1(x1,x2,x3,x4).lt.xmin) go to 10
                  if (amin1(x1,x2,x3,x4).gt.xmax) go to 10
                  if (amax1(y1,y2,y3,y4).lt.ymin) go to 10
                  if (amin1(y1,y2,y3,y4).gt.ymax) go to 10
               endif

               call igset('PLCI',cowirzg) !
               call igset('FACI',cowirzg) !
               call igset('LTYP',1.)
               call igset('LWID',1.)
               call ipl(5,xxx,yyy)
               call ifa(5,xxx,yyy)
            endif

         endif

*        **** display isochrone if option active
         if (lquantzg.or.index(chopt,'C').gt.0) call diiso(ih)

 10   continue
 11   continue

 999  end


