*-- Author :    Rainer Mankel   03/01/96

      subroutine pkpick()

*     **** (re)pick the picture, using parameters stored in
*     **** /zgrafr/ and /zgrafc/
*     **** may be called by kuip!
      implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "pris/zgraf.fi"
#include "pris/zmh.fi"
      character*40 chopt
      character*10 cpick
      character*15 cname
      character*40 corigin, cdestiny
      integer islsta, islend, isl, idmc, pl, ipl, ipl_i, nch, mimp,
     +        layer, sector, mv, rv, cmp, iwl, mc, hit, jauxpl, tuhrtra,
     +        rc
      integer ndetmx
      parameter (ndetmx=9000)
      integer ipldis(ndetmx), indexz(ndetmx), npldis, idrc, iipl,
     +     istat, nt
      real zpldis(ndetmx), wcm(3), xxx(1), yyy(1), x, y, savecol, pmc,
     +     alpha, arot, prc

      logical pickmc, pickrc, pickmimp, pickhit, pickpl, pickmv, pickrv,
     +     pickwall
      external dimag
#include "auto/GEO.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/HITB.ff"

      if (prisinit.eq.0) then
         print *,' () pkpick: display not initialized!'
         go to 999
      endif

      call kugetc(cpick,nch)    ! get object to be picked

      pickmc = index(cpick,'MC').eq.1.or.index(cpick,'MTRA').eq.1
      pickrc = index(cpick,'RC').eq.1.or.index(cpick,'RTRA').eq.1
      pickmimp = index(cpick,'MI').eq.1
      pickhit = index(cpick,'H').eq.1
      pickpl = index(cpick,'P').eq.1
      pickmv = index(cpick,'MV').eq.1
      pickrv = index(cpick,'RV').eq.1
      pickwall = index(cpick,'WA').eq.1

      if (.not.(pickmc.or.pickrc.or.pickmimp.or.pickhit.or.pickpl
     +     .or.pickmv.or.pickrv.or.pickwall)) then
         print *,' () pkpick: invalid PICK mode,  ',cpick
         go to 999
      endif

*     **** request pick locator
*     **** pick graphical objects in current display

      call irqlc(1,1,istat,nt,x,y)

      if (istat.ne.1) then
         print *,' () pkpick: locator input failed'
         go to 999
      endif
      xxx(1) = x
      yyy(1) = y
      call ismk(30)
      call ismksc(1.)
      call ipm(1,xxx,yyy)

      xpickzg = x
      ypickzg = y
      idpickzg = 0
      rpickzg = 1.e20

*     **** get redraw parameters from /zgrafr/, /zgrafc/
      if (modezg.eq.2) then
         islsta = sl1zg
         islend = sl2zg
      else
         islsta = 1
         islend = iq(jgesl+2)
      endif
      pl = plzg
      idmc = mczg
      idrc = rczg
      mv = mvzg
      rv = rvzg
      layer = layerzg
      sector = sectorzg
      cmp = cmpzg
      chopt = choptzg

*     **** fixup
      if (islend.eq.0.and.islsta.ne.0) islend = islsta
      islsta = max(islsta,1)
      if (islend.eq.0) then
       islend = iq(jgesl+2)
      endif

      call tusomh()

      npldis = 0

      if (modezg.eq.1.or.modezg.eq.2) then
*        **** display superlayer range
         do 10 isl=islsta,islend
            if (modezg.eq.1) then
               if (isl.gt.scmxzg) go to 10
               if (.not.lscopzg(isl)) go to 10
            endif

            if (igesl_cmp(isl).le.4.or.igesl_cmp(isl).eq.8
     +           .or.igesl_cmp(isl).eq.9) then ! tracking superlayer
*              **** loop over planes
               do 20 iipl=1,igesl_npl(isl)
                  if (iipl.eq.1) then
                     jauxpl = pgslx_gede(isl)
                  else
                     jauxpl = xgslx_gede(jauxpl)
                  endif
                  if (jauxpl.eq.0) stop ' pkpick: jauxpl zero '
                  ipl = mgslx_gede(jauxpl)

*                 **** check if plane belongs to sl
                  if (ogede_gesl(ipl).ne.isl) then
                     print *,' () pkpick: ipl, isl, ogede_gesl(ipl)=',
     +                    ipl, isl, ogede_gesl(ipl)
                  endif

*                 **** check layer
                  if (layer.gt.0.and.igede_lay(ipl).ne.layer) go to 20
*                 **** check sector
                  if (sector.gt.0.and.igede_sec(ipl).ne.sector) go to 20
*                 **** check component
                  if (cmp.gt.0.and.igede_cmp(ipl).ne.cmp) go to 20

*                 **** store plane
                  if (npldis.eq.ndetmx) then
                     print *,' () pkpick: npldis, ndetmx=',
     +                    npldis, ndetmx
                     stop
                  endif

                  npldis = npldis + 1
                  ipldis(npldis) = ipl
                  zpldis(npldis) = fgede_zmin(ipl)
 20            continue
            elseif (igesl_cmp(isl).eq.7
     +              .or.(igesl_cmp(isl).ge.13
     +                   .and.igesl_cmp(isl).le.14)) then ! CAL
               npldis = npldis + 1
               ipldis(npldis) = 1000000 + isl ! store sl for ECAL
               zpldis(npldis) = fgesl_z1(isl)
            endif
 10      continue

         if (lwallzg) then
*           **** loop over walls
            do 40 iwl=1,iq(jgwal+2)
*              **** store wall as plane with negative sign
               if (npldis.eq.ndetmx) then
                  print *,' () pkpick: npldis, ndetmx=', npldis, ndetmx
                  stop
               endif

               npldis = npldis + 1
               ipldis(npldis) = -iwl ! store wall with negative id
               zpldis(npldis) = 0.5 *
     +              (fgwal_zmin(iwl) + fgwal_zmax(iwl))
 40         continue
         endif

*        **** sort planes according to z
         call sortzv(zpldis,indexz,npldis,+1,idirzg+1,0)

*        **** display planes
         do 30 ipl_i=1,npldis
            ipl = ipldis(indexz(ipl_i))
            if (ipl.lt.1000000) then
               if (ipl.gt.0) then
                  isl = ogede_gesl(ipl)
                  if (pickpl) call pkplab(ipl,chopt)
                  if (pickhit) call pkhit (ipl,idmc,chopt)

                  if (pickmimp.and.(index(chopt,'G').ne.0.or.lmimpzg))
     +                 call pkghit(isl,ipl,idmc,chopt)
               else
                  if (pickwall) call pkwall(-ipl,chopt)
               endif
            else
**               isl = mod(ipl,1000000)
**               if (pickpl) call pkplac(isl,chopt) ! pick ECAL blocks
**               if (pickhit) call pkhitc(isl,0,idmc,chopt)
**               if (pickmimp.and.(index(chopt,'G').ne.0.or.lmimpzg))
**     +              call pkmcal(isl,idmc,chopt)
            endif
 30      continue

*        **** MC particles
         if (pickmc.and.(index(chopt,'M').gt.0.or.lmczg))
     +        call pkmc(idmc,mv,islsta,islend,chopt)

*        **** MC vertices
         if (pickmv.and.index(chopt,'V').gt.0) call pkmv(idmc,mv,chopt)

*        **** tracks ...
         if (pickrc.and.(lrczg.or.index(chopt,'T').gt.0))
     +        call pkrtra(idmc,idrc,islsta,islend,chopt)

      elseif (modezg.eq.3) then
*        **** display single plane
         if (pickpl) call pkplab(pl,chopt)
         if (pickhit) call pkhit (pl,idmc,chopt)

         if (pickmimp.and.(index(chopt,'G').ne.0.or.lmimpzg))
     +        call pkghit(ogede_gesl(pl),pl,idmc,chopt)
      else
         print *,' () pkpick: invalid redraw mode=', modezg
      endif

*     **** redraw highlighted object
      if (idpickzg.gt.0) then
         call iselnt(nt_detzg)
         call isclip(1)
         if (pickmc) then
            mc = idpickzg
            savecol = comczg    ! save normal MC color
            comczg = 6.         ! set highlight color
            call dimc(mc,mv,islsta,islend,'O')
            comczg = savecol    ! reset normal color
         elseif (pickrc) then
            rc = idpickzg
            savecol = corczg    ! save normal RC color
            corczg = 6.         ! set highlight color
            call dirtra(idmc,rc,islsta,islend,chopt)
            corczg = savecol    ! reset normal color
         elseif (pickmimp) then
            mimp = idpickzg
*           **** hit coordinate
            wcm(1) = fmimp_x(mimp)
            wcm(2) = fmimp_y(mimp)
            wcm(3) = fmimp_z(mimp)
*           **** projection
            call dipro(wcm,xxx(1),yyy(1))
            call isplci(1)
            call igset('PMCI',6.)
            call ismk(20)
            call ismksc(1.)
            call ipm(1,xxx(1),yyy(1))
         elseif (pickhit) then
            hit = idpickzg
            savecol = cowirzg
            cowirzg = 6.
            call dihit(ihitb_gede(hit),hit,idmc,chopt)
            cowirzg = savecol
         elseif (pickpl) then
            pl = idpickzg
            savecol = coplbzg    ! save normal plane color
            coplbzg = 6.         ! set highlight color
            call diplab(pl,chopt) ! display highlighted plane
            coplbzg = savecol    ! reset normal color
         elseif (pickmv) then
         elseif (pickrv) then
         elseif (pickwall) then
         endif
      endif

*     **** update wk and go to alpha mode
      call iuwk(0,1)
      call igterm()

*     **** print pick info
**      print *,' pkpick: pick result idpickzg=', idpickzg,
**     +     ' rpickzg=', rpickzg

      if (idpickzg.gt.0) then
         if (pickmc) then
            mc = idpickzg
            pmc = sqrt( fmtra_px(mc)**2 + fmtra_py(mc)**2
     +                + fmtra_pz(mc)**2 )
            call tudecay(mc,cname,corigin,cdestiny)
            print 102, mc, cname, pmc, fmtra_px(mc), fmtra_py(mc),
     +           fmtra_pz(mc), corigin, cdestiny
 102        format(
     +        /'***********************************************',
     +        /'*      mc=', i6, 15x, 'name=', a10,'*',
     +        /'*       p=', f9.2,14x,             'px=', f9.3,' *',
     +        /'*      py=', f9.2,14x,             'pz=', f9.3,' *',
     +        /'*  origin=', 1x, a34, 1x, '*',
     +        /'* destiny=', 1x, a34, 1x, '*'
     +        /'***********************************************')

         elseif (pickrc) then
            rc = idpickzg
            if (frtra_pf(rc).ne.0.) then
               prc = 1. / frtra_pf(rc)
            else
               prc = 0.
            endif
            print 105,rc,irtra_fit(rc),prc,frtra_zf(rc),frtra_txf(rc),
     +           frtra_tyf(rc),frtra_chi(rc),(irtra_hsi(rc)
     +           +irtra_hin(rc)+irtra_hou(rc)+irtra_hri(rc)+
     +           irtra_hca(rc)+irtra_htr(rc)+irtra_hmu(rc))
 105        format(
     +        /'***********************************************',
     +        /'*      rc=', i6, 16x, 'fit=', i9,' *',
     +        /'*       p=', f9.2,14x,             'zf=', f9.3,' *',
     +        /'*      tx=', f9.2,14x,             'ty=', f9.3,' *',
     +        /'*    chi2=', f9.2,12x,'nhit=',i9,' *',
     +        /'***********************************************')
            
         elseif (pickmimp) then
            mimp = idpickzg
            call tudecay(omimp_mtra(mimp),cname,corigin,cdestiny)

            print 101, mimp, omimp_mtra(mimp), cname, fmimp_x(mimp),
     +           fmimp_tx(mimp), fmimp_y(mimp), fmimp_ty(mimp),
     +           fmimp_p(mimp), imimp_gede(mimp)
 101        format(/'***********************************************',
     +             /'* mimp=', i6, 22x,              'mc=', i5,'   *',
     +             /'*      ', 26x,                'name=', a8,   '*',
     +             /'*    x=', f9.2,19x,             'tx=', f7.3,' *',
     +             /'*    y=', f9.2,19x,             'ty=', f7.3,' *',
     +             /'*    p=', f9.2,19x,             'pl=', i6, '  *',
     +             /'***********************************************')
         elseif (pickhit) then
            hit = idpickzg
            print 104, hit, ihitb_gede(hit), fhitb_z(hit), fhitb_q(hit),
     +           fhitb_x(hit), fhitb_r(hit), tuhrtra(hit)
 104        format(/'***********************************************',
     +             /'*  hit=', i6, 22x,              'pl=', i5,'   *',
     +             /'*    z=', f9.2,19x,             ' q=', f7.4,' *',
     +             /'*    x=', f9.2,19x,             ' r=', f7.4,' *',
     +             /'* rtra=', i6  ,22x,             '   ', 6x, '  *',
     +             /'***********************************************')
         elseif (pickpl) then
            pl = idpickzg
            alpha = 57.296 * atan2(fgede_sin(pl),fgede_cos(pl))
            arot  = 57.296 * atan2(fgede_rot(2,pl),fgede_rot(1,pl))
            print 103, pl, ogede_gesl(pl), igede_cmp(pl), igede_shp(pl),
     +           alpha, arot,
     +           fgede_zmin(pl), fgede_zmax(pl),
     +           fgede_xmin(pl), fgede_xmax(pl),
     +           fgede_ymin(pl), fgede_ymax(pl),
     +           fgede_sxmn(pl), fgede_sxmx(pl),
     +           fgede_symn(pl), fgede_symx(pl)
 103        format(
     +        /'***********************************************',
     +        /'*      pl=', i6, 16x, ' sl=', i6, '    *',
     +        /'*     cmp=', i6, 16x, 'shp=', i6, '    *',
     +        /'*     ste=', f9.2,12x,           ' rot=', f9.2,' *',
     +        /'*    zmin=', f9.2,12x,           'zmax=', f9.2,' *',
     +        /'*    xmin=', f9.2,12x,           'xmax=', f9.2,' *',
     +        /'*    ymin=', f9.2,12x,           'ymax=', f9.2,' *',
     +        /'*    sxmn=', f9.2,12x,           'sxmx=', f9.2,' *',
     +        /'*    symn=', f9.2,12x,           'symx=', f9.2,' *',
     +        /'***********************************************')

         elseif (pickmv) then
         elseif (pickrv) then
         elseif (pickwall) then
         else
            print *,' () pkpick: no pick mode selected'
         endif
      else
         print *,' pkpick: nothing picked'
      endif

 999  end


