*-- Author :    Rainer Mankel   21/09/95

      subroutine dmdom()

*     **** setup zdomain
      implicit none

#include "rang/zdomain.fi"
#include "rang/zdomdir.fi"
#include "rang/zdomdef.fi"
#include "rang/zfout.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
      integer domain, iisl, sl, pl, layer,
     +        sector, method, ii, lastwin_sect(max_sector_dm), 
     +        n_sum, df, nsl_active
      real z_sum
      character*4 csl
      data lastwin_sect /max_sector_dm * 0/
      save lastwin_sect
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      do df=1,min(n_df,maxdom_dm)   ! loop over defined domains
         if (active_df(df)) then
            nsl_active = 0
            do iisl=1,min(maxsl_df,maxsl_dm)
               if (csl_df(iisl,df).ne.'    ') 
     +              nsl_active = nsl_active + 1
            enddo
            n_dm = df
            nwin_dm(n_dm) = 0
            win1_dm(n_dm) = 0
            pc_dm(n_dm) = 0

            if (nsl_active.gt.0) then
               do iisl=1,min(maxsl_df,maxsl_dm)
                  if (csl_df(iisl,df).ne.'    ') then
                     do 10 sl=1,iq(jgesl+2) ! search for matching SL
                        write(csl,'(a4)') hgesl_name(sl)
                        if (csl.eq.csl_df(iisl,df)) then
                           domsl_dm(iisl,n_dm) = sl
                           scope_dm(n_dm) = scope_df(df)
                           go to 11
                        endif
 10                  continue
                     print *,' () dmdom: match not found for ',
     +                    csl_df(iisl,n_dm)
                     domsl_dm(iisl,n_dm) = 0
 11                  continue
                  else
                     domsl_dm(iisl,n_dm) = 0
                     scope_dm(n_dm) = 0
                  endif
               enddo            ! iisl
            endif               ! nonblank superlayers
         endif                  ! active_domain
      enddo ! domain

      if (llog_zfout) print *,' dmdom: #domains created=', n_dm

*     **** set up domain windows
      n_dw = 0
      do domain=1,n_dm          ! loop over domains
       z_sum = 0.
       n_sum = 0.
       do sector=1,max_sector_dm
        do iisl=1,maxsl_dm
         sl = domsl_dm(iisl,domain)
         if (sl.gt.0.and.sl.ge.min_sl_dm.and.sl.le.max_sl_dm) then
          layer = 1
          if (igesl_cmp(sl).eq.1) then
           method = 1  ! exist no 0-deg for Si
          else
           method = 2  ! take 0-deg
          endif
          pl = plane_matrix_dm(layer,method,sector,sl)
          if (pl.gt.0) then
           if (n_dw.lt.maxwin_dw) then   ! new window
            n_dw = n_dw + 1
            nwin_dm(domain) = nwin_dm(domain) + 1
            if (nwin_dm(domain).eq.1) win1_dm(domain) = n_dw
            domain_dw(n_dw) = domain
            plshad_dw(n_dw) = pl
            secshad_dw(n_dw) = sector
            if (lastwin_sect(sector).gt.0) then
             prvwin_dw(n_dw) = lastwin_sect(sector)
             nxtwin_dw(lastwin_sect(sector)) = n_dw
            else
             prvwin_dw(n_dw) = 0
            endif
            nxtwin_dw(n_dw) = 0
            lastwin_sect(sector) = n_dw  ! memorize for nxt dom
            do ii=1,3
             nlayer_dw(ii,n_dw) = 0
             layer1_dw(ii,n_dw) = 0
            enddo
            xmin_dw(n_dw) = fgede_sxmn(pl)
            xmax_dw(n_dw) = fgede_sxmx(pl)
            ymin_dw(n_dw) = fgede_symn(pl)
            ymax_dw(n_dw) = fgede_symx(pl)
            zmin_dw(n_dw) = fgede_zmin(pl)
            zmax_dw(n_dw) = fgede_zmax(pl)
            z_sum = z_sum + 0.5 * (fgede_zmin(pl)+fgede_zmax(pl))
            n_sum = n_sum + 1
           else
            print *,' () dmdom: overflowing n_dw=', n_dw
            stop 'dmdom'
           endif ! n_dw
          endif ! pl
         endif ! good sl
        enddo ! iisl
       enddo ! sector
       if (n_sum.ge.1) then
        z_dm(domain) = z_sum / n_sum  ! store reference z for domain
       else
**        print *,' () dmdom: no window in domain=',domain
        z_dm(domain) = 1000.
       endif
      enddo ! domain
      if (llog_zfout) print *,' dmdom: # domain windows created=', n_dw

      end


