*-- Author :    Rainer Mankel   19/06/97

      subroutine tfanlys(rt,chopt)

*     **** analyse reconstructed track, compare with MC
      implicit none

      integer rt                ! reconstructed track

      integer ih,rh,ii,jj,kk,indx,indrh,indmi,mt,nmt,nrh,ih_any,nprint,
     +     pl,mimp
      real xmc,ymc,txmc,tymc,qpmc,m_mc,m_rc,m_hit,dr,var_mc,var_rc,
     +     res_mc,res_rc,chi,tfmitoqp
      character*(*) chopt
      character*4 cmc,crc
      logical OK

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RTRX.fi"
#include "auto/RHIT.fi"
#include "auto/MIMP.fi"
#include "auto/TOPP.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"



#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RTRX.ff"
#include "auto/RHIT.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"

      if (jrtra.eq.0) go to 999


      if (rt.le.0.or.rt.gt.iq(jrtra+2)) then
         print *,' () tfanlys: number of rows in RTRA =',
     +        iq(jrtra+2)
         go to 999
      endif

      mt = 0
      nmt = 0

      do ii=1,99                ! locate related MC particle
         if (ii.eq.1) then
            indx = prtrx_mtra(rt)
         else
            indx = xrtrx_mtra(indx)
         endif
         if (indx.le.0) go to 11
         mt = mrtrx_mtra(indx)
         nmt = nmt + 1
      enddo
 11   continue
      if (nmt.gt.1) mt = 0      ! fix ambiguous case

      nprint = 0
      ih = 0
      do ii=1,9999              ! locate related HITBs
         
         if (ii.eq.1) then
            indx = prtrx_hitb(rt)
         else
            indx = xrtrx_hitb(indx)
         endif
         if (indx.le.0) go to 21
         ih_any = mrtrx_hitb(indx)

         rh = 0
         nrh = 0
         do jj=1,99             ! locate related RHIT
            if (jj.eq.1) then
               indrh = phitb_rhit(ih_any)
            else
               indrh = xhitb_rhit(indrh)
            endif
            if (indrh.le.0) go to 31
            if (irhit_rtra(mhitb_rhit(indrh)).eq.rt) then
               rh = mhitb_rhit(indrh)
               nrh = nrh + 1
               ih = ih_any
            endif
         enddo
 31      continue
         if (nrh.gt.1) rh = -1   ! fix ambiguous case

**         print *,' rt,ih,rh=',rt,ih,rh
         if (ih.gt.0) then
            do kk=1,99          ! loop over associated mimps
               if (kk.eq.1) then
                  indmi = phitb_mimp(ih)
               else
                  if (indmi.eq.0) go to 41
                  indmi = xhitb_mimp(indmi)
               endif
               if (indmi.gt.0) then
                  mimp = mhitb_mimp(indmi)
               else
                  if (kk.gt.1) go to 41 ! pass only if no mimp at all
                  mimp = 0
               endif

               OK = .false.
               if (mimp.gt.0) then
                  if (omimp_mtra(mimp).eq.mt) then
                     OK = .true.
                  endif
               endif

               if (OK) then
                  xmc = fmimp_x(mimp)
                  ymc = fmimp_y(mimp)
                  txmc = fmimp_tx(mimp)
                  tymc = fmimp_ty(mimp)
                  qpmc = tfmitoqp(mimp)

                  pl = ihitb_gede(ih)
                  call tfresid(ih,rh,mimp,m_mc,m_rc,m_hit,dr)
               else
                  xmc = 0.
                  ymc = 0.
                  txmc = 0.
                  tymc = 0.
                  qpmc = 0.
                  pl = 0
                  m_mc = 0.
                  m_rc = 0.
                  m_hit = 0.
                  dr = 0.
               endif

               res_mc = m_rc - m_mc
               res_rc = m_rc - m_hit

               if (dr.gt.0.) then
                  chi = res_rc**2 / dr**2
               else
                  chi = -1.
               endif

               if (index(chopt,'TX').gt.0) then
                  var_mc = txmc
                  var_rc = frhit_tx(rh)
                  cmc = 'txmc'
                  crc = 'txrc'
               elseif (index(chopt,'TY').gt.0) then
                  var_mc = tymc
                  var_rc = frhit_ty(rh)
                  cmc = 'tymc'
                  crc = 'tyrc'
               elseif (index(chopt,'X').gt.0) then
                  var_mc = xmc
                  var_rc = frhit_x(rh)
                  cmc = 'xmc'
                  crc = 'xrc'
               elseif (index(chopt,'Y').gt.0) then
                  var_mc = ymc
                  var_rc = frhit_y(rh)
                  cmc = 'ymc'
                  crc = 'yrc'
               elseif (index(chopt,'Q').gt.0) then
                  var_mc = qpmc
                  var_rc = frhit_p(rh)
                  cmc = 'qpmc'
                  crc = 'qprc'
               else
                  var_mc = m_mc
                  var_rc = m_rc
                  cmc = 'rmc'
                  crc = 'rrc'
               endif
                  
               nprint = nprint + 1

               if (nprint.eq.1) then
                  print *,' '
                  print *,' ranger track analysis for rt=',rt
                  print *,' '
               endif

               if (mod(nprint,10).eq.1) then
                  print '(4a6,a8,2a10,3a10,a10)',
     +                 'rh','hitb','mimp','mt','z',cmc,crc,'resMC',
     +                 'resRC',
     +                 'resol','chi**2'
               endif
               if (OK) then
                  print '(4i6,f8.2,2f10.4,3f10.5,f10.2)',
     +                 rh,ih,mimp,omimp_mtra(mimp),fhitb_z(ih),
     +                 var_mc,var_rc,
     +                 res_mc,res_rc,dr,chi
               else
                  print '(4i6,f8.2,10x,f10.4,10x,2f10.5,f10.2)',
     +                 rt,rh,ih,mimp,fhitb_z(ih),var_rc,res_rc,dr,chi
               endif
                  
            enddo               ! associated mimps
 41         continue
         endif                  ! ih.ne.0

      enddo                     ! loop over hitb
 21   continue

 999  end

        
