*-- Author :    Rainer Mankel   05/01/96

      subroutine tfdfram(nt)

      implicit none
#include "pris/zgraf.fi"
#include "pris/zframe.fi"
*     **** set up the NTs with an effective display window
*     **** given by x1zg, x2zg, y1zg, y2zg

      real mx_c, my_c, h_c, scal_x, scal_y, off_x,
     +     off_y, ymean, ydiff, aspect
      integer nt

      if (x1zg.ge.x2zg.or.y1zg.ge.y2zg) then
       print *,' () tfdfram: x1zg,x2zg,y1zg,y2zg=', x1zg,x2zg,y1zg,y2zg
       stop 'tfdfram'
      endif

*     **** for determination of usable screen (for nt) we adapt to
*     **** the current style
      if (lheaderzg) then
         h_c = h  ! header
      else
         h_c = 0. ! no header
      endif

      if (laxiszg) then
         mx_c = mx ! axis
         my_c = my
      else
         mx_c = 0. ! no axis
         my_c = 0.
      endif

*     **** set up transformation NDC -> WC
      scal_x = (x2zg - x1zg) / (a * (1. - mx_c))
      scal_y = (y2zg - y1zg) / (a * (b - h_c - my_c))
      off_x = x1zg - a * mx_c * scal_x
      off_y = y1zg - a * (my_c + c) * scal_y

*     **** calculate frame dimensions in WC
      mheadzg = a * h * scal_y
      mlabxzg = a * mx * scal_x
      mlabyzg = a * my * scal_y

      xminzg = off_x
      xmaxzg = off_x + a * scal_x
      yminzg = off_y + a * c * scal_y
      ymaxzg = off_y + a * (b + c) * scal_y

      uxzg = 0.01 * scal_x
      uyzg = 0.01 * scal_y

*     **** set up normalization transformation
      call iswn(nt,xminzg,xmaxzg,yminzg,ymaxzg)
      call isvp(nt,0.,a,a*c,a*(c+b))

      call iswn(nt,x1zg,x2zg,y1zg,y2zg)
      call isvp(nt,a*mx_c,a,a*(c+my_c),a*(c+b-h_c))

      call iselnt(nt)
      call igsa(1)
      call isclip(1)

 999  end


