*-- Author :    Rainer Mankel   15/01/95

      subroutine tffilo(it,izf)

*     **** take lowest-z point of track it & prepare it as a seed
*     **** for track continuation into /zf/-position izf
      implicit none

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"

      integer it, izf, ih, ift, tumchit, hf, hf_low, jaux,
     +        i_pack, i, j, ipl, nhit, jmc, mimp, nnmimp
      real wc(3), xxx(2), yyy(2), z_low
#include "arte/Arte.fi"

#include "auto/GEO.fi"
#include "auto/RTRA.fi"
#include "auto/HITB.fi"
#include "auto/RHIT.fi"
#include "auto/MTRA.fi"

#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/RTRA.ff"
#include "auto/HITB.ff"
#include "auto/RHIT.ff"
#include "auto/MTRA.ff"

*     **** check if track is good
      if (irtra_fit(it).ne.1) then
       print *,' () tffilo: it, irtra_fit(it)=', it, irtra_fit(it)
       stop 'tffilo'
      endif

*     **** here we could check stat_ft ...

*     **** find pointer to fitted hit of lowest z
      nhit = 0
      hf_low = 0  ! init pointer to lowest-z hit
      z_low = 0   !  ||  z-value of    ||
      do 10 hf=1,nrhit()
       if (irhit_rtra(hf).ne.it) go to 10

       nhit = nhit + 1

       if (hf_low.gt.0) then
        if (fhitb_z(orhit_hitb(hf)).gt.z_low) go to 10  ! z lower than
     +                                                  ! stored hit ?
       endif
       hf_low = hf
       z_low = fhitb_z(orhit_hitb(hf))
 10   continue

*     **** take track parameters of first hit
      if (hf_low.le.0.or.hf_low.gt.iq(jrhit+2)) then
       print *,' () tffilo: hf_low=', hf_low
       stop 'tffilo'
      endif

      z_zf(izf) = frtra_zf(it)
      xx_zf(1,izf) = frtra_xf(it)
      xx_zf(2,izf) = frtra_yf(it)
      xx_zf(3,izf) = frtra_txf(it)
      xx_zf(4,izf) = frtra_tyf(it)
      xx_zf(5,izf) = frtra_pf(it)      ! should be reviewed...

*     **** covariance of track parameters
      do i=1,5
       do j=i,5         ! undo the packing
        i_pack = matrix_pack(i,j)
        cx_zf(i,j,izf) = frtra_cvf(i_pack,it)
        if (i.ne.j) cx_zf(j,i,izf) = cx_zf(i,j,izf)
       enddo
      enddo

*     **** first hit
      ih = orhit_hitb(hf_low)
      ipl = ihitb_gede(ih)

*     **** set up momentum
      xx_zf(5,izf) = 0.

*     **** test! take MC momentum!
**      xx_zf(5,izf) = tfhtok(itfp(it))

      cx_zf(5,5,izf) = 1.73

*     **** set up other parameters
      ch_zf(izf) = 0.
      hit_zf(izf) = ih
      nhit_zf(izf) = 1
      whit_zf(izf) = 1.
      plane_zf(izf) = ipl
      z_zf(izf) = fhitb_z(ih)
      if (igede_cmp(ipl).eq.2) then
       if (fhitb_q(hit_zf(izf)).ge.0.) then
        sign_zf(izf) = +1
       else
        sign_zf(izf) = -1
       endif
      else
       sign_zf(izf) = 0
      endif
      fault_zf(izf) = 0
      pfault_zf(izf) = 0
      mc_zf(izf) = tumchit(ih)
      call tuhmimp(ih,jmc,mimp,nnmimp)
      if (nnmimp.eq.1) then
       mimp_zf(izf) = mimp
      else
       mimp_zf(izf) = 0
      endif
      dim_zf(izf) = 1
      shadow_zf(izf) = 0
      cht_zf(izf) = ch_zf(izf)
      prev_zf(izf) = 0
      n_zf = izf

*     **** find domain layer
      if (dlayer_dg(ipl).gt.0) then
       domlay_zf(izf) = dlayer_dg(ipl)
      else
       print *,' () tffilo: dlayer_dg=', dlayer_dg(ipl)
       stop
      endif

*     **** fill candidate info
      nca_ft  = 1
      ift = nca_ft
      first_ft(ift)   = izf
      last_ft(ift)    = izf
      prev_ft(ift)    = 0
      gen_ft(ift)     = 1
      nhit_ft(ift)    = 1
      nfault_ft(ift)  = 0
      quality_ft(ift) = 1.
      mature_ft(ift)  = .false.
      alive_ft(ift)   = .true.
      stat_ft(ift)    = 0

      badhits_ft(ift) = 0
      badsigs_ft(ift) = 0
      if (igede_cmp(ipl).eq.2) then
       if (sign_zf(izf)*fhitb_q(hit_zf(izf)).lt.0.)
     +                          badsigs_ft(ift) = 1
      endif

#ifdef RGRAF
*     **** draw
      if (l_graf) then
*      **** draw markers
       call igset('LWID',1.)
       call ismk(2)
       wc(1) = xx_zf(1,izf)
       wc(2) = 0.
       wc(3) = z_zf(izf)
       call dipro(wc,xxx(1),yyy(1))
       call ipm(1,xxx,yyy)
       call iuwk(0,1)
      endif
#endif

      if (diag_level.ge.4) then
       print *,' *******************************************'
       print *,' *    tf    listing : nca_ft=', nca_ft,'   *'
       print *,' *******************************************'

       call tfl()
      endif

      end



