
>Name TFKUIP

>Menu RANGER
>Guidance
Commands related to the ranger package.

>Command MAIN
>Guidance
Execute ranger reconstruction for this event
>Action TFMAIN

>Command LEVEL
>Guidance
Set level of ranger reconstruction
>Parameters
RL*EVEL   'Ranger level'                    I D=0
>Action TFKLEVEL

>Command SCENARIO
>Guidance
Modify domain definition table according to scenario
>Parameters
+
SL1       'Superlayer  1' C D=' '
SL2       'Superlayer  2' C D=' '
SL3       'Superlayer  3' C D=' '
SL4       'Superlayer  4' C D=' '
SL5       'Superlayer  5' C D=' '
SL6       'Superlayer  6' C D=' '
SL7       'Superlayer  7' C D=' '
SL8       'Superlayer  8' C D=' '
SL9       'Superlayer  9' C D=' '
SL10      'Superlayer 10' C D=' '
SL11      'Superlayer 11' C D=' '
SL12      'Superlayer 12' C D=' '
SL13      'Superlayer 13' C D=' '
SL14      'Superlayer 14' C D=' '
SL15      'Superlayer 15' C D=' '
SL16      'Superlayer 16' C D=' '
SL17      'Superlayer 17' C D=' '
SL18      'Superlayer 18' C D=' '
SL19      'Superlayer 19' C D=' '
SL20      'Superlayer 20' C D=' '
>Action DMKSCEN

>Command SELECT
>Guidance
Select MTRA for selective operation
>Parameters
MTRA      'Id of MC track'                  I D=0
>Action TFKSELECT

>Command IDEA
>Parameters
MTRA      'Id of MC particle'               I D=0
+
ZMIN      'Start of z range'                R D=200.
ZMAX      'End   of z range'                R D=850.
>Guidance
Perform track fit on hits from MC particle.
>Action TFKIDEA

>Command PARM
>Parameters
+
IFT       'Id of track candidate' I D=1
>Guidance
Perform tfparm analysis on track candidate
>Action TFKPARM

>Command PAR2
>Parameters
+
IFT       'Id of track candidate' I D=1
>Guidance
Perform tfpar2 analysis on track candidate
>Action TFKPAR2

>Command TPARM
>Parameters
+
RTRA       'Id of reconstructed track' I D=1
>Guidance
Perform tftparm analysis on track
>Action TFKTPARM

>Command RFIT
>Parameters
mtra       'MC track for ranger fit' I D=0
hit_min    'Minimal number of hits'  I D=6
zmin       'Lower z bound'           R D=700.
zmax       'Upper z bound'           R D=1000.
elec_corr  'Electron energy correction flag' I D=0
>Guidance
Perform ranger track fit on hits of given MC particle
>Action TFKRFIT


>Command FPAR
>Parameters
+
dl*evel   'Detector geometry level'           I D=-999
rl*evel   'Run level'                         I D=-999
sm*ooth   'Smoother flag for rangerfit'       I D=-999
nit*er    'Number of iterations for rangerfit' I D=-999
ms*mode   'Multiple scattering correction mode' I D=-999
max_plpick 'max N(planes) picked up in ms corr'   I D=-999
maxflt_x   'max N(faults) in sequence (x tracking)'   I D=-999
maxflt_y   'max N(faults) in sequence (y tracking)'   I D=-999
maxflt_mag 'max N(faults) in sequence (mag tracking)' I D=-999
maxflt_3d  'max N(faults) in sequence (3D tracking)'  I D=-999
rmax_x     'maximal rank (x tracking)'         I D=-999 
rmax_y     'maximal rank (y tracking)'         I D=-999 
min_mimp   'minimal Nmimps for pat ref track' I D=-999 
whmin_x    'minimal whit (x tracking)'         R D=-999. 
whmin_y    'minimal whit (y tracking)'         R D=-999.
whmin_3d   'minimal whit (3d tracking)'        R D=-999.
whmin_mag  'minimal whit (mag tracking)'       R D=-999.
f_moliere  'm.s. correction from moliere scat' R D=-999.
cxxrf      'Initial cxx   value for rangerfit' R D=-999.
cyyrf      'Initial cyy   value for rangerfit' R D=-999.
ctxtxrf    'Initial ctxtx value for rangerfit' R D=-999.
ctytyrf    'Initial ctyty value for rangerfit' R D=-999.
cqqrf      'Initial cqq   value for rangerfit' R D=-999.
qpl*imit   'momentum parm limit for rangerfit' R D=-999.
zmin_ec    'Lower z bound for energy loss corr' R D=-999.
zmax_ec    'Upper z bound for energy loss corr' R D=-999.
zmin_mag   'Lower z bound for magnet-type tracking' R D=-999.
zmax_mag   'Upper z bound for magnet-type tracking' R D=-999.
segstor    'Storage in segments'               C D=' '
clmimp_pr  'Clean mimps for ref track (y/n)'   C D=' '
chopt      'Options'                           C D=' '
>Guidance
Set parameters for ranger package.
>Action TFKFPAR

>Command FCOV
>Guidance
Set f_cov factors in /zfpar/
>Parameters
+
f1   'f_cov(1)'           R D=1.
f2   'f_cov(2)'           R D=1.
f3   'f_cov(3)'           R D=1.
f4   'f_cov(4)'           R D=1.
f5   'f_cov(5)'           R D=1.
>Action TFKFCOV

>Command DIAGNOSIS
>Parameters
+
diag      'Diagnosis y/n'                 C D=' '
diaglevel 'Diagnostics level'             I D=-99
mttrap    'MC particle trap'              I D=-99
graf      'Real time graphics y/n'        C D=' '
>Guidance
Set diagnostics level for ranger.
>Action TFKDIAG

>Command ANALYSIS
>Parameters
rtra      'Reconstructed track'         I D=0
+
chopt     'Options'                     C D=' '
>Guidance
Analyze reconstructed track
>Action TFKANLYS

>Menu DISPLAY
>Guidance
Display commands for the tf package

>Command FT
>Parameters
IFT1        'Id of first track candidate' I D=0
+
IFT2        'Id of last  track candidate' I D=0
>Guidance
Display track candidate
>Action TFKFT

>Command RESIDUAL
>Parameters
IFT        'Id of track candidate' I D=1
>Guidance
Display residuals of track candidate
>Action TFKRES

>Command SEEDX
>Guidance
Calculate all seeds in x and display
>Action TFKMSEEDX


>Command TRIPLET
>Guidance
Display all triplets.
>Action TFKDTRIP

>Command CLUSTER
>Guidance
Display all clusters.
>Action TFKDCLUS

>Menu \PRINT
>Guidance
Print commands for the tf package
>Command FT
>Parameters
+
IFT1      'Id of first track candidate to be printed' I D=0
IFT2      'Id of last  track candidate to be printed' I D=0
CHOPT     'Options'                          C D=' '
>Guidance
Display entries in ft data structure together with related zf entries.

Options:

      -R:  print residuals
      -S:  refer to smoothed coordinates

>Action TFKPFT

>Command ZF
>Parameters
+
IZF1      'Id of first hit in zf structure' I D=0
IZF2      'Id of last  hit in zf structure' I D=0
FT        'Restrict to candidate FT'        I D=0
CHOPT     'Options'                          C D=' '

>Guidance
Display entries in zf data structure.

Options:

      -R:  print residuals
      -S:  refer to smoothed coordinates

>Action TFKPZF

>Command SEED
>Guidance
Print entries in domain seeding table
>Action TFKPSEED

>Command DOMAIN
>Parameters
+
DOM1 'First domain to be printed' I D=0
DOM2 'Last  domain to be printed' I D=0
>Guidance
Print domains from domain structure
>Action TFKPDOM

>Command WINDOW
>Parameters
+
DOM1 'First domain window to be printed' I D=0
DOM2 'Last  domain windowto be printed' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print domain windows from domain structure.
Option -N prints the navigation table
>Action TFKPWIN

>Command DLAY
>Parameters
+
DLAY1 'First domain layer  to be printed' I D=0
DLAY2 'Last  domain layer to be printed' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print domain layers  from domain structure.
Option -P resolves the associated gede planes (dp)
>Action TFKPLAY

>Command DHIT
>Parameters
+
D*OMAIN 'Domain' I D=0
W*INDOW 'Domain window' I D=0
L*AYER  'Domain layer'  I D=0
M*ETHOD 'Method'        I D=1
>Guidance
Print domain hits from domain structure
>Action tfkpdh

>Command PMATRIX
>Parameters
+
SU*PERLAYER 'SUPERLAYER' I D=0
SE*CTOR 'SECTOR' I D=0
M*ETHOD  'METHOD'  I D=0
L*AYER 'LAYER'        I D=0
>Guidance
Print plane matrix
>Action tfkpmat

>Command CLUSTER
>Guidance
Print clusters
>Parameters
+
CLUSTER1 'Start cluster' I D=0
CLUSTER2 'End   cluster' I D=0
MTRA     'Associated MC track' I D=0
>Action TFKPCL

>Command TRIPLET
>Guidance
Print triplets
>Parameters
+
TRIPLET1 'Start triplet' I D=0
TRIPLET2 'End   triplet' I D=0
>Action TFKPTRIP

>Command SETS
>Guidance
Print sets
>Parameters
+
SET1 'Start set' I D=0
SET2 'End   set' I D=0
MTRA 'restrict to MC particle' I D=0
>Action TFKPSETS

>Command DIGI
>Guidance
Check digitization for particular track
>Parameters
MTRA 'MC track' I D=1
+
ZMIN 'lower z bound' R D=0.
ZMAX 'upper z bound' R D=1500.
>Action TFKDIGI

>Command TRANS
>Guidance
Check transport for particular track
>Parameters
MTRA 'MC track' I D=1
+
ZMIN 'lower z bound' R D=0.
ZMAX 'upper z bound' R D=1500.
>Action TFKTRANS

>Command ZONES
>Guidance
Print domain layer navigation zones for domain layer DL
>Parameters
DL     'Domain layer'            I D=1
+
NZONES 'Number of zones'         I D=3
DIRECTION 'Navigation direction' I D=-1
>Action TFKPZONE

>Command GOLD
>Guidance
Print particles from golden B decay
>Action TFKPGOLD



