*CMZ :  4.02/00 19/07/96  13.56.47  by  Rainer Mankel
*CMZ :  4.01/00 03/10/95  14.56.59  by  Rainer Mankel
*CMZ :  4.00/01 13/07/95  15.30.37  by  Rainer Mankel
*CMZ :  4.00/00 28/06/95  18.59.39  by  Rainer Mankel
*CMZ :  3.04/01 04/02/95  16.05.35  by  Rainer Mankel
*CMZ :  3.04/00 24/01/95  20.41.14  by  Rainer Mankel
*CMZ :  3.03/01 21/01/95  14.52.18  by  Rainer Mankel
*CMZ :  3.02/02 12/01/95  18.03.00  by  Rainer Mankel
*CMZ :  3.02/01 11/01/95  22.27.50  by  Rainer Mankel
*CMZ :          11/01/95  15.44.36  by  Rainer Mankel
      subroutine tfmafi(ift)

*     **** 3D refit of magnet candidate, using momentum
*     **** of lowest-z point
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"

      integer nzfmx_s
      parameter (nzfmx_s=100)
      integer ind_s(nzfmx_s), nzf_s, iizf, ift, izf, jpl,
     +        xsig, ii, jj, kk, jzf, jzf_ylast, ih, istat
      double precision dz, du, cs_thetu, xm_p, xr_p,
     +        cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum

      real xyfac
      parameter (xyfac=1.)
      logical lsmoo
      parameter (lsmoo=.true.)
#include "arte/Arte.fi"

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"

      if (l_diag) then
       print *,' tfmafi starting for ift=', ift
       call tfwait()
      endif

*     **** get izf of hits, sorted after decreasing z
      nzf_s = 0

      do iizf=1,nhit_ft(ift)
       if (iizf.eq.1) then
        izf = last_ft(ift)
       else
        izf = prev_zf(izf)
       endif
       if (izf.eq.0) then
        print *,' () tfmafi: izf=', izf
        stop 'tfmafi'
       endif
       ind_s(nhit_ft(ift)+1-iizf) = izf
      enddo

      nzf_s = nhit_ft(ift)

*     **** printout
      if (diag_level.ge.3) then
       print *,' tfmafi: hits to be fitted:'
       do iizf=1,nzf_s
        izf = ind_s(iizf)
        ih = hit_zf(izf)
        print '((a),4i6, 5f10.4)',
     +  ' izf, ih, imc, z, MC=', izf, hit_zf(izf), plane_zf(izf),
     +                              mc_zf(izf),
     +                               z_zf(izf),
     +    fmimp_x(mimp_zf(izf)), fmimp_y(mimp_zf(izf)),
     +    fmimp_tx(mimp_zf(izf)), fmimp_ty(mimp_zf(izf))
       enddo
      endif

*     **** filter next points
      do iizf=1,nzf_s
       jzf = ind_s(iizf)

       jpl = plane_zf(jzf)
       xsig = sign_zf(jzf)
       ih = hit_zf(jzf)

       if (iizf.eq.1) then
*       **** set curvature to value of lowest-z point
        jzf_ylast = last_ft(ift)
        xx_zf(5,jzf) = xx_zf(5,jzf_ylast)
        if (diag_level.ge.3)
     +    print *, ' 1st pt init:', xx_zf(5,jzf),
     +          ' jzf=', jzf, ' hit=', hit_zf(jzf),
     +          ' hit_last=', hit_zf(jzf_ylast)
       else
        izf = ind_s(iizf-1)
        dz = z_zf(jzf) - z_zf(izf)

*       **** Kalman filter prediction
        call tftran(dz,izf,jzf,istat)

        if (istat.lt.0) then
         print *,' tfmafi: transport was impossible '
         stop 'tfmafi'
        endif

*       **** projection
        if (igede_cmp(jpl).eq.2) then
         xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
         cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
*        **** tan(track angle) in uz-plane
         m_u = xp_zf(3,jzf) * fgede_cos(jpl)
     +       - xp_zf(4,jzf) * fgede_sin(jpl)
         cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*        **** distance from projection to wire (along u)
         du = xp_zf(1,jzf) * fgede_cos(jpl)  - fhitb_x(ih)
     +                                   - xp_zf(2,jzf) * fgede_sin(jpl)
         xm_p      = du * cs_thetu
*        **** difference to signed drift distance
         xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
         h_zf(1,1,jzf) =   fgede_cos(jpl) * cs_thetu
         h_zf(1,2,jzf) = - fgede_sin(jpl) * cs_thetu
         h_zf(1,3,jzf) = - du * m_u * cs_thetu**3 * ( fgede_cos(jpl))
         h_zf(1,4,jzf) = - du * m_u * cs_thetu**3 * (-fgede_sin(jpl))
         h_zf(1,5,jzf) = 0.
         hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +       +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +       +  h_zf(1,3,jzf)**2 * cp_zf(3,3,jzf)
     +       +  h_zf(1,4,jzf)**2 * cp_zf(4,4,jzf)
     +       + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) * cp_zf(1,2,jzf)
     +                + h_zf(1,1,jzf) * h_zf(1,3,jzf) * cp_zf(1,3,jzf)
     +                + h_zf(1,1,jzf) * h_zf(1,4,jzf) * cp_zf(1,4,jzf)
     +                + h_zf(1,2,jzf) * h_zf(1,3,jzf) * cp_zf(2,3,jzf)
     +                + h_zf(1,2,jzf) * h_zf(1,4,jzf) * cp_zf(2,4,jzf)
     +               + h_zf(1,3,jzf) * h_zf(1,4,jzf) * cp_zf(3,4,jzf) )

         cr_p = xyfac * fhitb_r(ih)**2 + hch
        elseif (igede_cmp(jpl).eq.3) then
         xm_zf(1,jzf)   = fhitb_x(ih)
         cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
         xm_p = xp_zf(1,jzf) * fgede_rot(1,jpl)
     +        - xp_zf(2,jzf) * fgede_rot(2,jpl)
         xr_p = fhitb_x(ih) - xm_p

         h_zf(1,1,jzf) = fgede_rot(1,jpl)
         h_zf(1,2,jzf) = - fgede_rot(2,jpl)
         h_zf(1,3,jzf) = 0.
         h_zf(1,4,jzf) = 0.
         h_zf(1,5,jzf) = 0.
         hch =         cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +        + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +               + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
         cr_p = cm_zf(1,1,jzf) + hch
        else
         print *,' tfmafi: non-supported type for jpl=', jpl
        endif

*       **** filter point
        do ii=1,5
         kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +                  + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +                  + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +                  + cp_zf(ii,4,jzf) * h_zf(1,4,jzf)
     +                  + cp_zf(ii,5,jzf) * h_zf(1,5,jzf) ) / cr_p
        enddo

*       **** updated x value
        do ii=1,5
         xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
        enddo

*       **** updated cov matrix
        do ii=1,5
         do jj=1,5
          cx_zf(ii,jj,jzf) = 0.
         enddo
        enddo

        do ii=1,5
         do jj=ii,5
          sum = 0.
          do kk=1,5
           if (ii.eq.kk) then
            sum = sum +
     +        (1.d0 - kalman(ii,1) * h_zf(1,kk,jzf)) * cp_zf(kk,jj,jzf)
           else
            sum = sum -kalman(ii,1) * h_zf(1,kk,jzf) * cp_zf(kk,jj,jzf)
           endif
          enddo
          cx_zf(ii,jj,jzf) = sum
          if (ii.ne.jj) cx_zf(jj,ii,jzf) = sum
         enddo
        enddo

*       **** updated residual
        ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +           - h_zf(1,2,jzf) * kalman(2,1)
     +           - h_zf(1,3,jzf) * kalman(3,1)
     +           - h_zf(1,4,jzf) * kalman(4,1)
     +           - h_zf(1,5,jzf) * kalman(5,1)

        xr_zf(1,jzf) = xr_p * ihk
        cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk

*       **** updated chi2 contribution
        ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

        cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
       endif
      enddo

      end


