*-- Author :    Rainer Mankel   01/04/96

      subroutine tfmatrip(istat)

*     **** mother routine for seed studies
      implicit none
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zf.fi"
#include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"

      integer ntot,ngood,mc,ift,nseed,izf,nhits,clus,
     +      dl,dw,nca_x,dom,direction,pc,run_level,nca_y,n_good,
     +      begin_store,jft,ft_good,istat,nca_prep
      real ef
      logical init, lstore

      save init
      data init /.false./

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      if (.not.l_rinit) call tfrinit() ! restricted init

      l_term = .false.
      lremzc = .false.

*     **** should we clear the track bank ??

*     **** do the work
      if (.not.init) then
         call dmmain()          ! set up domain structure
         init = .true.
      endif

      call dmhit(istat)         ! set domain hit buffer
      if (istat.le.-100) go to 999

      call tfref()   ! prepare reference track information
**      print *,' tfmatrip: loop over pc'
**      call tfwait()
      do pc=4,1,-3
         dom = dom_dpc(pc)
         direction = dir_dpc(pc)
         call tftripx(dom)      ! construct seeds for domain 20
         do 10 clus=1,nclusx
**            print *,' cluster ', clus
            call tfclr()
            begin_ft = 1
            call tfpropcx(clus,direction) ! propagate
            call tfbest()
            nca_x = nca_ft
            l_mag = .false.

            n_good = 0
            ft_good = 0
            do jft=1,nca_x
               if (alive_ft(jft)) then
                  if (quality_ft(jft).gt.6.) then
                     n_good = n_good + 1
                     ft_good = jft
                  endif
               endif
            enddo

**            print *,' after horizontal tracking '
**            print *,' ............n_good =',n_good,' ft=',ft_good

            if (rlevel_zfpar.le.1) go to 9

*           **** vertical continuation
            begin_ft = nca_x + 1
**            print *,' vertical for clus=', clus
            n_good = 0
            do 20 ift=1,nca_x
               if (alive_ft(ift)) then
                  if (quality_ft(ift).lt.6.) then
                     alive_ft(ift) = .false.
                     go to 20
                  endif
                  if (diag_level.ge.3) then
                     call tflft(ift,' ')
                     call tfparmft(ift)
                     if (diag_level.ge.5)
     +                    print *,' before tfsasegx,ift=', ift
                     if (l_diag) call tfwait()
                  endif
                  call tfsasegx(ift) ! save x-projection
**                  print *,' tfsaseg for ft=',ift

                  dl = dl_set(s_trip(1,trip1_clus(clus))) ! get dom lyer
                  dw = win_dl(dl) ! get domain window

                  call tfconty(dw) ! vertical completion

                  do jft=nca_x+1,nca_ft
                     if (alive_ft(jft)) then
                        if (quality_ft(jft).gt.6.) then
                           n_good = n_good + 1
                        endif
                     endif
                  enddo

                  if (n_good.ge.1) go to 20

                  if (dlx2_dlx.eq.4.and.dw_dlx(dlx2_dlx).ne.dw) then
                     call tfconty(dw_dlx(dlx2_dlx))
                  endif
                  if (dlx1_dlx.eq.1.and.dw_dlx(dlx1_dlx).ne.dw) then
                     call tfconty(dw_dlx(dlx1_dlx))
                  endif

                  do jft=nca_x+1,nca_ft
                     if (alive_ft(jft)) then
                        if (quality_ft(jft).gt.6.) then
                           n_good = n_good + 1
                        endif
                     endif
                  enddo
**                  print *,' ............n_good =',n_good
               endif
 20         continue  ! x candidates

            begin_ft = nca_x + 1
            call tfbest()       ! optimize vertical

            nca_y = nca_ft
**            print *,' vertical completion done, n_good=',n_good

**            call tfwait()
**            if (n_good.eq.0) go to 10

*           **** 3D processing
            n_good = 0
            do 30 ift=nca_x+1,nca_y
               if (alive_ft(ift)) then
**                  print *,' vertical candidate ift,q=',
**     +                 ift,quality_ft(ift)
                  if (quality_ft(ift).lt.6.) go to 30
                  n_good = n_good + 1
                  if (diag_level.ge.3) then
                     print *,' tfmatrip: vertical completion',
     +                    ' successful ',
     +                    ' ift=', ift
                     call tflft(ift,' ')
                     call tfparmft(ift)
                     if (l_diag) call tfwait()
                  endif
#ifdef OPTI
*                 **** check overlap with existing tracks
                  lstore = .true.
**                  call tfopti(ift,lstore)
                  if (lstore) then
                     call tfsmfi(ift)
                     if (diag_level.ge.3) then
                        print *,' tfmatrip: after smoothing...'
                        call tflft(ift,' ')
                        call tfparmft(ift)
                     endif
                     call tfstor(ift)
                     if (l_diag) call tfwait()
                  endif
#else
                  call tfsmfi(ift)   
#endif
               endif
 30         continue            ! 3D process loop

**            print *,' 3D processing done, n_good=', n_good

**            if (n_good.le.0) go to 10

            if (rlevel_zfpar.le.2) go to 9

*           **** magnet continuation

            do ift=nca_x+1,nca_y
               if (alive_ft(ift)) then
                  mature_ft(ift) = .false.
                  istat = 0
                  call tfmprep(ift,istat) ! prepare for magnet tracking
**                  call tflft(ift,' ')
**                  print *,' tfmatrip: before magnet, nca_ft=',nca_ft
**                  call tfwait()
               endif
            enddo

            nca_prep = nca_ft   ! store new endpointer

            l_2dx = .false.
            l_2dy = .false.
            l_mag = .true.
            begin_ft = nca_prep + 1
            istat = 0
            call tfpropm(nca_y+1,-1,istat)
            if (istat.ge.0) then
            elseif (istat.le.-100) then
               go to 999        ! no further propagation
            elseif (istat.le.-1) then
               go to 10         ! terminate branch
            endif

            if (diag_level.ge.2) then
               call tfl()
               print *,' after tfpropm,before tfbest'
               call tfwait()
            endif
            begin_ft = nca_prep + 1
            call tfbest()
            if (diag_level.ge.3) then
               call tfl()
               print *,' after tfbest'
               call tfwait()
            endif

*           **** store loop
 9          continue
            if (rlevel_zfpar.eq.1) then
               begin_store = 1
            elseif (rlevel_zfpar.eq.2) then
               begin_store = nca_x + 1
            else
               begin_store = nca_prep + 1
            endif
**            print *,' begin_store,nca_x,nca_y,nca_ft=',
**     +           begin_store,nca_x,nca_y,nca_ft
            do 40 ift=begin_store,nca_ft
               if (alive_ft(ift)) then
                  if (quality_ft(ift).lt.6.) go to 40
                  call tfstor(ift)
                  if (l_diag) call tfwait()
               endif
 40         continue

 10      continue               ! x clusters
      enddo

      if (rlevel_zfpar.le.2) then
         call tfstat()
      else
         call tfstam()
      endif

 999  end
