*-- Author :    Rainer Mankel   02/06/96


      subroutine tfmprep(ift,istat)

*     **** prepare track for magnet continuation
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "pris/hgmagnhelp.fi"
      integer ift,jft,i,j,izf,jzf,kzf,istat
      real qptmax,qpt,tfqptest,z,x,tx
      parameter (qptmax=0.96)

      if (stat_ft(ift).eq.3.or.stat_ft(ift).eq.5) then
         kzf = last_ft(ift)

            

         if (n_zf.lt.nzfmx) then ! create hardcopy of lowest-z hit
            n_zf = n_zf + 1
            izf = n_zf

            do i=1,4
               xx_zf(i,izf) = xs_zf(i,kzf)
               do j=1,4
                  cx_zf(i,j,izf) = cs_zf(i,j,kzf)
               enddo
            enddo
            do i=1,dimm
               xm_zf(i,izf) = xm_zf(i,kzf)
               do j=1,dimm
                  cm_zf(i,j,izf) = cm_zf(i,j,kzf)
               enddo
               do j=1,4
                  h_zf(i,j,izf) = h_zf(i,j,kzf)
               enddo
            enddo
            z_zf(izf)      = z_zf(kzf)
            ch_zf(izf)     = ch_zf(kzf)
            cht_zf(izf)    = cht_zf(kzf)
            hit_zf(izf)    = hit_zf(kzf)
            nhit_zf(izf)   = nhit_zf(kzf)
            sign_zf(izf)   = sign_zf(kzf)
            plane_zf(izf)  = plane_zf(kzf)
            domlay_zf(izf) = domlay_zf(kzf)
            prev_zf(izf)   = prev_zf(kzf)
            prevs_zf(izf)  = prevs_zf(kzf)
            fault_zf(izf)  = fault_zf(kzf)
            pfault_zf(izf) = pfault_zf(kzf)
            mc_zf(izf)     = mc_zf(kzf)
            mimp_zf(izf)   = mimp_zf(kzf)
            dim_zf(izf)    = dim_zf(kzf)
            shadow_zf(izf) = shadow_zf(kzf)
            whit_zf(izf)   = whit_zf(kzf)
            if (nca_ft.lt.ncamx) then ! create new candidate
               nca_ft = nca_ft + 1 
               jft = nca_ft
               first_ft(jft) = izf
               last_ft(jft) = izf
               prev_ft(jft) = ift
               gen_ft(jft) = 1
               nhit_ft(jft) = 1
               nfault_ft(jft) = 0
               quality_ft(jft) = quality_ft(ift)
               badhits_ft(jft) = 0
               badsigs_ft(jft) = 0
               stat_ft(jft) = 4
               alive_ft(jft) = .true.
               mature_ft(jft) = .false.
            else
               print *,' () tfmprep: overflowing nca_ft=',nca_ft
               istat = -10
            endif
         else
            print *,' () tfmprep: overflowing n_zf=',n_zf
            istat = -10
**            last_ft(ift) = izf
         endif
      else
         print *,' () tfmprep: invalid stat_ft=',stat_ft(ift)
         istat = -10
      endif

      do i=1,4
         cx_zf(i,5,izf) = 0.
         cx_zf(5,i,izf) = 0.
      enddo

      if (mc_trap.gt.0.and.mc_zf(izf).eq.mc_trap) then
         print *,' tfmprep: struck trap for mc=',mc_trap,
     +        ' ift=',ift
         call tfwait()
      endif

      z = z_zf(izf)
      x = xx_zf(1,izf)
      tx = xx_zf(3,izf)
      qpt = tfqptest(z,x,tx)
      if (abs(qpt).gt.qptmax) qpt = sign(qptmax,qpt)
      xx_zf(5,izf) = qpt
      cx_zf(5,5,izf) = 1.7388

      fault_zf(izf) = 0

#ifdef TFVERBOSE
      print *,' tfmprep: set qpt=',qpt,' cov(qpt)=',cx_zf(5,5,izf)
#endif

#ifdef OLDVERS
      jzf = izf
      do i=2,nhit_ft(ift)
         jzf = prevs_zf(jzf)
         if (jzf.le.0) then
            print *,' () tfmprep: inconsistent jzf=',jzf
            go to 999
         endif
         do j=1,5
            xx_zf(j,jzf) = xs_zf(j,jzf)
         enddo
         prev_zf(jzf) = prevs_zf(jzf)
      enddo
#endif

 999  end
