*-- Author :    Rainer Mankel   18/05/95

      subroutine tfref()

*     **** find the reference tracks & fill /zpstat/
      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"
#include "rang/zseed.fi"
#include "pris/zpstat.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"

      integer ii, n_prmimp, n_magmimp, n_propmimp, imc, nso, imim, ipl,
     +        isl, iso, cmp, gold, igold, jgold, moth_vx, moth_mc,
     +        code_photon, jaux, jauxh, hit, n_clean, maxpl_patt,
     +        npl_patt_zero, npl_patt_stereo, tpname
      parameter (maxpl_patt=200)
      integer pl_patt_zero(maxpl_patt), pl_patt_stereo(maxpl_patt),
     +        seedx, seedy, iplseed1, iplseed2
      logical init
      real z, r, zmag_mimp, p
      logical found_1, found_2, l_seedx, l_seedy
      integer event
#include "pris/hgmagnhelp.fi"
#include "auto/MIMP.fi"
#include "auto/MIMX.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/HITB.fi"
#include "auto/MVER.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

      save event, init
      data event /0/
      data init /.false./

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MIMX.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/HITB.ff"
#include "auto/MVER.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"


      if (.not.init) then
         code_photon  = tpname('gamma')
         init = .true.
      endif

      event = event + 1

*     **** reset /zpstat/
      pstat_nrefpat = 0
      pstat_nrefmag = 0
      pstat_ngold = 0

*     **** prepare mh
      call tusomh()

*     **** loop over MC particles
      do 10 imc=1,iq(jmtra+2)
       if (diag_level.ge.5) print *,' tfref: imc=', imc
       p = sqrt(fmtra_px(imc)**2 +fmtra_py(imc)**2 +fmtra_pz(imc)**2)
       if (p.lt.1.) go to 10   ! check momentum
       moth_vx = omtrx_bver(imc)
       if (diag_level.ge.5) print *,' tfref: moth_vx=', moth_vx
       if (moth_vx.gt.0) then
        moth_mc = omver_btra(moth_vx)
        if (moth_mc.gt.0) then
         if (omtra_topp(moth_mc).eq.code_photon) go to 10
        endif
       endif
*      **** loop over mimps in sorted order
       nso = nmimmh(imc)
       n_prmimp = 0     ! reset mimp counters for current particle
       n_magmimp = 0    !
       n_propmimp = 0   !

       npl_patt_zero   = 0 ! reset seeding plane monitoring
       npl_patt_stereo = 0 !

       do 30 iso=1,nso
        if (diag_level.ge.5) print *,' tfref: iso=', iso
        imim = imimmh( istamh(imc) + iso )
        if (diag_level.ge.5) print *,' tfref: imim=', imim
        ipl = imimp_gede(imim)
*       **** avoid packed IPLs in ECAL
        if (ipl.gt.iq(jgede+2)) go to 30
        isl = ogede_gesl(ipl)
        cmp = igede_cmp(ipl)
        if (cmp.lt.1.or.cmp.gt.3) go to 30     ! only Si,Straw,MSGC
*       **** locate hit(s)
        n_clean = 0
        do 40 ii=1,99
         if (ii.eq.1) then
          jaux = pmimx_hitb(imim)
         else
          jaux = xmimx_hitb(jaux)
         endif
         if (jaux.eq.0) go to 41
         hit = mmimx_hitb(jaux)
*        **** check if hit is clean
         jauxh = phitb_mimp(hit)
         if (jauxh.eq.0) go to 40            ! cannot happen
         if (xhitb_mimp(jauxh).ne.0) go to 40 ! more than 1 mimp
         n_clean = n_clean + 1
 40     continue
 41     continue
**        if (n_clean.le.0) go to 30 ! no clean hit associated with mimp

        z = fmimp_z(imim)
        if (z.gt.1000.) then
*        **** beyond-RICH area: ignore
        elseif (z.lt.200.) then
*        **** Si vertex area: ignore
        else
*        **** main tracker
         if (igesl_mfl(isl).eq.0) then
*         **** pattern recognition area
          n_prmimp = n_prmimp + 1
*         **** account for seeding planes
          if (abs(fgede_sin(ipl)).lt.0.001.and.
     +        abs(fgede_rot(2,ipl)).lt.0.001) then
           if (npl_patt_zero.ge.maxpl_patt) then
            print *,' () tfref: overflowing npl_patt_zero '
            stop 'tfref'
           endif
           npl_patt_zero = npl_patt_zero + 1
           pl_patt_zero(npl_patt_zero) = ipl
          else
           if (npl_patt_stereo.ge.maxpl_patt) then
            print *,' () tfref: overflowing npl_patt_stereo '
            stop 'tfref'
           endif
           npl_patt_stereo = npl_patt_stereo + 1
           pl_patt_stereo(npl_patt_stereo) = ipl
          endif

         else
*         **** magnet area
          n_magmimp = n_magmimp + 1
          r = sqrt( (z - zposmg)**2 + fmimp_x(imim)**2 )
          if (r.lt.rmag) then
*          **** magnet proper
           n_propmimp = n_propmimp + 1
           if (z.lt.zmag_mimp) zmag_mimp = z ! smallest z in mag proper
          endif
         endif
        endif
 30    continue ! loop over mimps


*      **** p.r. reference track ?
       if (n_prmimp.ge.minmimp_pref_zfpar) then

*       **** check if imc is a golden track
        jgold = 0
        do 20 gold=1,pstat_ngold
         do igold=1,4
          if (pstat_gold(igold,gold).eq.imc) then
           jgold = igold
           go to 21
          endif
         enddo
 20     continue
 21     continue

        if (pstat_nrefpat.lt.maxref) then
         pstat_nrefpat = pstat_nrefpat + 1  ! accept
         pstat_refpat(pstat_nrefpat) = imc
         pstat_jgoldpat(pstat_nrefpat) = jgold
         ref_mh(imc) = .true.
         if (diag_level.ge.6) print *,' tfref: accept imc=', imc

*        **** magnet reference track ?
         if (n_propmimp.gt.7.and.zmag_mimp.lt.450.) then
          if (pstat_nrefmag.lt.maxref) then
           pstat_nrefmag = pstat_nrefmag + 1  ! accept
           pstat_refmag(pstat_nrefmag) = imc
           pstat_jgoldmag(pstat_nrefmag) = jgold
          if (diag_level.ge.6) print *,' tfref: mag-accept imc=', imc
          else
           print *,' () tfref: overflowing pstat_nrefmag=',
     +                                                 pstat_nrefmag
          endif
         endif
        else
         print *,' () tfref: overflowing pstat_nrefpat=',
     +                                                 pstat_nrefpat
        endif
       endif
 10   continue ! loop over imc


      end






