
*-- Author :    Rainer Mankel   15/11/94


      subroutine tfsttra(ift)

*     **** store a fully recognized track
      implicit none
#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"
#include "auto/RPNT.fi"
#include "auto/RTRX.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zcut.fi"
#include "rang/zrtdir.fi"

      integer nzfmx_s
      parameter (nzfmx_s=300)

*     Integer i,j
      integer izf, ift, ih,ii,mcref(1000),imc,inhmc, jj,
     +     jft, iift, ihf, izf_s(nzfmx_s),
     +     nzf_s, iizf, i_pack, it

      real fracmc
      logical lchi2,llsmoo,smoothed(nzfmx_s),init

      integer maxpnt
      parameter (maxpnt=4)
      integer zfPnt(maxpnt),ipnt,jpnt,rp
      real zPnt(maxpnt),zlow,zhigh
      character*4 cc
      integer indrp

#include "pris/zmpack.fi"

      save init,zpnt,zlow,zhigh
      data init /.false./

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"
#include "auto/RPNT.ff"
#include "auto/RTRX.ff"

*********************************************************
*
*     Meaning of the candidate flag stat_ft:
*
*        stat_ft = 1   x candidate
*                  2   y candidate
*                  3   3D, smoothed
*                  4   momentum information
*                  5   momentum information,, smoothed
*
*********************************************************

*      lsmoo = stat_ft(ift).eq.3.or.stat_ft(ift).eq.5

      if (.not.init) then 
         init = .true.
*        **** default positions
         zpnt(1) = 854.         ! begin of RICH
         zpnt(2) = 1174.        ! end   of RICH
         zpnt(3) = 1214.        ! begin of TRD
         zpnt(4) = 1290.        ! end   of TRD

         do ii=1,iq(jgesl+2)    ! look at real superlayers
            write(cc,'(a4)') hgesl_name(ii)
            if (cc.eq.'RICH') then
               zpnt(1) = fgesl_z1(ii)
               zpnt(2) = fgesl_z2(ii)
               print *,' tfsttra: RICH start/end=',zpnt(1),zpnt(2)
            elseif (cc.eq.'TRSL') then
               zpnt(3) = fgesl_z1(ii)
               zpnt(4) = fgesl_z2(ii)
               print *,' tfsttra: TRD  start/end=',zpnt(3),zpnt(4)
            endif
         enddo
         zlow = zpnt(1) - 50.
         zhigh = zpnt(4) + 50.
      endif


      if (diag_level.ge.5) call tfl()

*     **** create vector of hits
      nzf_s = 0
*     **** loop over segments
      do 10 iift=1,3
       if (iift.eq.1) then
        jft = ift
       elseif (prev_ft(jft).gt.0) then
        jft = prev_ft(jft)
       else
        go to 11
       endif

       llsmoo = stat_ft(jft).eq.3.or.stat_ft(jft).eq.5
       do iizf=1,nhit_ft(jft)

        if (iizf.eq.1) then
         izf = last_ft(jft)
        else
         if (.not.llsmoo) then
          izf = prev_zf(izf)
         else
*         **** smoothed ordering
          izf = prevs_zf(izf)
         endif
        endif
        if (izf.eq.0) then
         print *,' () tfsttra: izf=', izf,
     +           ' iift,iizf,ift,jft,stat_ft,nhit_ft,llsmoo=',
     +             iift,iizf, ift, jft, stat_ft(ift), nhit_ft(jft),
     +             llsmoo
         call tfwait()
         stop 'tfsttra'
        endif
        if (hit_zf(izf).eq.0) go to 31 ! skip dummy hit
        if (nzf_s.lt.nzfmx_s) then
         nzf_s = nzf_s + 1
         izf_s(nzf_s) = izf
         smoothed(nzf_s) = llsmoo
        else
         print *,' () tfsttra: overflowing nzf_s=', nzf_s
         stop ' tfsttra '
        endif
       enddo
 31    continue
 10   continue
 11   continue

      if (diag_level.gt.0) then
       print *,' tfsttra: nzf_s=', nzf_s
       print *,'         izf_s=', (izf_s(iizf),iizf=1,nzf_s)
      endif

*      **** security check
      ih = hit_zf(izf_s(1))
      if (nzf_s.eq.0.or.ih.le.0.or.ih.gt.iq(jhitb+2)) then
         call tfl()
         print *,' () tfsttra: nzf_s,ii,ih,iq(jhitb+2),ift,nhit_ft =',
     +        nzf_s,ii,ih,iq(jhitb+2),ift,
     +        nhit_ft(ift)
         go to 999
      endif

      call mmbook(jrtra,1)      ! increase row counter
      it = nrtra()
      if (it.le.max_rtdir) then  ! reset rtdir
         rhit0_rtdir(it) = 0
         nrhit_rtdir(it) = 0
      else
         print *,' () tfsttra: overflowing it=',it,
     +        '  max_rtdir=',max_rtdir
      endif

      lchi2 = .true.

*     **** take impact parameter of lowest-z point
      izf = izf_s(1)

      q(qrtra_zf_l()) = z_zf(izf)

*     **** fill track parameters
      if (.not.smoothed(1)) then      ! for tracks without smoothing
         call tffill(it,xx_zf(1,izf),cx_zf(1,1,izf))
      else                      ! for tracks with smoothing
         call tffill(it,xs_zf(1,izf),cs_zf(1,1,izf))
      endif

      iq(iqrtra_hou_l()) = nzf_s ! hits in outer tracker (crude!)

*     **** set track flag
      if (stat_ft(ift).le.3) then
         iq(iqrtra_fit_l()) = 1
      else
         iq(iqrtra_fit_l()) = 2
      endif
      q (qrtra_chi_l()) = cht_zf(izf_s(1))

*     **** store the reconstructed hits
      if (it.le.max_rtdir) then
         rhit0_rtdir(it) = nrhit()
         nrhit_rtdir(it) = 0
      endif
      do 20 ii=nzf_s,1,-1       ! decreasing z order
         izf = izf_s(ii)
         ih = hit_zf(izf)
         if (ih.le.0.or.ih.gt.nhitb()) then
            print *,' () tfsttra: izf, nzf_s, ii, ih, iq(jhitb+2)=',
     +           izf, nzf_s, ii, ih, iq(jhitb+2)
            go to 20
**        stop 'tfsttra'
         endif
*        **** allocate row for new hit in hfit table
         call mmbook(jrhit,1)
         ihf = nrhit()
         if (it.le.max_rtdir) nrhit_rtdir(it) = nrhit_rtdir(it) + 1

         if (.not.smoothed(ii)) then
            q(qrhit_x_l())  = xx_zf(1,izf)
            q(qrhit_y_l())  = xx_zf(2,izf)
            q(qrhit_tx_l()) = xx_zf(3,izf)
            q(qrhit_ty_l()) = xx_zf(4,izf)
            q(qrhit_p_l())  = xx_zf(5,izf)
         else
            q(qrhit_x_l())  = xs_zf(1,izf)
            q(qrhit_y_l())  = xs_zf(2,izf)
            q(qrhit_tx_l()) = xs_zf(3,izf)
            q(qrhit_ty_l()) = xs_zf(4,izf)
            q(qrhit_p_l())  = xs_zf(5,izf)
         endif

         iq(iqrhit_rtra_l()) = it ! track
         call mmbrel(jhirh,ih,ihf) ! hitb

*        **** relation trac <-> hfit does not exist anymore

*        **** set track assignment in zhitb
         if (ih.gt.0.and.ih.le.nhitb()) then
            call mmbrel(jrthi,it,ih)
         else
            print *,' () tfsttra: invalid ih=', ih
         endif

 20   continue                  ! hitf loop

*     **** MC owned  ?
      call tfremcn(it,imc,fracmc)

      if (imc.ne.0.and.fracmc.gt.0.7) then
*        **** set relation rtra <-> mtra
         call mmbrel(jrtmt,it,imc)
      endif

*     **** produce RPNTs
*     **** ipnt = 1      before RICH
*     ****        2      after  RICH
*     ****        3      before TRD
*     ****        4      after  TRD

      do ipnt=1,maxpnt
         zfPnt(ipnt) = 0
      enddo

*     **** locate the proper points
      do 40 ii=1,nzf_s       ! loop over hits
         izf = izf_s(ii)
         ih = hit_zf(izf)
         if (ih.le.0) go to 40
         if (z_zf(izf).lt.zlow.or.z_zf(izf).gt.zhigh) go to 40
         
         ipnt = 1
         if (z_zf(izf).le.zPnt(ipnt).and.z_zf(izf).gt.(zPnt(ipnt)-50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).lt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

         ipnt = 2
         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

         ipnt = 3
         if (z_zf(izf).le.zPnt(ipnt).and.z_zf(izf).gt.(zPnt(ipnt)-50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).lt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

         ipnt = 4
         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

 40   continue

*     **** weedout the duplicates
      do ipnt=1,maxpnt
         do jpnt=ipnt+1,maxpnt
            if (zfPnt(jpnt).eq.zfPnt(ipnt)) zfPnt(jpnt) = 0
         enddo
      enddo

*     **** store the RPNTs
      do ipnt=maxpnt,1,-1
         if (zfPnt(ipnt).gt.0) then
            izf = zfPnt(ipnt)
            call mmbook(jrpnt,1)
            rp = nrpnt()
            q(qrpnt_zf_l()) = z_zf(izf)
            if (.not.smoothed(1)) then ! for tracks without smoothing
               call tfpnfill(rp,xx_zf(1,izf),cx_zf(1,1,izf))
            else                ! for tracks with smoothing
               call tfpnfill(rp,xs_zf(1,izf),cs_zf(1,1,izf))
            endif

            call mmbrel(jrtrp,it,rp) ! set relation
         endif
      enddo


 50   if (diag_level.ge.1) then
       print *,' **************************************************'
       print *,' *       track stored, current number=',it
       print *,' *                                ift=',ift
       print *,' *                     number of hits=',nzf_s
       print *,' *                       total chi**2=',frtra_chi(it)
       print *,' **************************************************'
       do ii=1,99
          if (ii.eq.1) then
             indrp = prtrx_rpnt(it)
          else
             indrp = xrtrx_rpnt(indrp)
          endif
          if (indrp.le.0) go to 71
          print *,' related to rpnt=',mrtrx_rpnt(indrp)
       enddo
 71    continue
      endif

 999  end




