*-- Author :    Rainer Mankel   25/02/96

      subroutine tftparm(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)

*     **** check reconstructed track parameters against MC
      implicit none
      double precision covi(5,5)
      real pa(5), pamc(5), dpa(5), ch2mc, ex(5), dpanorm(5), zref
      integer i, j, ndf, ifail, mimp, jaux, assmimp, istat, i_pack, ii,
     +     it, imc, hf, ih, icode
      real charge, mass, corc(5,5), cms, tx, ty
      character*20 cname
#include "arte/Arte.fi"
#include "rang/zfpar.fi"

#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/MTRA.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/MTRA.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"

      istat = 0
      ndf = 5
      zref = frtra_zf(it)

*     **** get last fitted hit (lowest z)
      do 30 hf=nrhit(),1,-1
         if (irhit_rtra(hf).eq.it) go to 31
30    continue
      print *,' tftparm: missing hf'
      istat = -1
      go to 999
31    continue

      ih = orhit_hitb(hf)

*     **** get mimp
      mimp = 0
      do 10 ii=1,99
         if (ii.eq.1) then
            jaux = phitb_mimp(ih)
         else
            jaux = xhitb_mimp(jaux)
         endif
         if (jaux.eq.0) go to 11
         assmimp = mhitb_mimp(jaux)
         if (omimp_mtra(assmimp).eq.imc) then
            mimp = assmimp
            go to 11
         endif
 10   continue
      istat = -1
      print *,' tftparm: no valid mimp found'
      go to 999
 11   continue

      if (abs(fmimp_z(mimp)-zref).gt.5.) then
         print *,' tftparm: funny z ', fmimp_z(mimp), zref,
     +        ' mimp=', mimp
         istat = -1
         go to 999
      endif

      if (mimp.le.0.or.mimp.gt.iq(jmimp+2)) then
       if (mimp.eq.0) then
        print *,' tftparm: mimp=', mimp  ! mimp ambiguous (allowed)
        istat = -1
        go to 999
       else
        print *,' () tftparm: mimp=', mimp  ! mimp invalid
        stop 'tftparm'
       endif
      endif

      icode = omtra_topp( omimp_mtra(mimp) )
      call tupaty(icode,cname,charge,mass,'G')

      tx = fmimp_tx(mimp)
      ty = fmimp_ty(mimp)

      pamc(1) = fmimp_x(mimp)
     +        + tx * (zref - fmimp_z(mimp))
      pamc(2) = fmimp_y(mimp)
     +        + ty * (zref - fmimp_z(mimp))
      pamc(3) = tx
      pamc(4) = ty
**      pamc(5) = 0.33 * itopp_chrg(icode) / abs(fmimp_p(mimp))
      if (itopp_chrg(icode).gt.0) then
         pamc(5) = 1. / abs(fmimp_p(mimp))
      elseif (itopp_chrg(icode).lt.0) then
         pamc(5) = -1. / abs(fmimp_p(mimp))
      else
         pamc(5) = 0.
         print *,' () tftparm: invalid charge=',itopp_chrg(icode)
      endif




      pa(1) = frtra_xf(it)
      pa(2) = frtra_yf(it)
      pa(3) = frtra_txf(it)
      pa(4) = frtra_tyf(it)
      pa(5) = frtra_pf(it)

      do i=1,5
         do j=1,5
            i_pack = matrix_pack(i,j)
            corc(i,j) = frtra_cvf(i_pack,it)
         enddo
      enddo

*     **** add last M.S.
      cms = fgede_ms(imimp_gede(mimp)) / fmimp_p(mimp)**2
      corc(3,3) = corc(3,3) + cms
      corc(4,4) = corc(4,4) + cms

      do i=1,5
         dpa(i) = pa(i) - pamc(i)
         ex(i)  = sqrt(corc(i,i))
         dpanorm(i) = dpa(i) / ex(i)
      enddo

*     **** MC chi2
      ch2mc = 0.
      do i=1,ndf
         do j=1,ndf
            covi(i,j) = corc(i,j)
         enddo
      enddo

*     **** blank remaining elements
      do i=ndf+1,5
         do j=ndf+1,5
            covi(i,j) = 0.d0
         enddo
      enddo

**      write(*,'((a),5(/5e11.3))') 'before inv:',covi
      call dsinv(ndf,covi,5,ifail)
      if (ifail.ne.0) then
         print *,' () tftparm: mx inversion fails'
         istat = -1
         go to 999
      endif
**      write(*,'((a),5(/5e11.3))') 'after  inv:',covi
      do i=1,ndf
         do j=1,ndf
            ch2mc = ch2mc + dpa(i) * dpa(j) * covi(i,j)
**          print *,' chi2 contr, i,j,contr=',
**     +            i,j,dpa(i) * dpa(j) * covi(i,j)
         enddo
      enddo
      if (ifail.ne.0) print *,' =====> ifail,chi2=',ifail,ch2mc





 999  end




