*-- Author :    Rainer Mankel   26/10/94

      subroutine tftram(lstore)
*     **** 3D track-follow all alive seeds in /zf/ (may be in magnet)
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"

      integer nmax
      parameter (nmax=30)
      integer target_vec(nmax), n_target, tumchit, domlay, dlnext
      integer ift, izf, ipl, icycle, method, ncan, ii,
     +        zone, iplnext, imust, izfnew, nhl, nhlmx, ihl
      double precision u_window, du_window
      parameter (nhlmx=100)
      integer hl(nhlmx), nca_now, to_be_grown
      logical continued, lstore

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"

*     **** in future the scope of planes should be specified
      lstore = .false.
*     **** loop over growth cycles
      do 10 icycle=1,99

*      **** loop over present number of track candidates
       nca_now = nca_ft
       to_be_grown = 0
       do 20 ift=1,nca_now
        if (.not.alive_ft(ift)) go to 20
        if (mature_ft(ift))     go to 20
        to_be_grown = to_be_grown + 1

        if (diag_level.ge.5) then
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
         print *,' << track candidate ', ift, '                    <<'
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
        endif

*       **** loop over planes in zone
        izf = last_ft(ift)
        ipl = plane_zf(izf)
        domlay = domlay_zf(izf)
        zone = fault_zf(izf) + 1
        ncan = 0
        continued = .false.
        method = 1  ! 3D    tracking
        if (diag_level.ge.6) then
         print *,' tftram: call tfdzone for domlay=', domlay,
     +           '  zone=', zone
        endif
        call tfdzone(domlay,method,zone,nmax,target_vec,n_target)
        if (diag_level.ge.5) then
         print *,' zone=', zone
         print '(6((a),i5))',
     +     'tftram: for ipl=',ipl,' dl=',domlay,' meth=',method,
     +     ' zone=',zone,
     +     ' nmax=',nmax,' we get n_target=', n_target
        endif
        do 30 ii=1,n_target
         dlnext = target_vec(ii)
         if (diag_level.ge.5) print *,' tftram: next target=', dlnext
*        **** check if plane is within scope

*        **** check if must/can/cannot plane
         call tfdmust(izf,dlnext,imust)
         if (diag_level.ge.6) print *,' tftram: imust=', imust
         if (cannot_zf(imust)) go to 30

*        **** can/must plane found
         ncan = ncan + 1

*        **** loop over hits
         call tfdhlcr(izf,dlnext,nhlmx,hl,nhl)
         if (diag_level.ge.6) print *,' tftram: hitlist nhl= ', nhl
         do 40 ihl=1,nhl
          if (diag_level.ge.5) then
           print *,' tftram: hitlist ihl=', ihl, ' hit=', hl(nhl),
     +          ' imc=', tumchit(hl(nhl))
          endif
          iplnext = ihitb_gede(hl(ihl))
          call tffilm(hl(ihl),dlnext,iplnext,ift,izf,izfnew)
          if (izfnew.gt.0) continued = .true.
 40      continue  ! hits in hitlist
 30     continue  ! planes in zone

*       **** allow fault on old candidate
        if (fault_zf(izf).lt.2) then
         fault_zf(izf) = fault_zf(izf) + 1
         nfault_ft(ift) = nfault_ft(ift) + 1
        else
*        **** kill or freeze old candidate
         if (whit_zf(izf).lt.9.) then
          alive_ft(ift) = .false.
         else
          mature_ft(ift) = .true.
          stat_ft(ift) = 4
         endif
        endif
        if (diag_level.ge.5) call tfl()

 20    continue
       call tfweed()
       if (l_diag) then
        print *,' **********************************************'
        print *,' *                                            *'
        print *,' *                                            *'
        print *,' *           E  N  D     O  F                 *'
        print *,' *                                            *'
        print *,' *           G  R  O  W  T  H                 *'
        print *,' *                                            *'
        print *,' *            C  Y  C  L  E                   *'
        print *,' *                                            *'
        print *,' *                                            *'
        print *,' **********************************************'
        if (diag_level.ge.4) call tfl()
        if (l_diag) call tfwait()
       endif

       if (to_be_grown.le.0) go to 11

 10   continue

      print *,' () tftram: loop ends ii=99'
      stop 'tftram'

 11   if (diag_level.ge.4) then
       call tfl()
       print *,' **** end growing of seed **** '
      endif

      if (l_diag) call tfwait()

      end



