*-- Author :    Rainer Mankel   09/10/96

      subroutine tftrkut(ndim,x_in,z_in,z_out,x_out,f,istat)

*     **** (slow) interface to Thorsten Oests rkmain
      implicit none
#include "rang/zfmode.fi"
      double precision ftx,ftxy,d_tx,d_ty,d_q,z_in,z_out,f(5,5),
     +     x_in(5),x_out(5),fstep,der_a(5,5),der_b(5,5),pin(6),
     +     pout(6),prec(4),fqp(5,5),sum,delta_z,dz_trunc
      integer ndim,i,j,k,l,istat,ierror
      integer message_id_1 
      data message_id_1 /1/

      if (ndim.ne.5) then
         print *,' () tftrkut: invalid dimension ',ndim
         stop 'tftrkut'
      endif

      istat = 0

      delta_z = dabs(z_out - z_in)

      if (delta_z.lt.0.001d0) then ! z_out = z_in case
         do i=1,5
            x_out(i) = x_in(i)
            do j=1,5
               if (i.eq.j) then
                  f(i,j) = 1.d0
               else
                  f(i,j) = 0.d0
               endif
            enddo
         enddo
         go to 999
      endif

*     **** qpt -> qp
      ftx = dsqrt(1.d0 + x_in(3)**2)
      ftxy = dsqrt(1.d0 + x_in(3)**2 + x_in(4)**2)
      d_tx =    x_in(5) * x_in(3) * x_in(4)**2 / (ftx * ftxy**3)
      d_ty =  - x_in(5) * x_in(4) * ftx / (ftxy**3)
      d_q  =  ftx / ftxy

      do i=1,5
         do j=1,5
            if (i.eq.j) then
               der_a(i,j) = 1.
               der_b(i,j) = 1.
            else
               der_a(i,j) = 0.
               der_b(i,j) = 0.
            endif
         enddo
      enddo

      der_a(5,3) = d_tx
      der_a(5,4) = d_ty
      der_a(5,5) = ftx / ftxy

      fstep = dabs(z_out - z_in)
      if (fstep.le.0.d0) fstep = 1.d0

      pin(1) = z_in
      pin(2) = x_in(1)
      pin(3) = x_in(2)
      pin(4) = x_in(3)
      pin(5) = x_in(4)
      pin(6) = d_q * x_in(5)


      dz_trunc = dmax1(delta_z,1.d0)
      prec(1) = 0.001 / dz_trunc
      prec(2) = 0.001 / dz_trunc
      prec(3) = 0.0001 / dz_trunc
      prec(4) = 0.0001 / dz_trunc

      call rkmain(1,z_out,fstep,pin,prec,pout,fqp,ierror)

      if (ierror.ne.0) then
         if (ierror.eq.3) then
            call mepric(message_id_1,1,
     +           'tftrkut: step adjustment limit exceeded')
            if (diag_level.ge.3) then
               print *,' pin=',pin
               print *,' fstep=', fstep
            endif
         endif
         if (diag_level.ge.3) print *,' tftrkut: transport impossible '
         istat = -1
         go to 999
      endif

*     **** qp -> qpt
      ftx = dsqrt(1.d0 + pout(4)**2)
      ftxy = dsqrt(1.d0 + pout(4)**2 + pout(5)**2)
      d_tx = -pout(6) * pout(4) * pout(5)**2 / (ftxy * ftx**3)
      d_ty =  pout(6) * pout(5) / (ftxy * ftx)
      d_q  =  ftxy / ftx

      x_out(1) = pout(2)
      x_out(2) = pout(3)
      x_out(3) = pout(4)
      x_out(4) = pout(5)
      x_out(5) = pout(6) * d_q

      der_b(5,3) = d_tx
      der_b(5,4) = d_ty
      der_b(5,5) = d_q

*     **** transport of derivative matrix
      do i=1,5
         do j=1,5
            sum = 0.
            do k=1,5
               do l=1,5
                  sum = sum + der_b(i,k) * fqp(k,l) * der_a(l,j)
               enddo
            enddo
            f(i,j) = sum
         enddo
      enddo

 999  end


