// ===========================================================================
//
//  digitisation
//


#include "rich/PhotonDetection.h"

RICHDetector *RICH_Detector=0;
RICHLosses    RICH_Loss;
int RICHdebug=0;

#ifdef NOARTE
 int    ArtePointer<CPOI>::nr =0;
 int    ArtePointer<CPOI>::nc =0;
 CPOI** ArtePointer<CPOI>::t  =0;
 int    ArtePointer<CPMT>::nr =0;   
 int    ArtePointer<CPMT>::nc =0;
 CPMT** ArtePointer<CPMT>::t  =0;
 int    ArtePointer<CEFF>::nr =0;
 int    ArtePointer<CEFF>::nc =0; 
 CEFF** ArtePointer<CEFF>::t  =0;
 int    ArtePointer<CPMD>::nr =0;
 int    ArtePointer<CPMD>::nc =0;
 CPMD** ArtePointer<CPMD>::t  =0;
 int    ArtePointer<CSUP>::nr =0;
 int    ArtePointer<CSUP>::nc =0;
 CSUP** ArtePointer<CSUP>::t  =0;
 int    ArtePointer<CSPM>::nr =0;
 int    ArtePointer<CSPM>::nc =0;
 CSPM** ArtePointer<CSPM>::t  =0;
 int    ArtePointer<CPMI>::nr =0;
 int    ArtePointer<CPMI>::nc =0;
 CPMI** ArtePointer<CPMI>::t  =0;
 int    ArtePointer<CSSM>::nr =0;
 int    ArtePointer<CSSM>::nc =0;
 CSSM** ArtePointer<CSSM>::t  =0;
 int    ArtePointer<CSMI>::nr =0;
 int    ArtePointer<CSMI>::nc =0;
 CSMI** ArtePointer<CSMI>::t  =0;
 int    ArtePointer<CDIM>::nr =0;
 int    ArtePointer<CDIM>::nc =0;
 CDIM** ArtePointer<CDIM>::t  =0;
 int    ArtePointer<CPDW>::nr =0;
 int    ArtePointer<CPDW>::nc =0;
 CPDW** ArtePointer<CPDW>::t  =0;
 int    ArtePointer<CVES>::nr =0;
 int    ArtePointer<CVES>::nc =0;
 CVES** ArtePointer<CVES>::t  =0;
/* int    ArtePointer<MPHO>::nr =0;
 int    ArtePointer<MPHO>::nc =0;
 MPHO** ArtePointer<MPHO>::t  =0;
 int    ArtePointer<DRIC>::nr =0;
 int    ArtePointer<DRIC>::nc =0;
 DRIC** ArtePointer<DRIC>::t  =0;
 int    ArtePointer<CCEL>::nr =0;
 int    ArtePointer<CCEL>::nc =0;
 CCEL** ArtePointer<CCEL>::t  =0;
 int    ArtePointer<CDAQ>::nr =0;
 int    ArtePointer<CDAQ>::nc =0;
 CDAQ** ArtePointer<CDAQ>::t  =0;
 */
#endif 

//=========================================================================

void RICHLosses::print(double n,FILE *fp) {
  fprintf(fp," ---------------------------------------------------------\n");
  fprintf(fp,"         Loss Statistic\n");
  fprintf(fp,"\n");
  fprintf(fp,"  Normalisation set to ..............: %f\n",n);
  fprintf(fp,"\n"); 
  fprintf(fp,"  Geometrical losses:\n");
  fprintf(fp,"     Outside of supermodule area  ...: %8d %f\n",OutOfSuperModules(),OutOfSuperModules()/n);
  fprintf(fp,"     No PMT in cell .................: %8d %f\n",CellEmpty(),CellEmpty()/n);
  fprintf(fp,"     Outside of PMT area ............: %8d %f\n",OutOfPMT(),OutOfPMT()/n);
  fprintf(fp,"\n");
  fprintf(fp,"  Efficiency losses:\n");
  fprintf(fp,"     Lenses-Wavelength ..............: %8d %f\n",LensWaveLength(),LensWaveLength()/n);
  fprintf(fp,"     Lenses-Angles ..................: %8d %f\n",LensAngle(),LensAngle()/n);
  fprintf(fp,"     PMT ............................: %8d %f\n",PMTEfficiency(),PMTEfficiency()/n);
  fprintf(fp," \n");
  fprintf(fp," ---------------------------------------------------------\n");
  fprintf(fp,"\n");
//  fprintf(fp,"
//  fprintf(fp,"
 }
  
//=========================================================================
//
//   initialisation of class PMType and input/output
//
/*
PMType::PMType() {
  CPMT d;
  a=ArtePointer<CPMT>::append(d);
  }
*/  
PMType::PMType(const ArtePointer<CPMT>& aa) :
  a(aa),
  nnx(aa->nx),xxdiv(aa->xdiv),
  nny(aa->ny),yydiv(aa->ydiv) {
  
  nname=(char*) malloc(sizeof(a->type)+1);
  memcpy(nname,a->type,sizeof(a->type));
  nname[sizeof(a->type)]='\0';
  
  xxmin=-(nnx*xxdiv)/2.;
  yymin=-(nny*yydiv)/2.;  
  numchan=nnx*nny;
  }

//
//  initialize from ascii file
//
PMType::PMType(ScriptFile& f) {
  char n[256],tag[256];
  CPMT pmt;


  if (RICHdebug) printf("HAllo\n");
  f.getline(n);
  sscanf(n,"%s",tag);
  if (RICHdebug) printf("%s\n",tag);
  nname=strdup(tag);

  while (f.getline(n)) {
    char *s=n;
    sscanf(s,"%s",tag);s+=f.itemlength(s,1);
    int err=0;
    if      (!strcmp(tag,"numchannel"))   err=(sscanf(s,"%d",&numchan)!=1);
    else if (!strcmp(tag,"numchannel_x")) err=(sscanf(s,"%d",&nnx)    !=1);
    else if (!strcmp(tag,"numchannel_y")) err=(sscanf(s,"%d",&nny)    !=1);
    else if (!strcmp(tag,"division_x"))   err=(sscanf(s,"%lf",&xxdiv)  !=1);
    else if (!strcmp(tag,"division_y"))   err=(sscanf(s,"%lf",&yydiv)  !=1);
    else if (!strcmp(tag,"quantum_efficiency")) eff=Table(f);
    else if (!strcmp(tag,"end"))  break;
    else {
      fprintf(stderr,"PMType(ScriptFile):  Unknown tag: %s %d\n",tag,err);
      exit(0);
      }
    }

  pmt.nx  =nnx;
  pmt.xdiv=xxdiv;
  pmt.ny  =nny;
  pmt.ydiv=yydiv; 
  pmt.ny  =nny;
  pmt.ieff=ArtePointer<CPOI>::nrow()+1;
  pmt.neff=eff.numpoints();

  xxmin=-(nnx*xxdiv)/2.;
  yymin=-(nny*yydiv)/2.;
 
  int i,l=sizeof(pmt.type);
  for (i=0;i<l;i++) pmt.type[i]=' ';
  if (l>strlen(name())) l=strlen(name());
  memcpy(pmt.type,name(),l);
 
  a=ArtePointer<CPMT>::append(pmt);
 
  }


// 
//  print data
//
void PMType::print(FILE* fp) {
  fprintf(fp,"#\n#\n");
  fprintf(fp,"pmtype %s\n",name());
  fprintf(fp,"  numchannel    %d\n",numchannel());
  fprintf(fp,"  numchannel_x  %d\n",numcol());
  fprintf(fp,"  numchannel_y  %d\n",numrow());
  fprintf(fp,"  division_x    %f\n",xxdiv);
  fprintf(fp,"  division_y    %f\n",yydiv);
  fprintf(fp,"#\n");
  fprintf(fp,"#    Table with wavelength dependent detection efficiencies\n");
  fprintf(fp,"#    with intervalls of equal sizeof equal size\n");
  fprintf(fp,"  quantum_efficiency\n");
  eff.print(fp,0);
  fprintf(fp,"  end\n");
  }

PMType::~PMType() {
  if (nname) delete nname;
  }


// =========================================================================
//
//  calculate efficiency and decide if it is detected.
//

int PM::dodetect(int k,const Photon& p) {
  //double eff=efficiency(k)*pmtype->efficiency(p.lambda());
  double eff=pmtype->efficiency(p.lambda());

  //added to take into account the photons cut in GEANT 
  //(see routine richcut.C)

  RICHDetector& rd=*RICH_Detector;
  double maxefficiency=rd.MaxQEfficiency(p.lambda());
  if( eff>maxefficiency) printf("ERROR! efficiency greater than maximum efficiency"); 
  eff=eff/maxefficiency;
  eff*=efficiency(k); //add the channel dependent efficiency

  //end of added code

  int ret=rnd_normal()<eff;
  if (!ret) RICH_Loss.PMTEfficiency()++;
  return ret;
  }  

float& PM::efficiency(int i) {
  if (a->efv0==-1) {
    if (!pmtype) {
      fprintf(stderr,"PM::efficiency: pmtype not initialized. Abort.\n");
      exit(0);
      }
    a->efv0=ArtePointer<CEFF>::nrow()+1;
    CEFF eff;
    int i;
    for (i=0;i<numchannel();i++) ArtePointer<CEFF>::append(eff);
    }
  return ArtePointer<CEFF>(a->efv0+i)->eff;
  }
  
// -------------------------------------------------------------------------
//  initialisation & input/ouput for class pm
//
/*
void PM::serialno(char *s) {
  strncpy(seno,s,sizeof(seno));
  memset(a->seno,' ',sizeof(a->seno));
  strncpy(a->seno,s,sizeof(a->seno));
  }
*/
PM::PM(const ArtePointer<CPMD>& aa,List<PMType>& PMTypeList) : a(aa) {
  char *type=(char*) malloc(sizeof(aa->type)+1);
  memcpy(type,aa->type,sizeof(aa->type));
  type[sizeof(aa->type)-1]='\0';
  
  for (PMTypeList.newiterator();(pmtype=PMTypeList.iterate());) {
    if (!strcmp(pmtype->name(),type)) break;
    }
  free(type);
  if (!pmtype) {
    fprintf(stderr,"class PM: Unknown PMType: %s\n",type);
    exit(0);
    }
  }  
 
PM::PM(ScriptFile& f,List<PMType>& PMTypeList,List<LensSystem>& LensList) {
  CPMD pm;

  int lens=1;
  char n[256],tag[256];
  while (f.getline(n)) {
    char *s=n;
    sscanf(s,"%s",tag);s+=f.itemlength(s,1);
    int err=0;
    if      (!strcmp(tag,"type")){ 
      err=(sscanf(s,"%s",tag)!=1);
      for (PMTypeList.newiterator();(pmtype=PMTypeList.iterate());) {
        if (!strcmp(pmtype->name(),tag)) break;
        }
      if (!pmtype) {
        fprintf(stderr,"class PM: Unknown PMType: %s\n",tag);
        exit(0);
        }
      int len=(strlen(tag)<sizeof(pm.type))?strlen(tag):sizeof(pm.type);
      memset(pm.type,' ',sizeof(pm.type));
      strncpy(pm.type,tag,len);
      }
    else if (!strcmp(tag,"serial_no")) {
      err=(sscanf(s,"%s",tag)!=1);
      int len=(strlen(tag)<sizeof(seno)-1) ? strlen(tag) : sizeof(seno)-1;
      strncpy(seno,tag,len);
      seno[len]='\0';
      /*
      memset(pm.seno,' ',sizeof(pm.seno));
      len=(strlen(tag)<sizeof(pm.seno)) ? strlen(tag) : sizeof(pm.seno);
      memcpy(pm.seno,tag,len);
      */
      }
    else if (!strcmp(tag,"position"))   
      err=(sscanf(s,"%d %d %d",&pm.isup,&pm.irow,&pm.icol)!=3);
    else if (!strcmp(tag,"lenssystem"))   
      err=(sscanf(s,"%d",&lens)!=1);
    else if (!strcmp(tag,"gain_variation")) {  
      int i,j;
      float eff[pmtype->numchannel()];
      for (i=pmtype->numrow()-1;i>=0;i--) {
        f.getline(n);
        char *s=n;
        for (j=pmtype->numcol()-1;j>=0;j--) {
          sscanf(s,"%f",&eff[channelindex(i,j)]);s+=f.itemlength(s,1);
          }
        }
      CEFF e;
      pm.efv0=ArtePointer<CEFF>::nrow()+1;
      for (i=0;i<pmtype->numchannel();i++) {
        e.eff=eff[i];
        ArtePointer<CEFF>::append(e);
        }
      }
    else if (!strcmp(tag,"pm"))  continue;
    else if (!strcmp(tag,"end")) break;
    else {
      fprintf(stderr,
         "PM(ScriptFile):  Unknown tag: %s
         %d\n",tag,err);
      exit(0);
      }
    }   

  for (LensList.newiterator();(ls=LensList.iterate());) {
    if (ls->type()==lens) break;
    }
  a=ArtePointer<CPMD>::append(pm);
  }
 
  
//
//  print data
//
void PM::print(FILE* fp) {
  if (!pmtype) {
    fprintf(stderr,"PM::print: pmtype not set.Abort.\n");
    exit(0);
    }
  fprintf(fp,"#\n pm\n");
  fprintf(fp,"  type      %s\n",pmtype->name());
  fprintf(fp,"  serial_no %s\n",serialno());
  fprintf(fp,"  position  %2d %2d %2d\n",SuperModule(),Row(),Col());
  int lens=0;
  if (ls) lens=ls->type();
  fprintf(fp,"  lenssystem %d\n",lens);
  fprintf(fp,"  gain_variation\n");
  int i,j;
  for (i=pmtype->numrow()-1;i>=0;i--) {
    fprintf(fp,"      ");  
    for (j=pmtype->numcol()-1;j>=0;j--) {
      fprintf(fp,"%5.3f ",efficiency(channelindex(i,j)));  
      }
    fprintf(fp,"\n");
    }
  fprintf(fp,"  end\n");
  }


// ==========================================================================
//
//  LenseSystem
//

LensSystem::LensSystem(ScriptFile& f) {
  char n[256],tag[256];
  id=0;
  while (f.getline(n)) {
    char *s=n;
    sscanf(s,"%s",tag);s+=f.itemlength(s,1);
    int err=0;
    if      (!strcmp(tag,"LensSystem")) continue;  
    else if (!strcmp(tag,"WavelengthEfficiency"))  WaveEff=Table(f);
    else if (!strcmp(tag,"AngularEfficiency")) AngEff=Table(f);
    else if (!strcmp(tag,"type"))       
      err=(sscanf(s,"%d",&id)  !=1);
    else if (!strcmp(tag,"end"))  break;
    else {
      fprintf(stderr,
         "LensSystem(ScriptFile):  Unknown tag: %s
         %d\n",tag,err);
      exit(0);
      }
    }
  }  

//
//  print data
//
void LensSystem::print(FILE* fp) {
  fprintf(fp,"#\n LensSystem\n");
  fprintf(fp,"  type      %d\n",type());
  WaveEff.print(fp,"WavelengthEfficiency");
  AngEff.print(fp,"AngularEfficiency");
  fprintf(fp,"  end\n");
  }


// ==========================================================================
//    
//    get the hit channel 
//

int PhotonDetectorCell::dodetect(const Photon& p,int *id) {
  int k;
//
//
  double x,y;
  if (pm().Collector()&&!pm().Collector()->trace(p,&x,&y)) return 0;
  if ((k=pm().channelindex(x,y))>=0&&pm().dodetect(k,p)) {
    *id=ID(k);
    return 1;
    }
  else if (k<0) RICH_Loss.OutOfPMT()++;
  else return 0;
  } 


Vec3 PhotonDetectorCell::pos(int channel,double costhein,double phiin) {
  Vec3 ret;
  if (pm().Collector()) 
    ret=pm().Collector()->inversetrace(
       pm().type().x(channel),pm().type().y(channel),costhein,phiin);
  else
    ret=Vec3(pm().type().x(channel),pm().type().y(channel),0);
  return ret;
  }
  
PhotonDetectorCell::PhotonDetectorCell(PM* pppm) {
  ppm=pppm; 
  id=new int[pm().numchannel()];
  int i;
  for (i=0;i<pm().numchannel();i++) {
    id[i]=ChannelID(pm().SuperModule(),pm().Row(),pm().Col(),i);
    }
  }
PhotonDetectorCell::~PhotonDetectorCell() { 
  delete id;
  }

//===========================================================================
//
//   determine the cell, which the photon hits: no physics here
//

int PhotonDetectorSuperModule::dodetect(Photon* pp,int *daqid) {
  Photon& p=*pp; // synonym
  double l;
  if (!r.intersection(p,&l)) return -1;
// r.hit() = intersection point in coordinates of "r"
  int row=r.i(r.hit().y());
  int col=r.j(r.hit().x());
  int k=r.index(row,col);
  if (k<0||k>=r.nx()*r.ny()) {
    fprintf(stderr,"RICH: code error in Rectangle\n lasthit: ");
    r.hit().print("%f %f %f\n",stderr);
    fprintf(stderr,"xsize %f ysize %f\n",r.xsize(),r.ysize());
    exit(0);
    }
  if (!pdcell[k]) {
    RICH_Loss.CellEmpty()++;
    return 0;
    }
  else {
    p.x()=r.hit()-Vec3(r.x(col),r.y(row),0);  
    p.n()=r.RotateFromOld(p.n());
    p.polarisation()=r.RotateFromOld(p.polarisation());
//
    return pdcell[k]->dodetect(p,daqid);
    }
  }

Vec3 PhotonDetectorSuperModule::pos(int row,int col,int channel) const {
  if (Cell(row,col)) {
/*
for (int i=0;i<Cell(row,col)->pm().numchannel();i++) { 
  int channel=i;
    printf("%2d %2d %2d ",col,row,channel);
    Cell(row,col)->pos(channel).print();
    Vec3(r.x(col),r.y(row),0).print();
    Vec3 w=(Cell(row,col)->pos(channel)+Vec3(r.x(col),r.y(row),0));
    w.print();
     Vec3 u=
      r.TransformToOld(Cell(row,col)->pos(channel)+Vec3(r.x(col),r.y(row),0));
      u.print();printf("\n");
      }
    getchar();
*/
    return r.TransformToOld(Cell(row,col)->pos(channel)+
                            Vec3(r.x(col),r.y(row),0));
    }
  else return Vec3(-1000,-1000,0);
  }
  
  
// --------------------------------------------------------------------------
//   initialisation and input/output
//

PhotonDetectorSuperModule::PhotonDetectorSuperModule(
     const ArtePointer<CSUP>& aa,List<PM>& PMList) : 
  r(Vec3(aa->x0[0],aa->x0[1],aa->x0[2]),
    Vec3(aa->xvec[0],aa->xvec[1],aa->xvec[2]),
    Vec3(aa->yvec[0],aa->yvec[1],aa->yvec[2]),
    aa->nx,aa->xdiv,aa->ny,aa->ydiv),
   numcell(r.nx()*r.ny()) {

  iid=aa->id;
  pdcell = new  PhotonDetectorCell*[numcell]; 

  int i;
  for (i=0;i<numcell;i++) pdcell[i]=0;
 
  PM* pm;
  for (PMList.newiterator();(pm=PMList.iterate());) {
    if (pm->SuperModule()==aa->id) {
      pdcell[r.index(pm->Row(),pm->Col())]=new PhotonDetectorCell(pm);
      }
    }
  }

void PhotonDetectorSuperModule::print(FILE* fp) {
  fprintf(fp,"#\n#\n supermodule\n");
  fprintf(fp,"  id          %d\n",id());
  fprintf(fp,"  origin      ");r.x0().print("%12f %12f %12f\n",fp);
  fprintf(fp,"  x_vector    ");(r.ex()*r.xsize()).print("%12f %12f %12f\n",fp);
  fprintf(fp,"  y_vector    ");(r.ey()*r.ysize()).print("%12f %12f %12f\n",fp);
  fprintf(fp,"  numcol      %2d\n",r.nx());  
  fprintf(fp,"  coldivision %f\n",r.xdiv());  
  fprintf(fp,"  numrow      %2d\n",r.ny());  
  fprintf(fp,"  rowdivision %f\n",r.ydiv());  
  fprintf(fp,"  end\n");  
  }

PhotonDetectorSuperModule::PhotonDetectorSuperModule(
     ScriptFile& f,List<PM>& PMList) {
  char n[256],tag[256];

  while (f.getline(n)) {
    char *s=n;
    sscanf(s,"%s",tag);s+=f.itemlength(s,1);
    if (RICHdebug) {printf("tag %s %s",tag,n);fflush(stdout);}
    int err=0;
    if      (!strcmp(tag,"supermodule")) continue;  
    else if      (!strcmp(tag,"origin"))   
      err=(sscanf(s,"%lf %lf %lf",&r.x0()[0],&r.x0()[1],&r.x0()[2])!=3);
    else if (!strcmp(tag,"x_vector")) 
      err=(sscanf(s,"%lf %lf %lf",&r.ex()[0],&r.ex()[1],&r.ex()[2])!=3);
    else if (!strcmp(tag,"y_vector"))   
      err=(sscanf(s,"%lf %lf %lf",&r.ey()[0],&r.ey()[1],&r.ey()[2])!=3);
    else if (!strcmp(tag,"numcol"))   
      err=(sscanf(s,"%d",&r.nx())  !=1);
    else if (!strcmp(tag,"coldivision")) 
      err=(sscanf(s,"%lf",&r.xdiv())!=1);
    else if (!strcmp(tag,"numrow"))   
      err=(sscanf(s,"%d",&r.ny())  !=1);
    else if (!strcmp(tag,"rowdivision")) 
      err=(sscanf(s,"%lf",&r.ydiv())!=1);
    else if (!strcmp(tag,"id")) {
      err=(sscanf(s,"%d",&iid)  !=1);
      }
    else if (!strcmp(tag,"end"))  break;
    else {
      fprintf(stderr,
         "PhotonDetectorSuperModule(ScriptFile):  Unknown tag: %s %d\n",tag,err);
      exit(0);
      }
    }   
    
  CSUP sm;
  sm.x0[0]=r.x0().x();
  sm.x0[1]=r.x0().y();
  sm.x0[2]=r.x0().z();
  sm.xvec[0]=r.ex().x();
  sm.xvec[1]=r.ex().y();
  sm.xvec[2]=r.ex().z();
  sm.yvec[0]=r.ey().x();
  sm.yvec[1]=r.ey().y();
  sm.yvec[2]=r.ey().z();
  sm.nx=r.nx();
  sm.xdiv=r.xdiv();
  sm.ny=r.ny();
  sm.ydiv=r.ydiv();
  sm.id=iid;

  ArtePointer<CSUP>::append(sm);

  r=Rectangle(r.x0(),r.ex(),r.ey(),r.nx(),r.xdiv(),r.ny(),r.ydiv());
  
  numcell=sm.nx*sm.ny;  
  pdcell = new  PhotonDetectorCell*[numcell]; 

  int i;
  for (i=0;i<numcell;i++) pdcell[i]=0;
 
  PM* pm;
  for (PMList.newiterator();(pm=PMList.iterate());) {
    if (pm->SuperModule()==sm.id) {
      PhotonDetectorCell* pc=new PhotonDetectorCell(pm);
      pdcell[r.index(pm->Row(),pm->Col())]=pc;
      }
    }
  }

PhotonDetectorSuperModule::~PhotonDetectorSuperModule() {
  delete pdcell;
  }

// ===========================================================================
//
//   determine the supermodule, which the photon hits: no physics here
//

int RICHDetector::dodetect(Photon* p,int*daqid) {
  int k,l;
  if (p->x().y()>0) { 
    k=numsm/4;  
    }
  else { 
    k=(3*numsm)/4; 
    }
  lasthit=-1;
  int ret=0;
  if ((ret=sm[k]->dodetect(p,daqid))>=0) {
    if (ret) lasthit=k;
    }
  else {
    for (l=1;l<=numsm/4;l++) {
      if ((ret=sm[k-l]->dodetect(p,daqid))>=0) {
        if (ret) lasthit=k-l;
        break;
        }
      if ((ret=sm[k+l]->dodetect(p,daqid))>=0) {
        if (ret) lasthit=k+l;
        break;
        }
      }
    }
  if (ret<0) {
    RICH_Loss.OutOfSuperModules()++;
    if (RICHdebug) {printf("Supermodule found? %d %d\n",ret,lasthit);fflush(stdout);}
    return 0;
    }
  else return ret;
  }


void RICHDetector::intersection(const Photon& p,double *path) {
  int k,l;
  if (p.x().y()>0) { 
    k=numsm/4;  
    }
  else { 
    k=(3*numsm)/4; 
    }
  lasthit=-1;
  int ret;
  if (sm[k]->intersection(p,path)) {
    lasthit=k;
    return;
    }
  for (l=1;l<=numsm/4;l++) {
    if (sm[k-l]->intersection(p,path)) {
      lasthit=k-l;
      return;
      }
    if (sm[k+l]->intersection(p,path)) {
      lasthit=k+l;
      return;
      }
    }
  sm[k]->intersection(p,path);
  lasthit=k;
  return;
  }



int RICHDetector::hit_in_acceptance(const Photon& p) {
  int k,l;
  if (p.x().y()>0) { 
    k=numsm/4;  
    }
  else { 
    k=(3*numsm)/4; 
    }
  lasthit=-1;
  int ret=0;
  double ll;
  if ((ret=sm[k]->intersection(p,&ll))) {
    lasthit=k;
    }
  else {
    for (l=1;l<=numsm/4;l++) {
      if ((ret=sm[k-l]->intersection(p,&ll))) {
        lasthit=k-l;
        break;
        }
      if ((ret=sm[k+l]->intersection(p,&ll))) {
        lasthit=k+l;
        break;
        }
      }
    }
  if (ret==0) return 0; // no supermodule is hit
  PhotonDetectorSuperModule& s=*sm[lasthit];
  return (s.Cell(s.hit().x(),s.hit().y())!=0);
  }





void  RICHDetector::NewChannelLoop() {
  s=r=c=maxp=0;p=-1;
  }

int RICHDetector::ChannelLoop() {
  p++;
  if (p==maxp) {
    do {
      if(++c==SuperModule(s).numcol()) {
        if (++r==SuperModule(s).numrow()) {
          if (++s==NumSuperModule()) return 0;
          r=0;
          }
        c=0;
        }
      } while (SuperModule(s).Cell(r,c)==0);
    p=0;
    maxp=SuperModule(s).Cell(r,c)->pm().numchannel();
    }
  return 1;
  }

int RICHDetector::ChannelLoop(int *ss,int *rr,int *cc,int *pp) {
  if (!ChannelLoop()) return 0;
  *ss=s;
  *rr=r;
  *cc=c;
  *pp=p;
  return 1;
  }



double RICHDetector::MaxQEfficiency(double lambda) {
  double qeffmax=0;
  PMType *pmtype;
  for (pmtype_list.newiterator();(pmtype=pmtype_list.iterate());) {
    double e=pmtype->efficiency(lambda);
    if (qeffmax<e) qeffmax=e;
  }
  return qeffmax;

}




double RICHDetector::MaxEfficiency(double lmin,double lmax) {
  double effmax=0.0;
  for (NewChannelLoop();ChannelLoop();) {
    int i;
    for (i=0;i<pm().numchannel();i++) {
      double e=pm().efficiency(i);
      if (e>effmax) effmax=e;
      }
    }
    
  double qeffmax=0;
  PMType *pmtype;
  for (pmtype_list.newiterator();(pmtype=pmtype_list.iterate());) {
    double l;
    for (l=lmin;l<lmax;l+=(lmax-lmin)/100) {
      double e=pmtype->efficiency(l);
      if (qeffmax<e) qeffmax=e;
      }
    }
  qeffmax*=1.05;

/*  
  int s,r,c;
  double leffmax=0;
  for (s=0;s<NumSuperModule();s++) {
    for (r=0;r<SuperModule(s).numrow();r++) {
      for (c=0;c<SuperModule(s).numcol();c++) {
        PhotonDetectorCell* cell=SuperModule(s).Cell(r,c);
        if (cell) {
          double e=cell->MaxCollectionEfficiency(lmin,lmax);
          if (leffmax<e) leffmax=e;
          }
        }
      }
    }
  return qeffmax*effmax*leffmax;
*/
  return 1;
  }
  
// ---------------------------------------------------------------------------
//    
//    initialisation and input/output
//

RICHDetector::RICHDetector(char *path) {
  if (path) {
    char n[256],tag[256];
    strcpy(n,path);
    strcat(n,"pmtype.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile fpmt(n);
    while (fpmt.gettag(n)) {
      if (RICHdebug) printf("%s\n",n);
      if (!strcmp(n,"pmtype")) {
        PMType* p=new PMType(fpmt);
        pmtype_list.append(p);
        }
      else {
        fprintf(stderr,"pmtype.dat: Unknown tag: %s\n",n);
        exit(1);
        }
      }

    strcpy(n,path);
    strcat(n,"lenssystem.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile flens(n);
    while (flens.gettag(n)) {
      if (RICHdebug) printf("%s\n",n);
      if (!strcmp(n,"LensSystem")) {
        flens.skipline(n);
        LensSystem* l=new LensSystem(flens);
        lens_list.append(l);
        }
      else {
        fprintf(stderr,"lens.dat: Unknown tag: %s\n",n);
        exit(1);
        }
      }

    strcpy(n,path);
    strcat(n,"pm.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile fpm(n);
    while (fpm.gettag(n)) {
      if (!strcmp(n,"pm")) {
        fpm.skipline(n);
        PM* p=new PM(fpm,pmtype_list,lens_list);
        pm_list.append(p);     
        }
      else {
        fprintf(stderr,"pm.dat: Unknown tag: %s\n",n);
        exit(1);
        }
      }

    strcpy(n,path);
    strcat(n,"detector.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile fpd(n);
    while (fpd.gettag(n)) {
      if (!strcmp(n,"PhotonDetector")) {
        fpd.skipline(n);
        fpd.getline(n);
        sscanf(n,"%s %d\n",tag,&numsm);
        sm=new PhotonDetectorSuperModule* [numsm];
        int i;
        for (i=0;i<numsm;i++) {
          fpd.getline(n);
          sm[i]=new PhotonDetectorSuperModule(fpd,pm_list);
          }
        }
      else {
        fprintf(stderr,"detector.dat: Unknown tag: %s\n",n);
        exit(1);
        }
      }

    }
  else {  // init from Arte Tables
    int n=ArtePointer<CPMT>::nrow();
    int i;
    for (i=0;i<n;i++) {
      pmtype_list.append(new PMType(ArtePointer<CPMT>(i+1)));
      }
    n=ArtePointer<CPMD>::nrow();
    for (i=0;i<n;i++) {
      pm_list.append(new PM(ArtePointer<CPMD>(i+1),pmtype_list));
      }
    sm=0;
    if (!(numsm=ArtePointer<CSUP>::nrow())) {
      fprintf(stderr,
        "RICHDetector: Arte table CSUP is not yet filled.\n");
      return;
      }
    sm=new PhotonDetectorSuperModule*[numsm];
    for (i=0;i<numsm;i++) {
      sm[i]=new PhotonDetectorSuperModule(ArtePointer<CSUP>(i+1),pm_list);
      }
    }

  if (RICHdebug) {printf("RICH scan fini\n");fflush(stdout);}
  firstCEFFindex=2000000;
  numchannel=0;
  int s,r,c,p;
  for (NewChannelLoop();ChannelLoop(&s,&r,&c,&p);) {
    const int i=ExistingPM(s,r,c).CEFFindex(p);
    if (i<firstCEFFindex) firstCEFFindex=i;
    numchannel++;
    }
  if (RICHdebug) {printf("RICHDetector init ends\n");fflush(stdout);}
  } 

RICHDetector::~RICHDetector() {
  PMType *pmt;
  for (pmtype_list.newiterator();(pmt=pmtype_list.iterate());) delete pmt;
  PM   *pm;
  for (pm_list.newiterator();(pm=pm_list.iterate());) delete pm;
   
  int i;
  for (i=0;i<numsm;i++) delete sm[i];
  if (sm) delete sm;
  }

// ---------------------------------------------------------------------------
//
//  print to ascii files
//

void RICHDetector::print() {
  FILE *fp;  

  if (!(fp=fopen("detector.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: pd.dat\n");
    exit(1);
    }

  int i;
  fprintf(fp,"#\n#\n");
  fprintf(fp,"PhotonDetector\n#\n");
  fprintf(fp,"  NumberOfSuperModules  %d\n",numsm);
  for (i=0;i<numsm;i++) {
    sm[i]->print(fp);
    }
  fclose(fp);


  if (!(fp=fopen("pmtype.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: pm.dat\n");
    exit(1);
    }
  PMType *pmtype;
  for (pmtype_list.newiterator();(pmtype=pmtype_list.iterate());) {
    pmtype->print(fp);
    }  
  fclose(fp);
  if (!(fp=fopen("lenssystem.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: lens.dat\n");
    exit(1);
    }
  LensSystem *ls;
  for (lens_list.newiterator();(ls=lens_list.iterate());) {
    ls->print(fp);
    }  
  fclose(fp);
  if (!(fp=fopen("pm.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: pm.dat\n");
    exit(1);
    }
  PM *pm;
  for (pm_list.newiterator();(pm=pm_list.iterate());) {
    pm->print(fp);
    }  
  fclose(fp);
 
  } 


