
/**********************************************************************/
/*
/* Function richcut
/*
/* Created: November, 1997 by Ignacio Arinyo
/* Changed: June, 1998 by Reinhard Eckmann
/*
/* Called from: ggckov.F
/*
/* Arguments: 
/*      phener   photon energy
/*
/*     returns 1/0 if photons passes the cut or not.
/*      Cut now only takes into account the max Q.E. of the PMT.
/*
/**********************************************************************/




#include "rich/PhotonDetection.h"
#include "rich/vessel.h"

extern "C" {

  //function to cut the number of photons before they are stored as
  //MIMPS to save disk space.

  //The maximum quantum efficiency for this energy of the two PMT types
  //is used. 

  int F77NAME(richcut)(float *phener) {


// R.Eckmann:  avoid segmentation violation on AIX
//    double lambda=197.327*2.*3.141592*pow(10,-18)/ *phener;
    double lambda=double(197.327*2.*3.141592*1e-18)/double(*phener);

    RICHDetector& rd=*RICH_Detector;
    double maxqeff=rd.MaxQEfficiency(lambda);

    return (maxqeff>rnd_normal());
  }

}






