
      SUBROUTINE LNPADD(DMASS, MRES, FS, FB, A, B,
     +                  LNP, D1LNP ,D2LNP)

************************************************************************
*
* Created: October 1997 by Ignacio Arinyo
*
* Description: Auxiliary routine of ricrec.F to compute likelihoods
*
* Called from: ricrec.F
*
* Arguments: 
*  IN      DMASS    DIfference sqared between the mass hypothesis and
*                   the mass that would correspond to a particluar photon.  
*  IN      MRES     Resolution in mass
*  IN      FS       Fraction of signal
*  IN      FB       Fraction of background
*  IN      A        Background parameter
*  IN      B        Background parameter
*  OUT     LNP      Log likelihood
*  OUT     D1LNP    First derivative of log likelihood
*  OUT     D2LNP    Second derivative of log likelihood
*
************************************************************************


      IMPLICIT NONE

#include "arte/Arte.fi"

      REAL*4  DMASS, MRES, FS, FB, A, B, LNP, D1LNP, D2LNP
      REAL*4  PADD, SQ2PI, XI

#include "arte/Arte.ff"


      DATA SQ2PI /0.3989422/

      XI   = DMASS/MRES
      PADD =   FS * SQ2PI * EXP(-0.5*XI**2)+FB * (A*XI+B)


      LNP   = LNP   - LOG(PADD)
      D1LNP = D1LNP +  FB*XI/PADD
      D2LNP = D2LNP - (FB*XI/PADD)**2

900   END






