*CMZ :          08/09/96  15.24.07  by   Ivan Belyaev
*-- Author :     Ivan Belyaev   08/09/96

      SUBROUTINE SKASPAS

************************************************************************
*
* Description: Create/Modify the SPAS/SSEE Arte Tables for SUSi
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"

      CHARACTER*78  CHPATL
      INTEGER       NSEEDS , ISEEDS , MAX_SEEDS
      PARAMETER(    MAX_SEEDS=100)
      INTEGER       SEED( MAX_SEEDS , 4 )
      INTEGER       IPL1,IPL2,IPL3,IPL4,NPAR,I
      LOGICAL       LFIRST
      SAVE          LFIRST , NSEEDS
      DATA          LFIRST /.TRUE./
      DATA          NSEEDS / 0 /
      DATA          ISEEDS / 0 /

#include "arte/Arte.ff"
#include "auto/SI.ff"

      IF( LFIRST )THEN
       IF( JSUSI .NE. 0 )THEN
        IF( JSPAS .NE. 0 .OR. JSSEE .NE. 0) THEN
         C78='SUSi==>Warning! Arte Tables SPAS/SSEE exist'
         CALL MEMESC(3487591,1,ILARGEST,C78(1:LEN(C78)))
        ENDIF
        IF( JSPAS .NE. 0 )CALL MMDROP(JSPAS)
        IF( JSSEE .NE. 0 )CALL MMDROP(JSSEE)
        IF( JSPSS .NE. 0 )CALL MMDROP(JSPSS)
       ELSE
        CALL MMBOOK(JSUSI,1)
       ENDIF
       CALL MMBOOK(JSPAS,0)
       CALL MMBOOK(JSSEE,0)
       LFIRST = .FALSE.
      ENDIF

      CALL KUPATL(CHPATL,NPAR)

      IF(    CHPATL(1:LEN(CHPATL)) .EQ. 'PASS' )THEN
       IF( ISEEDS .NE. NSEEDS )THEN
        C78='SUSi==> Not proper number of Commands SEED !'
        CALL MEMESC(47102,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       ENDIF
       IF( NSPAS() .GE. N_MAXPASS )THEN
        C78='SUSi==> Command PASS should be used not more'
        CALL CH78BI( N_MAXPASS )
        CALL MEMESC(978404792,ILARGEST,ILARGEST,C78(1:LEN(C78)))
        NSEEDS = 0
        RETURN
       ENDIF
       CALL KUGETI( NSEEDS )
       CALL MMBOOK(JSPAS,1)
       IF( NSEEDS .LE. 0 )THEN
        C78='SUSi==> NSEEDS for PASS='
        CALL CH78AI( NSPAS() )
        CALL CH78BC( 'is equal' )
        CALL CH78AI( NSEEDS )
        CALL MEMESC(470124,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       ELSEIF( NSEEDS .GT. MAX_SEEDS )THEN
        C78='SUSi==> NSEEDS for PASS='
        CALL CH78AI( NSPAS() )
        CALL CH78BC( 'is equal' )
        CALL CH78AI( NSEEDS )
        CALL CH78AC( '. Set to be' )
        NSEEDS = MAX_SEEDS
        CALL CH78BI( NSEEDS )
        CALL MEMESC(471114,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       ENDIF
       ISEEDS = 0
      ELSEIF( CHPATL(1:LEN(CHPATL)).EQ. 'SUSISEED' )THEN
       IF( NSPAS() .LE. 0)THEN
        C78='SUSi==> Command SEED is allowed only after command PASS'
        CALL MEMESC(48928,ILARGEST,ILARGEST,C78(1:LEN(C78)))
        RETURN
       ENDIF
       IF( NPAR .NE. 4 )THEN
        C78='SUSi==>Command SEED requests exactly 4 arguments!'
        CALL MEMESC(82479,ILARGEST,ILARGEST,C78(1:LEN(C78)))
        RETURN
       ENDIF
       CALL KUGETI( IPL1 )
       IF( IPL1 .LE. 0 .OR. IPL1 .GT. N_TOTSIPL )THEN
        C78='SUSi==> SEED Error! Wrong 1st plate number'
        CALL CH78BI( IPL1 )
        CALL MEMESC(432875037,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       ENDIF
       CALL KUGETI( IPL2 )
       IF( IPL2 .LE. 0 .OR. IPL2 .GT. N_TOTSIPL )THEN
        C78='SUSi==> SEED Error! Wrong 2nd plate number'
        CALL CH78BI( IPL1 )
        CALL MEMESC(43237,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       ENDIF
       CALL KUGETI( IPL3 )
       IF( IPL3 .LE. 0 .OR. IPL1 .GT. N_TOTSIPL )THEN
        C78='SUSi==> SEED Error! Wrong 3rd plate number'
        CALL CH78BI( IPL1 )
        CALL MEMESC(4328,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       ENDIF
       CALL KUGETI( IPL4 )
       IF( IPL4 .LE. 0 .OR. IPL4 .GT. N_TOTSIPL )THEN
        C78='SUSi==> SEED Error! Wrong 4th plate number'
        CALL CH78BI( IPL1 )
        CALL MEMESC(43287503,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       ENDIF
       IF( ISEEDS .LT. NSEEDS )THEN
        ISEEDS = ISEEDS + 1
        SEED( ISEEDS , 1 ) = IPL1
        SEED( ISEEDS , 2 ) = IPL2
        SEED( ISEEDS , 3 ) = IPL3
        SEED( ISEEDS , 4 ) = IPL4
       ENDIF
       IF( ISEEDS .EQ. NSEEDS ) THEN
        DO I = 1 , NSEEDS
         CALL MMBOOK(JSSEE,1)
         IQ(IQSSEE_PLN1_L()) = SEED( NSEEDS -I +1 , 1 )
         IQ(IQSSEE_PLN2_L()) = SEED( NSEEDS -I +1 , 2 )
         IQ(IQSSEE_PLN3_L()) = SEED( NSEEDS -I +1 , 3 )
         IQ(IQSSEE_PLN4_L()) = SEED( NSEEDS -I +1 , 4 )
         CALL MMBREL(JSPSS,NSPAS(),NSSEE())
        ENDDO
       ENDIF
      ELSE
       C78='SUSi==>PASS ! Unknown command:'
       CALL CH78BC( CHPATL(1:LEN(CHPATL)))
       CALL MEMESC(34897,ILARGEST,ILARGEST,C78(1:LEN(C78)))
      ENDIF




      END

************************************************************************
* End of KASPAS
************************************************************************
