*CMZ :  1.00/01 11/07/96  16.22.48  by   Ivan Belyaev
*CMZ :  1.04/06 14/06/95  18.13.57  by  joerg f. rieling
*CMZ :  1.04/05 31/05/95  16.49.22  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.51.11  by  joerg f. rieling
*-- Author :
c-----------------------------------------------------------------------
c
      subroutine sklmfil (p, C, m, co, si, sig, p_fil, C_fil, dchi2)
c
c     -- adds a measured coordinate to a state vector
c     -- p with cov matrix C. Track model: linear, 3d.
c
c     -- input  : p     : old param. vector at plane of measurement
c     --          C     : old cov matrix       --          m     : measured coordinate (=distance from x/y-origo)
c     --          co    : cosine of stereo angle
c     --          si    : sine   
c     -- output : p_fil : filtered param. vector
c     --          C_fil : filtered cov. matrix
c     --          dchi2 : increase in chi^2
c
c-----------------------------------------------------------------------

      implicit none


#include "arte/Arte.fi"

c     --- formal param. / local var.
      real p(4), C(4, 4), m, co, si, sig, p_fil(4), C_fil(4, 4), dchi2
      real invfctr, K(4)         ! K is gain matrix
      real rr, R                 ! rr is updatet res, R the cov matrix
      real cc, ss, cs            ! cos*2, sin*2, sincos of rho
      real help, mhelp(4, 2)
      real C_fil_inv(4,4)
      integer i,j,ifail
      REAL     AAA
      INTEGER  LENOCC 
      EXTERNAL LENOCC
      data mhelp / 0., 0.,
     &             0., 0.,
     &             0., 0.,
     &             0., 0. /


#include "arte/Arte.ff"

c     --- init
      cs = co * si
      cc = co * co
      ss = si * si

c     --- calculate factor [V + H C H^T]^-1
      invfctr = 1./ (sig * sig +
     &        ( C(1,1)*cc - 2*C(1,2)*cs + C(2,2)*ss ))

c     --- calculate gain matrix
      K(1) = invfctr * ( C(1,1)*co - C(2,1)*si )
      K(2) = invfctr * ( C(1,2)*co - C(2,2)*si )
      K(3) = invfctr * ( C(1,3)*co - C(2,3)*si )
      K(4) = invfctr * ( C(1,4)*co - C(2,4)*si )

c     --- filter parameter vector
      help     = m - co * p(1) + si * p(2) ! calc. m - H p
      p_fil(1) = p(1) + K(1)*help
      p_fil(2) = p(2) + K(2)*help
      p_fil(3) = p(3) + K(3)*help
      p_fil(4) = p(4) + K(4)*help

c     --- filter cov matrix
      mhelp(1,1) = 1 - K(1) * co
      mhelp(1,2) =  K(1) * si
      mhelp(2,1) = -K(2) * co
      mhelp(2,2) = 1 + K(2) * si
      mhelp(3,1) = -K(3) * co
      mhelp(3,2) =  K(3) * si
      mhelp(4,1) = -K(4) * co
      mhelp(4,2) =  K(4) * si
      C_fil(1,1) = mhelp(1,1)*C(1,1) + mhelp(1,2)*C(1,2)
      C_fil(2,1) = mhelp(1,1)*C(2,1) + mhelp(1,2)*C(2,2)
      C_fil(3,1) = mhelp(1,1)*C(3,1) + mhelp(1,2)*C(3,2)
      C_fil(4,1) = mhelp(1,1)*C(4,1) + mhelp(1,2)*C(4,2)
      C_fil(1,2) = mhelp(2,1)*C(1,1) + mhelp(2,2)*C(1,2)
      C_fil(2,2) = mhelp(2,1)*C(2,1) + mhelp(2,2)*C(2,2)
      C_fil(3,2) = mhelp(2,1)*C(3,1) + mhelp(2,2)*C(3,2)
      C_fil(4,2) = mhelp(2,1)*C(4,1) + mhelp(2,2)*C(4,2)
      C_fil(1,3) = mhelp(3,1)*C(1,1) + mhelp(3,2)*C(1,2) +
     &             C(1,3)
      C_fil(2,3) = mhelp(3,1)*C(2,1) + mhelp(3,2)*C(2,2) +
     &             C(2,3)
      C_fil(3,3) = mhelp(3,1)*C(3,1) + mhelp(3,2)*C(3,2) +
     &             C(3,3)
      C_fil(4,3) = mhelp(3,1)*C(4,1) + mhelp(3,2)*C(4,2) +
     &             C(4,3)
      C_fil(1,4) = mhelp(4,1)*C(1,1) + mhelp(4,2)*C(1,2) +
     &             C(1,4)
      C_fil(2,4) = mhelp(4,1)*C(2,1) + mhelp(4,2)*C(2,2) +
     &             C(2,4)
      C_fil(3,4) = mhelp(4,1)*C(3,1) + mhelp(4,2)*C(3,2) +
     &             C(3,4)
      C_fil(4,4) = mhelp(4,1)*C(4,1) + mhelp(4,2)*C(4,2) +
     &             C(4,4)

c     --- calculate Chi^2 increment
      r     =  m - co * p_fil(1) + si * p_fil(2)

c      RR    = (1.0 - co * K(1) + si * K(2)) * sig*sig

      AAA   =  C(1,1)*cc-2.0*C(1,2)*cs+C(2,2)*ss
      IF( AAA .LE. 0 )THEN
       C78='SKLMFIL,matrix is not pos-defined!' 
       CALL MEMESC(912743987,1,ILARGEST,C78(1:LENOCC(C78)))
       AAA = ABS(AAA)      
      ENDIF 
      RR    = (sig*sig)**2/(sig*sig+AAA)

      IF( ABS( RR ) .GE. 1.E-25 )THEN
       dchi2 = r*r / RR
      ELSE 
       dchi2 = 0.0 
      ENDIF 

      return
      end
