*CMZ :  1.04/06 14/06/95  10.38.00  by  joerg f. rieling
*CMZ :  1.04/05 26/05/95  00.02.35  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.51.11  by  joerg f. rieling
*-- Author :

c--------------------------------------------------------------
c
      subroutine sklmpre (p, C, dzZ, p_pre, C_pre)
c
c     -- swims parameter vector p and covariance matrix C
c     -- through a given z distance dz.
c     -- The m.s. contribution at the original z position
c     -- is added.
c
c     -- input:  p     = original parameter vector
c     --         C     =    "     cov matrix
c     --         dz    = z-distance to swim through
c     -- output: p_pre = predicted paramter vector
c     --         C_pre =     "     cov matrix
c
c---------------------------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/SI.fi"

c     --- formal param/local var
      real p(4), C(4, 4), dz, p_pre(4), C_pre(4, 4)
      real mhelp (4, 2) , dzz 
      INTEGER I1,I2 
      real        T2
      parameter ( T2 = 0.0000012 ) ! mean ms angle^2 for p ~= 1 GeV

      REAL PMIN2 
     
#include "arte/Arte.ff"
#include "auto/SI.ff"


      DZ = DZZ 
      
      IF( DZ .EQ. 0.0 )THEN
C*     copy the input data into output 
       DO i1=1,4
        P_pre(i1)=P(i1)
        DO i2=1,4
        C_pre(i1,i2)=C(i1,i2)
        ENDDO 
       ENDDO 
       RETURN
      ENDIF 

c     --- swim p
      p_pre(1) = p(1)+dz*p(3)
      p_pre(2) = p(2)+dz*p(4)
      p_pre(3) = p(3)
      p_pre(4) = p(4)

c     --- swim cov matrix = F C F^T
c     -   mhelp = C F^T
      mhelp(1,1)=C(1,1)+C(3,1)*dz
      mhelp(1,2)=C(2,1)+C(4,1)*dz

      mhelp(2,1)=C(1,2)+C(3,2)*dz
      mhelp(2,2)=C(2,2)+C(4,2)*dz

      mhelp(3,1)=C(1,3)+C(3,3)*dz
      mhelp(3,2)=C(2,3)+C(4,3)*dz

      mhelp(4,1)=C(1,4)+C(3,4)*dz
      mhelp(4,2)=C(2,4)+C(4,4)*dz

c     -   C = F mhelp
      C_pre(1,1) = mhelp(1,1)+
     &             dz*mhelp(3,1)
      C_pre(2,1) = mhelp(1,2)+
     &             dz*mhelp(3,2)
      C_pre(1,2) = C_pre(2,1)
      C_pre(3,1) = C(3,1)+
     &             dz*C(3,3)
      C_pre(1,3) = C_pre(3,1)
      C_pre(4,1) = C(4,1)+
     &             dz*C(4,3)
      C_pre(1,4) = C_pre(4,1)

      C_pre(2,2) = mhelp(2,2)+
     &             dz*mhelp(4,2)
      C_pre(3,2) = C(3,2)+
     &             dz*C(3,4)
      C_pre(2,3) = C_pre(3,2)
      C_pre(4,2) = C(4,2)+
     &             dz*C(4,4)
      C_pre(2,4) = C_pre(4,2)

      C_pre(3,3) = C(3,3)
      C_pre(4,3) = C(4,3)
      C_pre(3,4) = C_pre(4,3)

      C_pre(4,4) = C(4,4)

c     --- add ms contribution (from orig. z)
c      p_ass = whatever
c      p_ass = T2 / (p_ass*p_ass) ! =(mean ms angle)**2
c      p_ass is now mean ms angle for a particle with 1GeV,
c      add this to c_pre (3,3), (4,4).


      PMIN2 = FSPAR_PMIN(NSPAR())**2
      IF( PMIN2 .NE. 0)THEN
       C_pre (3,3) = C_pre (3,3) + T2/PMIN2
       C_pre (4,4) = C_pre (4,4) + T2/PMIN2
      ENDIF 

      return
      end

