*CMZ :          16/08/96  12.58.23  by   Ivan Belyaev
*CMZ :  1.00/01 03/08/96  20.16.43  by   Ivan Belyaev
*CMZ :  1.04/11 18/12/95  09.24.56  by  joerg f. rieling
*CMZ :  1.04/10 23/11/95  15.04.41  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  11.38.11  by  joerg f. rieling
*CMZ :  1.04/07 23/08/95  12.03.41  by  joerg f. rieling
*CMZ :  1.04/06 14/06/95  18.44.40  by  joerg f. rieling
*CMZ :  1.04/05 29/05/95  17.06.53  by  joerg f. rieling
*CMZ :  1.04/04 23/05/95  17.47.25  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.50.56  by  joerg f. rieling
*-- Author :

c     ---------------------------------------------------------
      subroutine smcass
c
c     -- tests if the active tracks in ZSIRCTRK are "the
c     -- same" as a certain mc track or if they are ghosts:
c     -- fills the array rc_mc in ZSIRCTRK,
c     -- does the performance bookkeeping and fills hists.
c
c     ---------------------------------------------------------

      implicit  none

c     --- common blocks

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/EV.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsiprtrk.fi"
#include "susi/zsigeo.fi"
#include "susi/zsihitmark.fi"
        
      INTEGER i,iPR,iSHRC,iHITB,iMIMP,iMTRA,jAUX,jAUX1
      INTEGER iMC,nMC,iTMP
      INTEGER NT_REC,NT_PRO,NT_EXT,NT_GHO
      REAL    E_PRO, E_EXT, E_GHO
      REAL    EM_PRO,EM_EXT,EM_GHO
      SAVE    EM_PRO,EM_EXT,EM_GHO

      INTEGER  LENOCC
      EXTERNAL LENOCC 

#include "susi/zsimtrx44.fi"

      DATA    EM_PRO / 0.0 /       
      DATA    EM_EXT / 0.0 /       
      DATA    EM_GHO / 0.0 /

c     --- statement functions

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/EV.ff"
#include "auto/SI.ff"
#include "susi/zsihitmark.ff"


      IF( JMCIN .LE. 0 )RETURN 

C*    First Loop: Fill MTRA & PERC fields in STRC 

C*    Book the working space for MTRA indicies 
      CALL MMBWRK(JTEMP,100,2,10)
      IQ(JTEMP+2)=0
      
      DO i=1,NSTRC()
       IF( ISTRC_AC(i) .NE. 0 )THEN
C*      reset the working space
        DO iTMP = 1 , N_U( JTEMP ) 
         IQ(L_A(1,iTMP,JTEMP))=0
         IQ(L_A(2,iTMP,JTEMP))=0
        ENDDO 
        IQ(JTEMP+2)=0

        jAUX = PSTRC_SHRC( i )
        DO WHILE( jAUX .NE. 0 )
         iSHRC = MSTRC_SHRC( jAUX  ) 
         iHITB = ISHRC_HITB( iSHRC )
         IF( iHITB .LE. 0 .OR. 
     &       iHITB .GT. NHITB() )THEN
          C78='SUSi warning! Wrong HITB='
          CALL CH78AI(iHITB)
          CALL MEMESC(224373,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
          IQ(IQSTRC_AC(i))=0
          GO TO 50 
         ENDIF 
         jAUX1 = PHITB_MIMP( iHITB ) 
         DO WHILE( jAUX1 .NE. 0 )
          iMIMP = MHITB_MIMP( jAUX1 ) 
          IF( iMIMP .LE. 0 .OR. 
     &        iMIMP .GT. NMIMP() )THEN
           GO TO 50 
          ENDIF 
          iMTRA = OMIMP_MTRA( iMIMP ) 
          IF( iMTRA .LE. 0 .OR. 
     &        iMTRA .GT. NMTRA() )THEN
           C78='SUSi warning! Wrong MTRA='
           CALL CH78AI(iMTRA)
           CALL CH78BC( 'for MIMP=' )
           CALL CH78AI(iMIMP)
           CALL CH78BC( 'for HITB=' )
           CALL CH78AI(iHITB)
           CALL MEMESC(20357203,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
           IQ(IQSTRC_AC(i))=0
           GO TO 50 
          ENDIF  
          DO iTMP=1,N_U(JTEMP)
           IF( I_V(1,iTMP,JTEMP) .EQ. iMTRA)THEN
            IQ(L_A(2,iTMP,JTEMP)) = 
     &         I_V(2,iTMP,JTEMP) + 1
            GO TO 10 
           ENDIF   
          ENDDO 
          CALL MMBOOK(JTEMP,1)
          IQ(L_A(1,N_U(JTEMP),JTEMP)) = iMTRA
          IQ(L_A(2,N_U(JTEMP),JTEMP)) = 1
 10       CONTINUE
          jAUX1 = XHITB_MIMP( jAUX1 )  
         ENDDO  
         jAUX  = XSTRC_SHRC( jAUX  ) 
        ENDDO   
C*      Now we have a list of all MC-particles assosiated with 
C*      this track
C*      Find the most frequent MC-particle
        IF(N_U(JTEMP).EQ.0)THEN
         iMC = 0 
         nMC = 0
         IQ(IQSTRC_AC(i))=0
         C78='SUSi warning! No MC information is found!'
         CALL MEMESC(572253,ILARGEST,iLARGEST,C78(1:LENOCC(C78)))
         GO TO 50  
        ENDIF 
        iMC = I_V(1,1,JTEMP)
        nMC = I_V(2,1,JTEMP)
        DO iTMP=1,N_U(JTEMP)
         IF(    I_V(2,iTMP,JTEMP).GT. nMC)THEN
          iMC = I_V(1,iTMP,JTEMP)
          nMC = I_V(2,iTMP,JTEMP)
         ENDIF 
        ENDDO 
C*      iMC - the most frequent MTRA, nMC - number of HITS
        IF( iMC .LE. 0 .OR. iMC .GT. NMTRA() 
     &          .OR.        nMC .EQ. 0 )THEN
         C78='SUSi Error! SMCASS, iMC='
         CALL CH78AI( iMC  )
         CALL CH78CC('nMC=')
         CALL CH78AI( nMC  ) 
         CALL CH78CC( 'skip #=' ) 
         CALL CH78AI( i ) 
         CALL MEMESC(92748,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
         GO TO 50 
        ENDIF  
C*      Fill PERC & MTRA field for STRC        
        IQ(IQSTRC_MTRA(i)) = iMC 
        IQ(IQSTRC_PERC(i)) = 
     &   INT( 100.0*FLOAT(nMC)/FLOAT(ISTRC_NHIT(i)) )
        IF( FLOAT(ISTRC_PERC(i))/100.0 .LE. 
     &            FSPAR_PERC(NSPAR()) )THEN
C*       "Ghost"
         IQ(IQSTRC_MTRA(i))=0 
        ENDIF 
 50     CONTINUE
       ENDIF 
      ENDDO

C*    Drop the working space
      CALL MMDROP(JTEMP)

      RETURN
      END





