*CMZ :  1.00/01 02/08/96  20.56.44  by   Ivan Belyaev
*CMZ :  1.04/11 18/12/95  14.55.48  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.37.22  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  11.17.05  by  joerg f. rieling
*-- Author :

c     -----------------------------------------------------------------

      SUBROUTINE SPROPSEED (spl1, spl2, spl3, spl4,
     &                       h1  , h2  , h3  , h4  ,
     &                       n_pass    , n_seed)

c     --         * * main tracking routine for the silicon * *
c     --
c     -- Gets  the   theoretically  last   hit  plane for a seed given
c     -- by the actual  parameters.
c     -- Then starts to look for the possible track by collecting hits
c     -- that lie in Kalman - ROIs;  if necessary, the track is FORKed
c     -- into a  couple of  candidates and each is  tracked separately.

c     -----------------------------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"

c     --- external functions / subroutines
      LOGICAL  INPLANE2 
      REAL     STRKQUAL 
      INTEGER  LENOCC 
      EXTERNAL INPLANE2 
      EXTERNAL STRKQUAL 
      EXTERNAL LENOCC 

c     --- common blocks

#include "susi/zsinavi.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsigeo.fi"

c     --- formal parameters
      INTEGER spl1, spl2, spl3, spl4    ! seeding plane numbers
      INTEGER h1  , h2  , h3  , h4      ! pointers in hit bank
      INTEGER n_pass    , n_seed        ! obvious

c     --- local CONSTANT array
      INTEGER D_TO_LASTPL (N_MAXPASS)   ! help field to find last plane
      REAL    M(4)                      ! local coo. in seeds


      REAL    p0  ( 4 ) , x_ex( 2 ) 
      REAL    Ppre( 4 ) , Cpre( 4 , 4 ) 
      REAL    MHITTOL( MAXFORK ),MEAS(MAXFORK+20)      
      REAL    dchi2,DZ,quality,best_quality

      INTEGER LP,NPL ,NHIT,NHITTOL,i,iCAND,iiCAND,iOLDCAND,pl_AKT
      INTEGER NNPL,iAUX,jAUX,Lay,iTMP,iSHCA,best_track
      INTEGER IHIT(MAXFORK+20)
      INTEGER IMIS(MAXFORK+20)
      INTEGER PLAN(MAXFORK+20)   
      INTEGER HITTOL( MAXFORK ) 

      LOGICAL TRACK_FOUND 
c     labels
      INTEGER end_cand_loop, start_plane_loop

#include "susi/zsimtrx44.fi"

c     --- data statements
      data  D_TO_LASTPL / 4, 0, 4 / ! help field to find last pl
c     --- common def''s / statement functions

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/SI.ff"
#include "susi/zsigeo.ff"

c     --- label assignments
      ASSIGN 10 TO END_CAND_LOOP
      ASSIGN 20 TO START_PLANE_LOOP

c     -- setup of local var

      M(1) = FHITB_X ( H1 )
      M(2) = FHITB_X ( H2 )
      M(3) = FHITB_X ( H3 )
      M(4) = FHITB_X ( H4 )

c     -- calculate p_0...
      CALL SSEEBLD4 (n_pass, n_seed, m, p0)
      IF( ABS(p0(1)) .GT. TARGET_WINDOW .OR.
     &    ABS(p0(2)) .GT. TARGET_WINDOW) RETURN

c     -- ... and find last plane in seeding arm
      do lp=spl1+D_TO_LASTPL(n_pass), spl1, -2
	x_ex(1) = p0(1) + p0(3)*plz(lp)
	x_ex(2) = p0(2) + p0(4)*plz(lp)
	if (inplane2(plxmi(lp), plxma(lp), plymi(lp),
     &                 plyma(lp), x_ex)) goto 30
      end do ! lp
 30   continue ! lp now contains last hit plane, x_ex hit point


C*
C*    These routine is called a lot of times per event
C*    therefore calling MMDROP and MMBOOK will waste a lot 
C*    of CPU times. Try not to drop the tables.
C*    Try to clean the tables. Faster???
C*    Also instead of Relation STCA <--> SHCA 
C*    use only Hit list in STCA, faster
C*    Also for the speed purposed do not call MMBOOK
C*    MMBOOK performs a lot of checks and therefore waste 
C*    a lot of CPU time.
C* 

      IF( JSTCA .LE. 0 )CALL MMBOOK(JSTCA,1)
      IF( JSHCA .LE. 0 )CALL MMBOOK(JSHCA,1)

C*    Check the table sizes 
      IF( N_F(JSTCA)+N_U(JSTCA) .GT.  100)THEN
       CALL MMDROP( JSTCA     )
       CALL MMDROP( JSHCA     )
       CALL MMBOOK( JSTCA , 1 )
       CALL MMBOOK( JSHCA , 1 )
      ENDIF 

C*    Check the table sizes 
      IF( N_F(JSHCA)+N_U(JSHCA) .GT. 2000)THEN
       CALL MMDROP( JSTCA     )
       CALL MMBOOK( JSTCA , 1 )
       CALL MMDROP( JSHCA     )
       CALL MMBOOK( JSHCA , 1 )
      ENDIF 

C*    Clear the tables 
      DO i1   = 1 ,  NSTCA()
       DO i2  = 1 , NCSTCA()        
        IQ(L_A(i2,i1,JSTCA)) = 0 ! remove the contents 
       ENDDO 
      ENDDO 


C*    Clear the tables 
      DO i1   = 1 ,  NSHCA()
       DO i2  = 1 , NCSHCA()        
        IQ(L_A(i2,i1,JSHCA)) = 0 ! remove the contents 
       ENDDO 
      ENDDO 
C*    Reset counters 
      IQ( JSTCA + 2 ) = 0        ! reset counters 
      IQ( JSHCA + 2 ) = 0        ! reset counters  

      iOLDCAND = NSTCA()


c     -- treat 1st plane exclusively to make 1st hit:
     
      IF( LP .EQ. SPL1 )THEN      ! Seeding plane
C*     In seeding Plane - only Seeding hits! 
        NHIT      = 1 
        IHIT( 1 ) = H1
        MEAS( 1 ) = M( 1 ) 
        IMIS( 1 ) = 0 
        PLAN( 1 ) = LP 
      ELSE
C*     Get hits from the plane 
        CALL SGETHIT3(x_ex,lp,lp,nhittol,hittol,mhittol)
        IF( nhittol .EQ. 0 )THEN 
C*      No hits!
         NHIT = 1 
         IHIT( 1 ) = 0 
         MEAS( 1 ) = 0.0
         IMIS( 1 ) = 1 
         PLAN( 1 ) = LP   
        ELSE 
C*      Hits!
         NHIT = NHITTOL 
         DO i1 = 1 , NHIT 
          IHIT( i1 ) =  HITTOL( i1 ) 
          MEAS( i1 ) = MHITTOL( i1 )
          IMIS( i1 ) = 0 
          PLAN( i1 ) = lp  
         ENDDO 
       ENDIF
      ENDIF 

C*    Create and initialise the Candidates 
      Ppre( 1 ) = x_ex( 1 )
      Ppre( 2 ) = x_ex( 2 )
      Ppre( 3 ) = p0  ( 3 )
      Ppre( 4 ) = p0  ( 4 )
      DO i1 = 1, 4 
       DO i2 = 1 , 4 
        Cpre( i1 , i2 ) = 0.0 
       ENDDO 
      ENDDO 
      Cpre( 1 , 1 ) = 0.100 
      Cpre( 2 , 2 ) = 0.100 
      Cpre( 3 , 3 ) = 0.001 
      Cpre( 4 , 4 ) = 0.001 

      DO i = 1 , NHIT
C*     Create Candidate
C*     Faster than MMBOOK   
       IF( N_F(JSTCA) .GE. 1 )THEN
        IQ( JSTCA + 2 ) = IQ( JSTCA + 2 ) + 1
       ELSE 
        CALL MMBOOK(JSTCA,1)
       ENDIF 
C*     Fill Candidate
       IF(IMIS(i).NE.0)IQ(IQSTCA_NMIS_L())=1
       IF(IMIS(i).NE.0)IQ(IQSTCA_N2MI_L())=1
       IF(IHIT(i).NE.0)IQ(IQSTCA_NHIT_L())=1
       IF(LP.EQ.SPL1  )IQ(IQSTCA_HSPL_L())=1
       IQ(IQSTCA_LPLX_L()) = LP
       IQ(IQSTCA_LPLY_L()) = LP
       IQ(IQSTCA_PLAN_L()) = LP
       IQ(IQSTCA_AC_L  ()) = 1
        Q( QSTCA_CHI2_L()) = 0.0
       IF(IHIT(i).NE.0)THEN
C*      Filter 
        CALL SKLMFIL( Ppre , Cpre , MEAS( i ) , 
     &     plcsr( LP ) , plsnr( LP ) , 0.0012   , 
     &     Q( QSTCA_P_L(1)) ,   ! Pout 
     &     Q( QSTCA_C_L(1)) ,   ! Cout 
     &     dchi2 )               
         Q( QSTCA_CHI2_L()) = dchi2
C*      Create "Hits" 
        IF(N_F(JSHCA).GE.1)THEN
         IQ( JSHCA + 2 ) = IQ( JSHCA + 2 ) + 1
        ELSE 
         CALL MMBOOK(JSHCA,1)
        ENDIF
C*      Fill it!
        IQ(IQSHCA_HITB_L())=IHIT(i)
        IQ(IQSHCA_PLAN_L())=LP
         Q( QSHCA_MEAS_L())=MEAS(i)
         Q( QSHCA_DCHI_L())=dchi2
        DO i1 = 1 , 4 
          Q( QSHCA_P_L(i1))=FSTCA_P(i1,NSTCA())
         DO i2 = 1 , 4 
           Q( QSHCA_C_L(MMMM(i1,i2)))=FSTCA_C(MMMM(i1,i2),NSTCA())
         ENDDO 
        ENDDO 
C*      Relation STCA<-->SHCA 
        IQ(IQSTCA_HILI_L(1))=NSHCA() 
       ELSE 
        DO i1 = 1 , 4 
          Q( QSTCA_P_L(i1))=Ppre(i1)
         DO i2 = 1 , 4 
          Q( QSTCA_C_L(MMMM(i1,i2)))=Cpre(i1,i2)
         ENDDO 
        ENDDO  
       ENDIF        
      ENDDO 

      iCAND = iOLDCAND 
      DO WHILE( iCAND .LT. NSTCA() )
       iCAND  = iCAND + 1 
       pl_akt = ISTCA_PLAN(iCAND)      ! Last processed plane 
 20    CONTINUE                        ! START_PLANE_LOOP 
       NNPL = ISNAV_NPLA( pl_akt )  
       IF( NNPL .EQ. 0 )THEN 
        IF( ISTCA_HSPL(iCAND) .GE. 4 )THEN
         IQ(IQSTCA_AC(iCAND))=2
        ELSE
         IQ(IQSTCA_AC(iCAND))=0
        ENDIF 
        GO TO END_CAND_LOOP
       ENDIF 
       jAUX=PSNAV_SNAX( pl_akt)
       DO WHILE( jAUX .GT. 0 )      ! loop over all planes,connected to pl_akt
        iAUX = MSNAV_SNAX( jAUX )
        jAUX = XSNAV_SNAX( jAUX )
        npl  = ISNAX_NEXT( iAux )   ! plane, connected to pl_akt 
C*      Z-difference between the plane under study and the last 
C*      plane with HIT found
        DZ   = plz( npl ) - plz( ISTCA_PLAN(iCAND) ) 
        IF(     npl .EQ. SPL1 )THEN     
C*       First SEEDing plane ? 
         NHIT      = 1 
         IHIT( 1 ) = H1
         MEAS( 1 ) = M( 1 ) 
         IMIS( 1 ) = 0 
         PLAN( 1 ) = LP 
        ELSEIF( npl .EQ. SPL2 )THEN
C*       Second SEEDing plane ? 
         NHIT      = 1 
         IHIT( 1 ) = H2
         MEAS( 1 ) = M( 2 ) 
         IMIS( 1 ) = 0 
         PLAN( 1 ) = npl 
        ELSEIF( npl .EQ. SPL3 )THEN
C*       Third SEEDing plane ? 
         NHIT      = 1 
         IHIT( 1 ) = H3
         MEAS( 1 ) = M( 3 ) 
         IMIS( 1 ) = 0 
         PLAN( 1 ) = npl
        ELSEIF( npl .EQ. SPL4 )THEN
C*       Forth SEEDing plane ? 
         NHIT      = 1 
         IHIT( 1 ) = H4
         MEAS( 1 ) = M( 4 ) 
         IMIS( 1 ) = 0 
         PLAN( 1 ) = npl
        ELSE 
C*       Not a SEEDing plane
C*       Check wether the particle touch the plane
          IF (ISTCA_HSPL(iCand) .GE. 4) then
 	  x_ex(1) = FSTCA_P(1,iCAND)+DZ*FSTCA_P(3,iCAND)
 	  x_ex(2) = FSTCA_P(2,iCAND)+DZ*FSTCA_P(4,iCAND)
          ELSE ! stay on p0-line if not yet all seeds collected
             x_ex(1) = p0(1) + plz(npl)*p0(3)
             x_ex(2) = p0(2) + plz(npl)*p0(4)
          ENDIF 
          IF (INPLANE2(plxmi(npl), plxma(npl),
     &                  plymi(npl), plyma(npl), x_ex))THEN
C*        Get Hits 
           Lay = igede_lay(plid(npl))
           IF( Lay.EQ.1 .OR. Lay .EQ. 3 )THEN
            CALL SGETHIT3 (x_ex , NPL , ISTCA_LPLX(iCAND) , 
     &                     nhittol, hittol , mhittol )
           ELSE
            CALL SGETHIT3 (x_ex , NPL , ISTCA_LPLY(iCAND) , 
     &                     nhittol,hittol,mhittol)
           ENDIF 
           IF( NHITTOL .EQ. 0 )THEN
C*         No HITS!! 
            NHIT = 1 
            IHIT( 1 ) = 0 
            MEAS( 1 ) = 0.0
            IMIS( 1 ) = 1 
            PLAN( 1 ) = ISTCA_PLAN(iCAND) ! do not change the last plane with HIT
           ELSE 
C*         There exist some hits! 
           NHIT = NHITTOL  
           DO i1 = 1 , NHIT 
             IHIT( i1 ) =  HITTOL( i1 ) 
             MEAS( i1 ) = MHITTOL( i1 )
             IMIS( i1 ) = 0 
             PLAN( i1 ) = NPL
            ENDDO  
          ENDIF    ! Hits!!!
         ELSE
C*        Plane is not touched.      
C*	  -- action if candidate left navi-table:
          IF(jAUX .EQ. 0 )THEN ! 2nd normal termination...
           IF(ISTCA_HSPL(iCAND) .GE. 4 )THEN
            IQ(IQSTCA_AC(iCAND))=2  ! ...: accept if enough hits
           ELSE
            IQ(IQSTCA_AC(iCAND))=0  ! ...: kill if not 
           ENDIF 
           GO TO END_CAND_LOOP
          ENDIF 
          NHIT = 0 
         ENDIF     ! Touch the plane???
        ENDIF      ! Seeding plane???
 
C*      Fill STCA,SHCA structures.
        DO i = NHIT , 1 , -1 
         IF( i .EQ. 1 ) THEN 
          iiCAND = iCAND 
         ELSE
C*       Create Candidate if is is nessesary
C*       Faster than MMBOOK   
          IF( N_F(JSTCA) .GE. 1 )THEN
           IQ( JSTCA + 2 ) = IQ( JSTCA + 2 ) + 1
          ELSE 
           CALL MMBOOK(JSTCA,1)
          ENDIF 
          iiCAND = NSTCA()       
C*        Copy information from iCAND to iiCAND 
          IQ(IQSTCA_NHIT_L()) = ISTCA_NHIT(iCAND)
          IQ(IQSTCA_NMIS_L()) = ISTCA_NMIS(iCAND)
          IQ(IQSTCA_N2MI_L()) = ISTCA_N2MI(iCAND)
          IQ(IQSTCA_HSPL_L()) = ISTCA_HSPL(iCAND)
          IQ(IQSTCA_LPLX_L()) = ISTCA_LPLX(iCAND)
          IQ(IQSTCA_LPLY_L()) = ISTCA_LPLY(iCAND)
          IQ(IQSTCA_NHIT_L()) = ISTCA_NHIT(iCAND)
          IQ(IQSTCA_AC_L  ()) = ISTCA_AC  (iCAND)
          IQ(IQSTCA_PLAN_L()) = ISTCA_PLAN(iCAND)
           Q( QSTCA_CHI2_L()) = FSTCA_CHI2(iCAND)
          DO i1 = 1 , 4 
            Q( QSTCA_P_L(i1)) = FSTCA_P(i1,iCAND) 
           DO i2 = 1 , 4 
             Q( QSTCA_C_L(MMMM(i1,i2))) = 
     &          FSTCA_C  (MMMM(i1,i2),iCAND)
           ENDDO 
          ENDDO
          DO iTMP=1,ISTCA_NHIT(iCAND)
           iSHCA = ISTCA_HILI(iTMP,iCAND)
           IF( N_F(JSHCA) .GE. 1 )THEN
            IQ( JSHCA + 2 ) = IQ( JSHCA + 2 ) + 1
           ELSE 
            CALL MMBOOK(JSHCA,1)
           ENDIF
           IQ(IQSHCA_HITB_L()) = ISHCA_HITB(iSHCA)
           IQ(IQSHCA_PLAN_L()) = ISHCA_PLAN(iSHCA)
            Q( QSHCA_MEAS_L()) = FSHCA_MEAS(iSHCA)
            Q( QSHCA_DCHI_L()) = FSHCA_DCHI(iSHCA)
           DO i1 = 1, 4 
             Q( QSHCA_P_L(i1)) = FSHCA_P(i1,iSHCA)
            DO i2 = 1 , 4 
              Q( QSHCA_C_L(MMMM(i1,i2))) = 
     &           FSHCA_C  (MMMM(i1,i2),iSHCA)
            ENDDO 
           ENDDO 
C*         Relation 
           IQ(IQSTCA_HILI_L(iTMP)) = NSHCA()
          ENDDO   
C*        Now all information from iCAND is copied into iiCAND
         ENDIF 
C*       Update  Candidate iiCAND 
         IF(IMIS(i).NE.0)THEN
          IQ(IQSTCA_NMIS(iiCAND))=ISTCA_NMIS(iiCAND)+1
          IQ(IQSTCA_N2MI(iiCAND))=ISTCA_N2MI(iiCAND)+1
         ENDIF 
         IF(IHIT(i).NE.0)THEN
          IQ(IQSTCA_NHIT(iiCAND))=ISTCA_NHIT(iiCAND)+1
          IQ(IQSTCA_N2MI(iiCAND))=0
          IQ(IQSTCA_PLAN(iiCAND)) = PLAN( i ) 
         ENDIF 
         LAY = IGEDE_LAY(plid(NPL))
         IF( LAY .EQ. 1 .OR. LAY .EQ. 3 )THEN 
          IQ(IQSTCA_LPLX(iiCAND)) = NPL
         ELSE 
          IQ(IQSTCA_LPLY(iiCAND)) = NPL
         ENDIF 
         IF( NPL .EQ. SPL1 .OR. 
     &       NPL .EQ. SPL2 .OR. 
     &       NPL .EQ. SPL3 .OR. 
     &       NPL .EQ. SPL4      )THEN 
          IQ(IQSTCA_HSPL(iiCAND))=ISTCA_HSPL(iiCAND)+1
         ENDIF 
C*       Some checks. 
         IF(ISTCA_N2MI(iiCAND)  .GE. MX2MSS )THEN
          IF(ISTCA_HSPL(iiCAND) .GE. 4      )THEN
           IQ(IQSTCA_AC(iiCAND)) = 2   ! ...: accept if all seeds collected
          ELSE
           IQ(IQSTCA_AC(iiCAND)) = 0   ! ...: kill if not.
          ENDIF 
          GO TO  END_CAND_LOOP
         ENDIF 
         IF(ISTCA_NMIS(iiCAND)  .GT. 5      )THEN
          IF(ISTCA_HSPL(iiCAND) .GE. 4      )THEN
           IQ(IQSTCA_AC(iiCAND)) = 2   ! ...: accept if all seeds collected
          ELSE
           IQ(IQSTCA_AC(iiCAND)) = 0   ! ...: kill if not.
          ENDIF 
          GO TO  END_CAND_LOOP
         ENDIF 
         IF(IHIT(i).NE.0)THEN
C*        Prepare 
          CALL SKLMPRE( Q( QSTCA_P(1,iiCAND)) ,   ! Pin 
     &                   Q( QSTCA_C(1,iiCAND)) ,   ! Cin
     &                   DZ                    ,   ! dZ 
     &                   Ppre                  ,   ! Ppre
     &                   Cpre                  )   ! Cpre
C*        Filter 
          CALL SKLMFIL( Ppre , Cpre , MEAS( i ) , 
     &     plcsr( NPL ) , plsnr( NPL ) , 0.0012    , 
     &     Q( QSTCA_P(1,iiCAND)) ,   ! Pout 
     &     Q( QSTCA_C(1,iiCAND)) ,   ! Cout 
     &     dchi2 )               
           Q( QSTCA_CHI2(iiCAND)) = FSTCA_CHI2(iiCAND)+dchi2
C*        Create "Hits" 
          IF(N_F(JSHCA).GE.1)THEN
           IQ( JSHCA + 2 ) = IQ( JSHCA + 2 ) + 1
          ELSE 
           CALL MMBOOK(JSHCA,1)
          ENDIF
C*        Fill it!
          IQ(IQSHCA_HITB_L())=IHIT(i)
          IQ(IQSHCA_PLAN_L())=NPL
           Q( QSHCA_MEAS_L())=MEAS(i)
           Q( QSHCA_DCHI_L())=dchi2
          DO i1 = 1 , 4 
            Q( QSHCA_P_L(i1))=FSTCA_P(i1,iiCAND)
           DO i2 = 1 , 4 
             Q( QSHCA_C_L(MMMM(i1,i2)))=FSTCA_C(MMMM(i1,i2),iiCAND)
           ENDDO 
          ENDDO 
C*        Relation STCA<-->SHCA 
          IQ(IQSTCA_HILI(ISTCA_NHIT(iiCAND),iiCAND))=NSHCA() 
         ENDIF                       ! hits?   
        ENDDO                        ! End of loop over the found hits

        IF( NHIT .NE. 0 )THEN 
         pl_akt = NPL 
         GO TO START_PLANE_LOOP
        ENDIF 

       ENDDO                         ! END of loop over connected planes
 10    CONTINUE                      ! END_CAND_LOOP
      ENDDO                          ! End of Loop over All candidates

      TRACK_FOUND  = .FALSE. 
      BEST_QUALITY = -999.0 
      DO iCAND     = iOLDCAND+1,NSTCA()
       IF( ISTCA_AC(iCAND) .NE. 0 ) THEN
        quality = STRKQUAL( FSTCA_CHI2(iCAND) , 
     &                       ISTCA_NHIT(iCAND) , 
     &                       ISTCA_NMIS(iCAND))
        IF( QUALITY .LE. FSPAR_QUAL(NSPAR()) )THEN
         IQ(IQSTCA_AC(iCAND))=0
        ELSEIF( QUALITY .GE. BEST_QUALITY )THEN 
         BEST_QUALITY = QUALITY 
         BEST_TRACK   = iCAND 
         TRACK_FOUND  = .TRUE. 
        ENDIF 
       ENDIF 
      ENDDO  

      IF( TRACK_FOUND )THEN ! store in rc bank and history bank
C*     Save the track in STRC table 
       CALL MMBOOK(JSTRC,1)
C*     MTRA,AC and PERC attributes are to be filled yet. 
       IQ(IQSTRC_NHIT_L()) = ISTCA_NHIT(BEST_TRACK)
       IQ(IQSTRC_NMIS_L()) = ISTCA_NMIS(BEST_TRACK)
       IQ(IQSTRC_PLAN_L()) = ISTCA_PLAN(BEST_TRACK)
       IQ(IQSTRC_SEED_L()) = N_SEED+100*(N_PASS-1)
       IQ(IQSTRC_AC_L())   = 1
        Q( QSTRC_CHI2_L()) = FSTCA_CHI2(BEST_TRACK)       
        Q( QSTRC_QUAL_L()) = BEST_QUALITY
        Q( QSTRC_Z_L(   )) = PLZ(ISTCA_PLAN(BEST_TRACK))        
       DO i1=1,4
         Q( QSTRC_P_L(i1) ) = FSTCA_P(i1,BEST_TRACK)
        DO i2=1,4
         Q( QSTRC_C_L(MATRIX_PACK(i1,i2))) = 
     & FSTCA_C(MMMM(i1,i2),BEST_TRACK)
        ENDDO 
       ENDDO 
c       DO iTMP = ISTCA_NHIT(BEST_TRACK),1,-1 
       DO iTMP = 1 , ISTCA_NHIT(BEST_TRACK) 
        iSHCA = ISTCA_HILI(iTMP,BEST_TRACK)
        CALL MMBOOK(JSHRC,1)
        IQ(IQSHRC_HITB_L()) = ISHCA_HITB(iSHCA)
        IQ(IQSHRC_PLAN_L()) = ISHCA_PLAN(iSHCA)
         Q( QSHRC_MEAS_L()) = FSHCA_MEAS(iSHCA)
        DO i1=1,4
          Q( QSHRC_P_L(i1)) = FSHCA_P(i1,iSHCA)
         DO i2=1,4
           Q( QSHRC_C_L(MATRIX_PACK(i1,i2))) = 
     &        FSHCA_C(MMMM(i1,i2),iSHCA)
         ENDDO 
        ENDDO 
        CALL MMBREL(JSRSH,NSTRC(),NSHRC())   
       ENDDO
      ENDIF 


      RETURN 
      END
