*CMZ :          20/08/96  18.22.58  by   Ivan Belyaev
*CMZ :  1.00/01 02/08/96  20.56.44  by   Ivan Belyaev
*CMZ :  1.04/11 18/12/95  14.55.48  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.37.22  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  11.17.05  by  joerg f. rieling
*-- Author :

c     -----------------------------------------------------------------

      SUBROUTINE SSIMcol(iFIRST,FORWARD,iNOTPLANE)
C*    
C*   Collect "upstream" ( FORWARD = .TRUE. ) or 
C*   "downstream" hits for all Track Candidates staring from iFIRST 
C*   iNOTPLANE - plane which should NOT e used in the hit collection!  

c     -----------------------------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/SI.fi"
#include "auto/EV.fi"

#include "susi/zsiconst.fi"

c     --- external functions / subroutines
      INTEGER   LENOCC
      LOGICAL INPLANE2
      REAL      SSIMERF 
      EXTERNAL  LENOCC , SSIMERF,INPLANE2


#include "susi/zsirctrk.fi"
#include "susi/zsigeo.fi"
#include "susi/zsicand.fi"



c     --- formal parameters
       INTEGER   iFIRST 
       LOGICAL   FORWARD ,SWITCH
       INTEGER   iNOTPLANE

C*     Internal variables
       INTEGER   NHITS_MAX 
       PARAMETER(NHITS_MAX=16)

       INTEGER   iCAND , iPLANE , nPlane , iPLA , iiCAND
       INTEGER   iAUX  , jAUX   , LAY  , iHIT , iSHCA
       INTEGER   NHITS 
       INTEGER   NHIT 
       INTEGER   HIT( MAXFORK+20) 
       INTEGER   HITS(NHITS_MAX+20)
       INTEGER   MISS(NHITS_MAX+20)
       INTEGER   LAYE(NHITS_MAX+20)
       INTEGER   PLAN(NHITS_MAX+20)
              
       REAL      dZ    , dCHI2
       REAL      Ppre ( 4 ) , Cpre ( 4 , 4 ) 
       REAL      Ppre0( 4 ) , Cpre0( 4 , 4 ) 
       REAL      Pin  ( 4 ) , Cin  ( 4 , 4 ) 
       REAL      X( 2 ) , zPLA 
       REAL      SIGX , SIGY , PROX , PROY , PROB 
       REAL      DX1  , DY1  , DX2  , DY2
       REAL      MEA( MAXFORK+20) 
       REAL      MEAS(NHITS_MAX)
       
       REAL xmax,ymax
       LOGICAL   DIRECTION 
  
       real c_test(4,4)

#include "susi/zsimtrx44.fi"


#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/SI.ff"
#include "auto/EV.ff"

#include "susi/zsigeo.ff"
#include "susi/zsicand.ff"



      DIRECTION = FORWARD 

      iCAND = iFIRST         
C*    Loop over all track Candidates

      DO WHILE( iCAND .LE. NSTCA() ) 
  
 100   CONTINUE                 ! Iterate the planes... 

       NHITS = 0                ! found so far # of hits

       IF( ISTCA_AC(iCAND) .EQ. 0 )GO TO 900

C*     Last processed plane 
       iplane  = ISTCA_PLAN(iCAND) 
C*     Number of planes to be connected 

       IF( DIRECTION )THEN 
        nplane = ISNAV_NPLA(iplane)
       ELSE 
        nplane = ISNAV_NBAC(iPlane)
       ENDIF  
       IF( nplane .LE. 0 )GO TO 900  ! No planes to be connected  
      
       IF( DIRECTION )THEN
        jAUX = PSNAV_SNAX( iPlane ) 
       ELSE 
        jAUX = PSNAV_SNAB( iPlane ) 
       ENDIF 
       DO WHILE( jAUX .NE. 0 )
        IF( DIRECTION ) THEN
         iAUX = MSNAV_SNAX( jAUX ) 
         iPLA = ISNAX_NEXT( iAUX )    ! Plane number to be connected!
         jAUX = XSNAV_SNAX( jAUX )
        ELSE 
         iAUX = MSNAV_SNAB( jAUX ) 
         iPLA = ISNAB_NEXT( iAUX )    ! Plane number to be connected!
         jAUX = XSNAV_SNAB( jAUX )
        ENDIF  

        Lay  = IGEDE_LAY( PLID( iPLA ) )        

        zPLA = plz ( iPLA ) 

cc        dZ   = zPLA - plz( ISTCA_PLAN(iCAND) )

        dZ   = zPLA - plz( iPLANE )
        IF(     dZ .GT. 0 .AND.       DIRECTION )THEN
         C78='SUSi warning==> SSIMtra, dZ>0,dZ='
         CALL CH78AF(dZ,-3)
         CALL MEMESC(928744,100,ILARGEST,C78(1:LENOCC(C78)))
        ELSEIF( dZ .LT. 0 .AND. .NOT. DIRECTION )THEN
         C78='SUSi warning==> SSIMtra, dZ<0,dZ='
         CALL CH78AF(dZ,-3)
         CALL MEMESC(24324445,100,ILARGEST,C78(1:LENOCC(C78)))
        ENDIF 
        IF( iPLA .NE. iNOTPLANE )THEN
C*       NOT already used plane 
C*       Touch the plane iPLA ? Tolerance scheme. Time consuming. 
c         CALL SKLMPRE( Q( QSTCA_P(1,iCAND) ) , ! Pin  
c     &                  Q( QSTCA_C(1,iCAND) ) , ! Cin 
c     &                     dz,Ppre,Cpre) 
cC*       Neglect  x and y - correlations 
c         X( 1 ) = Ppre( 1 ) 
c         X( 2 ) = Ppre( 2 ) 
c         SIGX = 1.0/SQRT(ABS(Cpre(1,1)))
c         SIGY = 1.0/SQRT(ABS(Cpre(2,2)))
c         DX1  = ( PLXMA(iPLA) - Ppre( 1 ) ) * SIGX 
c         DX2  = ( PLXMI(iPLA) - Ppre( 1 ) ) * SIGX 
c         DY1  = ( PLYMA(iPLA) - Ppre( 2 ) ) * SIGY 
c         DY2  = ( PLYMI(iPLA) - Ppre( 2 ) ) * SIGY 
c         PROX = SSIMERF( MAX( MIN( DX1 ,  4.0 ) , -4.0 ) ,
c     &                    MIN( MAX( DX2 , -4.0 ) ,  4.0 ) )
c         PROY = SSIMERF( MAX( MIN( DY1 ,  4.0 ) , -4.0 ) ,
c     &                    MIN( MAX( DY2 , -4.0 ) ,  4.0 ) )        
c         PROB = PROX * PROY * 0.25 
C*       More fast scheme (no tolerance.) 
         X(1)=FSTCA_P(1,iCAND)+DZ*FSTCA_P(3,iCAND)
         X(2)=FSTCA_P(2,iCAND)+DZ*FSTCA_P(4,iCAND)
         PROB=0.0
         switch = .FALSE.
         IF (INPLANE2(plxmi(ipla), plxma(ipla),
     &                 plymi(ipla), plyma(ipla), x))PROB=1.0
C*       End of faster scheme. 
         IF( PROB .GE. 0.25 )THEN  ! probability to touch >25% !!! 
C*        Comment next 3 lines if "Tolerance" scheme is used. 
          CALL SKLMPRE( Q( QSTCA_P(1,iCAND) ) , ! Pin  
     &                   Q( QSTCA_C(1,iCAND) ) , ! Cin 
     &                      dz,Ppre,Cpre)
C*        End of comment region. 
          CALL SGETHITS(x,Cpre,ipla,NHIT,HIT,MEA)
          IF( NHIT .EQ. 0 )THEN
           NHIT     = 1 
           HIT( 1 ) = 0 
           MEA( 1 ) = 0.0
          ENDIF 
         ELSE 
c         the plane is not touched, maybe switched off???  
          IF ((ABS(plxma(ipla)-plxmi(ipla)).LE.0.01) .OR.   
     &    (ABS(plyma(ipla)-plymi(ipla)).LE. 0.01)) THEN   
c         switched off!!
c         track in plane ?? change xmax,ymax accord to rotation
           IF (plxma(ipla).gt.plxmi(ipla)) THEN
             xmax=plxmi(ipla)-7.30
             ELSE
             xmax=plxmi(ipla)+7.30
           ENDIF
           IF (plyma(ipla).gt.plymi(ipla)) THEN
             ymax=plymi(ipla)-7.30
             ELSE
             ymax=plymi(ipla)+7.30
           ENDIF
           IF (inplane2(plxmi(ipla),xmax,plymi(ipla),
     &     ymax,x)) THEN
            NHIT=1                                          
            HIT(1)=0                                        
            MEA(1)=0.0 
            switch=.TRUE.
c            print *, ipla,plid(ipla), icand  
           ELSE
            NHIT=0
           ENDIF   
          ELSE                                             

          NHIT = 0 
C*        The plane is not touched! 
C*        IF( jAUX .EQ. 0 )GO TO 900  ! ???
          ENDIF
         ENDIF 
        ELSE  
C*       This Plane was already used.Arbitrary Information.
         NHIT = 1 
         HIT( 1 ) = 1 
         MEA( 1 ) = 0 
        ENDIF      

        DO iHIT = 1 , NHIT 
         IF( NHITS .LT. NHITS_MAX )THEN
          NHITS = NHITS + 1 
          HITS( NHITS ) = HIT( iHIT )
          IF( HITS( NHIT ) .NE. 0 .OR. switch)THEN 
           MISS( NHITS ) = 0
          ELSE 
           MISS( NHITS ) = 1 
          ENDIF
          MEAS( NHITS ) = MEA( iHIT )  
          LAYE( NHITS ) = LAY 
          PLAN( NHITS ) = iPLA 
         ELSE 
          C78='SUSi warning! SSIMcol, NHIT>'
          CALL CH78AI( NHITS_MAX )
          CALL CH78CC( 'skip others!' )
          CALL MEMESC(947414,1,ILARGEST,C78(1:LENOCC(C78)))
         ENDIF 
        ENDDO 
 800    CONTINUE
       ENDDO                         ! End of NEXT plane Loop 


        IF( NHITS .EQ. 0 )GO TO 900 ! No hits!!! another candidate

        DO i1 = 1, 4 
         Pin( i1 ) = FSTCA_P(i1,iCAND)
         DO i2 = 1, 4 
          Cin(I1,i2)=FSTCA_C(MMMM(i1,i2),iCAND)
         ENDDO 
        ENDDO  

        DO iHIT = NHITS , 1 , -1
         IF( iHIT .EQ. 1 ) THEN 
          iiCAND = iCAND 
         ELSE 
C*        Book new candidate and copy information 
C*        into it from the old one.
C*        Instead of simple MMBOOK
          IF( N_F(JSTCA) .GE. 1)THEN
           IQ(JSTCA+2)=IQ(JSTCA+2)+1
          ELSE 
           CALL MMBOOK(JSTCA,1)
          ENDIF 
          iiCAND = NSTCA()
          IQ(IQSTCA_AC_L  ()) = ISTCA_AC  (iCAND)
          IQ(IQSTCA_NHIT_L()) = ISTCA_NHIT(iCAND)
          IQ(IQSTCA_NMIS_L()) = ISTCA_NMIS(iCAND)
          IQ(IQSTCA_N2MI_L()) = ISTCA_N2MI(iCAND)
          IQ(IQSTCA_HSPL_L()) = ISTCA_HSPL(iCAND)
          IQ(IQSTCA_LPLX_L()) = ISTCA_LPLX(iCAND)
          IQ(IQSTCA_LPLY_L()) = ISTCA_LPLY(iCAND)
          IQ(IQSTCA_PLAN_L()) = ISTCA_PLAN(iCAND)
           Q( QSTCA_CHI2_L()) = FSTCA_CHI2(iCAND)
          DO i1=1,4 
            Q( QSTCA_P_L(i1)) = FSTCA_P(i1,iCAND)
           DO i2=1,4
            Q( QSTCA_C_L(MMMM(i1,i2))) = 
     &          FSTCA_C(MMMM(i1,i2),iCAND) 
           ENDDO 
          ENDDO 
C*        Faster then relations  !!
          DO i1=1,ISTCA_NHIT(iCAND)              ! faster
           iSHCA = ISTCA_HILI(i1,iCAND)
C*         Instead of simple MMBOOK. Faster. 
           IF( N_F(JSHCA).GE.1)THEN
            IQ(JSHCA+2)=IQ(JSHCA+2)+1
           ELSE 
            CALL MMBOOK(JSHCA,1)
           ENDIF 
           DO i2=1,NCSHCA()
            IQ(L_L(i2,JSHCA))=IQ(L_A(i2,iSHCA,JSHCA))
           ENDDO 
           IQ(IQSTCA_HILI(i1,iiCAND))=NSHCA()    ! faster
          ENDDO                                  ! faster
C*        All information from iCAND is copied to iiCand now.
         ENDIF
         IQ(IQSTCA_PLAN(iiCAND)) = PLAN(iHIT)
         IF( ISTCA_PLAN(iCAND) .EQ. iNOTPLANE)THEN
          DZ = plz ( PLAN( iHIT ) ) - plz( iPLANE ) 
C*        Predict: 
          CALL SKLMPRE(  Pin , Cin ,   
     &                    dz  ,
     &                    Q( QSTCA_P(1,iiCAND)) , ! Ppre 
     &                    Q( QSTCA_C(1,iiCAND)) ) ! Ppre 
          GO TO 700
         ENDIF 
         IQ(IQSTCA_NMIS(iiCAND))=ISTCA_NMIS(iiCAND)+MISS(iHIT)
         IQ(IQSTCA_N2MI(iiCAND))=ISTCA_N2MI(iiCAND)+MISS(iHIT)
         IF( HITS( iHIT ) .EQ. 0)IQ(IQSTCA_N2MI(iiCAND))=0
C*       Check the number of double foults
         IF( ISTCA_N2MI(iiCAND) .GE. MX2MSS )THEN
          IQ(IQSTCA_AC(iiCAND)) = 0   ! kill it! 
          GO TO 900 
         ENDIF 
C*       Check the number of foults
         IF( ISTCA_NMIS(iiCAND) .GT. 5  )THEN
          IQ(IQSTCA_AC(iiCAND)) = 0   ! kill it! 
          GO TO 900 
         ENDIF 
         Lay = LAYE( iHIT ) 
         IF( Lay .EQ. 1 .OR. Lay .EQ. 3 ) THEN  
          IQ(IQSTCA_LPLX(iiCAND)) = PLAN(iHIT)
         ELSE 
          IQ(IQSTCA_LPLY(iiCAND)) = PLAN(iHIT)
         ENDIF 
         IF( HITS( iHIT ) .NE. 0 )THEN 
          IF(ISTCA_NHIT(iiCAND) .LT. 40)THEN
           IQ(IQSTCA_NHIT(iiCAND))=ISTCA_NHIT(iiCAND)+1
          ELSE 
           C78='SUSi Error!Number of Hits larger than 40'
           CALL MEMESC(9871414,1,ILARGEST,C78(1:LENOCC(C78)))           
          ENDIF 
C*        Remove the next 5 lines????? faster??? 
          DZ = plz ( PLAN( iHIT ) ) - plz( iPLANE ) 
C*        Predict: 
          CALL SKLMPRE(  Pin , Cin ,   
     &                      dz,Ppre,Cpre)
C*        be careful! with "tolerance" scheme this line should not be removed!
C*        Filter from Pre, Cpre 
	  CALL SKLMFIL(Ppre,Cpre,MEAS(iHIT),
     &     plcsr(PLAN(iHIT)), plsnr(PLAN(IHIT)), .0012,
     &     Q( QSTCA_P(1,iiCAND) ) ,            ! Pout 
     &     Q( QSTCA_C(1,iiCAND) ) ,            ! Cout 
     &                    dchi2 )
           Q( QSTCA_CHI2(iiCAND))=FSTCA_CHI2(iiCAND)+dchi2

C*        Instead of simple MMBOOK
          IF( N_F(JSHCA) .GE. 1 )THEN
           IQ(JSHCA+2)=IQ(JSHCA+2)+1
          ELSE 
           CALL MMBOOK(JSHCA,1)
          ENDIF 
          IQ(IQSHCA_HITB_L()) = HITS( iHIT ) 
          IQ(IQSHCA_PLAN_L()) = PLAN( iHIT )
           Q( QSHCA_MEAS_L()) = MEAS( iHIT )          
           Q( QSHCA_DCHI_L()) = dchi2
           Q( QSTCA_CHI2(iiCAND)) = FSTCA_CHI2(iiCAND)+dchi2
          IQ(IQSTCA_PLAN(iiCAND)) = PLAN( iHIT ) 
          DO i1=1,4
            Q( QSHCA_P_L(i1)) = FSTCA_P(i1,iiCAND) 
           DO i2=1,4
             Q( QSHCA_C_L(MMMM(i1,i2))) = 
     &          FSTCA_C(  MMMM(i1,i2),iiCAND)
           ENDDO 
          ENDDO 
C*        instead of relation! Much faster!  
          IQ(IQSTCA_HILI(ISTCA_NHIT(iiCAND),iiCAND))=NSHCA() 
         ELSE                                       ! hit?
C*        If hit is not found , simple put the prediction into 
C*        parameter vector. 
C* ATT! with "tolerance" scheme this lines should not be removed!
          DZ = plz ( PLAN( iHIT ) ) - plz( iPLANE ) 
C*        Predict: 
          CALL SKLMPRE(  Pin , Cin ,   
     &                    dz  ,
     &                    Q( QSTCA_P(1,iiCAND)) , ! Ppre 
     &                    Q( QSTCA_C(1,iiCAND)) ) ! Ppre 
c          DO i1 = 1 , 4
c            Q( QSTCA_P(i1,iiCAND)) = Ppre(i1)
c           DO i2 =1 , 4
c             Q( QSTCA_C(MMMM(i1,i2),iiCAND)) = Cpre(i1,i2)
c           ENDDO 
c          ENDDO 
C*        Above 6 lines should be skiped in "tolerance" scheme. 
         ENDIF                                    ! end of Hit
 700     CONTINUE 
        ENDDO 

       IF( ISTCA_AC(iCAND) .EQ. 1 )THEN
C*      Still alive ?? 
        GO TO 100                    ! Iterate the NEXT plane  
       ELSE 
C*      Kill it! 
        IQ(IQSTCA_AC(iCAND))=0
       ENDIF 

 900   CONTINUE                      ! End of Loop over all Candidates 
       iCAND = iCAND + 1             ! Iterate iCAND 
      ENDDO                          ! End of Loop over all Candidates 

      RETURN
      END
