      REAL FUNCTION SSIMERF(X1,X2)

C*    Fast evaluation of ERF 
     
      IMPLICIT NONE

      REAL       XMAX ,X1,AX1,SX1,X2,AX2,SX2,X,XMIN
      PARAMETER( XMAX = 4.5 )
      PARAMETER( XMIN = -1.0*XMAX)

      INTEGER    IX1,IX2,NBIN,I
      PARAMETER  (NBIN=100)
      REAL       FUNC(0:NBIN)

      REAL       ERF 
      EXTERNAL   ERF

      LOGICAL    FIRST 
      SAVE       FIRST
      DATA       FIRST /.TRUE./

      IF( FIRST )THEN
       FIRST = .FALSE. 
       DO i=0,NBIN
        X=FLOAT(i)*XMAX/FLOAT(NBIN)
        FUNC(i)=ERF(X) 
       ENDDO 
      ENDIF 

      IF(X1 .GE. XMAX .AND. X2.GE.XMAX)THEN
       SSIMERF =  0.0
       RETURN 
      ENDIF 
      IF(X1.LE.XMIN.AND.X2.LE.XMIN)THEN
       SSIMERF = 0.0
       RETURN
      ENDIF  
      IF(X1.GE.XMAX.AND.X2.LE.XMIN)THEN
       SSIMERF = 2.0
       RETURN
      ENDIF  
      
      AX1 = ABS( X1 )    ! absolute value of X 
      SX1 = SIGN(1.0,X1) ! sign of X
      AX2 = ABS( X2 )    ! absolute value of X 
      SX2 = SIGN(1.0,X2) ! sign of X

      IX1 = INT(AX1/XMAX*FLOAT(NBIN)) 
      IX2 = INT(AX2/XMAX*FLOAT(NBIN)) 

      IF(IX1 .LE.    0 )IX1=1
      IF(IX2 .LE.    0 )IX2=1

      IF(IX1 .GT. NBIN )IX1=NBIN
      IF(IX2 .GT. NBIN )IX2=NBIN

      SSIMERF=SX1*FUNC(IX1)-SX2*FUNC(IX2)

      RETURN
      END


