*CMZ :          20/08/96  18.22.58  by   Ivan Belyaev
*CMZ :  1.00/01 02/08/96  20.56.44  by   Ivan Belyaev
*CMZ :  1.04/11 18/12/95  14.55.48  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.37.22  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  11.17.05  by  joerg f. rieling
*-- Author :

c     -----------------------------------------------------------------

      SUBROUTINE SSIMprB(iCAND)
C*
C*      Propagate iCAND to lowest Z 
C*

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/SI.fi"
#include "auto/EV.fi"

#include "susi/zsiconst.fi"

c     --- external functions / subroutines
      INTEGER   LENOCC 
      EXTERNAL  ERF  


#include "susi/zsirctrk.fi"
#include "susi/zsigeo.fi"
#include "susi/zsicand.fi"



c     --- formal parameters
       INTEGER   iPL   , iCAND , iSHCA 
       INTEGER   NHIT , SHCA( 40 )
       INTEGER   iPLAN , iHIT , INDE( 40 ) 
       REAL      ZHIT( 40 ) , MEAS  , Zin , DZ 
       REAL      Ppre( 4 ) , CPre( 4 , 4 ) , dchi2 

#include "susi/zsimtrx44.fi"


#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/SI.ff"
#include "auto/EV.ff"

#include "susi/zsigeo.ff"
#include "susi/zsicand.ff"


C*    Check Arguments:

      IF(JSTCA .LE. 0)THEN
       C78='SUSi Error! SSIMPRB, STCA Table does not exist!'
       CALL MEMESC(923235,1,ILARGEST,C78(1:LENOCC(C78)))
       RETURN 
      ENDIF 

      IF( iCAND .LE. 0 .OR. iCAND .GT. NSTCA())THEN
       C78='SUSi Error! SSIMPRB, wrong CAND parameter!'
       CALL MEMESC(3452345,1,ILARGEST,C78(1:LENOCC(C78)))
       RETURN 
      ENDIF 


      NHIT = ISTCA_NHIT(iCAND)
      IF( NHIT .LE.  0 )RETURN 
      IF( NHIT .GT. 40 )THEN
       C78='SUSi warning! SSIMPRB, NHIT='
       CALL CH78AI( NHIT )
       CALL MEMESC(92236087,1,ILARGEST,C78(1:LENOCC(C78)))
       NHIT = 40 
      ENDIF 
      DO iHIT = 1 , NHIT 
       iSHCA = ISTCA_HILI(iHIT,iCAND)
       INDE( iHIT ) = 0  
       SHCA( iHIT ) = iSHCA 
       ZHIT( iHIT ) = FHITB_Z(ISHCA_HITB(iSHCA))
      ENDDO 

      CALL SORTZV(ZHIT,INDE,NHIT,1,1,0)

            
      DO iHIT = 1 , NHIT
       IQ(IQSTCA_HILI(iHIT,ICAND))=SHCA(INDE(iHIT))
      ENDDO 


C*    Start from the "last" plane (nominally  --> minimal Z)
C*    and go to the "first" plane (nominally  --> iPL      )


C*    Prepare matrix for the Kalman Filtering

      DO i1 = 1 , 4 
       DO i2 = 1 , 4 
        Q( QSTCA_C(MMMM(i1,i2),iCAND)) = 0 
       ENDDO 
      ENDDO 
       Q( QSTCA_C(MMMM(1,1),iCAND)) = 0.100 
       Q( QSTCA_C(MMMM(2,2),iCAND)) = 0.100 
       Q( QSTCA_C(MMMM(3,3),iCAND)) = 0.001 
       Q( QSTCA_C(MMMM(4,4),iCAND)) = 0.001 
       Q( QSTCA_CHI2(       iCAND)) = 0.000 
      Zin = plz( iSTCA_PLAN( iCAND ) ) 


      DO iHIT = 1 , NHIT 
       iSHCA = ISTCA_HILI(iHIT,iCAND)
       iPLAN = ISHCA_PLAN(iSHCA)
       DZ =  plz( iPLAN ) - Zin 
C*     Predict 
       CALL SKLMPRE( Q( QSTCA_P(1,iCAND) ) , ! Pin  
     &                Q( QSTCA_C(1,iCAND) ) , ! Cin 
     &                    dz,Ppre,Cpre) 
        MEAS = FSHCA_MEAS(iSHCA)
C*     Filter 
       CALL SKLMFIL(Ppre,Cpre,MEAS  ,
     &     plcsr(iPLAN),plsnr(iPLAN) , 0.0012 , 
     &     Q( QSTCA_P(1,iCAND) )     ,            ! Pout 
     &     Q( QSTCA_C(1,iCAND) )     ,            ! Cout 
     &                   dchi2 )
        Q( QSTCA_CHI2(iCAND)) =FSTCA_CHI2(iCAND)+DCHI2 
       IQ(IQSTCA_PLAN(iCAND)) = iPLAN
        
        Q( QSHCA_DCHI(iSHCA)) = dchi2 
       DO i1 = 1 , 4
         Q( QSHCA_P(i1,iSHCA)) = FSTCA_P(i1,iCAND) 
        DO i2 = 1 , 4 
         Q( QSHCA_C(MMMM(i1,i2),iSHCA)) = FSTCA_C(MMMM(i1,i2),iCAND) 
        ENDDO 
       ENDDO 
       Zin = plz( ISHCA_PLAN(iSHCA) )
      ENDDO 

         
      RETURN 
      END 
