*CMZ :          20/08/96  18.22.58  by   Ivan Belyaev
*CMZ :  1.00/01 02/08/96  20.56.44  by   Ivan Belyaev
*CMZ :  1.04/11 18/12/95  14.55.48  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.37.22  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  11.17.05  by  joerg f. rieling
*-- Author :

c     -----------------------------------------------------------------

      SUBROUTINE SSIMtra(iPL1,iPL2,iHIT1,iHIT2,Z,P,C,MINIMALZ)

c     --         * * main tracking routine for the silicon * *
c     --
c     -- Gets  the   theoretically  last   hit  plane for a seed given
c     -- by the actual  parameters.
c     -- Then starts to look for the possible track by collecting hits
c     -- that lie in Kalman - ROIs;  if necessary, the track is FORKed
c     -- into a  couple of  candidates and each is  tracked separately.

c     -----------------------------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/SI.fi"
#include "auto/EV.fi"

#include "susi/zsiconst.fi"

c     --- external functions / subroutines
      INTEGER   INPLANE2 
      INTEGER   LENOCC 
      REAL      STRKQUAL
      EXTERNAL  INPLANE2, STRKQUAL, LENOCC


#include "susi/zsirctrk.fi"
#include "susi/zsigeo.fi"
#include "susi/zsicand.fi"



c     --- formal parameters
       LOGICAL   MINIMALZ
       INTEGER   iPL1 , iPL2 , iHIT1, iHIT2 
       REAL      Z    , P( 4 ) , C( 4 , 4 ) 

C*     Internal variables
       INTEGER   iCAND , iOLDCAND , iHIT , iTMP, iSHCA

       INTEGER   PLA( 2 ) , BEST_TRACK 
       INTEGER   HIT( 2 )
       REAL      MEA( 2 ) 
       REAL      Zin , dZ , Ppre( 4 ) , Cpre( 4 , 4 ) 
       REAL      dCHI2 , BEST_QUALITY , QUALITY 
       
       REAL C_TEST(4,4)
C*            
       LOGICAL   FORWARD , TRACK_FOUND , HIT_FOUND

       INTEGER   N_SEED, N_PASS , NHITS  

#include "susi/zsimtrx44.fi"

  
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/SI.ff"
#include "auto/EV.ff"

#include "susi/zsigeo.ff"
#include "susi/zsicand.ff"



      N_SEED = 0 
      N_PASS = 0 
C*
C*    These routine is called a lot of times per event
C*    therefore calling MMDROP and MMBOOK will waste a lot 
C*    of CPU times. Try not to drop the tables.
C*    Try to clean the tables. Faster???
C*    Also instead of Relation STCA <--> SHCA 
C*    use only Hit list in STCA, faster
C*    Also for the speed purposed do not call MMBOOK
C*    MMBOOK performs a lot of checks and therefore waste 
C*    a lot of CPU time.Therefore avoid to use MMBOOK often.
C* 

      IF( JSTCA .LE. 0 )CALL MMBOOK(JSTCA,1)
      IF( JSHCA .LE. 0 )CALL MMBOOK(JSHCA,1)

C*    Check the table sizes 
      IF( N_F(JSTCA)+N_U(JSTCA) .GT.  100)THEN
       CALL MMDROP( JSTCA     )
       CALL MMDROP( JSHCA     )
       CALL MMBOOK( JSTCA , 1 )
       CALL MMBOOK( JSHCA , 1 )
      ENDIF 

C*    Check the table sizes 
      IF( N_F(JSHCA)+N_U(JSHCA) .GT. 2000)THEN
       CALL MMDROP( JSTCA     )
       CALL MMBOOK( JSTCA , 1 )
       CALL MMDROP( JSHCA     )
       CALL MMBOOK( JSHCA , 1 )
      ENDIF 

C*    Clear the tables 
      DO i1   = 1 ,  NSTCA()
       DO i2  = 1 , NCSTCA()        
        IQ(L_A(i2,i1,JSTCA)) = 0 ! remove the contents 
       ENDDO 
      ENDDO 

C*    Clear the tables 
      DO i1   = 1 ,  NSHCA()
       DO i2  = 1 , NCSHCA()        
        IQ(L_A(i2,i1,JSHCA)) = 0 ! remove the contents 
       ENDDO 
      ENDDO 
C*    Reset counters 
      IQ( JSTCA + 2 ) = 0        ! reset counters 
      IQ( JSHCA + 2 ) = 0        ! reset counters  


      iOLDCAND    = NSTCA()


C*
C*   First Step:
C*   Create Candidate and 
C*   collect explicitly given hits
C* 


      IF( N_F(JSTCA) .GE. 1)THEN
       IQ(JSTCA+2)=IQ(JSTCA+2)+1
      ELSE 
       CALL MMBOOK(JSTCA,1)
      ENDIF 
      IQ(IQSTCA_NHIT_L()) = 0 
      IQ(IQSTCA_NMIS_L()) = 0 
      IQ(IQSTCA_N2MI_L()) = 0
      IQ(IQSTCA_HSPL_L()) = 0  
      IQ(IQSTCA_LPLX_L()) = iPL1
      IQ(IQSTCA_LPLY_L()) = iPL1
      IQ(IQSTCA_AC_L  ()) = 1 
       Q( QSTCA_CHI2_L()) = 0.0 
      IQ(IQSTCA_PLAN_L()) = iPL1 
      DO i1=1,4 
        Q( QSTCA_P_L(i1)) = P(i1)
       DO i2=1,4
         Q( QSTCA_C_L(MMMM(i1,i2)))=C(i1,i2)
       ENDDO 
      ENDDO 
      HIT( 1 )  = IHIT1
      HIT( 2 )  = IHIT2
      MEA( 1 )  = FHITB_X( IHIT1 )  
      MEA( 2 )  = FHITB_X( IHIT2 )  
      PLA( 1 )  = iPL1 
      PLA( 2 )  = iPL2 
      Zin        = Z 

      DO iHIT   = 1 , 2
       IQ(IQSTCA_NHIT_L()) = ISTCA_NHIT(NSTCA())+1
       DZ = plz( ISTCA_PLAN(NSTCA() ) )  - Zin 
C*     Predict
       CALL SKLMPRE( Q( QSTCA_P_L(1) ) ,   ! Pin  
     &                Q( QSTCA_C_L(1) ) ,   ! Cin 
     &                    dz,Ppre,Cpre) 
C*     Filter 
       CALL SKLMFIL(Ppre , Cpre , MEA(iHIT),
     &     plcsr(PLA(iHIT)), plsnr(PLA(iHIT)), .0012,
     &     Q( QSTCA_P_L(1) ) ,            ! Pout 
     &     Q( QSTCA_C_L(1) ) ,            ! Cout 
     &                    dchi2 )
        Q( QSTCA_CHI2_L()) =FSTCA_CHI2(NSTCA())+DCHI2 
C*     Book the hit 
       IF( N_F(JSHCA) .GE. 1 )THEN
        IQ(JSHCA+2) = IQ(JSHCA+2)+1
       ELSE 
        CALL MMBOOK(JSHCA,1)
       ENDIF 
C*     Instead of relations - much faster
       IQ(IQSTCA_HILI_L(ISTCA_NHIT(NSTCA())))=NSHCA()
       IQ(IQSTCA_PLAN_L()) = PLA (iHIT)

       IQ(IQSHCA_PLAN_L()) = PLA ( iHIT )
       IQ(IQSHCA_HITB_L()) = HIT ( iHIT ) 
        Q( QSHCA_MEAS_L()) = MEA ( iHIT )      
        Q( QSHCA_DCHI_L()) = dchi2 

       DO i1 = 1 , 4
         Q( QSHCA_P_L(i1)) = FSTCA_P(i1,NSTCA()) 
        DO i2 = 1 , 4 
         Q( QSHCA_C_L(MMMM(i1,i2))) = FSTCA_C(MMMM(i1,i2),NSTCA()) 
        ENDDO 
       ENDDO 
       Zin = plz( ISHCA_PLAN(NSHCA() ) )
      ENDDO 
         
C*
C*    Routine works in 3 steps
C*     First collect the  upstream   hits
C*     Then come back to the reference plane iPL1 
C*     and then  collect      downstream hits       
C* 

C*    Collect "upstream" hits 
      FORWARD = .TRUE. 
      CALL SSIMCOL( iOLDCAND + 1 , FORWARD , iPL1 ) 

      IF( MINIMALZ )THEN
C*     Propagate to plane iPL1 
       DO iCAND = iOLDCAND + 1  ,NSTCA()
        IF( ISTCA_AC(iCAND) .NE. 0)THEN
         CALL SSIMPRO( iCAND , iPL1 ) 
        ENDIF
       ENDDO 
      ELSE
C*     Propagate to plane iPL2 
       DO iCAND = iOLDCAND + 1  ,NSTCA()
        IF( ISTCA_AC(iCAND) .NE. 0)THEN
         CALL SSIMPRO( iCAND , iPL2 ) 
        ENDIF
       ENDDO 
      ENDIF        
  
C*    Collect "downstream" hits 
      FORWARD = .FALSE. 
      CALL SSIMCOL( iOLDCAND + 1 , FORWARD , iPL1 ) 


      TRACK_FOUND  = .FALSE. 
      BEST_QUALITY = -999.0 
      BEST_TRACK   = NSTCA()
      DO iCAND     = iOLDCAND+1,NSTCA()
       IF( ISTCA_AC(iCAND) .NE. 0 ) THEN
        quality = STRKQUAL( FSTCA_CHI2(iCAND) , 
     &                       ISTCA_NHIT(iCAND) , 
     &                       ISTCA_NMIS(iCAND))
        IF( QUALITY .LE. FSPAR_QUAL(NSPAR()) )THEN
         IQ(IQSTCA_AC(iCAND))=0
        ELSEIF( QUALITY .GE. BEST_QUALITY )THEN 
c        IF( QUALITY .GE. BEST_QUALITY )THEN 
         BEST_QUALITY = QUALITY 
         BEST_TRACK   = iCAND 
         TRACK_FOUND  = .TRUE. 
        ENDIF 
       ENDIF 
      ENDDO  

      IF( TRACK_FOUND )THEN ! store in rc bank and history bank
C*     Save the track in STRC table 
       CALL MMBOOK(JSTRC,1)
C*     MTRA,AC and PERC attributes are to be filled yet. 
       IQ(IQSTRC_NHIT_L()) = ISTCA_NHIT(BEST_TRACK)
       IQ(IQSTRC_NMIS_L()) = ISTCA_NMIS(BEST_TRACK)
       IQ(IQSTRC_PLAN_L()) = ISTCA_PLAN(BEST_TRACK)
       IQ(IQSTRC_SEED_L()) = N_SEED+100*(N_PASS-1)
       IQ(IQSTRC_AC_L  ()) = 1 
        Q( QSTRC_CHI2_L()) = FSTCA_CHI2(BEST_TRACK)       
        Q( QSTRC_QUAL_L()) = BEST_QUALITY
        Q( QSTRC_Z_L(   )) = PLZ(ISTCA_PLAN(BEST_TRACK))        
       DO i1=1,4
         Q( QSTRC_P_L(i1) ) = FSTCA_P(i1,BEST_TRACK)
        DO i2=1,4
         Q( QSTRC_C_L(MATRIX_PACK(i1,i2))) = 
     & FSTCA_C(MMMM(i1,i2),BEST_TRACK)
        ENDDO 
       ENDDO 
c*       DO iTMP = ISTCA_NHIT(BEST_TRACK),1,-1 
       DO iTMP = 1,ISTCA_NHIT(BEST_TRACK)
        iSHCA = ISTCA_HILI(iTMP,BEST_TRACK)
        CALL MMBOOK(JSHRC,1)
        IQ(IQSHRC_HITB_L()) = ISHCA_HITB(iSHCA)
        IQ(IQSHRC_PLAN_L()) = ISHCA_PLAN(iSHCA)
         Q( QSHRC_MEAS_L()) = FSHCA_MEAS(iSHCA)
        DO i1=1,4
          Q( QSHRC_P_L(i1)) = FSHCA_P(i1,iSHCA)
         DO i2=1,4
           Q( QSHRC_C_L(MATRIX_PACK(i1,i2))) = 
     &        FSHCA_C(MMMM(i1,i2),iSHCA)
         ENDDO 
        ENDDO 
        CALL MMBREL(JSRSH,NSTRC(),NSHRC())   
       ENDDO
C*      Mark hit as "USED"
        IQ(IQMARK_USED(IHIT1))=1
        IQ(IQMARK_USED(IHIT2))=1

       ENDIF 

      RETURN
      END
