*CMZ :  1.00/01 11/07/96  16.22.48  by   Ivan Belyaev
*CMZ :  1.04/11 11/12/95  14.25.57  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.38.03  by  joerg f. rieling
*-- Author :    joerg f. rieling   14/11/95

c     ---------------------------------------

      subroutine ssmooth

c     -- steering routine for smoothing step.
c     -- Every valid track in the rc bank is
c     -- smoothed back to the first plane of
c     -- measurement.

c     ---------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MC.fi"
#include "auto/SI.fi"

c     -- local variables
      REAL     Zin ,  Pin (4), Cin (4,4)
      REAL     Ztmp,  Ptmp(4), Ctmp(4,4)
      REAL     Zcur,  Pcur(4), Ccur(4,4)
      REAL            Pout(4), Cout(4,4)
      REAL     DCHI2, Rout 
      INTEGER  i,iSHRC,jAUX 
      LOGICAL  DOWNSTREAM
 
      INTEGER  LENOCC 
      EXTERNAL LENOCC

c     -- common blocks / def''s / statement functions

#include "susi/zsiconst.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsitrhist.fi"
#include "susi/zsigeo.fi"

#include "susi/zsimtrx44.fi"


#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MC.ff"
#include "auto/SI.ff"
#include "susi/zsigeo.ff"

C*********************************************************
C*    Attention!                                         *
C*    In 4-plane seeding scheme Kalman Smoother has to   *
C*    propagate track parameters from the smallest Z to  *
C*    the largest one. In the 2-plane seeding scheme     *
C*    Kalman Smoother has to propagate track parameters  *
C*     in upstream direction!                            *
C*********************************************************

 1     CONTINUE 
       IF( JSPAR   .LE. 0 ) CALL SUSIDEFV
       IF( NSPAR() .NE. 1 ) CALL SUSIDEFV
       IF(     ISPAR_SEED(NSPAR()) .EQ. 4 )THEN
        DOWNSTREAM = .TRUE. 
       ELSEIF( ISPAR_SEED(NSPAR()) .EQ. 2 )THEN
        DOWNSTREAM = .FALSE. 
       ELSE 
        C78='SUSi error!Unknown value for SEED Parameter='
        CALL CH78AI( ISPAR_SEED(NSPAR()) )
        CALL MEMESC(9847198,1,ILARGEST,C78(1:LENOCC(C78)))
        GO TO 1 
       ENDIF 

c     -- loop over all rec tracks


       DO i=1,NSTRC()
       IF( ISTRC_AC(i) .NE. 0 )THEN 
C*      Get the Parameters and Error Matrix
        DO i1=1,4
         Pin(i1) = FSTRC_P(i1,i)
         DO i2=1,4
          Cin(i1,i2) = FSTRC_C(MATRIX_PACK(i1,i2),i) 
         ENDDO 
         Zin = FSTRC_Z( i ) 
        ENDDO 
        jAUX = PSTRC_SHRC( i ) 
         Q( QSTRC_CHI2(i)) = 0 
        DO WHILE( jAUX .NE. 0 )
         iSHRC = MSTRC_SHRC( jAUX ) 
         IF( ISHRC_PLAN( iSHRC ) .NE. ISTRC_PLAN(i))THEN
C*        Get the Current Parameters
          DO i1=1,4
           Pcur( i1 ) = FSHRC_P(i1,iSHRC)
           DO i2=1,4
            Ccur(i1,i2) = FSHRC_C(MATRIX_PACK(i1,i2),iSHRC)
           ENDDO 
          ENDDO 
          Zcur = FHITB_Z(ISHRC_HITB(iSHRC))
C* for minimal angular algorithm a lot of such messages.
          IF(Zcur.LT.Zin.AND. DOWNSTREAM )THEN 
           C78='SUSi warning! SSMOOTH, Zcur<Zin;Zcur='
           CALL CH78AF(  Zcur , -3 )
           CALL CH78CC( 'Zin='     )
           CALL CH78AF(  Zin  , -3 )
           CALL MEMESC(23623876,1,ILARGEST,C78(1:LENOCC(C78)))
          ELSEIF(Zcur.GT.Zin.AND. .NOT. DOWNSTREAM)THEN
           C78='SUSi warning! SSMOOTH, Zcur>Zin;Zcur='
           CALL CH78AF(  Zcur , -3 )
           CALL CH78CC( 'Zin='     )
           CALL CH78AF(  Zin  , -3 )
           CALL MEMESC(2734746,1,ILARGEST,C78(1:LENOCC(C78)))
          ENDIF          
C*        Smooth:
          CALL SKLMSMO  (Pin,Cin,Pcur,Ccur,
     &                    Zin,    Zcur,
     &                   plsnr(ISHRC_PLAN(iSHRC)),
     &                   plcsr(ISHRC_PLAN(iSHRC)),
     &                   FSHRC_MEAS(iSHRC),
     &                   Pout,Cout,Rout,dchi2)
C*        Copy OUT-data into IN-data
          Zin = Zcur
           Q( QSTRC_CHI2(i))=FSTRC_CHI2(i)+dchi2 
C*        and Update the error matrix at SHRC 
           Q( QSHRC_RES(iSHRC)) = Rout 
          DO i1=1,4
           Pin( i1 ) = Pout( i1 ) 
            Q( QSHRC_P(i1,iSHRC)) = Pout( i1 ) 
           DO i2=1,4
            Cin(i1,i2) = Cout(i1,i2)
             Q( QSHRC_C(MATRIX_PACK(i1,i2),iSHRC) ) = 
     &                   Cout( i1 , i2 ) 
           ENDDO 
          ENDDO             
         ENDIF 
         jAUX  = XSTRC_SHRC( jAUX )
        ENDDO
C*   
        IF( .NOT. DOWNSTREAM )THEN
          Q( QSTRC_Z(i)) = Zin
         DO i1=1,4
           Q( QSTRC_P(i1,i))=Pin(i1)
          DO i2=1,4
            Q( QSTRC_C(MATRIX_PACK(i1,i2),i))=Cin(i1,i2)
          ENDDO 
         ENDDO
        ENDIF          
C*
       ENDIF
      ENDDO 

      RETURN 
      END 




