*CMZ :          26/08/96  15.06.36  by   Ivan Belyaev
*CMZ :  2.01/01 07/08/96  16.28.30  by   Ivan Belyaev
*-- Author :     Ivan Belyaev   05/08/96

      SUBROUTINE StoRSEG

************************************************************************
*
* Description:
*    Transform SUSi tracks into Arte RSEG Table.
*    Fill RPNT Table for SUSi Track Segments
*
* Called from: SUSiEVNT
*
* External references:
*
* Argument in/out description - none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/ZGESL.fi"
#include "auto/GEO.fi"
#include "auto/EV.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsitrhist.fi"

      INTEGER NSEG_OLD,NSEG_NEW,NPNT_OLD,
     &        NPNT_NEW,NHIT_OLD,NHIT_NEW,
     &        NPNT    ,NHIT    ,NSEG
      INTEGER iSTRC,iSHRC,iHITB,iMTRA,jAUX

      INTEGER  LENOCC
      EXTERNAL LENOCC

#include "susi/zsimtrx44.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/EV.ff"
#include "auto/SI.ff"


      NSEG_OLD = 0
      IF( JRSEG .GT. 0)NSEG_OLD = NRSEG()
      NPNT_OLD = 0
      IF( JRPNT .GT. 0)NPNT_OLD = NRPNT()

C* LOOP OVER SUSi TRACKS

      DO iSTRC = 1 , NSTRC()
       IF( ISTRC_AC(iSTRC) .NE. 0)THEN 
C*      Active Track
        IF( ISTRC_NHIT( iSTRC ) .LE. 0 )THEN 
         C78='SUSi warning! NHIT='
         CALL CH78AI( ISTRC_NHIT( iSTRC ) ) 
         CALL CH78BC( 'for RC=' ) 
         CALL CH78AI( iSTRC ) 
         CALL CH78CC( 'skip it!' ) 
         CALL MEMESC(741247,0,ILARGEST,C78(1:LENOCC(C78)))
         GO TO 50  
        ENDIF 
C*      Book and Fill a new RSEGment 
        CALL MMBOOK(JRSEG,1)
         Q( QRSEG_CHI_L ()) = FSTRC_CHI2 ( iSTRC ) 
        IQ(IQRSEG_FIT_L ()) = 1 
        IQ(IQRSEG_CMP_L ()) = LGESL_SIL
C*      Segment''s parameters at the begin
         Q( QRSEG_PF_L  ()) = 0.0 ! arbitrary value , not defined yet 
         Q( QRSEG_ZF_L  ()) = FSTRC_Z    ( iSTRC ) 
         Q( QRSEG_XF_L  ()) = FSTRC_P( 1 , iSTRC ) 
         Q( QRSEG_YF_L  ()) = FSTRC_P( 2 , iSTRC ) 
         Q( QRSEG_TXF_L ()) = FSTRC_P( 3 , iSTRC ) 
         Q( QRSEG_TYF_L ()) = FSTRC_P( 4 , iSTRC ) 
        DO i1 = 1 , 4
         DO i2 = i1 , 4 
           Q( QRSEG_CVF_L(MATRIX_PACK(i1,i2))) = 
     &        FSTRC_C( MATRIX_PACK( i1 , i2 ) , iSTRC )    
         ENDDO 
        ENDDO 
         Q( QRSEG_CVF_L(MATRIX_PACK(5,5))) = 
     &        1.0E-6 * FLARGEST 
C*      Segment''s parameter at the end 
         Q( QRSEG_ZE_L  ()) = FSTRC_Z    ( iSTRC ) 
         Q( QRSEG_XE_L  ()) = FSTRC_P( 1 , iSTRC ) 
         Q( QRSEG_YE_L  ()) = FSTRC_P( 2 , iSTRC ) 
         Q( QRSEG_TXE_L ()) = FSTRC_P( 3 , iSTRC ) 
         Q( QRSEG_TYE_L ()) = FSTRC_P( 4 , iSTRC ) 
        DO i1 = 1 , 4
         DO i2 = i1 , 4 
           Q( QRSEG_CVE_L(MATRIX_PACK(i1,i2))) = 
     &        FSTRC_C( MATRIX_PACK( i1 , i2 ) , iSTRC )    
         ENDDO 
        ENDDO
         Q( QRSEG_CVE_L(MATRIX_PACK(5,5))) = 
     &        1.0E-6 * FLARGEST 
C*      Relation RSEG<-->MTRA     
        iMTRA = ISTRC_MTRA( iSTRC ) 
        IF( iMTRA .GE. 1 .AND. 
     &      iMTRA .LE. NMTRA() )THEN
         CALL MMBREL(JRSMT,NRSEG(),iMTRA)  ! RSEG<-->MTRA
        ENDIF 
C*      Loop over the assosiated HITS
        jAUX = PSTRC_SHRC( iSTRC ) 
        DO WHILE( jAUX .NE. 0 ) 
         iSHRC = MSTRC_SHRC( jAUX  ) 
         iHITB = ISHRC_HITB( iSHRC ) 
         IF( iHITB .LE. 0 .OR. 
     &       iHITB .GT. NHITB())THEN
          C78='SUSi warning! Incorrect HITB='
          CALL CH78AI( iHITB ) 
          CALL CH78BC( 'for iSTRC/iRSEG=')
          CALL CH78AI( iSTRC   ) 
          CALL CH78AC( '/'   ) 
          CALL CH78AI( NRSEG() )
          CALL CH78CC( 'skip hit!' ) 
          CALL MEMESC(29746297,0,ILARGEST,C78(1:LENOCC(C78)))
          GO TO 10 
         ENDIF
         IF( ISPAR_RPNT(NSPAR()) .NE. 0 )THEN 
C*        Book and Fill the "Reconstructed Point" 
          CALL MMBOOK(JRPNT,1) 
           Q( QRPNT_ZF_L ()) = FHITB_Z(ISHRC_HITB(iSHRC)) ! z 
           Q( QRPNT_XF_L ()) = FSHRC_P( 1 , iSHRC )   ! x
           Q( QRPNT_YF_L ()) = FSHRC_P( 2 , iSHRC )   ! y
           Q( QRPNT_TXF_L()) = FSHRC_P( 3 , iSHRC )   ! Px/Pz
           Q( QRPNT_TYF_L()) = FSHRC_P( 4 , iSHRC )   ! Py/Pz
           Q( QRPNT_PF_L ()) = 0.0     ! Momentum is still undefined
          DO i1 = 1 , 4
           DO i2 = i1 , 4 
             Q( QRPNT_CVF_L(MATRIX_PACK(i1,i2))) = 
     &          FSHRC_C( MATRIX_PACK( i1 , i2 ) , iSHRC )    
           ENDDO 
          ENDDO
           Q( QRPNT_CVF_L(MATRIX_PACK(5,5))) = 
     &          1.0E-6 * FLARGEST 
C*        Relation RSEG<-->RPNT
          CALL MMBREL(JRSRP,NRSEG(),NRPNT()) ! RSEG<-->RPNT
         ENDIF 
         IF( ISPAR_RPNT(NSPAR()) .NE. 0 )THEN 
C*        Book and Fill the "Reconstructed Hit" 
          CALL MMBOOK(JRHIT,1) 
           Q( QRHIT_X_L ()) = FSHRC_P( 1 , iSHRC )   ! x
           Q( QRHIT_Y_L ()) = FSHRC_P( 2 , iSHRC )   ! y
           Q( QRHIT_TX_L()) = FSHRC_P( 3 , iSHRC )   ! Px/Pz
           Q( QRHIT_TY_L()) = FSHRC_P( 4 , iSHRC )   ! Py/Pz
           Q( QRHIT_P_L ()) = 0.0     ! Momentum is still undefined
           Q( QRHIT_Q_L ()) = 1.

           IQ( IQRHIT_RTRA_L())=0 
C*        Relation RSEG<-->RHIT
          CALL MMBREL(JRSRH,NRSEG(),NRHIT()) ! RSEG<-->RHIT
c*        Relation RHIT<--> HITB 
          CALL MMBREL(JHIRH,iHITB,NRHIT())          
         ENDIF 
C*       Compare the Z 
         IF(FHITB_Z(ISHRC_HITB(iSHRC))
     &                   .LT.FRSEG_ZF(NRSEG()))THEN
           Q( QRSEG_ZF_L  ()) = FHITB_Z(ISHRC_HITB(iSHRC))
           Q( QRSEG_PF_L  ()) = 0.0 ! Momentum is still undefined
           Q( QRSEG_XF_L  ()) = FSHRC_P( 1 , iSHRC )
           Q( QRSEG_YF_L  ()) = FSHRC_P( 2 , iSHRC )
           Q( QRSEG_TXF_L ()) = FSHRC_P( 3 , iSHRC )
           Q( QRSEG_TYF_L ()) = FSHRC_P( 4 , iSHRC )
          DO i1 = 1 , 4
           DO i2 = i1 , 4 
             Q( QRSEG_CVF_L(MATRIX_PACK(i1,i2))) = 
     &          FSHRC_C( MATRIX_PACK( i1 , i2 ) , iSHRC )    
           ENDDO 
          ENDDO
           Q( QRSEG_CVF_L(MATRIX_PACK(5,5))) = 
     &          1.0E-6 * FLARGEST 
         ENDIF 
C*       Compare the Z 
         IF(FHITB_Z(ISHRC_HITB(iSHRC))
     &                   .GT.FRSEG_ZE(NRSEG()))THEN
           Q( QRSEG_ZE_L  ()) = FHITB_Z(ISHRC_HITB(iSHRC))
           Q( QRSEG_PE_L  ()) = 0.0 ! Momentum is still undefined
           Q( QRSEG_XE_L  ()) = FSHRC_P( 1 , iSHRC )
           Q( QRSEG_YE_L  ()) = FSHRC_P( 2 , iSHRC )
           Q( QRSEG_TXE_L ()) = FSHRC_P( 3 , iSHRC )
           Q( QRSEG_TYE_L ()) = FSHRC_P( 4 , iSHRC )
          DO i1 = 1 , 4
           DO i2 = i1 , 4 
             Q( QRSEG_CVE_L(MATRIX_PACK(i1,i2))) = 
     &          FSHRC_C( MATRIX_PACK( i1 , i2 ) , iSHRC )    
           ENDDO 
          ENDDO
           Q( QRSEG_CVE_L(MATRIX_PACK(5,5))) = 
     &          1.0E-6 * FLARGEST 
         ENDIF 

C*       Relation RSEG<-->HITB
         CALL MMBREL(JRSHI,NRSEG(),iHITB)   ! RSEG<-->HITB

 10      CONTINUE
         jAUX  = XSTRC_SHRC( jAUX  ) 
        ENDDO 
 50     CONTINUE 
       ENDIF 
      ENDDO 

      NSEG_NEW = 0
      IF( JRSEG .GT. 0)NSEG_NEW = NRSEG()
      NPNT_NEW = 0
      IF( JRPNT .GT. 0)NPNT_NEW = NRPNT()

      NSEG = NSEG_NEW - NSEG_OLD
      NPNT = NPNT_NEW - NPNT_OLD

      C78='SUSi==>StoRSEG:Numbers of Silicon RSEG/RPNT are:'
      CALL CH78BI( NSEG )
      CALL CH78AC('/')
      CALL CH78AI( NPNT )
      CALL MEMESC(4334846,1,ILARGEST,C78(1:LENOCC(C78)))

      IF( JSSTA   .LE. 0 )CALL SUSISTAT 
      IF( NSSTA() .NE. 1 )CALL SUSISTAT 

      IQ(IQSSTA_NSEG_L ()) = ISSTA_NSEG(NSSTA())+NSEG
       Q( QSSTA_YSEG_L ()) = FSSTA_YSEG(NSSTA())+NSEG**2

      IQ(IQSSTA_NPNT_L ()) = ISSTA_NPNT(NSSTA())+NPNT      
       Q( QSSTA_YPNT_L ()) = FSSTA_YPNT(NSSTA())+NPNT**2      

      IF( NSEG .LT. ISSTA_MNSE(NSSTA()))
     &IQ(IQSSTA_MNSE_L()) = NSEG 
      IF( NSEG .GT. ISSTA_MXSE(NSSTA()))
     &IQ(IQSSTA_MXSE_L()) = NSEG 
      IF( NPNT .LT. ISSTA_MNRP(NSSTA()))
     &IQ(IQSSTA_MNRP_L()) = NPNT 
      IF( NPNT .GT. ISSTA_MXRP(NSSTA()))
     &IQ(IQSSTA_MXRP_L()) = NPNT
 
      RETURN
      END

************************************************************************
* End of StoRSEG
************************************************************************




