*CMZ :          19/08/96  18.31.43  by   Ivan Belyaev
*CMZ :  1.00/01 03/08/96  19.01.06  by   Ivan Belyaev
*CMZ :  1.04/11 12/12/95  20.07.24  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.36.52  by  joerg f. rieling
*CMZ :  1.04/09 08/11/95  11.29.39  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  13.40.38  by  joerg f. rieling
*-- Author :

c     -----------------------------------------------------------------
      subroutine strack
c     --          steering algorithm for silicon                     --
c     --                   PR / fit.                                 --
c     --   Called everu event; generates seeds, calls spropseed     --
c     --      for propagation of seeds, then finds out the best      --
c     --        non-compatible tracks and marks the used hits.       --
c     -----------------------------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/SI.fi"
#include "auto/EV.fi"

c     --- common blocks
#include "susi/zsiconst.fi"
#include "susi/zsigeo.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsihitmark.fi"

c     --- counters
      INTEGER  n_call, n_pass, n_seed, n_oldrctrk
c     --- misc
      INTEGER  spl1, spl2, spl3, spl4    ! seeding plane id''s
      INTEGER  h1  , h2  , h3  , h4      ! hit #
      INTEGER  ISTAT 
      INTEGER  F1,F2,F3,F4 
      INTEGER  L1,L2,L3,L4
C*  
      REAL     M( 4 ) , P0( 4 ) , TWIN
c     --- labels
      INTEGER  end_h1_loop,end_h2_loop,end_h3_loop,end_h4_loop
c     --- data / save
      SAVE     n_call

      INTEGER  iAUX,jAUX

 
#include "susi/zsimtrx44.fi"

      DATA     n_call /0/

c     --- common def''s / statement functions

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/SI.ff"
#include "auto/EV.ff"
#include "susi/zsigeo.ff"
#include "susi/zsihitmark.ff"

c     --- label assignments
      assign 50 to end_h4_loop
      assign 60 to end_h3_loop
      assign 70 to end_h2_loop
      assign 80 to end_h1_loop

c     --- init
      n_call      = n_call + 1

      IF( JSPAR   .EQ. 0 )CALL SUSIDEFV
      IF( NSPAR() .NE. 1 )CALL SUSIDEFV
      
      TWIN = FSPAR_TWIN( NSPAR() )

c     --- clear hit mark array (TMP! Another ARTE-Table?)

      CALL MMDROP(JMARK)
      IF( JHITB .GT. 0 )THEN
       CALL MMBOOK(JMARK,NHITB())
      ELSE 
       CALL MMBOOK(JMARK,0)
      ENDIF 

c     --- 6 enclosing loops: pass, seed, hits. Fill meas-,angle- & z-vector.
 
C*      
      ISTAT = 0 
      DO n_pass = 1 , NSPAS()
       jAUX     = PSPAS_SSEE( n_pass )
       n_seed   = 0
       DO WHILE( jAUX .GT. 0 )
        n_seed  = n_seed + 1
        iAUX = MSPAS_SSEE( jAUX )
        jAUX = XSPAS_SSEE( jAUX )
        spl1 = ISSEE_PLN1( iAUX )
        spl2 = ISSEE_PLN2( iAUX )
        spl3 = ISSEE_PLN3( iAUX )
        spl4 = ISSEE_PLN4( iAUX )

        F1  = IGEPT_HIT1(plid(spl1))
        IF( F1 .LE. 0   )GO TO 100 
        L1  = IGEPT_HITL(plid(spl1))
        IF( L1 .LE. 0   )GO TO 100 
        IF( L1 .LT. F1  )GO TO 100 

        F2  = IGEPT_HIT1(plid(spl2))
        IF( F2 .LE. 0   )GO TO 100 
        L2  = IGEPT_HITL(plid(spl2))
        IF( L2 .LE. 0   )GO TO 100 
        IF( L2 .LT. F2  )GO TO 100 

        F3  = IGEPT_HIT1(plid(spl3))
        IF( F3 .LE. 0   )GO TO 100 
        L3  = IGEPT_HITL(plid(spl3))
        IF( L3 .LE. 0   )GO TO 100 
        IF( L3 .LT. F3  )GO TO 100 

        F4  = IGEPT_HIT1(plid(spl4))
        IF( F4 .LE. 0   )GO TO 100 
        L4  = IGEPT_HITL(plid(spl4))
        IF( L4 .LE. 0   )GO TO 100 
        IF( L4 .LT. F4  )GO TO 100 

        DO       h1 = F1 , L1
         IF     (h1 .LE. 0 )     goto end_h1_loop
         IF     (hitmark(h1)) goto end_h1_loop
          DO     h2 = F2 , L2
           IF   (h2 .LE. 0 ) goto end_h2_loop
           IF   (hitmark(h2)) goto end_h2_loop
           DO    h3 = F3 , L3
            IF  (h3 .LE. 0 ) goto end_h3_loop
            IF  (hitmark(h3)) goto end_h3_loop
            DO   h4 = F4 , L4
             IF (h4 .LE. 0) goto end_h4_loop
             IF (hitmark(h4)) goto end_h4_loop
             IF( H1 .LE. 0 .OR. H2 .LE. 0 .OR. 
     &           H3 .LE. 0 .OR. H4 .LE. 0)
     &             GO TO END_H4_LOOP
c             --- propagate the seed characaterized by spl1..4, h1..4
             ISTAT = ISTAT + 1 
             CALL SPROPSEED (spl1, spl2, spl3, spl4,
     &                        h1  , h2  , h3  , h4  ,
     &                        n_pass    , n_seed)
C            --- close seeding loops...
 50          CONTINUE                     ! end_h4_loop
            ENDDO                         ! h4
 60         CONTINUE                      ! end_h3_loop
           ENDDO                          ! h3
 70        CONTINUE                       ! end_h2_loop
          ENDDO                           ! h2
 80      CONTINUE                         ! end_h1_loop
        ENDDO                             ! h1
 100    CONTINUE
       ENDDO                              ! n_seed
c      --- after every pass: mark used hits.
       CALL sgeteqtrk(n_pass) ! get reconstructed tracks
       CALL smarkhit (n_pass) ! as name says
      ENDDO ! n_pass


      IF( JSSTA .LE. 0 )CALL  SUSISTAT

      IF( ISTAT .LT. ISSTA_MNCP( NSSTA() ) )
     &  IQ(IQSSTA_MNCP_L()) = ISTAT
      IF( ISTAT .GT. ISSTA_MXCP( NSSTA() ) )
     &  IQ(IQSSTA_MXCP_L()) = ISTAT
      IQ(IQSSTA_NNCP_L()) = ISSTA_NNCP(NSSTA()) + ISTAT
       Q( QSSTA_YNCP_L()) = FSSTA_YNCP(NSSTA()) + ISTAT**2

C*    Drop the temporary banks:
      CALL MMDROP(JMARK)
      CALL MMDROP(JSTCA)
      CALL MMDROP(JSHCA)

      RETURN
      END




