*CMZ :          08/08/96  14.10.32  by   Ivan Belyaev
*CMZ :  2.01/01 07/08/96  15.24.17  by   Ivan Belyaev
*CMZ :  1.00/01 03/08/96  19.47.42  by   Ivan Belyaev
*-- Author :                          30/06/96

      SUBROUTINE SUSIEVNT

************************************************************************
*
* Description:
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/SI.fi"

      INTEGER  LENOCC 
      EXTERNAL LENOCC
 
      INTEGER  NCALL
      DATA     NCALL /0/
      SAVE     NCALL

#include "arte/Arte.ff"
#include "auto/SI.ff"

      NCALL = NCALL + 1
     
      IF( NCALL .EQ. 1 )THEN
C*    Perform some initialisation
      C78='************************************************************'
      CALL ME78AP
      C78='************************************************************'
      CALL ME78AP
      C78='***                ***********                            **'
      CALL ME78AP
      C78='*** HITB --> RSEG  ***********  A  Pattern Recognition    **'
      CALL ME78AP
      C78='***                ***********  Algorithm  for  HERA-B    **'
      CALL ME78AP
      C78='******************************  Silicon Vertex Detector   **'
      CALL ME78AP
      C78='******************************                            **'
      CALL ME78AP
      C78='************************************************************'
      CALL ME78AP
      C78='************************************************************'
      CALL ME78AP
      C78='**                                                        **'
      CALL ME78AP
      C78='**   SSSS     UU    UU     SSSS                           **'
      CALL ME78AP
      C78='**  SSSSSS    UU    UU    SSSSSS                          **'
      CALL ME78AP
      C78='** SSS   SS   UU    UU   SSS   SS      ii                 **'
      CALL ME78AP
      C78='** SSS   SS   UU    UU   SSS   SS     iiii                **'
      CALL ME78AP
      C78='**  SSS       UU    UU    SSS          ii                 **'
      CALL ME78AP
      C78='**   SSS      UU    UU     SSS                            **'
      CALL ME78AP
      C78='**    SSS     UU    UU      SSS       iiii                **'
      CALL ME78AP
      C78='**     SSS    UU    UU       SSS       ii                 **'
      CALL ME78AP
      C78='**      SSS   UU    UU        SSS      ii                 **'
      CALL ME78AP
      C78='** SS    SS   UU    UU   SS    SS      ii                 **'
      CALL ME78AP
      C78='** SS   SSS   UUU  UUU   SS   SSS      ii                 **'
      CALL ME78AP
      C78='**  SSSSSS     UUUUUU     SSSSSS       ii                 **'
      CALL ME78AP
      C78='**   SSSS       UUUU       SSSS     iiiiiiii              **'
      CALL ME78AP
      C78='**                                                        **'
      CALL ME78AP
      C78='************************************************************'
      CALL ME78AP
      C78='************************************************************'
      CALL ME78AP
      C78='***                                                      ***'
      CALL ME78AP
      C78='**                                                        **'
      CALL ME78AP
      C78='* http://www-hera-b.desy.de/subgroup/software/welcome.html *'
      CALL ME78AP
      C78='**   "SUSi - Pattern Recognition for SiVD" by J.Rieling   **'
      CALL ME78AP
      C78='***                                                      ***'
      CALL ME78AP
      C78='************************************************************'
      CALL ME78AP
      C78='************************************************************'
      CALL ME78AP

       CALL SINIT
       CALL SSETTRNSM
 
      ENDIF

      IF( JSPAR   .EQ. 0 )CALL SUSIDEFV 
      IF( NSPAR() .NE. 1 )CALL SUSIDEFV 

C*    Select Proper Tracks? 
      IF( ISPAR_PROP(NSPAR()) .NE. 0 )THEN
       CALL sgetprtrk
      ENDIF 

 10   CONTINUE 
C*    4plane SEEDS of 2-plane Seeds ? 
      IF(      ISPAR_SEED(NSPAR()) .EQ. 2 )THEN
       IF(     ISPAR_ANGU(NSPAR()) .EQ. 0 )THEN
        CALL SSIMPLZ 
       ELSEIF( ISPAR_ANGU(NSPAR()) .EQ. 1 )THEN
        CALL SSIMPLA
       ELSE 
        C78='SUSi FATAL Error! Unknown value of ANGU Parameter!'
        CALL MEMESC(35554,1,ILARGEST,C78(1:LENOCC(C78)))
        CALL SUSIDEFV 
        GO TO 10 
       ENDIF 
      ELSEIF(  ISPAR_SEED(NSPAR()) .EQ. 4 )THEN
       CALL STRACK
      ELSE 
       C78='SUSi FATAL Error! Unknown value of SEED Parameter!'
       CALL MEMESC(7410748,1,ILARGEST,C78(1:LENOCC(C78)))
       CALL SUSIDEFV 
       GO TO 10 
      ENDIF 


 20   CONTINUE 
C*    Smooth ?Refit? 
      IF(     ISPAR_ALGO(NSPAR()) .EQ. 1 )THEN
C*     Kalman Smoother
       CALL ssmooth
      ELSEIF( ISPAR_ALGO(NSPAR()) .EQ. 2 )THEN
C*     Inverse Kalman refit (downstream direction)
       CALL SREVFIL 
      ELSEIF( ISPAR_ALGO(NSPAR()) .EQ. 0 )THEN
C*     No any refit business.
      ELSE 
       C78='SUSi error! Unknown value of ALGO Parameter!'
       CALL MEMESC(19246,1,ILARGEST,C78(1:LENOCC(C78)))
       CALL SUSIDEFV 
       GO TO 20 
      ENDIF 


C*    Assign MC track to the "reconstructed" Tracks
      CALL SMCASS

C*    Perform some SUSi Statistics
      CALL sstat

C*    FIll RSEG table
      CALL stoRSEG

C*    Print Final Statistics:
      IF( JSSTA .EQ. 0)CALL SUSISTAT

      IF(     ISSTA_PRN(NSSTA())   .GT. 0 )THEN
C*     Print the statistics.
       CALL SUSIPRNT
       IQ(IQSSTA_PRN_L()) = 
     &     ISSTA_PRN(NSSTA()) - 1
      ELSEIF( ISSTA_PRN(NSSTA())   .LT. 0 )THEN
       IF(MOD(NEVENTS,-1*ISSTA_PRN(NSSTA())).EQ.0)THEN
        CALL SUSIPRNT 
       ENDIF 
      ENDIF

C*    Remove banks 
      CALL MMDROP(JSTPR)
      CALL MMDROP(JSHPR)
      CALL MMDROP(JSTCA)
      CALL MMDROP(JSHCA)
      CALL MMDROP(JSTRC)
      CALL MMDROP(JSHRC)
      CALL MMDROP(JMARK)

      END

************************************************************************
* End of SUSIEVNT
************************************************************************



