
      SUBROUTINE  SUSIPRNT

************************************************************************
*
* $Source: /afs/desy.de/group/hera-b/repository/ARTE/susi/susiprnt.F,v $
* $Revision: 1.2 $
* $Author: hbcvs $
* $Date: 1997/11/23 23:45:45 $
*
* Created: Feb 30, 1991 by The Unknown Hacker
*
* Description: 
* Perform the printing of some SUSi Status & Statistical Info 
* Called from: anywhere
*
* Arguments:
* name       in/out/update Argument description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/EV.fi"
#include "auto/SI.fi"
#include "susi/zsiconst.fi"

       INTEGER  LENOCC 
       EXTERNAL LENOCC

       INTEGER  NNNN
       REAL     AVER 
       REAL     ERROR 

       LOGICAL  FIRST , L_PRINT
       DATA     FIRST / .TRUE. / 
       SAVE     FIRST 

#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/SI.ff"


      IF( JSUSI .LE. 0 )THEN
       C78='SUSi Error! Impossible to print SUSi Info (No SUSi at all)'
       CALL MEMESC(13840341,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       RETURN
      ENDIF 
       
      IF( JSSTA .LE. 0)CALL SUSISTAT

      IF( JSPAR .LE. 0 )THEN
       C78='SUSi warning!The default PAR values will be activated!' 
       CALL MEMESC(1043398,ILARGEST,ILARGEST,C78(1:LENOCC(C78))) 
       CALL SUSIDEFV
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ENDIF 

       C78='*****************************************************'
       CALL ME78AP

       C78='SUSi Parameters: (the printout of Table SPAR)' 
       CALL ME78AP

       C78='*****************************************************'
       CALL ME78AP

       C78='* SUSi version                      :' 
       CALL CH78BF(FSUSI_VERS(NSUSI()),-5)
       CALL ME78AP

       C78='* NAVI version                      :' 
       CALL CH78BF(FSUSI_NVER(NSUSI()),-5)
       CALL ME78AP

       C78='* SEED version                      :'
       CALL CH78BF(FSUSI_SVER(NSUSI()),-5)
       CALL ME78AP

       C78='* Number of Parameters Modifications:'
       CALL CH78BI(ISPAR_NMOD(NSPAR()))
       CALL ME78AP

       C78='* Proper Track Flag     :'
       IF( ISPAR_PROP(NSPAR()).EQ.0 )THEN
        CALL CH78BC( 'OFF' ) 
       ELSE 
        CALL CH78BC( 'ON' ) 
       ENDIF 
       CALL CH78CC( '(default is')
       CALL CH78BC( 'ON' ) 
       CALL CH78AC( ')' )
       CALL ME78AP
 
       C78='* SEEDing algorithm is :'
       CALL CH78BI( ISPAR_SEED(NSPAR()) )
       CALL CH78AC( '-plane seeding' )
       CALL CH78CC( '(default is')
       CALL CH78BC( '2-plane seeding' ) 
       CALL CH78AC( ')' )
       CALL ME78AP

       IF( ISPAR_SEED(NSPAR()).EQ.2 )THEN
        C78='* Plane selection for 2-point seeding is :'
        IF( ISPAR_ANGU(NSPAR()) .EQ. 0 )THEN 
         CALL CH78BC( 'Minimal Delta Z' ) 
        ELSE 
         CALL CH78BC( 'Minimal Delta Phi' ) 
        ENDIF
        CALL CH78CC( '(default is')
        CALL CH78BC( 'Minimal Delta Phi' ) 
        CALL CH78AC( ')' )
        CALL ME78AP
       ENDIF 



       C78='* Refit Algorithm is :'
       IF(     ISPAR_ALGO(NSPAR()) .EQ.0 )THEN
        CALL CH78BC( 'OFF' ) 
       ELSEIF( ISPAR_ALGO(NSPAR()) .EQ. 1 )THEN 
        CALL CH78BC( 'Kalman Smoother' )
       ELSEIF( ISPAR_ALGO(NSPAR()) .EQ. 2 )THEN 
        CALL CH78BC( 'Kalman Refit' )
       ENDIF 
       CALL CH78CC( '(default is')
       CALL CH78BC( 'Kalman Smoother' ) 
       CALL CH78AC( ')' )
       CALL ME78AP

       C78='* Reconstructed Points booking :'
       IF( ISPAR_RPNT(NSPAR()).EQ.0 )THEN
        CALL CH78BC( 'OFF' ) 
       ELSE 
        CALL CH78BC( 'ON' ) 
       ENDIF 
       CALL CH78CC( '(default is')
       CALL CH78BC( 'ON' ) 
       CALL CH78AC( ')' )
       CALL ME78AP

       C78='* Track Quality Cut     :'
       CALL CH78BF( FSPAR_QUAL(NSPAR()),-2 ) 
       CALL CH78CC( '(default is')
       CALL CH78BF( MIN_QUAL , -2 ) 
       CALL CH78AC( ')' )
       CALL ME78AP

       C78='* Hit Percentage Cut    :'
       CALL CH78BF( FSPAR_PERC(NSPAR()),-2 ) 
       CALL CH78CC( '(default is')
       CALL CH78BF( 0.7 , -2 ) 
       CALL CH78AC( ')' )
       CALL ME78AP

       C78='* Weight for Miss.Hits  :'
       CALL CH78BF( FSPAR_WMIS(NSPAR()),-3 ) 
       CALL CH78CC( '(default is')
       CALL CH78BF( WEIGHT_MISS , -3 ) 
       CALL CH78AC( ')' )
       CALL ME78AP

       C78='* Weight for Chi2       :'
       CALL CH78BF( FSPAR_WCH2(NSPAR()),-3 ) 
       CALL CH78CC( '(default is')
       CALL CH78BF( WEIGHT_CHI2 , -3 ) 
       CALL CH78AC( ')' )
       CALL ME78AP


       C78='* Minimal Tolerance     :'
       CALL CH78BF( FSPAR_MNTO(NSPAR()),-5) 
       CALL CH78CC( '(default is')
       CALL CH78BF( MIN_TOL     , -5) 
       CALL CH78AC( ')' )
       CALL ME78AP


       C78='* Maximal tolerance     :'
       CALL CH78BF( FSPAR_MXTO(NSPAR()),-5) 
       CALL CH78CC( '(default is')
       CALL CH78BF( MAX_TOL     , -5) 
       CALL CH78AC( ')' )
       CALL ME78AP

       C78='* Angular Tolerance     :'
       CALL CH78BF( FSPAR_ANTO(NSPAR()),-5) 
       CALL CH78CC( '(default is')
       CALL CH78BF( TOL_ANGLE , -5) 
       CALL CH78AC( ')' ) 
       CALL ME78AP

       C78='* Critical Parameter    :'
       CALL CH78BF( FSPAR_CRIT(NSPAR()),-5) 
       CALL CH78CC( '(default is')
       CALL CH78BF( CRITICAL , -5) 
       CALL CH78AC( ')' ) 
       CALL ME78AP

       C78='* Target Window         :'
       CALL CH78BF( FSPAR_TWIN(NSPAR()),-3) 
       CALL CH78CC( '(default is')
       CALL CH78BF( TARGET_WINDOW , -3) 
       CALL CH78AC( ')' ) 
       CALL ME78AP

       C78='* Minimal Momentum      :'
       CALL CH78BF( FSPAR_PMIN(NSPAR()),-3) 
       CALL CH78CC( '(default is')
       CALL CH78BF( P_MIN , -3) 
       CALL CH78AC( ')' ) 
       CALL ME78AP      

       C78='*****************************************************'
       CALL ME78AP

 
       C78='*****************************************************'
       CALL ME78AP

       C78='SUSi Parameters: (the printout of Table SSTA)' 
       CALL ME78AP

       C78='*****************************************************'
       CALL ME78AP

       C78='SUSi current Nevents,Evt/Run/Exp:' 
       CALL CH78BI(NEVENTS)
       CALL CH78CI( IEVHD_EVT( NEVHD() ) )
       CALL CH78AC('/')
       CALL CH78AI( IEVHD_RUN( NEVHD() ) )
       CALL CH78AC('/')
       CALL CH78AI( IEVHD_EXP( NEVHD() ) )
       IF( JMCME .NE. 0 )THEN
        CALL CH78CC( '(MC,Nmix=' ) 
        CALL CH78AI( NMCME() )
        CALL CH78AC( ')' )
       ENDIF 
       CALL ME78AP
            
       C78='SUSi first NEVENT for STAT :'
       CALL CH78BI(ISSTA_FRST(NSSTA()))
       CALL ME78AP 

       C78='SUSi number of events for STAT:'
       NNNN = ISSTA_LAST(NSSTA())-ISSTA_FRST(NSSTA())+1
       IF( NNNN .LE. 0 ) NNNN = 1
       CALL CH78BI(NNNN)
       CALL ME78AP 
 

       AVER  = FLOAT(ISSTA_NSTP(NSSTA()))/FLOAT(NNNN)
       IF( FSSTA_YSTP(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_YSTP(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Number of Proper Tracks/Event:'
       CALL CH78BF( AVER  , -1 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -2 )
       CALL ME78AP 
       C78='  Minimal number:'
       CALL CH78BI( ISSTA_MNPF(NSSTA()) )
       CALL ME78AP 
       C78='  Maximal number:'
       CALL CH78BI( ISSTA_MXPF(NSSTA()) )
       CALL ME78AP 




       AVER  = FLOAT(ISSTA_NPRE(NSSTA()))/FLOAT(NNNN)
       IF( FSSTA_YPRE(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_YPRE(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Number of Prelim.Rec Tracks/Event:'
       CALL CH78BF( AVER , -1 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -1 )
       CALL ME78AP 
       C78='  Minimal number:'
       CALL CH78BI( ISSTA_MNPR(NSSTA()) )
       CALL ME78AP 
       C78='  Maximal number:'
       CALL CH78BI( ISSTA_MXPR(NSSTA()) )
       CALL ME78AP 



       AVER  = FLOAT(ISSTA_NREC(NSSTA()))/FLOAT(NNNN)
       IF( FSSTA_YREC(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_YREC(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Number of Reconctructed Tracks/Event:'
       CALL CH78BF( AVER , -1 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -1 )
       CALL ME78AP 
       C78='  Minimal number:'
       CALL CH78BI( ISSTA_MNRE(NSSTA()) )
       CALL ME78AP 
       C78='  Maximal number:'
       CALL CH78BI( ISSTA_MXRE(NSSTA()) )
       CALL ME78AP 



       AVER  = FLOAT(ISSTA_NSEG(NSSTA()))/FLOAT(NNNN)
       IF( FSSTA_YSEG(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_YSEG(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Number of Reconctructed Segments/Event:'
       CALL CH78BF( AVER , -1 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -1 )
       CALL ME78AP 
       C78='  Minimal number:'
       CALL CH78BI( ISSTA_MNSE(NSSTA()) )
       CALL ME78AP 
       C78='  Maximal number:'
       CALL CH78BI( ISSTA_MXSE(NSSTA()) )
       CALL ME78AP 


       AVER  = FLOAT(ISSTA_NPNT(NSSTA()))/FLOAT(NNNN)
       IF( FSSTA_YPNT(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_YPNT(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Number of Reconctructed Points/Event:'
       CALL CH78BF( AVER  , -1 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -1 )
       CALL ME78AP 
       C78='  Minimal number:'
       CALL CH78BI( ISSTA_MNRP(NSSTA()) )
       CALL ME78AP 
       C78='  Maximal number:'
       CALL CH78BI( ISSTA_MXRP(NSSTA()) )
       CALL ME78AP 


       AVER  = FLOAT(ISSTA_NGHO(NSSTA()))/FLOAT(NNNN)
       IF( FSSTA_YGHO(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_YGHO(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Number of Reconctructed Ghosts/Event:'
       CALL CH78BF( AVER  , -1 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -1 )
       CALL ME78AP 
       C78='  Minimal number:'
       CALL CH78BI( ISSTA_MNGH(NSSTA()) )
       CALL ME78AP 
       C78='  Maximal number:'
       CALL CH78BI( ISSTA_MXGH(NSSTA()) )
       CALL ME78AP 




       AVER  = FSSTA_EPRO(NSSTA())/FLOAT(NNNN)
       IF( FSSTA_APRO(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_APRO(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Efficiency for the Proper Tracks:'
       CALL CH78AC( '(' )
       CALL CH78AF( AVER  , -2 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -2 )
       CALL CH78AC( ')' ) 
       CALL CH78AC( '%' ) 
       CALL ME78AP 


       AVER  = FSSTA_EEXT(NSSTA())/FLOAT(NNNN)
       IF( FSSTA_AEXT(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_AEXT(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Efficiency for the Extra Tracks:'
       CALL CH78AC( '(' )
       CALL CH78AF( AVER  , -2 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -2 )
       CALL CH78AC( ')' ) 
       CALL CH78AC( '%' ) 
       CALL ME78AP 

       AVER  = FSSTA_EGHO(NSSTA())/FLOAT(NNNN)
       IF( FSSTA_AGHO(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_AGHO(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       C78='Efficiency for the Ghost Tracks:'
       CALL CH78AC( '(' )
       CALL CH78AF( AVER  , -2 )
       CALL CH78AC('+-')
       CALL CH78AF( ERROR , -2 )
       CALL CH78AC( ')' ) 
       CALL CH78AC( '%' ) 
       CALL ME78AP 


 1     CONTINUE 

       AVER  = FLOAT(ISSTA_NNCP(NSSTA()))/FLOAT(NNNN)
       IF( FSSTA_YNCP(NSSTA()) .GT. 0 )THEN
        ERROR = FSSTA_YNCP(NSSTA())/FLOAT(NNNN) - 
     &          AVER**2 
        IF(ERROR .LE. 0 )ERROR = 0 
        ERROR = SQRT( ERROR )
       ELSE 
        ERROR = 0.0 
       ENDIF 
       IF(     ISPAR_SEED(NSPAR()) .EQ. 4 )THEN
        C78='Number of  spropseed.F calls/Event:'
       ELSEIF( ISPAR_SEED(NSPAR()) .EQ. 2 )THEN
        IF(     ISPAR_ANGU(NSPAR()) .EQ. 0 )THEN
         C78='Number of  SSIMtra.F calls/Event:'
        ELSEIF( ISPAR_ANGU(NSPAR()) .EQ. 1 )THEN
         C78='Number of  SSIMtra.F calls/Event:'
        ELSE
         CALL SUSIDEFV
         GO TO 1 
        ENDIF 
       ELSE 
        CALL SUSIDEFV
        GO TO 1 
       ENDIF 
       CALL CH78BF( AVER , -1 )
       CALL CH78AC('+-')
       CALL CH78BF( ERROR , -1 )
       CALL ME78AP 
       C78='  Minimal number:'
       CALL CH78BI( ISSTA_MNCP(NSSTA()) )
       CALL ME78AP 
       C78='  Maximal number:'
       CALL CH78BI( ISSTA_MXCP(NSSTA()) )
       CALL ME78AP 

    
      RETURN
      END


