*CMZ :          02/10/96  16.58.23  by  T. Oest
*-- Author :    T. Oest   12/04/96

      SUBROUTINE V0SWIM(SCATT,TRK, Z, PTRK, VTRK, IRET)

************************************************************************
*
* Description:
*
* Called from:
*
* External references:
*
* Argument in/out description
*  in   SCATT : =.TRUE.  with multiple scattering
*       TRK   : track number in RTRA
*       Z     : z position for the new parameters
*
*  out  PTRK  : track parameter (x,y,tx,ty,rho) at position Z
*       VTRK  : covariance matrix (x,y,tx,ty,rho) at position Z
*
************************************************************************

      IMPLICIT NONE


#include "arte/Arte.fi"
#include "auto/EV.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"

      LOGICAL          SCATT
      INTEGER          TRK, IRET
      DOUBLE PRECISION Z, PTRK(5), VTRK(5,5)

      INTEGER          IERROR, IC
      LOGICAL          COVAR
      DOUBLE PRECISION FSTEP, PIN(6), POUT(6), PREC(4), RKD(6,6)

      INTEGER          NZ, NZMAX
      PARAMETER        (NZMAX=100)
      DOUBLE PRECISION ZMUSC(NZMAX), ANG(NZMAX)

      INTEGER          I, J, L, M
      DOUBLE PRECISION V(5,5)

      DOUBLE PRECISION MA(6,3), MB(6,3), MVMS(6,6)

#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/GEO.ff"


      DATA PREC /2*1.D-4, 2*1.D-6/
************************************************************************
      IRET = 0

      IF (PRTRX_HITB(TRK).EQ.0) THEN
       IC = 0
      ELSE
       IC = 1
      ENDIF
C-----------------------------------------------------------------------
C CALL RKMAIN
C-----------------------------------------------------------------------
      PIN(1)   = DBLE( FRTRA_ZF(TRK) )
      PIN(2)   = DBLE( FRTRA_XF(TRK) )
      PIN(3)   = DBLE( FRTRA_YF(TRK) )
      PIN(4)   = DBLE( FRTRA_TXF(TRK) )
      PIN(5)   = DBLE( FRTRA_TYF(TRK) )
      PIN(6)   = DBLE( FRTRA_PF(TRK) )

      NZ = 0
      CALL V0FEXT(IC, SCATT, NZ, ZMUSC, ANG,
     +            PIN, Z, PREC, POUT, MA, MB, COVAR, MVMS, IERROR)
c      FSTEP = 20.
c      CALL RKMAIN(Z, FSTEP, PIN, PREC, POUT, RKD, IERROR)
      IF (IERROR.NE.0) THEN
       IRET = -1
       GOTO 9000
      ENDIF

      DO I=1,6
      DO J=1,3
       RKD(I,J)   = MA(I,J)
       RKD(I,J+3) = MB(I,J)
      ENDDO
      ENDDO


      DO I=1,5
       PTRK(I)  = POUT(I+1)
      ENDDO
c      print*,' zout ',sngl(z)
c      print*,' ptrk ',sngl(ptrk(1)),sngl(ptrk(2)),sngl(ptrk(3)),
c     +                sngl(ptrk(4)),sngl(ptrk(5))


      V(1,1)   = DBLE( FRTRA_CVF(1,TRK) )
      V(2,1)   = DBLE( FRTRA_CVF(2,TRK) )
      V(2,2)   = DBLE( FRTRA_CVF(3,TRK) )
      V(3,1)   = DBLE( FRTRA_CVF(4,TRK) )
      V(3,2)   = DBLE( FRTRA_CVF(5,TRK) )
      V(3,3)   = DBLE( FRTRA_CVF(6,TRK) )
      V(4,1)   = DBLE( FRTRA_CVF(7,TRK) )
      V(4,2)   = DBLE( FRTRA_CVF(8,TRK) )
      V(4,3)   = DBLE( FRTRA_CVF(9,TRK) )
      V(4,4)   = DBLE( FRTRA_CVF(10,TRK) )
      V(5,1)   = DBLE( FRTRA_CVF(11,TRK) )
      V(5,2)   = DBLE( FRTRA_CVF(12,TRK) )
      V(5,3)   = DBLE( FRTRA_CVF(13,TRK) )
      V(5,4)   = DBLE( FRTRA_CVF(14,TRK) )
      V(5,5)   = DBLE( FRTRA_CVF(15,TRK) )

      DO I=1,5
      DO J=I+1,5
       V(I,J) = V(J,I)
      ENDDO
      ENDDO


      DO I=1,5
      DO J=I,5
       VTRK(I,J) = 0.0
       DO L=1,5
       DO M=1,5
        VTRK(I,J) = VTRK(I,J) + RKD(I+1,L+1) * V(L,M) * RKD(J+1,M+1)
       ENDDO
       ENDDO
        IF (COVAR) VTRK(I,J) = VTRK(I,J) + MVMS(I+1,J+1)
        VTRK(J,I) = VTRK(I,J)
      ENDDO
      ENDDO


 9000 END

************************************************************************
* End of V0SWIM
************************************************************************
