*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c------------------------------------------------------------
c
c       subroutine:   VTLIN(iv,momflg,flag)
c
c       input:    iv       =  vertex index      Int
c                 momflg   =  flag for mom. fit Int
c
c       output:   flag     < 0 if fail          Int
c
c       action:   initial fit using linear fit-steps
c
c------------------------------------------------------------
c
      subroutine  VTLIN ( iv, momflg, flag )

      implicit none

      integer iv, momflg
      integer flag

      integer ifail
      integer i, j, k, n, m, it, l, iter, imax, jmax

#include "vt/vtdat.fi"

      double precision 
     1  AGB(5,3), WBG(3,5), AGA(3,3)
      double precision 
     1  pc(5), AGpc(3), Cx(3), Wwork(3,3), Cwork(3,3)
      double precision 
     1  xk0(3), qk0(3)
      double precision 
     1  chi2f, chi2f1
      double precision 
     1  a33, a34, b13

      double precision 
     1  VTCHI2

      integer itmax 
      DATA    itmax / 1000 /

      flag = -1
      n = ntr(iv)
      iter = 0
      chi2f1 = 0.

      if (momflg.eq.0) then
        imax = 4
        jmax = 2
      else
        imax = 5
        jmax = 3
      endif

      do  i = 1, n
        qvs(1,iv,i) = p(1,ktr(iv,i))
        qvs(2,iv,i) = p(2,ktr(iv,i))
        if (momflg.eq.1) qvs(3,iv,i) = p(5,ktr(iv,i))
      enddo

   50 continue

      iter = iter + 1

c--->  step 1 : fit vertex, tracks fixed

      do  k = 1, n

        it = ktr(iv,k)
        l  = k-1

        b13 = 0.
        a33 = -qvs(1,iv,k)
        a34 = -qvs(2,iv,k)

        AGA(1,1) = G(3,3,it)
        AGA(1,2) = G(3,4,it)
        AGA(1,3) = G(3,3,it)*a33+G(3,4,it)*a34
        AGA(2,2) = G(4,4,it)
        AGA(2,3) = G(3,4,it)*a33+G(4,4,it)*a34
        AGA(3,3) = G(3,3,it)*a33**2+G(4,4,it)*a34**2
     1             + 2.d0*G(3,4,it)*a33*a34
        AGA(2,1) = AGA(1,2)
        AGA(3,1) = AGA(1,3)
        AGA(3,2) = AGA(2,3)

        do  i = 1, 3
          do  j = i, 3
            CINV(i,j,iv,k) = CINV(i,j,iv,l) + AGA(i,j)
            CINV(j,i,iv,k) = CINV(i,j,iv,k)
            Cwork(i,j) = CINV(i,j,iv,k)
            Cwork(j,i) = Cwork(i,j)
          enddo
        enddo
        call DSINV(3,Cwork,3,ifail)
        if ( ifail .eq. -1 )         goto 999
        do  i = 1, 3
          do  j = i, 3
            C(i,j,iv,k) = Cwork(i,j)
            C(j,i,iv,k) = Cwork(i,j)
          enddo
        enddo

        pc(1) = p(1,it) - qvs(1,iv,k)
        pc(2) = p(2,it) - qvs(2,iv,k)
        pc(3) = p(3,it)
        pc(4) = p(4,it)
        if (momflg.eq.1) pc(5) = p(5,it)

        do  i = 1, 2
          AGpc(i) = 0.
          do  j = 1, imax
            AGpc(i) = AGpc(i) + G(j,i+2,it)*pc(j)
          enddo
        enddo
        AGpc(3) = 0.
        do  j = 1, imax
          AGpc(3) = AGpc(3) + pc(j) *
     1        ( a33*G(j,3,it) + a34*G(j,4,it) )
        enddo

        do  i = 1, 3
          Cx(i) = AGpc(i)
          do  j = 1, 3
            Cx(i) = Cx(i) + CINV(i,j,iv,l)*xv(j,iv,l)
          enddo
        enddo
        do  i = 1, 3
          xv(i,iv,k) = 0.
          do  j = 1, 3
            xv(i,iv,k) = xv(i,iv,k) + C(i,j,iv,k)*Cx(j)
          enddo
        enddo

      enddo

      do  i = 1, 3
        xvs(i,iv) = xv(i,iv,n)
      enddo


c--->  step 2 : fit tracks for fixed vertex

      if (iter.eq.100) then
c---> no convergence, use initial vertex as new estimate
        do  i = 1, 3
          xvs(i,iv) = xv(i,iv,0)
        enddo
      endif

      do  i = 1, 3
        xk0(i) = xvs(i,iv)
      enddo

      do  k = 1, n

        l = k-1

        a33 = 0.
        a34 = 0.
        b13 = -xvs(3,iv)

        it = ktr(iv,k)

        Wwork(1,1) = G(1,1,it)+2.d0*b13*G(1,3,it)+b13**2*G(3,3,it)
        Wwork(2,2) = G(2,2,it)+2.d0*b13*G(2,4,it)+b13**2*G(4,4,it)
        Wwork(1,2) = G(1,2,it)+b13*G(2,3,it)
     1               +b13*G(1,4,it)+b13**2*G(3,4,it)
        Wwork(2,1) = Wwork(1,2)
        if (momflg.eq.0) then
          call DSINV(2,Wwork,3,ifail)
          if ( ifail .eq. -1 ) goto 999
        else
          Wwork(1,3) = G(1,5,it)+b13*G(3,5,it)
          Wwork(2,3) = G(2,5,it)+b13*G(4,5,it)
          Wwork(3,3) = G(5,5,it)
          Wwork(3,1) = Wwork(1,3)
          Wwork(3,2) = Wwork(2,3)
          call DSINV(3,Wwork,3,ifail)
          if ( ifail .eq. -1 ) goto 999
        endif

        do  i = 1, imax
          AGB(i,1) = G(1,i,it)+b13*G(3,i,it)
          AGB(i,2) = G(2,i,it)+b13*G(4,i,it)
        enddo
        if (momflg.ne.0) then
          do  i = 1, 5
            AGB(i,3) = G(i,5,it)
          enddo
        endif
        do  i = 1, jmax
          do  j = 1, imax
            WBG(i,j) = 0.
            do  m = 1, jmax
              WBG(i,j) = WBG(i,j) + Wwork(i,m)*AGB(j,m)
            enddo
          enddo
        enddo

        pc(1) = p(1,it)
        pc(2) = p(2,it)
        pc(3) = p(3,it) - xvs(1,iv)
        pc(4) = p(4,it) - xvs(2,iv)
        if (momflg.eq.1) pc(5) = p(5,it)

        do  i = 1, jmax
          qvs(i,iv,k) = 0.
          do  j = 1, imax
            qvs(i,iv,k) = qvs(i,iv,k) + WBG(i,j)*pc(j)
          enddo
        enddo

        qk0(1) = qvs(1,iv,k)
        qk0(2) = qvs(2,iv,k)
        qk0(3) = qvs(3,iv,k)

        chi2f = VTCHI2(iv,k,xk0,qk0,b13,a33,a34,momflg)

        chi2(iv,k) = chi2f
        if ( k .gt. 1 ) chi2(iv,k)=chi2(iv,k)+chi2(iv,k-1)

      enddo

      if ( abs( chi2f1-chi2f ) .gt. .0001 ) then
        chi2f1 = chi2f
        if (iter.gt.itmax) then
          flag = -2
          goto 999
        endif
        goto 50
      endif

      flag = 0

999   continue

      return
      end
