*CMZ :          20/05/96  12.58.00  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTPSIK(il1,il2,iKs,itB,flag)
c
c       input:    il1 = lepton track no 1           Int
c                 il2 = lepton track no 2           Int
c                 iKs = Ks track no                 Int
c
c       output:   itB = track no of reconstructed B Int
c                 flag (<0 if fail)                 Int
c                 -1 ---> vertex fit failed
c                 -2 ---> B incompatible with a wire
c
c       action:   reconstruct a B--->J/Psi Ks vertex on a wire
c
c-------------------------------------------------------------
c
      subroutine  VTPSIK(il1,il2,iKs,itB,flag)

      implicit none

      integer il1, il2, iKs, itB, flag

#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"

      integer iv, flag1, i, j
      double precision 
     1  xm, ch2max

      logical maskc(ntrk)

      double precision 
     1  xvB(3),xvcov(3,3),parB(5),covB(5,5)
      data xvB / 3*0.d0 /
      data xvcov / 1000.d0,    0.d0,    0.d0,
     1                0.d0, 1000.d0,    0.d0,
     1                0.d0 ,   0.d0, 1000.d0 /

      flag = 0
      ivB = 0
      ivpsiK = 0
      ch2max = ch2wB
c
c---> fit the B decay vertex into J/Psi Ks
c
      call VTINIT( xvB, xvcov, iv, flag1 )
      if ( flag1.lt.0 ) goto 999
      call VTADD( iv, il1, flag1 )
      if ( flag1.lt.0 ) goto 999
      call VTADD( iv, il2, flag1 )
      if ( flag1.lt.0 ) goto 999
      call VTADD( iv, iKs, flag1 )
      if ( flag1.lt.0 ) goto 999

      maskc(1) = .true.
      maskc(2) = .true.
      maskc(3) = .false.
      xm = mPsi
      call VTADDC(iv,xm,maskc,flag1)
      if ( flag1.lt.0 ) goto 999
      maskc(1) = .true.
      maskc(2) = .true.
      maskc(3) = .true.
      xm = mB
      call VTADDC(iv,xm,maskc,flag1)
      if ( flag1.lt.0 ) goto 999
      call VTSUM(iv,parB,covB,flag1)
      if ( flag1.lt.0 ) goto 999
      ivpsiK = iv

c
c---> Add the B as a track
c
      if ( trmult.ge.ntrtot ) goto 999
      trmult = trmult + 1
      do  i = 1, 5
        p(i,trmult) = parB(i)
        do  j = 1, 5
          V(i,j,trmult) = covB(i,j)
        enddo
      enddo
      xmass(trmult)  = mB
      invflg(trmult) = 0
      itB = trmult

c
c---> try to put the B on a wire
c
      call VTWINI(0)
      call VTIDWI(trmult,trmult,ch2max)
      if ( iwitr(trmult) .eq. 0 )  goto 998

      return

  998 continue
      flag = -2
      return

  999 continue
      flag = -1
      return

      end
